﻿namespace core.GUI
{
    using System;
    using System.Windows.Forms;

    public sealed class OutputHelper
    {
        public static RichTextBox outputBox;
        public static ProgressBar progressBar;
        public static ToolStripStatusLabel progressLabel;
        public static string timeStampFormt = "[hh:mm:ss]";

        public static void OutputText(string Text)
        {
            if (outputBox != null)
            {
                outputBox.AppendText((DateTime.Now.ToString(timeStampFormt) + " " + Text) + "\r\n");
                outputBox.ScrollToCaret();
                Application.DoEvents();
            }
        }

        public static void UpdateLabel(string Text)
        {
            if (progressLabel != null)
            {
                progressLabel.Text = Text;
                Application.DoEvents();
            }
        }
    }
}

