﻿namespace core.H1
{
    using core;
    using core.TagInterface;
    using System;

    public class H1TagCategory : Tag_Category
    {
        public static TagDefinition coll = new TagDefinition("coll", core.H1.coll.Layout, 10, "model_collision_geometry");
        public static TagDefinition mod2 = new TagDefinition("mod2", core.H1.mod2.Layout, 5, "gbxmodel");
        public static TagDefinition sbsp = new TagDefinition("sbsp", SBSP.Layout, 5, "scenario_structure_bsp");

        public H1TagCategory() : base(Map.HaloVersionEnum.Halo1)
        {
            base.Add(sbsp);
            base.Add(mod2);
            base.Add(coll);
        }
    }
}

