﻿namespace core.H2
{
    using core.TagInterface;
    using System;

    public class PRTM : TagBlockLayout
    {
        public TagBlock Faces = new TagBlock("Faces", Faces_Layout.Layout, Map.HaloVersionEnum.Halo2);
        public static readonly PRTM Layout = new PRTM();
        public core.TagInterface.Padding Padding = new core.TagInterface.Padding("Padding", 0x10);
        public core.TagInterface.Padding Padding_0 = new core.TagInterface.Padding("Padding", 4);
        public core.TagInterface.Padding Padding_1 = new core.TagInterface.Padding("Padding", 4);
        public core.TagInterface.Padding Padding_2 = new core.TagInterface.Padding("Padding", 4);
        public core.TagInterface.Padding Padding_3 = new core.TagInterface.Padding("Padding", 0x10);
        public core.TagInterface.Padding Padding_4 = new core.TagInterface.Padding("Padding", 8);
        public core.TagInterface.Padding Padding_5 = new core.TagInterface.Padding("Padding", 20);
        public HaloTagType Shader = new HaloTagType("Shader");
        public TagIdent Shader_0 = new TagIdent("Shader");
        public LongInteger Unknown = new LongInteger("Unknown");
        public LongInteger Unknown_0 = new LongInteger("Unknown");
        public LongInteger Unknown_1 = new LongInteger("Unknown");
        public TagBlock Unknown_10 = new TagBlock("Unknown", Unknown_10_Layout.Layout, Map.HaloVersionEnum.Halo2);
        public TagBlock Unknown_11 = new TagBlock("Unknown", Unknown_11_Layout.Layout, Map.HaloVersionEnum.Halo2);
        public TagBlock Unknown_12 = new TagBlock("Unknown", Unknown_12_Layout.Layout, Map.HaloVersionEnum.Halo2);
        public LongInteger Unknown_13 = new LongInteger("Unknown");
        public TagBlock Unknown_2 = new TagBlock("Unknown", Unknown_2_Layout.Layout, Map.HaloVersionEnum.Halo2);
        public LongInteger Unknown_3 = new LongInteger("Unknown");
        public TagBlock Unknown_4 = new TagBlock("Unknown", Unknown_4_Layout.Layout, Map.HaloVersionEnum.Halo2);
        public LongInteger Unknown_5 = new LongInteger("Unknown");
        public TagBlock Unknown_6 = new TagBlock("Unknown", Unknown_6_Layout.Layout, Map.HaloVersionEnum.Halo2);
        public LongInteger Unknown_7 = new LongInteger("Unknown");
        public LongInteger Unknown_8 = new LongInteger("Unknown");
        public TagBlock Unknown_9 = new TagBlock("Unknown", Unknown_9_Layout.Layout, Map.HaloVersionEnum.Halo2);
        public TagBlock Visual_Model = new TagBlock("Visual Model", Visual_Model_Layout.Layout, Map.HaloVersionEnum.Halo2);
        public Raw_Tag_Block Visual_Raw = new Raw_Tag_Block("Visual Raw", Map.HaloVersionEnum.Halo2, Data.RawDataTypes.H2_PRTM, new TagBlockLayout());

        public PRTM()
        {
            base.Add(this.Unknown);
            base.Add(this.Unknown_0);
            base.Add(this.Padding);
            base.Add(this.Shader);
            base.Add(this.Shader_0);
            base.Add(this.Unknown_1);
            base.Add(this.Padding_0);
            base.Add(this.Unknown_2);
            base.Add(this.Unknown_3);
            base.Add(this.Padding_1);
            base.Add(this.Unknown_4);
            base.Add(this.Unknown_5);
            base.Add(this.Padding_2);
            base.Add(this.Unknown_6);
            base.Add(this.Unknown_7);
            base.Add(this.Unknown_8);
            base.Add(this.Unknown_9);
            base.Add(this.Padding_3);
            base.Add(this.Unknown_10);
            base.Add(this.Unknown_11);
            base.Add(this.Unknown_12);
            base.Add(this.Visual_Model);
            base.Add(this.Faces);
            base.Add(this.Padding_4);
            base.Add(this.Visual_Raw);
            base.Add(this.Padding_5);
            base.Add(this.Unknown_13);
        }

        public class Faces_Layout : TagBlockLayout
        {
            public static readonly PRTM.Faces_Layout Layout = new PRTM.Faces_Layout();
            public ShortInteger Verticie_Index = new ShortInteger("Verticie Index");

            public Faces_Layout()
            {
                base.Add(this.Verticie_Index);
            }
        }

        public class Unknown_10_Layout : TagBlockLayout
        {
            public static readonly PRTM.Unknown_10_Layout Layout = new PRTM.Unknown_10_Layout();
            public StringID Unknown = new StringID("Unknown");

            public Unknown_10_Layout()
            {
                base.Add(this.Unknown);
            }
        }

        public class Unknown_11_Layout : TagBlockLayout
        {
            public static readonly PRTM.Unknown_11_Layout Layout = new PRTM.Unknown_11_Layout();
            public core.TagInterface.Padding Padding = new core.TagInterface.Padding("Padding", 12);
            public HaloTagType Unknown = new HaloTagType("Unknown");
            public TagIdent Unknown_0 = new TagIdent("Unknown");
            public LongInteger Unknown_1 = new LongInteger("Unknown");
            public RealFloat Unknown_2 = new RealFloat("Unknown");
            public RealFloat Unknown_3 = new RealFloat("Unknown");
            public RealFloat Unknown_4 = new RealFloat("Unknown");
            public RealFloat Unknown_5 = new RealFloat("Unknown");
            public RealFloat Unknown_6 = new RealFloat("Unknown");
            public RealFloat Unknown_7 = new RealFloat("Unknown");
            public TagBlock Unknown_8 = new TagBlock("Unknown", Unknown_8_Layout.Layout, Map.HaloVersionEnum.Halo2);

            public Unknown_11_Layout()
            {
                base.Add(this.Unknown);
                base.Add(this.Unknown_0);
                base.Add(this.Padding);
                base.Add(this.Unknown_1);
                base.Add(this.Unknown_2);
                base.Add(this.Unknown_3);
                base.Add(this.Unknown_4);
                base.Add(this.Unknown_5);
                base.Add(this.Unknown_6);
                base.Add(this.Unknown_7);
                base.Add(this.Unknown_8);
            }

            public class Unknown_8_Layout : TagBlockLayout
            {
                public static readonly PRTM.Unknown_11_Layout.Unknown_8_Layout Layout = new PRTM.Unknown_11_Layout.Unknown_8_Layout();
                public core.TagInterface.Padding Padding = new core.TagInterface.Padding("Padding", 4);
                public core.TagInterface.Padding Padding_0 = new core.TagInterface.Padding("Padding", 4);
                public core.TagInterface.Padding Padding_1 = new core.TagInterface.Padding("Padding", 4);
                public core.TagInterface.Padding Padding_2 = new core.TagInterface.Padding("Padding", 4);
                public core.TagInterface.Padding Padding_3 = new core.TagInterface.Padding("Padding", 4);
                public core.TagInterface.Padding Padding_4 = new core.TagInterface.Padding("Padding", 4);
                public core.TagInterface.Padding Padding_5 = new core.TagInterface.Padding("Padding", 4);
                public core.TagInterface.Padding Padding_6 = new core.TagInterface.Padding("Padding", 4);
                public core.TagInterface.Padding Padding_7 = new core.TagInterface.Padding("Padding", 20);
                public LongInteger Unknown = new LongInteger("Unknown");
                public LongInteger Unknown_0 = new LongInteger("Unknown");
                public TagBlock Unknown_1 = new TagBlock("Unknown", Unknown_1_Layout.Layout, Map.HaloVersionEnum.Halo2);
                public LongInteger Unknown_10 = new LongInteger("Unknown");
                public TagBlock Unknown_11 = new TagBlock("Unknown", Unknown_11_Layout.Layout, Map.HaloVersionEnum.Halo2);
                public LongInteger Unknown_12 = new LongInteger("Unknown");
                public TagBlock Unknown_13 = new TagBlock("Unknown", Unknown_13_Layout.Layout, Map.HaloVersionEnum.Halo2);
                public LongInteger Unknown_14 = new LongInteger("Unknown");
                public LongInteger Unknown_15 = new LongInteger("Unknown");
                public TagBlock Unknown_16 = new TagBlock("Unknown", Unknown_16_Layout.Layout, Map.HaloVersionEnum.Halo2);
                public LongInteger Unknown_17 = new LongInteger("Unknown");
                public TagBlock Unknown_18 = new TagBlock("Unknown", Unknown_18_Layout.Layout, Map.HaloVersionEnum.Halo2);
                public LongInteger Unknown_19 = new LongInteger("Unknown");
                public LongInteger Unknown_2 = new LongInteger("Unknown");
                public LongInteger Unknown_20 = new LongInteger("Unknown");
                public TagBlock Unknown_3 = new TagBlock("Unknown", Unknown_3_Layout.Layout, Map.HaloVersionEnum.Halo2);
                public LongInteger Unknown_4 = new LongInteger("Unknown");
                public TagBlock Unknown_5 = new TagBlock("Unknown", Unknown_5_Layout.Layout, Map.HaloVersionEnum.Halo2);
                public LongInteger Unknown_6 = new LongInteger("Unknown");
                public TagBlock Unknown_7 = new TagBlock("Unknown", Unknown_7_Layout.Layout, Map.HaloVersionEnum.Halo2);
                public LongInteger Unknown_8 = new LongInteger("Unknown");
                public TagBlock Unknown_9 = new TagBlock("Unknown", Unknown_9_Layout.Layout, Map.HaloVersionEnum.Halo2);
                public HaloTagType Unused = new HaloTagType("Unused");
                public TagIdent Unused_0 = new TagIdent("Unused");

                public Unknown_8_Layout()
                {
                    base.Add(this.Unused);
                    base.Add(this.Unused_0);
                    base.Add(this.Unknown);
                    base.Add(this.Unknown_0);
                    base.Add(this.Unknown_1);
                    base.Add(this.Unknown_2);
                    base.Add(this.Padding);
                    base.Add(this.Unknown_3);
                    base.Add(this.Unknown_4);
                    base.Add(this.Padding_0);
                    base.Add(this.Unknown_5);
                    base.Add(this.Unknown_6);
                    base.Add(this.Padding_1);
                    base.Add(this.Unknown_7);
                    base.Add(this.Unknown_8);
                    base.Add(this.Padding_2);
                    base.Add(this.Unknown_9);
                    base.Add(this.Unknown_10);
                    base.Add(this.Padding_3);
                    base.Add(this.Unknown_11);
                    base.Add(this.Unknown_12);
                    base.Add(this.Padding_4);
                    base.Add(this.Unknown_13);
                    base.Add(this.Unknown_14);
                    base.Add(this.Unknown_15);
                    base.Add(this.Padding_5);
                    base.Add(this.Unknown_16);
                    base.Add(this.Unknown_17);
                    base.Add(this.Padding_6);
                    base.Add(this.Unknown_18);
                    base.Add(this.Padding_7);
                    base.Add(this.Unknown_19);
                    base.Add(this.Unknown_20);
                }

                public class Unknown_1_Layout : TagBlockLayout
                {
                    public static readonly PRTM.Unknown_11_Layout.Unknown_8_Layout.Unknown_1_Layout Layout = new PRTM.Unknown_11_Layout.Unknown_8_Layout.Unknown_1_Layout();
                    public ByteInteger Unknown = new ByteInteger("Unknown");

                    public Unknown_1_Layout()
                    {
                        base.Add(this.Unknown);
                    }
                }

                public class Unknown_11_Layout : TagBlockLayout
                {
                    public static readonly PRTM.Unknown_11_Layout.Unknown_8_Layout.Unknown_11_Layout Layout = new PRTM.Unknown_11_Layout.Unknown_8_Layout.Unknown_11_Layout();
                    public ByteInteger Unknown = new ByteInteger("Unknown");

                    public Unknown_11_Layout()
                    {
                        base.Add(this.Unknown);
                    }
                }

                public class Unknown_13_Layout : TagBlockLayout
                {
                    public static readonly PRTM.Unknown_11_Layout.Unknown_8_Layout.Unknown_13_Layout Layout = new PRTM.Unknown_11_Layout.Unknown_8_Layout.Unknown_13_Layout();
                    public ByteInteger Unknown = new ByteInteger("Unknown");

                    public Unknown_13_Layout()
                    {
                        base.Add(this.Unknown);
                    }
                }

                public class Unknown_16_Layout : TagBlockLayout
                {
                    public static readonly PRTM.Unknown_11_Layout.Unknown_8_Layout.Unknown_16_Layout Layout = new PRTM.Unknown_11_Layout.Unknown_8_Layout.Unknown_16_Layout();
                    public ByteInteger Unknown = new ByteInteger("Unknown");

                    public Unknown_16_Layout()
                    {
                        base.Add(this.Unknown);
                    }
                }

                public class Unknown_18_Layout : TagBlockLayout
                {
                    public static readonly PRTM.Unknown_11_Layout.Unknown_8_Layout.Unknown_18_Layout Layout = new PRTM.Unknown_11_Layout.Unknown_8_Layout.Unknown_18_Layout();
                    public ByteInteger Unknown = new ByteInteger("Unknown");

                    public Unknown_18_Layout()
                    {
                        base.Add(this.Unknown);
                    }
                }

                public class Unknown_3_Layout : TagBlockLayout
                {
                    public static readonly PRTM.Unknown_11_Layout.Unknown_8_Layout.Unknown_3_Layout Layout = new PRTM.Unknown_11_Layout.Unknown_8_Layout.Unknown_3_Layout();
                    public ByteInteger Unknown = new ByteInteger("Unknown");

                    public Unknown_3_Layout()
                    {
                        base.Add(this.Unknown);
                    }
                }

                public class Unknown_5_Layout : TagBlockLayout
                {
                    public static readonly PRTM.Unknown_11_Layout.Unknown_8_Layout.Unknown_5_Layout Layout = new PRTM.Unknown_11_Layout.Unknown_8_Layout.Unknown_5_Layout();
                    public ByteInteger Unknown = new ByteInteger("Unknown");

                    public Unknown_5_Layout()
                    {
                        base.Add(this.Unknown);
                    }
                }

                public class Unknown_7_Layout : TagBlockLayout
                {
                    public static readonly PRTM.Unknown_11_Layout.Unknown_8_Layout.Unknown_7_Layout Layout = new PRTM.Unknown_11_Layout.Unknown_8_Layout.Unknown_7_Layout();
                    public ByteInteger Unknown = new ByteInteger("Unknown");

                    public Unknown_7_Layout()
                    {
                        base.Add(this.Unknown);
                    }
                }

                public class Unknown_9_Layout : TagBlockLayout
                {
                    public static readonly PRTM.Unknown_11_Layout.Unknown_8_Layout.Unknown_9_Layout Layout = new PRTM.Unknown_11_Layout.Unknown_8_Layout.Unknown_9_Layout();
                    public ByteInteger Unknown = new ByteInteger("Unknown");

                    public Unknown_9_Layout()
                    {
                        base.Add(this.Unknown);
                    }
                }
            }
        }

        public class Unknown_12_Layout : TagBlockLayout
        {
            public static readonly PRTM.Unknown_12_Layout Layout = new PRTM.Unknown_12_Layout();
            public StringID Unknown = new StringID("Unknown");
            public LongInteger Unknown_0 = new LongInteger("Unknown");

            public Unknown_12_Layout()
            {
                base.Add(this.Unknown);
                base.Add(this.Unknown_0);
            }
        }

        public class Unknown_2_Layout : TagBlockLayout
        {
            public static readonly PRTM.Unknown_2_Layout Layout = new PRTM.Unknown_2_Layout();
            public ByteInteger Unknown = new ByteInteger("Unknown");

            public Unknown_2_Layout()
            {
                base.Add(this.Unknown);
            }
        }

        public class Unknown_4_Layout : TagBlockLayout
        {
            public static readonly PRTM.Unknown_4_Layout Layout = new PRTM.Unknown_4_Layout();
            public ByteInteger Unknown = new ByteInteger("Unknown");

            public Unknown_4_Layout()
            {
                base.Add(this.Unknown);
            }
        }

        public class Unknown_6_Layout : TagBlockLayout
        {
            public static readonly PRTM.Unknown_6_Layout Layout = new PRTM.Unknown_6_Layout();
            public ByteInteger Unknown = new ByteInteger("Unknown");

            public Unknown_6_Layout()
            {
                base.Add(this.Unknown);
            }
        }

        public class Unknown_9_Layout : TagBlockLayout
        {
            public static readonly PRTM.Unknown_9_Layout Layout = new PRTM.Unknown_9_Layout();
            public ByteInteger Unknown = new ByteInteger("Unknown");

            public Unknown_9_Layout()
            {
                base.Add(this.Unknown);
            }
        }

        public class Visual_Model_Layout : TagBlockLayout
        {
            public static readonly PRTM.Visual_Model_Layout Layout = new PRTM.Visual_Model_Layout();
            public RealFloat U = new RealFloat("U");
            public LongInteger Unknown = new LongInteger("Unknown");
            public LongInteger Unknown_0 = new LongInteger("Unknown");
            public LongInteger Unknown_1 = new LongInteger("Unknown");
            public LongInteger Unknown_2 = new LongInteger("Unknown");
            public LongInteger Unknown_3 = new LongInteger("Unknown");
            public LongInteger Unknown_4 = new LongInteger("Unknown");
            public LongInteger Unknown_5 = new LongInteger("Unknown");
            public LongInteger Unknown_6 = new LongInteger("Unknown");
            public LongInteger Unknown_7 = new LongInteger("Unknown");
            public RealFloat V = new RealFloat("V");
            public RealFloat X = new RealFloat("X");
            public RealFloat Y = new RealFloat("Y");
            public RealFloat Z = new RealFloat("Z");

            public Visual_Model_Layout()
            {
                base.Add(this.X);
                base.Add(this.Y);
                base.Add(this.Z);
                base.Add(this.Unknown);
                base.Add(this.Unknown_0);
                base.Add(this.Unknown_1);
                base.Add(this.Unknown_2);
                base.Add(this.Unknown_3);
                base.Add(this.Unknown_4);
                base.Add(this.Unknown_5);
                base.Add(this.Unknown_6);
                base.Add(this.Unknown_7);
                base.Add(this.U);
                base.Add(this.V);
            }
        }
    }
}

