﻿namespace core.H2
{
    using core.TagInterface;
    using System;

    public class hlmt : TagBlockLayout
    {
        public TagBlock Damageable_Effects = new TagBlock("Damageable_Effects", Damageable_Effects_Layout.Layout, Map.HaloVersionEnum.Halo2);
        public TagBlock Damageable_Parts = new TagBlock("Damageable_Parts", Damageable_Parts_Layout.Layout, Map.HaloVersionEnum.Halo2);
        public TagBlock Health_Shields = new TagBlock("Health_Shields", Health_Shields_Layout.Layout, Map.HaloVersionEnum.Halo2);
        public static readonly hlmt Layout = new hlmt();
        public core.TagInterface.Padding Padding = new core.TagInterface.Padding("Padding", 4);
        public core.TagInterface.Padding Padding_0 = new core.TagInterface.Padding("Padding", 4);
        public core.TagInterface.Padding Padding_1 = new core.TagInterface.Padding("Padding", 4);
        public core.TagInterface.Padding Padding_2 = new core.TagInterface.Padding("Padding", 8);
        public core.TagInterface.Padding Padding_3 = new core.TagInterface.Padding("Padding", 20);
        public core.TagInterface.Padding Padding_4 = new core.TagInterface.Padding("Padding", 20);
        public core.TagInterface.Padding Padding_5 = new core.TagInterface.Padding("Padding", 8);
        public TagBlock Removeable_Parts = new TagBlock("Removeable_Parts", Removeable_Parts_Layout.Layout, Map.HaloVersionEnum.Halo2);
        public HaloTagType Unknown = new HaloTagType("Unknown");
        public TagIdent Unknown_0 = new TagIdent("Unknown_0");
        public HaloTagType Unknown_1 = new HaloTagType("Unknown_1");
        public LongInteger Unknown_10 = new LongInteger("Unknown_10");
        public RealFloat Unknown_11 = new RealFloat("Unknown_11");
        public RealFloat Unknown_12 = new RealFloat("Unknown_12");
        public RealFloat Unknown_13 = new RealFloat("Unknown_13");
        public RealFloat Unknown_14 = new RealFloat("Unknown_14");
        public RealFloat Unknown_15 = new RealFloat("Unknown_15");
        public LongInteger Unknown_16 = new LongInteger("Unknown_16");
        public TagBlock Unknown_17 = new TagBlock("Unknown_17", Unknown_17_Layout.Layout, Map.HaloVersionEnum.Halo2);
        public TagBlock Unknown_18 = new TagBlock("Unknown_18", Unknown_18_Layout.Layout, Map.HaloVersionEnum.Halo2);
        public HaloTagType Unknown_19 = new HaloTagType("Unknown_19");
        public TagIdent Unknown_2 = new TagIdent("Unknown_2");
        public TagIdent Unknown_20 = new TagIdent("Unknown_20");
        public HaloTagType Unknown_21 = new HaloTagType("Unknown_21");
        public TagIdent Unknown_22 = new TagIdent("Unknown_22");
        public LongInteger Unknown_23 = new LongInteger("Unknown_23");
        public LongInteger Unknown_24 = new LongInteger("Unknown_24");
        public LongInteger Unknown_25 = new LongInteger("Unknown_25");
        public LongInteger Unknown_26 = new LongInteger("Unknown_26");
        public LongInteger Unknown_27 = new LongInteger("Unknown_27");
        public LongInteger Unknown_28 = new LongInteger("Unknown_28");
        public LongInteger Unknown_29 = new LongInteger("Unknown_29");
        public HaloTagType Unknown_3 = new HaloTagType("Unknown_3");
        public HaloTagType Unknown_30 = new HaloTagType("Unknown_30");
        public TagIdent Unknown_31 = new TagIdent("Unknown_31");
        public StringID Unknown_32 = new StringID("Unknown_32");
        public TagIdent Unknown_4 = new TagIdent("Unknown_4");
        public HaloTagType Unknown_5 = new HaloTagType("Unknown_5");
        public TagIdent Unknown_6 = new TagIdent("Unknown_6");
        public HaloTagType Unknown_7 = new HaloTagType("Unknown_7");
        public TagIdent Unknown_8 = new TagIdent("Unknown_8");
        public LongInteger Unknown_9 = new LongInteger("Unknown_9");
        public TagBlock Variation = new TagBlock("Variation", Variation_Layout.Layout, Map.HaloVersionEnum.Halo2);

        public hlmt()
        {
            base.Add(this.Unknown);
            base.Add(this.Unknown_0);
            base.Add(this.Unknown_1);
            base.Add(this.Unknown_2);
            base.Add(this.Unknown_3);
            base.Add(this.Unknown_4);
            base.Add(this.Unknown_5);
            base.Add(this.Unknown_6);
            base.Add(this.Unknown_7);
            base.Add(this.Unknown_8);
            base.Add(this.Unknown_9);
            base.Add(this.Unknown_10);
            base.Add(this.Padding);
            base.Add(this.Unknown_11);
            base.Add(this.Unknown_12);
            base.Add(this.Unknown_13);
            base.Add(this.Unknown_14);
            base.Add(this.Unknown_15);
            base.Add(this.Padding_0);
            base.Add(this.Unknown_16);
            base.Add(this.Variation);
            base.Add(this.Unknown_17);
            base.Add(this.Health_Shields);
            base.Add(this.Damageable_Effects);
            base.Add(this.Damageable_Parts);
            base.Add(this.Removeable_Parts);
            base.Add(this.Padding_1);
            base.Add(this.Unknown_18);
            base.Add(this.Unknown_19);
            base.Add(this.Unknown_20);
            base.Add(this.Unknown_21);
            base.Add(this.Unknown_22);
            base.Add(this.Padding_2);
            base.Add(this.Unknown_23);
            base.Add(this.Unknown_24);
            base.Add(this.Unknown_25);
            base.Add(this.Padding_3);
            base.Add(this.Unknown_26);
            base.Add(this.Unknown_27);
            base.Add(this.Unknown_28);
            base.Add(this.Padding_4);
            base.Add(this.Unknown_29);
            base.Add(this.Padding_5);
            base.Add(this.Unknown_30);
            base.Add(this.Unknown_31);
            base.Add(this.Unknown_32);
        }

        public class Damageable_Effects_Layout : TagBlockLayout
        {
            public RealFloat Damage_Caused_Question_Mark_ = new RealFloat("Damage_Caused_Question_Mark_");
            public static readonly hlmt.Damageable_Effects_Layout Layout = new hlmt.Damageable_Effects_Layout();
            public StringID Mode_Marker = new StringID("Mode_Marker");
            public RealFloat Unknown = new RealFloat("Unknown");
            public LongInteger Unknown_0 = new LongInteger("Unknown_0");
            public RealFloat Unknown_1 = new RealFloat("Unknown_1");
            public LongInteger Unknown_2 = new LongInteger("Unknown_2");
            public RealFloat Unknown_3 = new RealFloat("Unknown_3");

            public Damageable_Effects_Layout()
            {
                base.Add(this.Mode_Marker);
                base.Add(this.Unknown);
                base.Add(this.Damage_Caused_Question_Mark_);
                base.Add(this.Unknown_0);
                base.Add(this.Unknown_1);
                base.Add(this.Unknown_2);
                base.Add(this.Unknown_3);
            }
        }

        public class Damageable_Parts_Layout : TagBlockLayout
        {
            public StringID Bone_Marker = new StringID("Bone_Marker");
            public TagBlock Damage_Levels = new TagBlock("Damage_Levels", Damage_Levels_Layout.Layout, Map.HaloVersionEnum.Halo2);
            public static readonly hlmt.Damageable_Parts_Layout Layout = new hlmt.Damageable_Parts_Layout();
            public LongInteger Unknown = new LongInteger("Unknown");

            public Damageable_Parts_Layout()
            {
                base.Add(this.Bone_Marker);
                base.Add(this.Unknown);
                base.Add(this.Damage_Levels);
            }

            public class Damage_Levels_Layout : TagBlockLayout
            {
                public static readonly hlmt.Damageable_Parts_Layout.Damage_Levels_Layout Layout = new hlmt.Damageable_Parts_Layout.Damage_Levels_Layout();
                public StringID Level_of_Damage = new StringID("Level_of_Damage");
                public LongInteger Unknown = new LongInteger("Unknown");

                public Damage_Levels_Layout()
                {
                    base.Add(this.Level_of_Damage);
                    base.Add(this.Unknown);
                }
            }
        }

        public class Health_Shields_Layout : TagBlockLayout
        {
            public TagBlock Damage_Locations = new TagBlock("Damage_Locations", Damage_Locations_Layout.Layout, Map.HaloVersionEnum.Halo2);
            public RealFloat Health__no_shields_ = new RealFloat("Health__no_shields_");
            public TagBlock Hinges = new TagBlock("Hinges", Hinges_Layout.Layout, Map.HaloVersionEnum.Halo2);
            public static readonly hlmt.Health_Shields_Layout Layout = new hlmt.Health_Shields_Layout();
            public core.TagInterface.Padding Padding = new core.TagInterface.Padding("Padding", 4);
            public core.TagInterface.Padding Padding_0 = new core.TagInterface.Padding("Padding", 20);
            public core.TagInterface.Padding Padding_1 = new core.TagInterface.Padding("Padding", 4);
            public core.TagInterface.Padding Padding_2 = new core.TagInterface.Padding("Padding", 0x40);
            public TagBlock Seat_Protection = new TagBlock("Seat_Protection", Seat_Protection_Layout.Layout, Map.HaloVersionEnum.Halo2);
            public RealFloat Shield = new RealFloat("Shield");
            public StringID Shield_Noise = new StringID("Shield_Noise");
            public RealFloat Shield_Recharge_Rate = new RealFloat("Shield_Recharge_Rate");
            public RealFloat Shield_Recharge_Time = new RealFloat("Shield_Recharge_Time");
            public LongInteger Unknown = new LongInteger("Unknown");
            public StringID Unknown_0 = new StringID("Unknown_0");
            public LongInteger Unknown_1 = new LongInteger("Unknown_1");
            public HaloTagType Unknown_10 = new HaloTagType("Unknown_10");
            public TagIdent Unknown_11 = new TagIdent("Unknown_11");
            public RealFloat Unknown_12 = new RealFloat("Unknown_12");
            public RealFloat Unknown_13 = new RealFloat("Unknown_13");
            public RealFloat Unknown_14 = new RealFloat("Unknown_14");
            public HaloTagType Unknown_15 = new HaloTagType("Unknown_15");
            public TagIdent Unknown_16 = new TagIdent("Unknown_16");
            public HaloTagType Unknown_17 = new HaloTagType("Unknown_17");
            public TagIdent Unknown_18 = new TagIdent("Unknown_18");
            public HaloTagType Unknown_19 = new HaloTagType("Unknown_19");
            public ByteInteger Unknown_2 = new ByteInteger("Unknown_2");
            public TagIdent Unknown_20 = new TagIdent("Unknown_20");
            public TagBlock Unknown_21 = new TagBlock("Unknown_21", Unknown_21_Layout.Layout, Map.HaloVersionEnum.Halo2);
            public ShortInteger Unknown_22 = new ShortInteger("Unknown_22");
            public ShortInteger Unknown_23 = new ShortInteger("Unknown_23");
            public RealFloat Unknown_24 = new RealFloat("Unknown_24");
            public HaloTagType Unknown_25 = new HaloTagType("Unknown_25");
            public TagIdent Unknown_26 = new TagIdent("Unknown_26");
            public HaloTagType Unknown_27 = new HaloTagType("Unknown_27");
            public TagIdent Unknown_28 = new TagIdent("Unknown_28");
            public ByteInteger Unknown_3 = new ByteInteger("Unknown_3");
            public ShortInteger Unknown_4 = new ShortInteger("Unknown_4");
            public RealFloat Unknown_5 = new RealFloat("Unknown_5");
            public RealFloat Unknown_6 = new RealFloat("Unknown_6");
            public RealFloat Unknown_7 = new RealFloat("Unknown_7");
            public HaloTagType Unknown_8 = new HaloTagType("Unknown_8");
            public TagIdent Unknown_9 = new TagIdent("Unknown_9");

            public Health_Shields_Layout()
            {
                base.Add(this.Unknown);
                base.Add(this.Unknown_0);
                base.Add(this.Unknown_1);
                base.Add(this.Padding);
                base.Add(this.Unknown_2);
                base.Add(this.Unknown_3);
                base.Add(this.Unknown_4);
                base.Add(this.Padding_0);
                base.Add(this.Health__no_shields_);
                base.Add(this.Padding_1);
                base.Add(this.Unknown_5);
                base.Add(this.Unknown_6);
                base.Add(this.Unknown_7);
                base.Add(this.Padding_2);
                base.Add(this.Unknown_8);
                base.Add(this.Unknown_9);
                base.Add(this.Unknown_10);
                base.Add(this.Unknown_11);
                base.Add(this.Shield);
                base.Add(this.Shield_Noise);
                base.Add(this.Unknown_12);
                base.Add(this.Shield_Recharge_Time);
                base.Add(this.Unknown_13);
                base.Add(this.Unknown_14);
                base.Add(this.Unknown_15);
                base.Add(this.Unknown_16);
                base.Add(this.Unknown_17);
                base.Add(this.Unknown_18);
                base.Add(this.Unknown_19);
                base.Add(this.Unknown_20);
                base.Add(this.Damage_Locations);
                base.Add(this.Unknown_21);
                base.Add(this.Unknown_22);
                base.Add(this.Unknown_23);
                base.Add(this.Shield_Recharge_Rate);
                base.Add(this.Unknown_24);
                base.Add(this.Seat_Protection);
                base.Add(this.Hinges);
                base.Add(this.Unknown_25);
                base.Add(this.Unknown_26);
                base.Add(this.Unknown_27);
                base.Add(this.Unknown_28);
            }

            public class Damage_Locations_Layout : TagBlockLayout
            {
                public RealFloat Damage_to_Activate = new RealFloat("Damage_to_Activate");
                public static readonly hlmt.Health_Shields_Layout.Damage_Locations_Layout Layout = new hlmt.Health_Shields_Layout.Damage_Locations_Layout();
                public StringID Name = new StringID("Name");
                public core.TagInterface.Padding Padding = new core.TagInterface.Padding("Padding", 0x10);
                public TagBlock Piece = new TagBlock("Piece", Piece_Layout.Layout, Map.HaloVersionEnum.Halo2);
                public LongInteger Unknown = new LongInteger("Unknown");
                public RealFloat Unknown_0 = new RealFloat("Unknown_0");
                public RealFloat Unknown_1 = new RealFloat("Unknown_1");
                public RealFloat Unknown_2 = new RealFloat("Unknown_2");
                public StringID Unknown_3 = new StringID("Unknown_3");
                public ShortInteger Unknown_4 = new ShortInteger("Unknown_4");
                public ShortInteger Unknown_5 = new ShortInteger("Unknown_5");

                public Damage_Locations_Layout()
                {
                    base.Add(this.Name);
                    base.Add(this.Unknown);
                    base.Add(this.Damage_to_Activate);
                    base.Add(this.Piece);
                    base.Add(this.Padding);
                    base.Add(this.Unknown_0);
                    base.Add(this.Unknown_1);
                    base.Add(this.Unknown_2);
                    base.Add(this.Unknown_3);
                    base.Add(this.Unknown_4);
                    base.Add(this.Unknown_5);
                }

                public class Piece_Layout : TagBlockLayout
                {
                    public RealFloat Damage_to_Activate = new RealFloat("Damage_to_Activate");
                    public static readonly hlmt.Health_Shields_Layout.Damage_Locations_Layout.Piece_Layout Layout = new hlmt.Health_Shields_Layout.Damage_Locations_Layout.Piece_Layout();
                    public StringID Location = new StringID("Location");
                    public ShortInteger Phase = new ShortInteger("Phase");
                    public ShortInteger Piece__Number_ = new ShortInteger("Piece__Number_");
                    public ShortInteger Unknown = new ShortInteger("Unknown");
                    public ShortInteger Unknown_0 = new ShortInteger("Unknown_0");
                    public LongInteger Unknown_1 = new LongInteger("Unknown_1");
                    public TagIdent Unknown_10 = new TagIdent("Unknown_10");
                    public StringID Unknown_11 = new StringID("Unknown_11");
                    public StringID Unknown_12 = new StringID("Unknown_12");
                    public StringID Unknown_13 = new StringID("Unknown_13");
                    public RealFloat Unknown_14 = new RealFloat("Unknown_14");
                    public StringID Unknown_15 = new StringID("Unknown_15");
                    public RealFloat Unknown_16 = new RealFloat("Unknown_16");
                    public HaloTagType Unknown_2 = new HaloTagType("Unknown_2");
                    public TagIdent Unknown_3 = new TagIdent("Unknown_3");
                    public HaloTagType Unknown_4 = new HaloTagType("Unknown_4");
                    public TagIdent Unknown_5 = new TagIdent("Unknown_5");
                    public StringID Unknown_6 = new StringID("Unknown_6");
                    public StringID Unknown_7 = new StringID("Unknown_7");
                    public RealFloat Unknown_8 = new RealFloat("Unknown_8");
                    public HaloTagType Unknown_9 = new HaloTagType("Unknown_9");

                    public Piece_Layout()
                    {
                        base.Add(this.Unknown);
                        base.Add(this.Unknown_0);
                        base.Add(this.Unknown_1);
                        base.Add(this.Damage_to_Activate);
                        base.Add(this.Unknown_2);
                        base.Add(this.Unknown_3);
                        base.Add(this.Unknown_4);
                        base.Add(this.Unknown_5);
                        base.Add(this.Location);
                        base.Add(this.Phase);
                        base.Add(this.Piece__Number_);
                        base.Add(this.Unknown_6);
                        base.Add(this.Unknown_7);
                        base.Add(this.Unknown_8);
                        base.Add(this.Unknown_9);
                        base.Add(this.Unknown_10);
                        base.Add(this.Unknown_11);
                        base.Add(this.Unknown_12);
                        base.Add(this.Unknown_13);
                        base.Add(this.Unknown_14);
                        base.Add(this.Unknown_15);
                        base.Add(this.Unknown_16);
                    }
                }
            }

            public class Hinges_Layout : TagBlockLayout
            {
                public static readonly hlmt.Health_Shields_Layout.Hinges_Layout Layout = new hlmt.Health_Shields_Layout.Hinges_Layout();
                public StringID Location = new StringID("Location");
                public StringID Name = new StringID("Name");
                public StringID Object_Affected = new StringID("Object_Affected");
                public RealFloat Unknown = new RealFloat("Unknown");
                public LongInteger Unknown_0 = new LongInteger("Unknown_0");

                public Hinges_Layout()
                {
                    base.Add(this.Name);
                    base.Add(this.Location);
                    base.Add(this.Object_Affected);
                    base.Add(this.Unknown);
                    base.Add(this.Unknown_0);
                }
            }

            public class Seat_Protection_Layout : TagBlockLayout
            {
                public static readonly hlmt.Health_Shields_Layout.Seat_Protection_Layout Layout = new hlmt.Health_Shields_Layout.Seat_Protection_Layout();
                public StringID Type = new StringID("Type");
                public RealFloat Unknown = new RealFloat("Unknown");
                public RealFloat Unknown_0 = new RealFloat("Unknown_0");
                public RealFloat Unknown_1 = new RealFloat("Unknown_1");
                public RealFloat Unknown_2 = new RealFloat("Unknown_2");

                public Seat_Protection_Layout()
                {
                    base.Add(this.Type);
                    base.Add(this.Unknown);
                    base.Add(this.Unknown_0);
                    base.Add(this.Unknown_1);
                    base.Add(this.Unknown_2);
                }
            }

            public class Unknown_21_Layout : TagBlockLayout
            {
                public static readonly hlmt.Health_Shields_Layout.Unknown_21_Layout Layout = new hlmt.Health_Shields_Layout.Unknown_21_Layout();
                public core.TagInterface.Padding Padding = new core.TagInterface.Padding("Padding", 12);
                public LongInteger Unknown = new LongInteger("Unknown");

                public Unknown_21_Layout()
                {
                    base.Add(this.Unknown);
                    base.Add(this.Padding);
                }
            }
        }

        public class Removeable_Parts_Layout : TagBlockLayout
        {
            public StringID Bone_Marker = new StringID("Bone_Marker");
            public static readonly hlmt.Removeable_Parts_Layout Layout = new hlmt.Removeable_Parts_Layout();
            public LongInteger Unknown = new LongInteger("Unknown");
            public LongInteger Unknown_0 = new LongInteger("Unknown_0");
            public LongInteger Unknown_1 = new LongInteger("Unknown_1");
            public LongInteger Unknown_10 = new LongInteger("Unknown_10");
            public LongInteger Unknown_11 = new LongInteger("Unknown_11");
            public LongInteger Unknown_12 = new LongInteger("Unknown_12");
            public LongInteger Unknown_13 = new LongInteger("Unknown_13");
            public LongInteger Unknown_14 = new LongInteger("Unknown_14");
            public LongInteger Unknown_15 = new LongInteger("Unknown_15");
            public LongInteger Unknown_16 = new LongInteger("Unknown_16");
            public LongInteger Unknown_17 = new LongInteger("Unknown_17");
            public LongInteger Unknown_18 = new LongInteger("Unknown_18");
            public LongInteger Unknown_19 = new LongInteger("Unknown_19");
            public LongInteger Unknown_2 = new LongInteger("Unknown_2");
            public LongInteger Unknown_20 = new LongInteger("Unknown_20");
            public LongInteger Unknown_3 = new LongInteger("Unknown_3");
            public LongInteger Unknown_4 = new LongInteger("Unknown_4");
            public LongInteger Unknown_5 = new LongInteger("Unknown_5");
            public LongInteger Unknown_6 = new LongInteger("Unknown_6");
            public LongInteger Unknown_7 = new LongInteger("Unknown_7");
            public RealFloat Unknown_8 = new RealFloat("Unknown_8");
            public LongInteger Unknown_9 = new LongInteger("Unknown_9");

            public Removeable_Parts_Layout()
            {
                base.Add(this.Bone_Marker);
                base.Add(this.Unknown);
                base.Add(this.Unknown_0);
                base.Add(this.Unknown_1);
                base.Add(this.Unknown_2);
                base.Add(this.Unknown_3);
                base.Add(this.Unknown_4);
                base.Add(this.Unknown_5);
                base.Add(this.Unknown_6);
                base.Add(this.Unknown_7);
                base.Add(this.Unknown_8);
                base.Add(this.Unknown_9);
                base.Add(this.Unknown_10);
                base.Add(this.Unknown_11);
                base.Add(this.Unknown_12);
                base.Add(this.Unknown_13);
                base.Add(this.Unknown_14);
                base.Add(this.Unknown_15);
                base.Add(this.Unknown_16);
                base.Add(this.Unknown_17);
                base.Add(this.Unknown_18);
                base.Add(this.Unknown_19);
                base.Add(this.Unknown_20);
            }
        }

        public class Unknown_17_Layout : TagBlockLayout
        {
            public static readonly hlmt.Unknown_17_Layout Layout = new hlmt.Unknown_17_Layout();
            public StringID Unknown = new StringID("Unknown");
            public LongInteger Unknown_0 = new LongInteger("Unknown_0");
            public RealFloat Unknown_1 = new RealFloat("Unknown_1");
            public StringID Unknown_2 = new StringID("Unknown_2");
            public LongInteger Unknown_3 = new LongInteger("Unknown_3");

            public Unknown_17_Layout()
            {
                base.Add(this.Unknown);
                base.Add(this.Unknown_0);
                base.Add(this.Unknown_1);
                base.Add(this.Unknown_2);
                base.Add(this.Unknown_3);
            }
        }

        public class Unknown_18_Layout : TagBlockLayout
        {
            public static readonly hlmt.Unknown_18_Layout Layout = new hlmt.Unknown_18_Layout();
            public LongInteger Unknown = new LongInteger("Unknown");
            public LongInteger Unknown_0 = new LongInteger("Unknown_0");
            public LongInteger Unknown_1 = new LongInteger("Unknown_1");
            public LongInteger Unknown_2 = new LongInteger("Unknown_2");
            public LongInteger Unknown_3 = new LongInteger("Unknown_3");

            public Unknown_18_Layout()
            {
                base.Add(this.Unknown);
                base.Add(this.Unknown_0);
                base.Add(this.Unknown_1);
                base.Add(this.Unknown_2);
                base.Add(this.Unknown_3);
            }
        }

        public class Variation_Layout : TagBlockLayout
        {
            public static readonly hlmt.Variation_Layout Layout = new hlmt.Variation_Layout();
            public StringID Name = new StringID("Name");
            public core.TagInterface.Padding Padding = new core.TagInterface.Padding("Padding", 8);
            public TagBlock Piece = new TagBlock("Piece", Piece_Layout.Layout, Map.HaloVersionEnum.Halo2);
            public LongInteger Unknown = new LongInteger("Unknown");
            public LongInteger Unknown_0 = new LongInteger("Unknown_0");
            public LongInteger Unknown_1 = new LongInteger("Unknown_1");
            public RealFloat Unknown_2 = new RealFloat("Unknown_2");
            public TagBlock Unknown_3 = new TagBlock("Unknown_3", Unknown_3_Layout.Layout, Map.HaloVersionEnum.Halo2);
            public StringID Unknown_4 = new StringID("Unknown_4");
            public HaloTagType Unknown_5 = new HaloTagType("Unknown_5");
            public TagIdent Unknown_6 = new TagIdent("Unknown_6");

            public Variation_Layout()
            {
                base.Add(this.Name);
                base.Add(this.Unknown);
                base.Add(this.Unknown_0);
                base.Add(this.Unknown_1);
                base.Add(this.Unknown_2);
                base.Add(this.Piece);
                base.Add(this.Unknown_3);
                base.Add(this.Padding);
                base.Add(this.Unknown_4);
                base.Add(this.Unknown_5);
                base.Add(this.Unknown_6);
            }

            public class Piece_Layout : TagBlockLayout
            {
                public static readonly hlmt.Variation_Layout.Piece_Layout Layout = new hlmt.Variation_Layout.Piece_Layout();
                public StringID Name = new StringID("Name");
                public core.TagInterface.Padding Padding = new core.TagInterface.Padding("Padding", 4);
                public TagBlock Permutation = new TagBlock("Permutation", Permutation_Layout.Layout, Map.HaloVersionEnum.Halo2);
                public ShortInteger Region_Index = new ShortInteger("Region_Index");
                public ShortInteger Unknown1 = new ShortInteger("Unknown1");

                public Piece_Layout()
                {
                    base.Add(this.Name);
                    base.Add(this.Region_Index);
                    base.Add(this.Unknown1);
                    base.Add(this.Permutation);
                    base.Add(this.Padding);
                }

                public class Permutation_Layout : TagBlockLayout
                {
                    public static readonly hlmt.Variation_Layout.Piece_Layout.Permutation_Layout Layout = new hlmt.Variation_Layout.Piece_Layout.Permutation_Layout();
                    public StringID Name = new StringID("Name");
                    public core.TagInterface.Padding Padding = new core.TagInterface.Padding("Padding", 12);
                    public TagBlock Permutation = new TagBlock("Permutation", Permutation_Layout1.Layout, Map.HaloVersionEnum.Halo2);
                    public ByteInteger Permutation_Index = new ByteInteger("Permutation_index");
                    public LongInteger Unknown_0 = new LongInteger("Unknown_0");
                    public ByteInteger unknown1 = new ByteInteger("unknown1");
                    public ByteInteger unknown2 = new ByteInteger("unknown1");
                    public ByteInteger unknown3 = new ByteInteger("unknown1");

                    public Permutation_Layout()
                    {
                        base.Add(this.Name);
                        base.Add(this.Permutation_Index);
                        base.Add(this.unknown1);
                        base.Add(this.unknown2);
                        base.Add(this.unknown3);
                        base.Add(this.Unknown_0);
                        base.Add(this.Permutation);
                        base.Add(this.Padding);
                    }

                    public class Permutation_Layout1 : TagBlockLayout
                    {
                        public static readonly hlmt.Variation_Layout.Piece_Layout.Permutation_Layout.Permutation_Layout1 Layout = new hlmt.Variation_Layout.Piece_Layout.Permutation_Layout.Permutation_Layout1();
                        public StringID Name = new StringID("Name");
                        public ByteInteger Permutation_Index = new ByteInteger("Permutation_index");
                        public HaloTagType Unknown_0 = new HaloTagType("Unknown_0");
                        public TagIdent Unknown_1 = new TagIdent("Unknown_1");
                        public StringID Unknown_2 = new StringID("Unknown_2");
                        public RealFloat Unknown_3 = new RealFloat("Unknown_3");
                        public ByteInteger unknown1 = new ByteInteger("unknown1");
                        public ByteInteger unknown2 = new ByteInteger("unknown1");
                        public ByteInteger unknown3 = new ByteInteger("unknown1");

                        public Permutation_Layout1()
                        {
                            base.Add(this.Name);
                            base.Add(this.Permutation_Index);
                            base.Add(this.unknown1);
                            base.Add(this.unknown2);
                            base.Add(this.unknown3);
                            base.Add(this.Unknown_0);
                            base.Add(this.Unknown_1);
                            base.Add(this.Unknown_2);
                            base.Add(this.Unknown_3);
                        }
                    }
                }
            }

            public class Unknown_3_Layout : TagBlockLayout
            {
                public static readonly hlmt.Variation_Layout.Unknown_3_Layout Layout = new hlmt.Variation_Layout.Unknown_3_Layout();
                public StringID Unknown = new StringID("Unknown");
                public StringID Unknown_0 = new StringID("Unknown_0");
                public HaloTagType Unknown_1 = new HaloTagType("Unknown_1");
                public TagIdent Unknown_2 = new TagIdent("Unknown_2");

                public Unknown_3_Layout()
                {
                    base.Add(this.Unknown);
                    base.Add(this.Unknown_0);
                    base.Add(this.Unknown_1);
                    base.Add(this.Unknown_2);
                }
            }
        }
    }
}

