﻿namespace core.H2
{
    using core.TagInterface;
    using System;

    public class scen : TagBlockLayout
    {
        public RealFloat Bounding_Radius = new RealFloat("Bounding_Radius");
        public HaloTagType Creation_Effect = new HaloTagType("Creation_Effect");
        public TagIdent Creation_Effect_0 = new TagIdent("Creation_Effect_0");
        public StringID Default_Permutation = new StringID("Default_Permutation");
        public core.TagInterface.Flags Flags = new core.TagInterface.Flags("Flags", core.TagInterface.Flags.BitmaskTypeEnum.Long);
        public static readonly scen Layout = new scen();
        public HaloTagType Object_Properties = new HaloTagType("Object_Properties");
        public TagIdent Object_Properties_0 = new TagIdent("Object_Properties_0");
        public core.TagInterface.Padding Padding = new core.TagInterface.Padding("Padding", 4);
        public core.TagInterface.Padding Padding_0 = new core.TagInterface.Padding("Padding", 8);
        public TagBlock Predicted_Resource = new TagBlock("Predicted_Resource", Predicted_Resource_Layout.Layout, Map.HaloVersionEnum.Halo2);
        public LongInteger Unknown = new LongInteger("Unknown");
        public LongInteger Unknown_0 = new LongInteger("Unknown_0");
        public LongInteger Unknown_1 = new LongInteger("Unknown_1");
        public RealFloat Unknown_10 = new RealFloat("Unknown_10");
        public RealFloat Unknown_11 = new RealFloat("Unknown_11");
        public RealFloat Unknown_12 = new RealFloat("Unknown_12");
        public RealFloat Unknown_13 = new RealFloat("Unknown_13");
        public RealFloat Unknown_14 = new RealFloat("Unknown_14");
        public RealFloat Unknown_15 = new RealFloat("Unknown_15");
        public RealFloat Unknown_16 = new RealFloat("Unknown_16");
        public RealFloat Unknown_17 = new RealFloat("Unknown_17");
        public LongInteger Unknown_18 = new LongInteger("Unknown_18");
        public LongInteger Unknown_19 = new LongInteger("Unknown_19");
        public RealFloat Unknown_2 = new RealFloat("Unknown_2");
        public LongInteger Unknown_3 = new LongInteger("Unknown_3");
        public LongInteger Unknown_4 = new LongInteger("Unknown_4");
        public RealFloat Unknown_5 = new RealFloat("Unknown_5");
        public RealFloat Unknown_6 = new RealFloat("Unknown_6");
        public RealFloat Unknown_7 = new RealFloat("Unknown_7");
        public RealFloat Unknown_8 = new RealFloat("Unknown_8");
        public RealFloat Unknown_9 = new RealFloat("Unknown_9");
        public TagBlock Unknown26 = new TagBlock("Unknown26", Unknown26_Layout.Layout, Map.HaloVersionEnum.Halo2);
        public TagBlock Unknown31 = new TagBlock("Unknown31", Unknown31_Layout.Layout, Map.HaloVersionEnum.Halo2);
        public TagBlock Unknown52 = new TagBlock("Unknown52", Unknown52_Layout.Layout, Map.HaloVersionEnum.Halo2);
        public TagBlock Unknown60 = new TagBlock("Unknown60", Unknown60_Layout.Layout, Map.HaloVersionEnum.Halo2);
        public TagBlock Unknown65 = new TagBlock("Unknown65", Unknown65_Layout.Layout, Map.HaloVersionEnum.Halo2);
        public HaloTagType Unused = new HaloTagType("Unused");
        public TagIdent Unused_0 = new TagIdent("Unused_0");
        public HaloTagType Unused_1 = new HaloTagType("Unused_1");
        public TagIdent Unused_2 = new TagIdent("Unused_2");
        public HaloTagType Unused_3 = new HaloTagType("Unused_3");
        public TagIdent Unused_4 = new TagIdent("Unused_4");

        public scen()
        {
            base.Add(this.Flags);
            base.Add(this.Bounding_Radius);
            base.Add(this.Unknown);
            base.Add(this.Unknown_0);
            base.Add(this.Unknown_1);
            base.Add(this.Unknown_2);
            base.Add(this.Unknown_3);
            base.Add(this.Unknown_4);
            base.Add(this.Unknown_5);
            base.Add(this.Unknown_6);
            base.Add(this.Unknown_7);
            base.Add(this.Unknown_8);
            base.Add(this.Default_Permutation);
            base.Add(this.Object_Properties);
            base.Add(this.Object_Properties_0);
            base.Add(this.Unused);
            base.Add(this.Unused_0);
            base.Add(this.Unused_1);
            base.Add(this.Unused_2);
            base.Add(this.Creation_Effect);
            base.Add(this.Creation_Effect_0);
            base.Add(this.Unused_3);
            base.Add(this.Unused_4);
            base.Add(this.Unknown26);
            base.Add(this.Unknown31);
            base.Add(this.Unknown_9);
            base.Add(this.Unknown_10);
            base.Add(this.Unknown_11);
            base.Add(this.Unknown_12);
            base.Add(this.Unknown_13);
            base.Add(this.Unknown_14);
            base.Add(this.Unknown_15);
            base.Add(this.Unknown_16);
            base.Add(this.Unknown_17);
            base.Add(this.Padding);
            base.Add(this.Unknown52);
            base.Add(this.Unknown60);
            base.Add(this.Padding_0);
            base.Add(this.Unknown65);
            base.Add(this.Predicted_Resource);
            base.Add(this.Unknown_18);
            base.Add(this.Unknown_19);
        }

        public class Predicted_Resource_Layout : TagBlockLayout
        {
            public static readonly scen.Predicted_Resource_Layout Layout = new scen.Predicted_Resource_Layout();
            public TagIdent Resource = new TagIdent("Resource");
            public ShortInteger Resource_Index = new ShortInteger("Resource_Index");
            public ShortInteger Tag_Index = new ShortInteger("Tag_Index");

            public Predicted_Resource_Layout()
            {
                base.Add(this.Resource_Index);
                base.Add(this.Tag_Index);
                base.Add(this.Resource);
            }
        }

        public class Unknown26_Layout : TagBlockLayout
        {
            public static readonly scen.Unknown26_Layout Layout = new scen.Unknown26_Layout();
            public core.TagInterface.Padding Padding = new core.TagInterface.Padding("Padding", 8);
            public LongInteger Unknown = new LongInteger("Unknown");
            public LongInteger Unknown_0 = new LongInteger("Unknown_0");

            public Unknown26_Layout()
            {
                base.Add(this.Unknown);
                base.Add(this.Padding);
                base.Add(this.Unknown_0);
            }
        }

        public class Unknown31_Layout : TagBlockLayout
        {
            public static readonly scen.Unknown31_Layout Layout = new scen.Unknown31_Layout();
            public core.TagInterface.Padding Padding = new core.TagInterface.Padding("Padding", 4);
            public LongInteger Unknown = new LongInteger("Unknown");
            public StringID Unknown_0 = new StringID("Unknown_0");
            public StringID Unknown_1 = new StringID("Unknown_1");
            public StringID Unknown_2 = new StringID("Unknown_2");
            public StringID Unknown_3 = new StringID("Unknown_3");
            public TagBlock Unknown37 = new TagBlock("Unknown37", Unknown37_Layout.Layout, Map.HaloVersionEnum.Halo2);

            public Unknown31_Layout()
            {
                base.Add(this.Unknown);
                base.Add(this.Unknown_0);
                base.Add(this.Unknown_1);
                base.Add(this.Unknown_2);
                base.Add(this.Padding);
                base.Add(this.Unknown37);
                base.Add(this.Unknown_3);
            }

            public class Unknown37_Layout : TagBlockLayout
            {
                public static readonly scen.Unknown31_Layout.Unknown37_Layout Layout = new scen.Unknown31_Layout.Unknown37_Layout();
                public ByteInteger Unknown = new ByteInteger("Unknown");

                public Unknown37_Layout()
                {
                    base.Add(this.Unknown);
                }
            }
        }

        public class Unknown52_Layout : TagBlockLayout
        {
            public static readonly scen.Unknown52_Layout Layout = new scen.Unknown52_Layout();
            public core.TagInterface.Padding Padding = new core.TagInterface.Padding("Padding", 4);
            public core.TagInterface.Padding Padding_0 = new core.TagInterface.Padding("Padding", 4);
            public HaloTagType Unknown = new HaloTagType("Unknown");
            public TagIdent Unknown_0 = new TagIdent("Unknown_0");
            public StringID Unknown_1 = new StringID("Unknown_1");
            public StringID Unknown_2 = new StringID("Unknown_2");

            public Unknown52_Layout()
            {
                base.Add(this.Unknown);
                base.Add(this.Unknown_0);
                base.Add(this.Unknown_1);
                base.Add(this.Padding);
                base.Add(this.Unknown_2);
                base.Add(this.Padding_0);
            }
        }

        public class Unknown60_Layout : TagBlockLayout
        {
            public static readonly scen.Unknown60_Layout Layout = new scen.Unknown60_Layout();
            public HaloTagType Unknown = new HaloTagType("Unknown");
            public TagIdent Unknown_0 = new TagIdent("Unknown_0");

            public Unknown60_Layout()
            {
                base.Add(this.Unknown);
                base.Add(this.Unknown_0);
            }
        }

        public class Unknown65_Layout : TagBlockLayout
        {
            public static readonly scen.Unknown65_Layout Layout = new scen.Unknown65_Layout();
            public core.TagInterface.Padding Padding = new core.TagInterface.Padding("Padding", 8);
            public TagBlock Unknown66 = new TagBlock("Unknown66", Unknown66_Layout.Layout, Map.HaloVersionEnum.Halo2);

            public Unknown65_Layout()
            {
                base.Add(this.Unknown66);
                base.Add(this.Padding);
            }

            public class Unknown66_Layout : TagBlockLayout
            {
                public static readonly scen.Unknown65_Layout.Unknown66_Layout Layout = new scen.Unknown65_Layout.Unknown66_Layout();
                public RealFloat Unknown = new RealFloat("Unknown");
                public RealFloat Unknown_0 = new RealFloat("Unknown_0");
                public RealFloat Unknown_1 = new RealFloat("Unknown_1");
                public RealFloat Unknown_2 = new RealFloat("Unknown_2");
                public RealFloat Unknown_3 = new RealFloat("Unknown_3");
                public RealFloat Unknown_4 = new RealFloat("Unknown_4");
                public RealFloat Unknown_5 = new RealFloat("Unknown_5");
                public StringID Unknown_6 = new StringID("Unknown_6");

                public Unknown66_Layout()
                {
                    base.Add(this.Unknown);
                    base.Add(this.Unknown_0);
                    base.Add(this.Unknown_1);
                    base.Add(this.Unknown_2);
                    base.Add(this.Unknown_3);
                    base.Add(this.Unknown_4);
                    base.Add(this.Unknown_5);
                    base.Add(this.Unknown_6);
                }
            }
        }
    }
}

