﻿namespace core.H2
{
    using core.TagInterface;
    using System;

    public class shad : TagBlockLayout
    {
        public RealFloat Diffuse_Level = new RealFloat("Diffuse_Level");
        public static readonly shad Layout = new shad();
        public StringID Material_Type = new StringID("Material_Type");
        public core.TagInterface.Padding Padding = new core.TagInterface.Padding("Padding", 8);
        public core.TagInterface.Padding Padding_0 = new core.TagInterface.Padding("Padding", 4);
        public core.TagInterface.Padding Padding_1 = new core.TagInterface.Padding("Padding", 4);
        public core.TagInterface.Padding Padding_2 = new core.TagInterface.Padding("Padding", 8);
        public TagBlock Resources = new TagBlock("Resources", Resources_Layout.Layout, Map.HaloVersionEnum.Halo2);
        public TagBlock Self_Illumination_Properties = new TagBlock("Self_Illumination_Properties", Self_Illumination_Properties_Layout.Layout, Map.HaloVersionEnum.Halo2);
        public TagIdent Shader_Template = new TagIdent("Shader_Template");
        public RealFloat Specularity = new RealFloat("Specularity");
        public ShortInteger type = new ShortInteger("type");
        public HaloTagType Unknown = new HaloTagType("Unknown");
        public ShortInteger Unknown_0 = new ShortInteger("Unknown_0");
        public TagBlock Unknown_1 = new TagBlock("Unknown_1", Unknown_1_Layout.Layout, Map.HaloVersionEnum.Halo2);
        public ByteInteger Unknown_2 = new ByteInteger("Unknown_2");
        public ByteInteger Unknown_3 = new ByteInteger("Unknown_3");
        public ByteInteger Unknown_4 = new ByteInteger("Unknown_4");
        public ByteInteger Unknown_5 = new ByteInteger("Unknown_5");
        public ShortInteger Unknown1 = new ShortInteger("Unknown1");
        public ShortInteger Unknown2 = new ShortInteger("Unknown2");
        public ShortInteger Unknown3 = new ShortInteger("Unknown3");
        public ShortInteger Unknown4 = new ShortInteger("Unknown4");

        public shad()
        {
            base.Add(this.Unknown);
            base.Add(this.Shader_Template);
            base.Add(this.Material_Type);
            base.Add(this.Self_Illumination_Properties);
            base.Add(this.type);
            base.Add(this.Unknown_0);
            base.Add(this.Padding);
            base.Add(this.Unknown_1);
            base.Add(this.Padding_0);
            base.Add(this.Resources);
            base.Add(this.Unknown_2);
            base.Add(this.Unknown_3);
            base.Add(this.Unknown_4);
            base.Add(this.Unknown_5);
            base.Add(this.Padding_1);
            base.Add(this.Unknown1);
            base.Add(this.Unknown2);
            base.Add(this.Unknown3);
            base.Add(this.Unknown4);
            base.Add(this.Specularity);
            base.Add(this.Diffuse_Level);
            base.Add(this.Padding_2);
        }

        public class Resources_Layout : TagBlockLayout
        {
            public TagIdent Bitmap_Used = new TagIdent("Bitmap_Used");
            public static readonly shad.Resources_Layout Layout = new shad.Resources_Layout();
            public LongInteger Unknown = new LongInteger("Unknown");

            public Resources_Layout()
            {
                base.Add(this.Unknown);
                base.Add(this.Bitmap_Used);
            }
        }

        public class Self_Illumination_Properties_Layout : TagBlockLayout
        {
            public HaloTagType Base_Map = new HaloTagType("Base_Map");
            public TagIdent Base_Map_0 = new TagIdent("Base_Map_0");
            public static readonly shad.Self_Illumination_Properties_Layout Layout = new shad.Self_Illumination_Properties_Layout();
            public core.TagInterface.Padding Padding = new core.TagInterface.Padding("Padding", 4);
            public core.TagInterface.Padding Padding_0 = new core.TagInterface.Padding("Padding", 4);
            public RealFloat Primary_On_Colour_Blue = new RealFloat("Primary_On_Colour_Blue");
            public RealFloat Primary_On_Colour_Brightness = new RealFloat("Primary_On_Colour_Brightness");
            public RealFloat Primary_On_Colour_Green = new RealFloat("Primary_On_Colour_Green");
            public RealFloat Primary_On_Colour_Red = new RealFloat("Primary_On_Colour_Red");
            public RealFloat Secondary_On_Colour_Blue = new RealFloat("Secondary_On_Colour_Blue");
            public RealFloat Secondary_On_Colour_Brightness = new RealFloat("Secondary_On_Colour_Brightness");
            public RealFloat Secondary_On_Colour_Green = new RealFloat("Secondary_On_Colour_Green");
            public RealFloat Secondary_On_Colour_Red = new RealFloat("Secondary_On_Colour_Red");
            public HaloTagType Secondary_Self_Illumination_Map = new HaloTagType("Secondary_Self_Illumination_Map");
            public TagIdent Secondary_Self_Illumination_Map_0 = new TagIdent("Secondary_Self_Illumination_Map_0");
            public HaloTagType Self_Illumination_Map = new HaloTagType("Self_Illumination_Map");
            public TagIdent Self_Illumination_Map_0 = new TagIdent("Self_Illumination_Map_0");
            public RealFloat Unknown = new RealFloat("Unknown");
            public HaloTagType Unknown_0 = new HaloTagType("Unknown_0");
            public TagIdent Unknown_1 = new TagIdent("Unknown_1");
            public RealFloat Unknown_2 = new RealFloat("Unknown_2");

            public Self_Illumination_Properties_Layout()
            {
                base.Add(this.Base_Map);
                base.Add(this.Base_Map_0);
                base.Add(this.Self_Illumination_Map);
                base.Add(this.Self_Illumination_Map_0);
                base.Add(this.Primary_On_Colour_Red);
                base.Add(this.Primary_On_Colour_Blue);
                base.Add(this.Primary_On_Colour_Green);
                base.Add(this.Primary_On_Colour_Brightness);
                base.Add(this.Padding);
                base.Add(this.Unknown);
                base.Add(this.Padding_0);
                base.Add(this.Unknown_0);
                base.Add(this.Unknown_1);
                base.Add(this.Secondary_Self_Illumination_Map);
                base.Add(this.Secondary_Self_Illumination_Map_0);
                base.Add(this.Secondary_On_Colour_Red);
                base.Add(this.Secondary_On_Colour_Blue);
                base.Add(this.Secondary_On_Colour_Green);
                base.Add(this.Secondary_On_Colour_Brightness);
                base.Add(this.Unknown_2);
            }
        }

        public class Unknown_1_Layout : TagBlockLayout
        {
            public TagBlock Detail_Tiling_Faloff_Colours = new TagBlock("Detail_Tiling_Faloff_Colours", Detail_Tiling_Faloff_Colours_Layout.Layout, Map.HaloVersionEnum.Halo2);
            public static readonly shad.Unknown_1_Layout Layout = new shad.Unknown_1_Layout();
            public core.TagInterface.Padding Padding = new core.TagInterface.Padding("Padding", 8);
            public TagBlock Radiosity_Properties_1st_chunk_colour_of_emitted_light_second_chunk_tint_colour = new TagBlock("Radiosity_Properties_1st_chunk_colour_of_emitted_light_second_chunk_tint_colour", Radiosity_Properties_1st_chunk_colour_of_emitted_light_second_chunk_tint_colour_Layout.Layout, Map.HaloVersionEnum.Halo2);
            public TagIdent Unknown = new TagIdent("Unknown");
            public TagBlock Unknown_0 = new TagBlock("Unknown_0", Unknown_0_Layout.Layout, Map.HaloVersionEnum.Halo2);
            public TagBlock Unknown_1 = new TagBlock("Unknown_1", Unknown_1_Layout1.Layout, Map.HaloVersionEnum.Halo2);
            public TagBlock Unknown_10 = new TagBlock("Unknown_10", Unknown_10_Layout.Layout, Map.HaloVersionEnum.Halo2);
            public TagBlock Unknown_11 = new TagBlock("Unknown_11", Unknown_11_Layout.Layout, Map.HaloVersionEnum.Halo2);
            public TagBlock Unknown_2 = new TagBlock("Unknown_2", Unknown_2_Layout.Layout, Map.HaloVersionEnum.Halo2);
            public TagBlock Unknown_3 = new TagBlock("Unknown_3", Unknown_3_Layout.Layout, Map.HaloVersionEnum.Halo2);
            public TagBlock Unknown_4 = new TagBlock("Unknown_4", Unknown_4_Layout.Layout, Map.HaloVersionEnum.Halo2);
            public TagBlock Unknown_5 = new TagBlock("Unknown_5", Unknown_5_Layout.Layout, Map.HaloVersionEnum.Halo2);
            public TagBlock Unknown_6 = new TagBlock("Unknown_6", Unknown_6_Layout.Layout, Map.HaloVersionEnum.Halo2);
            public TagBlock Unknown_7 = new TagBlock("Unknown_7", Unknown_7_Layout.Layout, Map.HaloVersionEnum.Halo2);
            public TagBlock Unknown_8 = new TagBlock("Unknown_8", Unknown_8_Layout.Layout, Map.HaloVersionEnum.Halo2);
            public TagBlock Unknown_9 = new TagBlock("Unknown_9", Unknown_9_Layout.Layout, Map.HaloVersionEnum.Halo2);

            public Unknown_1_Layout()
            {
                base.Add(this.Unknown);
                base.Add(this.Unknown_0);
                base.Add(this.Unknown_1);
                base.Add(this.Detail_Tiling_Faloff_Colours);
                base.Add(this.Unknown_2);
                base.Add(this.Unknown_3);
                base.Add(this.Unknown_4);
                base.Add(this.Unknown_5);
                base.Add(this.Unknown_6);
                base.Add(this.Unknown_7);
                base.Add(this.Unknown_8);
                base.Add(this.Unknown_9);
                base.Add(this.Unknown_10);
                base.Add(this.Radiosity_Properties_1st_chunk_colour_of_emitted_light_second_chunk_tint_colour);
                base.Add(this.Unknown_11);
                base.Add(this.Padding);
            }

            public class Detail_Tiling_Faloff_Colours_Layout : TagBlockLayout
            {
                public RealFloat Color_Green_V_tiling = new RealFloat("Color_Green_V_tiling");
                public static readonly shad.Unknown_1_Layout.Detail_Tiling_Faloff_Colours_Layout Layout = new shad.Unknown_1_Layout.Detail_Tiling_Faloff_Colours_Layout();
                public RealFloat U_Tiling_Red_Colour = new RealFloat("U_Tiling_Red_Colour");
                public RealFloat Unknown = new RealFloat("Unknown");
                public RealFloat W_Tiling_Blue_Colour = new RealFloat("W_Tiling_Blue_Colour");

                public Detail_Tiling_Faloff_Colours_Layout()
                {
                    base.Add(this.U_Tiling_Red_Colour);
                    base.Add(this.Color_Green_V_tiling);
                    base.Add(this.W_Tiling_Blue_Colour);
                    base.Add(this.Unknown);
                }
            }

            public class Radiosity_Properties_1st_chunk_colour_of_emitted_light_second_chunk_tint_colour_Layout : TagBlockLayout
            {
                public RealFloat B = new RealFloat("B");
                public RealFloat G = new RealFloat("G");
                public static readonly shad.Unknown_1_Layout.Radiosity_Properties_1st_chunk_colour_of_emitted_light_second_chunk_tint_colour_Layout Layout = new shad.Unknown_1_Layout.Radiosity_Properties_1st_chunk_colour_of_emitted_light_second_chunk_tint_colour_Layout();
                public RealFloat R = new RealFloat("R");

                public Radiosity_Properties_1st_chunk_colour_of_emitted_light_second_chunk_tint_colour_Layout()
                {
                    base.Add(this.R);
                    base.Add(this.G);
                    base.Add(this.B);
                }
            }

            public class Unknown_0_Layout : TagBlockLayout
            {
                public static readonly shad.Unknown_1_Layout.Unknown_0_Layout Layout = new shad.Unknown_1_Layout.Unknown_0_Layout();
                public TagIdent Unknown = new TagIdent("Unknown");
                public LongInteger Unknown_0 = new LongInteger("Unknown_0");
                public RealFloat Unknown_1 = new RealFloat("Unknown_1");

                public Unknown_0_Layout()
                {
                    base.Add(this.Unknown);
                    base.Add(this.Unknown_0);
                    base.Add(this.Unknown_1);
                }
            }

            public class Unknown_1_Layout1 : TagBlockLayout
            {
                public static readonly shad.Unknown_1_Layout.Unknown_1_Layout1 Layout = new shad.Unknown_1_Layout.Unknown_1_Layout1();
                public LongInteger Unknown = new LongInteger("Unknown");

                public Unknown_1_Layout1()
                {
                    base.Add(this.Unknown);
                }
            }

            public class Unknown_10_Layout : TagBlockLayout
            {
                public static readonly shad.Unknown_1_Layout.Unknown_10_Layout Layout = new shad.Unknown_1_Layout.Unknown_10_Layout();
                public LongInteger Unknown = new LongInteger("Unknown");

                public Unknown_10_Layout()
                {
                    base.Add(this.Unknown);
                }
            }

            public class Unknown_11_Layout : TagBlockLayout
            {
                public static readonly shad.Unknown_1_Layout.Unknown_11_Layout Layout = new shad.Unknown_1_Layout.Unknown_11_Layout();
                public RealFloat Unknown = new RealFloat("Unknown");

                public Unknown_11_Layout()
                {
                    base.Add(this.Unknown);
                }
            }

            public class Unknown_2_Layout : TagBlockLayout
            {
                public static readonly shad.Unknown_1_Layout.Unknown_2_Layout Layout = new shad.Unknown_1_Layout.Unknown_2_Layout();
                public LongInteger Unknown = new LongInteger("Unknown");
                public LongInteger Unknown_0 = new LongInteger("Unknown_0");

                public Unknown_2_Layout()
                {
                    base.Add(this.Unknown);
                    base.Add(this.Unknown_0);
                }
            }

            public class Unknown_3_Layout : TagBlockLayout
            {
                public static readonly shad.Unknown_1_Layout.Unknown_3_Layout Layout = new shad.Unknown_1_Layout.Unknown_3_Layout();
                public ShortInteger Unknown = new ShortInteger("Unknown");

                public Unknown_3_Layout()
                {
                    base.Add(this.Unknown);
                }
            }

            public class Unknown_4_Layout : TagBlockLayout
            {
                public static readonly shad.Unknown_1_Layout.Unknown_4_Layout Layout = new shad.Unknown_1_Layout.Unknown_4_Layout();
                public LongInteger Unknown = new LongInteger("Unknown");

                public Unknown_4_Layout()
                {
                    base.Add(this.Unknown);
                }
            }

            public class Unknown_5_Layout : TagBlockLayout
            {
                public static readonly shad.Unknown_1_Layout.Unknown_5_Layout Layout = new shad.Unknown_1_Layout.Unknown_5_Layout();
                public LongInteger Unknown = new LongInteger("Unknown");
                public LongInteger Unknown_0 = new LongInteger("Unknown_0");
                public LongInteger Unknown_1 = new LongInteger("Unknown_1");

                public Unknown_5_Layout()
                {
                    base.Add(this.Unknown);
                    base.Add(this.Unknown_0);
                    base.Add(this.Unknown_1);
                }
            }

            public class Unknown_6_Layout : TagBlockLayout
            {
                public static readonly shad.Unknown_1_Layout.Unknown_6_Layout Layout = new shad.Unknown_1_Layout.Unknown_6_Layout();
                public StringID Unknown = new StringID("Unknown");
                public StringID Unknown_0 = new StringID("Unknown_0");
                public RealFloat Unknown_1 = new RealFloat("Unknown_1");
                public TagBlock Unknown_2 = new TagBlock("Unknown_2", Unknown_2_Layout.Layout, Map.HaloVersionEnum.Halo2);

                public Unknown_6_Layout()
                {
                    base.Add(this.Unknown);
                    base.Add(this.Unknown_0);
                    base.Add(this.Unknown_1);
                    base.Add(this.Unknown_2);
                }

                public class Unknown_2_Layout : TagBlockLayout
                {
                    public static readonly shad.Unknown_1_Layout.Unknown_6_Layout.Unknown_2_Layout Layout = new shad.Unknown_1_Layout.Unknown_6_Layout.Unknown_2_Layout();
                    public ByteInteger Unknown = new ByteInteger("Unknown");

                    public Unknown_2_Layout()
                    {
                        base.Add(this.Unknown);
                    }
                }
            }

            public class Unknown_7_Layout : TagBlockLayout
            {
                public static readonly shad.Unknown_1_Layout.Unknown_7_Layout Layout = new shad.Unknown_1_Layout.Unknown_7_Layout();
                public LongInteger Unknown = new LongInteger("Unknown");

                public Unknown_7_Layout()
                {
                    base.Add(this.Unknown);
                }
            }

            public class Unknown_8_Layout : TagBlockLayout
            {
                public static readonly shad.Unknown_1_Layout.Unknown_8_Layout Layout = new shad.Unknown_1_Layout.Unknown_8_Layout();
                public LongInteger Unknown = new LongInteger("Unknown");

                public Unknown_8_Layout()
                {
                    base.Add(this.Unknown);
                }
            }

            public class Unknown_9_Layout : TagBlockLayout
            {
                public static readonly shad.Unknown_1_Layout.Unknown_9_Layout Layout = new shad.Unknown_1_Layout.Unknown_9_Layout();
                public LongInteger Unknown = new LongInteger("Unknown");

                public Unknown_9_Layout()
                {
                    base.Add(this.Unknown);
                }
            }
        }
    }
}

