﻿namespace core.H2
{
    using core.TagInterface;
    using System;

    public class vehc : TagBlockLayout
    {
        public static readonly vehc Layout = new vehc();
        public LongInteger Spawn_Time = new LongInteger("Unused_Spawn_Time_____in_seconds,_0_=_default_");
        public TagBlock Vehicle_Permutations = new TagBlock("Vehicle_Permutations", Vehicle_Permutations_Layout.Layout, Map.HaloVersionEnum.Halo2);

        public vehc()
        {
            base.Add(this.Vehicle_Permutations);
            base.Add(this.Spawn_Time);
        }

        public class Vehicle_Permutations_Layout : TagBlockLayout
        {
            public static readonly vehc.Vehicle_Permutations_Layout Layout = new vehc.Vehicle_Permutations_Layout();
            public StringID Permutation = new StringID("Permutation");
            public HaloTagType Vehicle = new HaloTagType("Vehicle");
            public TagIdent Vehicle_0 = new TagIdent("Vehicle_0");
            public RealFloat Weight = new RealFloat("Weight");

            public Vehicle_Permutations_Layout()
            {
                base.Add(this.Weight);
                base.Add(this.Vehicle);
                base.Add(this.Vehicle_0);
                base.Add(this.Permutation);
            }
        }
    }
}

