﻿namespace core.TagInterface
{
    using System;

    public enum BaseObjectType
    {
        RealPoint2D,
        RealPlane2D,
        RealPlane3D,
        RealQuaternion,
        RealPoint3D,
        RealVector3D,
        Angle,
        RealEulerAngles3D,
        Flags,
        RealBounds,
        RealRGBColor,
        RealARGBColor,
        RealRGBAColor,
        RGBAColor,
        Data,
        Animation_Raw,
        Sound_Raw,
        Bitmap_Raw,
        Unicode_Raw,
        RawDataOffset,
        Raw_Tag_Block,
        TagEnumerator,
        EnumerableIndex,
        TagBlockIndex,
        LongInteger,
        ShortInteger,
        ByteInteger,
        RealFloat,
        RealFraction,
        Padding,
        String,
        StringID,
        Pointer,
        TagBlock,
        TagReference,
        TagIdent,
        HaloTagType,
        Syntax_Block,
        Model_Bounds
    }
}

