﻿namespace core.H2
{
    using core;
    using core.TagInterface;
    using System;

    public class H2TagCategory : Tag_Category
    {
        public static TagDefinition _fx_ = new TagDefinition("<fx>", @"Plugins\Halo 2\_fx_.ent", 10, "effects");
        public static TagDefinition adlg = new TagDefinition("adlg", core.H2.adlg.Layout, @"Plugins\Halo 2\adlg.ent", 10, "ai_dialogue", TagDefinition.TagMode.Hard_Coded);
        public static TagDefinition ant_ = new TagDefinition("ant!", @"Plugins\Halo 2\ant!.ent", 10, "antenna");
        public static TagDefinition bipd = new TagDefinition("bipd", @"Plugins\Halo 2\bipd.ent", 10, "biped");
        public static TagDefinition bitm = new TagDefinition("bitm", core.H2.bitm.Layout, @"Plugins\Halo 2\bitm.ent", 10, "bitmap", TagDefinition.TagMode.Hard_Coded);
        public static TagDefinition bloc = new TagDefinition("bloc", @"Plugins\Halo 2\bloc.ent", 10, "obstacle");
        public static TagDefinition bsdt = new TagDefinition("bsdt", @"Plugins\Halo 2\bsdt.ent", 10, "breakable_surface");
        public static TagDefinition char_ = new TagDefinition("char", @"Plugins\Halo 2\char.ent", 10, "character");
        public static TagDefinition clwd = new TagDefinition("clwd", @"Plugins\Halo 2\clwd.ent", 10, "cloth_wind");
        public static TagDefinition coll = new TagDefinition("coll", core.H2.coll.Layout, 10, "model_collision_geometry");
        public static TagDefinition colo = new TagDefinition("colo", @"Plugins\Halo 2\colo.ent", 10, "colo_table");
        public static TagDefinition cont = new TagDefinition("cont", @"Plugins\Halo 2\cont.ent", 10, "contrail");
        public static TagDefinition crea = new TagDefinition("crea", @"Plugins\Halo 2\crea.ent", 10, "creature");
        public static TagDefinition ctrl = new TagDefinition("ctrl", @"Plugins\Halo 2\ctrl.ent", 10, "device_control");
        public static TagDefinition deca = new TagDefinition("deca", @"Plugins\Halo 2\deca.ent", 10, "decal");
        public static TagDefinition DECR = new TagDefinition("DECR", core.H2.DECR.Layout, @"Plugins\Halo 2\DECR.ent", 10, "decoration", TagDefinition.TagMode.Hard_Coded);
        public static TagDefinition effe = new TagDefinition("effe", @"Plugins\Halo 2\effe.ent", 10, "effect");
        public static TagDefinition egor = new TagDefinition("egor", @"Plugins\Halo 2\egor.ent", 10, "egor");
        public static TagDefinition eqip = new TagDefinition("eqip", @"Plugins\Halo 2\eqip.ent", 10, "equipment");
        public static TagDefinition fog = new TagDefinition("fog ", @"Plugins\Halo 2\fog.ent", 10, "fog");
        public static TagDefinition foot = new TagDefinition("foot", @"Plugins\Halo 2\foot.ent", 10, "material_effects");
        public static TagDefinition fpch = new TagDefinition("fpch", @"Plugins\Halo 2\fpch.ent", 10, "fog_patch");
        public static TagDefinition garb = new TagDefinition("garb", @"Plugins\Halo 2\garb.ent", 10, "garbage");
        public static TagDefinition gldf = new TagDefinition("gldf", @"Plugins\Halo 2\gldf.ent", 10, "global_lighting");
        public static TagDefinition goof = new TagDefinition("goof", @"Plugins\Halo 2\goof.ent", 10, "goof");
        public static TagDefinition hlmt = new TagDefinition("hlmt", core.H2.hlmt.Layout, @"Plugins\Halo 2\hlmt.ent", 10, "object_properties", TagDefinition.TagMode.Hard_Coded);
        public static TagDefinition hudg = new TagDefinition("hudg", @"Plugins\Halo 2\hudg.ent", 10, "hud_globals");
        public static TagDefinition itmc = new TagDefinition("itmc", core.H2.itmc.Layout, @"Plugins\Halo 2\itmc.ent", 10, "item_collection", TagDefinition.TagMode.Hard_Coded);
        public static TagDefinition jmad = new TagDefinition("jmad", core.H2.jmad.Layout, @"Plugins\Halo 2\jmad.ent", 10, "animation", TagDefinition.TagMode.Hard_Coded);
        public static TagDefinition jpt_ = new TagDefinition("jpt!", @"Plugins\Halo 2\jpt!.ent", 10, "damage_effect");
        public static TagDefinition lens = new TagDefinition("lens", @"Plugins\Halo 2\lens.ent", 10, "lens");
        public static TagDefinition ligh = new TagDefinition("ligh", @"Plugins\Halo 2\ligh.ent", 10, "light");
        public static TagDefinition lsnd = new TagDefinition("lsnd", core.H2.lsnd.Layout, @"Plugins\Halo 2\lsnd.ent", 10, "looping_sound", TagDefinition.TagMode.Hard_Coded);
        public static TagDefinition ltmp = new TagDefinition("ltmp", core.H2.ltmp.Layout, @"Plugins\Halo 2\ltmp.ent", 10, "lightmap", TagDefinition.TagMode.Hard_Coded);
        public static TagDefinition mach = new TagDefinition("mach", @"Plugins\Halo 2\mach.ent", 10, "machine");
        public static TagDefinition matg = new TagDefinition("matg", core.H2.matg.Layout, @"Plugins\Halo 2\matg.ent", 10, "globals", TagDefinition.TagMode.Hard_Coded);
        public static TagDefinition mdlg = new TagDefinition("mdlg", @"Plugins\Halo 2\mdlg.ent", 10, "level_dialogue");
        public static TagDefinition MGS2 = new TagDefinition("MGS2", @"Plugins\Halo 2\MGS2.ent", 10, "light_volume");
        public static TagDefinition mode = new TagDefinition("mode", core.H2.mode.Layout, @"Plugins\Halo 2\mode.ent", 10, "gbx_model", TagDefinition.TagMode.Hard_Coded);
        public static TagDefinition mulg = new TagDefinition("mulg", @"Plugins\Halo 2\mulg.ent", 10, "multiplayer_globals");
        public static TagDefinition nhdt = new TagDefinition("nhdt", @"Plugins\Halo 2\nhdt.ent", 10, "hud");
        public static TagDefinition phmo = new TagDefinition("phmo", core.H2.phmo.Layout, @"Plugins\Halo 2\phmo.ent", 10, "physics_model", TagDefinition.TagMode.Hard_Coded);
        public static TagDefinition phys = new TagDefinition("phys", @"Plugins\Halo 2\phys.ent", 10, "physics");
        public static TagDefinition pmov = new TagDefinition("pmov", @"Plugins\Halo 2\pmov.ent", 10, "particle_physics");
        public static TagDefinition pphy = new TagDefinition("pphy", @"Plugins\Halo 2\pphy.ent", 10, "point_physics");
        public static TagDefinition proj = new TagDefinition("proj", @"Plugins\Halo 2\proj.ent", 10, "projectile");
        public static TagDefinition prt3 = new TagDefinition("prt3", @"Plugins\Halo 2\prt3.ent", 10, "particle");
        public static TagDefinition PRTM = new TagDefinition("PRTM", core.H2.PRTM.Layout, @"Plugins\Halo 2\PRTM.ent", 10, "particle_model", TagDefinition.TagMode.Hard_Coded);
        public static TagDefinition sbsp = new TagDefinition("sbsp", SBSP.Layout, @"Plugins\Halo 2\sbsp.ent", 5, "scenario_structure_bsp", TagDefinition.TagMode.Hard_Coded);
        public static TagDefinition scen = new TagDefinition("scen", core.H2.scen.Layout, @"Plugins\Halo 2\scen.ent", 10, "scenery", TagDefinition.TagMode.Hard_Coded);
        public static TagDefinition scnr = new TagDefinition("scnr", core.H2.scnr.Layout, @"Plugins\Halo 2\scnr.ent", 10, "scenario", TagDefinition.TagMode.Hard_Coded);
        public static TagDefinition sfx_ = new TagDefinition("sfx+", @"Plugins\Halo 2\sfx+.ent", 10, "global_sound_effects");
        public static TagDefinition shad = new TagDefinition("shad", core.H2.shad.Layout, @"Plugins\Halo 2\shad.ent", 10, "shader", TagDefinition.TagMode.Hard_Coded);
        public static TagDefinition sily = new TagDefinition("sily", @"Plugins\Halo 2\sily.ent", 10, "");
        public static TagDefinition skin = new TagDefinition("skin", @"Plugins\Halo 2\skin.ent", 10, "ui_skin");
        public static TagDefinition sky = new TagDefinition("sky ", @"Plugins\Halo 2\sky.ent", 10, "skybox");
        public static TagDefinition sncl = new TagDefinition("sncl", core.H2.sncl.Layout, @"Plugins\Halo 2\sncl.ent", 10, "sound_class_definition", TagDefinition.TagMode.Hard_Coded);
        public static TagDefinition snd_ = new TagDefinition("snd!", core.H2.snd_.Layout, @"Plugins\Halo 2\snd!.ent", 10, "sound", TagDefinition.TagMode.Hard_Coded);
        public static TagDefinition snde = new TagDefinition("snde", @"Plugins\Halo 2\snde.ent", 10, "sound_environment");
        public static TagDefinition snmx = new TagDefinition("snmx", @"Plugins\Halo 2\snmx.ent", 10, "sound_mix");
        public static TagDefinition spas = new TagDefinition("spas", @"Plugins\Halo 2\spas.ent", 10, "shader_pass");
        public static TagDefinition spk_ = new TagDefinition("spk!", core.H2.spk_.Layout, @"Plugins\Halo 2\spk!.ent", 10, "dialogue_constants", TagDefinition.TagMode.Hard_Coded);
        public static TagDefinition ssce = new TagDefinition("ssce", @"Plugins\Halo 2\ssce.ent", 10, "sound_scenery");
        public static TagDefinition stem = new TagDefinition("stem", @"Plugins\Halo 2\stem.ent", 10, "shader_template");
        public static TagDefinition styl = new TagDefinition("styl", @"Plugins\Halo 2\styl.ent", 10, "ai_style");
        public static TagDefinition tdtl = new TagDefinition("tdtl", @"Plugins\Halo 2\tdtl.ent", 10, "");
        public static TagDefinition trak = new TagDefinition("trak", @"Plugins\Halo 2\trak.ent", 10, "camera_track");
        public static TagDefinition udlg = new TagDefinition("udlg", @"Plugins\Halo 2\udlg.ent", 10, "unit_dialogue");
        public static TagDefinition ugh_ = new TagDefinition("ugh!", core.H2.ugh_.Layout, @"Plugins\Halo 2\ugh!.ent", 10, "sound_data", TagDefinition.TagMode.Hard_Coded);
        public static TagDefinition unic = new TagDefinition("unic", @"Plugins\Halo 2\unic.ent", 10, "unicode");
        public static TagDefinition vehc = new TagDefinition("vehc", core.H2.vehc.Layout, @"Plugins\Halo 2\vehc.ent", 10, "vehicle_collection", TagDefinition.TagMode.Hard_Coded);
        public static TagDefinition vehi = new TagDefinition("vehi", core.H2.vehi.Layout, @"Plugins\Halo 2\vehi.ent", 10, "vehicle", TagDefinition.TagMode.Hard_Coded);
        public static TagDefinition vrtx = new TagDefinition("vrtx", @"Plugins\Halo 2\vrtx.ent", 10, "vertex_shader");
        public static TagDefinition weap = new TagDefinition("weap", core.H2.weap.Layout, @"Plugins\Halo 2\weap.ent", 10, "weapon", TagDefinition.TagMode.Hard_Coded);
        public static TagDefinition weat = new TagDefinition("weat", core.H2.weat.Layout, @"Plugins\Halo 2\weat.ent", 10, "weather", TagDefinition.TagMode.Hard_Coded);
        public static TagDefinition wgit = new TagDefinition("wgit", @"Plugins\Halo 2\wgit.ent", 10, "widget");
        public static TagDefinition wgtz = new TagDefinition("wgtz", @"Plugins\Halo 2\wgtz.ent", 10, "widget_collection");
        public static TagDefinition wigl = new TagDefinition("wigl", @"Plugins\Halo 2\wigl.ent", 10, "ui_menu");

        public H2TagCategory() : base(Map.HaloVersionEnum.Halo2)
        {
            base.Add(_fx_);
            base.Add(adlg);
            base.Add(ant_);
            base.Add(bipd);
            base.Add(bitm);
            base.Add(bloc);
            base.Add(bsdt);
            base.Add(char_);
            base.Add(clwd);
            base.Add(coll);
            base.Add(colo);
            base.Add(cont);
            base.Add(crea);
            base.Add(ctrl);
            base.Add(deca);
            base.Add(DECR);
            base.Add(effe);
            base.Add(egor);
            base.Add(eqip);
            base.Add(fog);
            base.Add(foot);
            base.Add(fpch);
            base.Add(garb);
            base.Add(gldf);
            base.Add(goof);
            base.Add(hlmt);
            base.Add(hudg);
            base.Add(itmc);
            base.Add(jmad);
            base.Add(jpt_);
            base.Add(lens);
            base.Add(ligh);
            base.Add(lsnd);
            base.Add(ltmp);
            base.Add(mach);
            base.Add(matg);
            base.Add(mdlg);
            base.Add(MGS2);
            base.Add(mode);
            base.Add(mulg);
            base.Add(nhdt);
            base.Add(phmo);
            base.Add(phys);
            base.Add(pmov);
            base.Add(pphy);
            base.Add(proj);
            base.Add(prt3);
            base.Add(PRTM);
            base.Add(sbsp);
            base.Add(scen);
            base.Add(scnr);
            base.Add(sfx_);
            base.Add(shad);
            base.Add(sily);
            base.Add(skin);
            base.Add(sky);
            base.Add(sncl);
            base.Add(snd_);
            base.Add(snde);
            base.Add(snmx);
            base.Add(spas);
            base.Add(spk_);
            base.Add(ssce);
            base.Add(stem);
            base.Add(styl);
            base.Add(tdtl);
            base.Add(trak);
            base.Add(udlg);
            base.Add(ugh_);
            base.Add(unic);
            base.Add(vehc);
            base.Add(vehi);
            base.Add(vrtx);
            base.Add(weap);
            base.Add(weat);
            base.Add(wgit);
            base.Add(wgtz);
            base.Add(wigl);
        }
    }
}

