﻿namespace core.H2
{
    using core.TagInterface;
    using System;

    public class adlg : TagBlockLayout
    {
        public TagBlock Death_Taunting_Dialog = new TagBlock("Death/Taunting Dialog", Death_Taunting_Dialog_Layout.Layout, Map.HaloVersionEnum.Halo2);
        public TagBlock Killing_Cautious_Dialog = new TagBlock("Killing/Cautious Dialog", Killing_Cautious_Dialog_Layout.Layout, Map.HaloVersionEnum.Halo2);
        public static readonly adlg Layout = new adlg();
        public core.TagInterface.Padding Padding = new core.TagInterface.Padding("Padding", 12);
        public TagBlock Unknown = new TagBlock("Unknown", Unknown_Layout.Layout, Map.HaloVersionEnum.Halo2);
        public TagBlock Unknown_0 = new TagBlock("Unknown", Unknown_0_Layout.Layout, Map.HaloVersionEnum.Halo2);

        public adlg()
        {
            base.Add(this.Death_Taunting_Dialog);
            base.Add(this.Killing_Cautious_Dialog);
            base.Add(this.Padding);
            base.Add(this.Unknown);
            base.Add(this.Unknown_0);
        }

        public class Death_Taunting_Dialog_Layout : TagBlockLayout
        {
            public static readonly adlg.Death_Taunting_Dialog_Layout Layout = new adlg.Death_Taunting_Dialog_Layout();
            public core.TagInterface.Padding Padding = new core.TagInterface.Padding("Padding", 8);
            public core.TagInterface.Padding Padding_0 = new core.TagInterface.Padding("Padding", 8);
            public StringID Root_Situation = new StringID("Root Situation");
            public StringID Situation = new StringID("Situation");
            public StringID Spoken_Dialog = new StringID("Spoken Dialog");
            public RealFloat Unknown = new RealFloat("Unknown");
            public RealFloat Unknown_0 = new RealFloat("Unknown");
            public RealFloat Unknown_1 = new RealFloat("Unknown");
            public RealFloat Unknown_10 = new RealFloat("Unknown");
            public RealFloat Unknown_11 = new RealFloat("Unknown");
            public RealFloat Unknown_12 = new RealFloat("Unknown");
            public RealFloat Unknown_13 = new RealFloat("Unknown");
            public TagBlock Unknown_14 = new TagBlock("Unknown", Unknown_14_Layout.Layout, Map.HaloVersionEnum.Halo2);
            public RealFloat Unknown_2 = new RealFloat("Unknown");
            public RealFloat Unknown_3 = new RealFloat("Unknown");
            public RealFloat Unknown_4 = new RealFloat("Unknown");
            public RealFloat Unknown_5 = new RealFloat("Unknown");
            public RealFloat Unknown_6 = new RealFloat("Unknown");
            public RealFloat Unknown_7 = new RealFloat("Unknown");
            public RealFloat Unknown_8 = new RealFloat("Unknown");
            public RealFloat Unknown_9 = new RealFloat("Unknown");

            public Death_Taunting_Dialog_Layout()
            {
                base.Add(this.Situation);
                base.Add(this.Root_Situation);
                base.Add(this.Unknown);
                base.Add(this.Padding);
                base.Add(this.Unknown_0);
                base.Add(this.Unknown_1);
                base.Add(this.Unknown_2);
                base.Add(this.Unknown_3);
                base.Add(this.Unknown_4);
                base.Add(this.Unknown_5);
                base.Add(this.Unknown_6);
                base.Add(this.Unknown_7);
                base.Add(this.Unknown_8);
                base.Add(this.Unknown_9);
                base.Add(this.Unknown_10);
                base.Add(this.Unknown_11);
                base.Add(this.Unknown_12);
                base.Add(this.Unknown_13);
                base.Add(this.Spoken_Dialog);
                base.Add(this.Unknown_14);
                base.Add(this.Padding_0);
            }

            public class Unknown_14_Layout : TagBlockLayout
            {
                public static readonly adlg.Death_Taunting_Dialog_Layout.Unknown_14_Layout Layout = new adlg.Death_Taunting_Dialog_Layout.Unknown_14_Layout();
                public StringID Unknown = new StringID("Unknown");
                public RealFloat Unknown_0 = new RealFloat("Unknown");
                public RealFloat Unknown_1 = new RealFloat("Unknown");

                public Unknown_14_Layout()
                {
                    base.Add(this.Unknown);
                    base.Add(this.Unknown_0);
                    base.Add(this.Unknown_1);
                }
            }
        }

        public class Killing_Cautious_Dialog_Layout : TagBlockLayout
        {
            public static readonly adlg.Killing_Cautious_Dialog_Layout Layout = new adlg.Killing_Cautious_Dialog_Layout();
            public core.TagInterface.Padding Padding = new core.TagInterface.Padding("Padding", 4);
            public core.TagInterface.Padding Padding_0 = new core.TagInterface.Padding("Padding", 4);
            public core.TagInterface.Padding Padding_1 = new core.TagInterface.Padding("Padding", 8);
            public StringID Situation = new StringID("Situation");
            public RealFloat Unknown = new RealFloat("Unknown");
            public RealFloat Unknown_0 = new RealFloat("Unknown");
            public RealFloat Unknown_1 = new RealFloat("Unknown");
            public RealFloat Unknown_2 = new RealFloat("Unknown");
            public RealFloat Unknown_3 = new RealFloat("Unknown");
            public RealFloat Unknown_4 = new RealFloat("Unknown");
            public RealFloat Unknown_5 = new RealFloat("Unknown");
            public StringID Unknown_6 = new StringID("Unknown");
            public RealFloat Unknown_7 = new RealFloat("Unknown");
            public StringID Unknown_8 = new StringID("Unknown");
            public RealFloat Unknown_9 = new RealFloat("Unknown");

            public Killing_Cautious_Dialog_Layout()
            {
                base.Add(this.Unknown);
                base.Add(this.Situation);
                base.Add(this.Unknown_0);
                base.Add(this.Unknown_1);
                base.Add(this.Padding);
                base.Add(this.Unknown_2);
                base.Add(this.Unknown_3);
                base.Add(this.Padding_0);
                base.Add(this.Unknown_4);
                base.Add(this.Unknown_5);
                base.Add(this.Unknown_6);
                base.Add(this.Unknown_7);
                base.Add(this.Unknown_8);
                base.Add(this.Padding_1);
                base.Add(this.Unknown_9);
            }
        }

        public class Unknown_0_Layout : TagBlockLayout
        {
            public static readonly adlg.Unknown_0_Layout Layout = new adlg.Unknown_0_Layout();
            public LongInteger Unknown = new LongInteger("Unknown");

            public Unknown_0_Layout()
            {
                base.Add(this.Unknown);
            }
        }

        public class Unknown_Layout : TagBlockLayout
        {
            public static readonly adlg.Unknown_Layout Layout = new adlg.Unknown_Layout();
            public RealFloat Unknown = new RealFloat("Unknown");

            public Unknown_Layout()
            {
                base.Add(this.Unknown);
            }
        }
    }
}

