﻿namespace core.H2
{
    using core.TagInterface;
    using System;

    public class matg : TagBlockLayout
    {
        public TagBlock Ai_Information = new TagBlock("Ai Information", Ai_Information_Layout.Layout, Map.HaloVersionEnum.Halo2);
        public TagBlock Camera = new TagBlock("Camera", Camera_Layout.Layout, Map.HaloVersionEnum.Halo2);
        public LongInteger crazy_offset1 = new LongInteger("Crazy Offset");
        public LongInteger crazy_offset2 = new LongInteger("Crazy Offset");
        public TagBlock Damage_Effects = new TagBlock("Damage Effects", Damage_Effects_Layout.Layout, Map.HaloVersionEnum.Halo2);
        public TagBlock Difficulty = new TagBlock("Difficulty", Difficulty_Layout.Layout, Map.HaloVersionEnum.Halo2);
        public TagBlock Falling_Damage = new TagBlock("Falling Damage", Falling_Damage_Layout.Layout, Map.HaloVersionEnum.Halo2);
        public TagBlock Fp_Interface = new TagBlock("Fp Interface", Fp_Interface_Layout.Layout, Map.HaloVersionEnum.Halo2);
        public TagBlock Grenades = new TagBlock("Grenades", Grenades_Layout.Layout, Map.HaloVersionEnum.Halo2);
        public TagBlock Interface_Tag_Refernces = new TagBlock("Interface Tag Refernces", Interface_Tag_Refernces_Layout.Layout, Map.HaloVersionEnum.Halo2);
        public static readonly matg Layout = new matg();
        public HaloTagType Lighting_Globals = new HaloTagType("Lighting Globals");
        public TagIdent Lighting_Globals_0 = new TagIdent("Lighting Globals");
        public TagBlock Materials = new TagBlock("Materials", Materials_Layout.Layout, Map.HaloVersionEnum.Halo2);
        public TagBlock Materials_Collisions = new TagBlock("Materials Collisions", Materials_Collisions_Layout.Layout, Map.HaloVersionEnum.Halo2);
        public HaloTagType Multiplayer_Globals = new HaloTagType("Multiplayer Globals");
        public TagIdent Multiplayer_Globals_0 = new TagIdent("Multiplayer Globals");
        public TagBlock Multiplayer_Information__depricated_ = new TagBlock("Multiplayer Information (depricated)", Multiplayer_Information__depricated__Layout.Layout, Map.HaloVersionEnum.Halo2);
        public core.TagInterface.Padding Padding = new core.TagInterface.Padding("Padding", 0xb0);
        public core.TagInterface.Padding Padding_0 = new core.TagInterface.Padding("Padding", 8);
        public core.TagInterface.Padding Padding_1 = new core.TagInterface.Padding("Padding", 0x10);
        public core.TagInterface.Padding Padding_2 = new core.TagInterface.Padding("Padding", 8);
        public core.TagInterface.Padding Padding_3 = new core.TagInterface.Padding("Padding", 8);
        public TagBlock Player_Control = new TagBlock("Player Control", Player_Control_Layout.Layout, Map.HaloVersionEnum.Halo2);
        public TagBlock Player_Information = new TagBlock("Player Information", Player_Information_Layout.Layout, Map.HaloVersionEnum.Halo2);
        public TagBlock Rasterizer_Data = new TagBlock("Rasterizer Data", Rasterizer_Data_Layout.Layout, Map.HaloVersionEnum.Halo2);
        public TagBlock Scenario_Descriptions = new TagBlock("Scenario Descriptions", Scenario_Descriptions_Layout.Layout, Map.HaloVersionEnum.Halo2);
        public TagBlock Scenarios = new TagBlock("Scenarios", Scenarios_Layout.Layout, Map.HaloVersionEnum.Halo2);
        public TagBlock Something_Materials441 = new TagBlock("Something Materials441", Something_Materials441_Layout.Layout, Map.HaloVersionEnum.Halo2);
        public TagBlock Sound = new TagBlock("Sound", Sound_Layout.Layout, Map.HaloVersionEnum.Halo2);
        public Unicode_Raw[] Unicode = new Unicode_Raw[8];
        public TagBlock Unknown_Effects = new TagBlock("Unknown Effects", Unknown_Effects_Layout.Layout, Map.HaloVersionEnum.Halo2);
        public LongInteger unknown_int = new LongInteger("unk");
        public TagBlock Unknown486 = new TagBlock("Unknown486", Unknown486_Layout.Layout, Map.HaloVersionEnum.Halo2);
        public TagBlock Unknown491 = new TagBlock("Unknown491", Unknown491_Layout.Layout, Map.HaloVersionEnum.Halo2);
        public TagBlock Unknown95 = new TagBlock("Unknown95", Unknown95_Layout.Layout, Map.HaloVersionEnum.Halo2);

        public matg()
        {
            base.Add(this.Padding);
            base.Add(this.Unknown_Effects);
            base.Add(this.Damage_Effects);
            base.Add(this.Sound);
            base.Add(this.Ai_Information);
            base.Add(this.Materials_Collisions);
            base.Add(this.Padding_0);
            base.Add(this.Unknown95);
            base.Add(this.Camera);
            base.Add(this.Player_Control);
            base.Add(this.Difficulty);
            base.Add(this.Grenades);
            base.Add(this.Rasterizer_Data);
            base.Add(this.Interface_Tag_Refernces);
            base.Add(this.Padding_1);
            base.Add(this.Multiplayer_Information__depricated_);
            base.Add(this.Player_Information);
            base.Add(this.Fp_Interface);
            base.Add(this.Falling_Damage);
            base.Add(this.Materials);
            base.Add(this.Something_Materials441);
            base.Add(this.Unknown486);
            base.Add(this.Unknown491);
            base.Add(this.Multiplayer_Globals);
            base.Add(this.Multiplayer_Globals_0);
            base.Add(this.Scenarios);
            base.Add(this.Scenario_Descriptions);
            base.Add(this.Lighting_Globals);
            base.Add(this.Lighting_Globals_0);
            base.Add(this.Padding_2);
            for (int i = 0; i < 8; i++)
            {
                this.Unicode[i] = new Unicode_Raw("Unicode");
                base.Add(this.Unicode[i]);
            }
            base.Add(this.Padding_3);
            base.Add(this.crazy_offset1);
            base.Add(this.crazy_offset2);
            base.Add(this.unknown_int);
        }

        public class Ai_Information_Layout : TagBlockLayout
        {
            public HaloTagType AI_Dialog = new HaloTagType("AI Dialog");
            public TagIdent AI_Dialog_0 = new TagIdent("AI Dialog");
            public TagBlock Colors_Question_Mark_ = new TagBlock("Colors?", Colors_Question_Mark__Layout.Layout, Map.HaloVersionEnum.Halo2);
            public static readonly matg.Ai_Information_Layout Layout = new matg.Ai_Information_Layout();
            public core.TagInterface.Padding Padding = new core.TagInterface.Padding("Padding", 4);
            public core.TagInterface.Padding Padding_0 = new core.TagInterface.Padding("Padding", 4);
            public core.TagInterface.Padding Padding_1 = new core.TagInterface.Padding("Padding", 4);
            public core.TagInterface.Padding Padding_2 = new core.TagInterface.Padding("Padding", 4);
            public core.TagInterface.Padding Padding_3 = new core.TagInterface.Padding("Padding", 0x30);
            public core.TagInterface.Padding Padding_4 = new core.TagInterface.Padding("Padding", 0x18);
            public core.TagInterface.Padding Padding_5 = new core.TagInterface.Padding("Padding", 0x18);
            public core.TagInterface.Padding Padding_6 = new core.TagInterface.Padding("Padding", 0x30);
            public core.TagInterface.Padding Padding_7 = new core.TagInterface.Padding("Padding", 0x30);
            public RealFloat Unknown = new RealFloat("Unknown");
            public RealFloat Unknown_0 = new RealFloat("Unknown");
            public RealFloat Unknown_1 = new RealFloat("Unknown");
            public RealFloat Unknown_10 = new RealFloat("Unknown");
            public RealFloat Unknown_11 = new RealFloat("Unknown");
            public RealFloat Unknown_12 = new RealFloat("Unknown");
            public RealFloat Unknown_13 = new RealFloat("Unknown");
            public RealFloat Unknown_14 = new RealFloat("Unknown");
            public RealFloat Unknown_15 = new RealFloat("Unknown");
            public RealFloat Unknown_16 = new RealFloat("Unknown");
            public RealFloat Unknown_17 = new RealFloat("Unknown");
            public RealFloat Unknown_18 = new RealFloat("Unknown");
            public RealFloat Unknown_19 = new RealFloat("Unknown");
            public RealFloat Unknown_2 = new RealFloat("Unknown");
            public RealFloat Unknown_20 = new RealFloat("Unknown");
            public RealFloat Unknown_21 = new RealFloat("Unknown");
            public RealFloat Unknown_22 = new RealFloat("Unknown");
            public RealFloat Unknown_23 = new RealFloat("Unknown");
            public RealFloat Unknown_24 = new RealFloat("Unknown");
            public RealFloat Unknown_25 = new RealFloat("Unknown");
            public RealFloat Unknown_26 = new RealFloat("Unknown");
            public RealFloat Unknown_27 = new RealFloat("Unknown");
            public RealFloat Unknown_28 = new RealFloat("Unknown");
            public RealFloat Unknown_29 = new RealFloat("Unknown");
            public RealFloat Unknown_3 = new RealFloat("Unknown");
            public RealFloat Unknown_30 = new RealFloat("Unknown");
            public RealFloat Unknown_31 = new RealFloat("Unknown");
            public RealFloat Unknown_32 = new RealFloat("Unknown");
            public RealFloat Unknown_4 = new RealFloat("Unknown");
            public RealFloat Unknown_5 = new RealFloat("Unknown");
            public RealFloat Unknown_6 = new RealFloat("Unknown");
            public RealFloat Unknown_7 = new RealFloat("Unknown");
            public RealFloat Unknown_8 = new RealFloat("Unknown");
            public RealFloat Unknown_9 = new RealFloat("Unknown");

            public Ai_Information_Layout()
            {
                base.Add(this.Unknown);
                base.Add(this.Padding);
                base.Add(this.Unknown_0);
                base.Add(this.Padding_0);
                base.Add(this.Unknown_1);
                base.Add(this.Padding_1);
                base.Add(this.Unknown_2);
                base.Add(this.Padding_2);
                base.Add(this.Unknown_3);
                base.Add(this.Unknown_4);
                base.Add(this.Unknown_5);
                base.Add(this.Unknown_6);
                base.Add(this.Padding_3);
                base.Add(this.AI_Dialog);
                base.Add(this.AI_Dialog_0);
                base.Add(this.Padding_4);
                base.Add(this.Unknown_7);
                base.Add(this.Unknown_8);
                base.Add(this.Unknown_9);
                base.Add(this.Unknown_10);
                base.Add(this.Unknown_11);
                base.Add(this.Unknown_12);
                base.Add(this.Unknown_13);
                base.Add(this.Unknown_14);
                base.Add(this.Unknown_15);
                base.Add(this.Unknown_16);
                base.Add(this.Unknown_17);
                base.Add(this.Unknown_18);
                base.Add(this.Unknown_19);
                base.Add(this.Unknown_20);
                base.Add(this.Unknown_21);
                base.Add(this.Unknown_22);
                base.Add(this.Unknown_23);
                base.Add(this.Unknown_24);
                base.Add(this.Padding_5);
                base.Add(this.Unknown_25);
                base.Add(this.Unknown_26);
                base.Add(this.Unknown_27);
                base.Add(this.Unknown_28);
                base.Add(this.Padding_6);
                base.Add(this.Colors_Question_Mark_);
                base.Add(this.Padding_7);
                base.Add(this.Unknown_29);
                base.Add(this.Unknown_30);
                base.Add(this.Unknown_31);
                base.Add(this.Unknown_32);
            }

            public class Colors_Question_Mark__Layout : TagBlockLayout
            {
                public RealFloat B = new RealFloat("B");
                public RealFloat G = new RealFloat("G");
                public static readonly matg.Ai_Information_Layout.Colors_Question_Mark__Layout Layout = new matg.Ai_Information_Layout.Colors_Question_Mark__Layout();
                public RealFloat R = new RealFloat("R");

                public Colors_Question_Mark__Layout()
                {
                    base.Add(this.R);
                    base.Add(this.G);
                    base.Add(this.B);
                }
            }
        }

        public class Camera_Layout : TagBlockLayout
        {
            public HaloTagType Default_Unit_Camera_Track = new HaloTagType("Default Unit Camera Track");
            public TagIdent Default_Unit_Camera_Track_0 = new TagIdent("Default Unit Camera Track");
            public static readonly matg.Camera_Layout Layout = new matg.Camera_Layout();
            public RealFloat Unknown = new RealFloat("Unknown");
            public RealFloat Unknown_0 = new RealFloat("Unknown");
            public RealFloat Unknown_1 = new RealFloat("Unknown");

            public Camera_Layout()
            {
                base.Add(this.Default_Unit_Camera_Track);
                base.Add(this.Default_Unit_Camera_Track_0);
                base.Add(this.Unknown);
                base.Add(this.Unknown_0);
                base.Add(this.Unknown_1);
            }
        }

        public class Damage_Effects_Layout : TagBlockLayout
        {
            public static readonly matg.Damage_Effects_Layout Layout = new matg.Damage_Effects_Layout();
            public core.TagInterface.Padding Padding = new core.TagInterface.Padding("Padding", 0x20);
            public HaloTagType Reference = new HaloTagType("Reference");
            public TagIdent Reference_0 = new TagIdent("Reference");
            public RealFloat Unknown_Lower = new RealFloat("Unknown Lower");
            public RealFloat Unknown_Lower_0 = new RealFloat("Unknown Lower");
            public RealFloat Unknown_Lower_1 = new RealFloat("Unknown Lower");
            public RealFloat Unknown_Lower_2 = new RealFloat("Unknown Lower");
            public RealFloat Unknown_Upper = new RealFloat("Unknown Upper");
            public RealFloat Unknown_Upper_0 = new RealFloat("Unknown Upper");
            public RealFloat Unknown_Upper_1 = new RealFloat("Unknown Upper");
            public RealFloat Unknown_Upper_2 = new RealFloat("Unknown Upper");

            public Damage_Effects_Layout()
            {
                base.Add(this.Reference);
                base.Add(this.Reference_0);
                base.Add(this.Unknown_Lower);
                base.Add(this.Unknown_Upper);
                base.Add(this.Unknown_Lower_0);
                base.Add(this.Unknown_Upper_0);
                base.Add(this.Unknown_Lower_1);
                base.Add(this.Unknown_Upper_1);
                base.Add(this.Unknown_Lower_2);
                base.Add(this.Unknown_Upper_2);
                base.Add(this.Padding);
            }
        }

        public class Difficulty_Layout : TagBlockLayout
        {
            public static readonly matg.Difficulty_Layout Layout = new matg.Difficulty_Layout();
            public core.TagInterface.Padding Padding = new core.TagInterface.Padding("Padding", 4);
            public core.TagInterface.Padding Padding_0 = new core.TagInterface.Padding("Padding", 8);
            public core.TagInterface.Padding Padding_1 = new core.TagInterface.Padding("Padding", 0x10);
            public core.TagInterface.Padding Padding_2 = new core.TagInterface.Padding("Padding", 0x10);
            public core.TagInterface.Padding Padding_3 = new core.TagInterface.Padding("Padding", 4);
            public core.TagInterface.Padding Padding_4 = new core.TagInterface.Padding("Padding", 20);
            public core.TagInterface.Padding Padding_5 = new core.TagInterface.Padding("Padding", 0x34);
            public core.TagInterface.Padding Padding_6 = new core.TagInterface.Padding("Padding", 8);
            public core.TagInterface.Padding Padding_7 = new core.TagInterface.Padding("Padding", 4);
            public core.TagInterface.Padding Padding_8 = new core.TagInterface.Padding("Padding", 4);
            public core.TagInterface.Padding Padding_9 = new core.TagInterface.Padding("Padding", 0x84);
            public RealFloat Unknown = new RealFloat("Unknown");
            public RealFloat Unknown_0 = new RealFloat("Unknown");
            public RealFloat Unknown_1 = new RealFloat("Unknown");
            public RealFloat Unknown_10 = new RealFloat("Unknown");
            public RealFloat Unknown_11 = new RealFloat("Unknown");
            public RealFloat Unknown_12 = new RealFloat("Unknown");
            public RealFloat Unknown_13 = new RealFloat("Unknown");
            public RealFloat Unknown_14 = new RealFloat("Unknown");
            public RealFloat Unknown_15 = new RealFloat("Unknown");
            public RealFloat Unknown_16 = new RealFloat("Unknown");
            public RealFloat Unknown_17 = new RealFloat("Unknown");
            public RealFloat Unknown_18 = new RealFloat("Unknown");
            public RealFloat Unknown_19 = new RealFloat("Unknown");
            public RealFloat Unknown_2 = new RealFloat("Unknown");
            public RealFloat Unknown_20 = new RealFloat("Unknown");
            public RealFloat Unknown_21 = new RealFloat("Unknown");
            public RealFloat Unknown_22 = new RealFloat("Unknown");
            public RealFloat Unknown_23 = new RealFloat("Unknown");
            public RealFloat Unknown_24 = new RealFloat("Unknown");
            public RealFloat Unknown_25 = new RealFloat("Unknown");
            public RealFloat Unknown_26 = new RealFloat("Unknown");
            public RealFloat Unknown_27 = new RealFloat("Unknown");
            public RealFloat Unknown_28 = new RealFloat("Unknown");
            public RealFloat Unknown_29 = new RealFloat("Unknown");
            public RealFloat Unknown_3 = new RealFloat("Unknown");
            public RealFloat Unknown_30 = new RealFloat("Unknown");
            public RealFloat Unknown_31 = new RealFloat("Unknown");
            public RealFloat Unknown_32 = new RealFloat("Unknown");
            public RealFloat Unknown_33 = new RealFloat("Unknown");
            public RealFloat Unknown_34 = new RealFloat("Unknown");
            public RealFloat Unknown_35 = new RealFloat("Unknown");
            public RealFloat Unknown_36 = new RealFloat("Unknown");
            public RealFloat Unknown_37 = new RealFloat("Unknown");
            public RealFloat Unknown_38 = new RealFloat("Unknown");
            public RealFloat Unknown_39 = new RealFloat("Unknown");
            public RealFloat Unknown_4 = new RealFloat("Unknown");
            public RealFloat Unknown_40 = new RealFloat("Unknown");
            public RealFloat Unknown_41 = new RealFloat("Unknown");
            public RealFloat Unknown_42 = new RealFloat("Unknown");
            public RealFloat Unknown_43 = new RealFloat("Unknown");
            public RealFloat Unknown_44 = new RealFloat("Unknown");
            public RealFloat Unknown_45 = new RealFloat("Unknown");
            public RealFloat Unknown_46 = new RealFloat("Unknown");
            public RealFloat Unknown_47 = new RealFloat("Unknown");
            public RealFloat Unknown_48 = new RealFloat("Unknown");
            public RealFloat Unknown_49 = new RealFloat("Unknown");
            public RealFloat Unknown_5 = new RealFloat("Unknown");
            public RealFloat Unknown_50 = new RealFloat("Unknown");
            public RealFloat Unknown_51 = new RealFloat("Unknown");
            public RealFloat Unknown_52 = new RealFloat("Unknown");
            public RealFloat Unknown_53 = new RealFloat("Unknown");
            public RealFloat Unknown_54 = new RealFloat("Unknown");
            public RealFloat Unknown_55 = new RealFloat("Unknown");
            public RealFloat Unknown_56 = new RealFloat("Unknown");
            public RealFloat Unknown_57 = new RealFloat("Unknown");
            public RealFloat Unknown_58 = new RealFloat("Unknown");
            public RealFloat Unknown_59 = new RealFloat("Unknown");
            public RealFloat Unknown_6 = new RealFloat("Unknown");
            public RealFloat Unknown_60 = new RealFloat("Unknown");
            public RealFloat Unknown_61 = new RealFloat("Unknown");
            public RealFloat Unknown_62 = new RealFloat("Unknown");
            public RealFloat Unknown_63 = new RealFloat("Unknown");
            public RealFloat Unknown_64 = new RealFloat("Unknown");
            public RealFloat Unknown_65 = new RealFloat("Unknown");
            public RealFloat Unknown_66 = new RealFloat("Unknown");
            public RealFloat Unknown_67 = new RealFloat("Unknown");
            public RealFloat Unknown_68 = new RealFloat("Unknown");
            public RealFloat Unknown_69 = new RealFloat("Unknown");
            public RealFloat Unknown_7 = new RealFloat("Unknown");
            public RealFloat Unknown_70 = new RealFloat("Unknown");
            public RealFloat Unknown_71 = new RealFloat("Unknown");
            public RealFloat Unknown_72 = new RealFloat("Unknown");
            public RealFloat Unknown_73 = new RealFloat("Unknown");
            public RealFloat Unknown_74 = new RealFloat("Unknown");
            public RealFloat Unknown_75 = new RealFloat("Unknown");
            public RealFloat Unknown_76 = new RealFloat("Unknown");
            public RealFloat Unknown_77 = new RealFloat("Unknown");
            public RealFloat Unknown_78 = new RealFloat("Unknown");
            public RealFloat Unknown_79 = new RealFloat("Unknown");
            public RealFloat Unknown_8 = new RealFloat("Unknown");
            public RealFloat Unknown_80 = new RealFloat("Unknown");
            public RealFloat Unknown_81 = new RealFloat("Unknown");
            public RealFloat Unknown_82 = new RealFloat("Unknown");
            public RealFloat Unknown_83 = new RealFloat("Unknown");
            public RealFloat Unknown_84 = new RealFloat("Unknown");
            public RealFloat Unknown_85 = new RealFloat("Unknown");
            public RealFloat Unknown_86 = new RealFloat("Unknown");
            public RealFloat Unknown_87 = new RealFloat("Unknown");
            public RealFloat Unknown_88 = new RealFloat("Unknown");
            public RealFloat Unknown_89 = new RealFloat("Unknown");
            public RealFloat Unknown_9 = new RealFloat("Unknown");
            public RealFloat Unknown_90 = new RealFloat("Unknown");
            public RealFloat Unknown_91 = new RealFloat("Unknown");
            public RealFloat Unknown_92 = new RealFloat("Unknown");

            public Difficulty_Layout()
            {
                base.Add(this.Unknown);
                base.Add(this.Unknown_0);
                base.Add(this.Unknown_1);
                base.Add(this.Unknown_2);
                base.Add(this.Unknown_3);
                base.Add(this.Unknown_4);
                base.Add(this.Unknown_5);
                base.Add(this.Unknown_6);
                base.Add(this.Unknown_7);
                base.Add(this.Unknown_8);
                base.Add(this.Unknown_9);
                base.Add(this.Unknown_10);
                base.Add(this.Unknown_11);
                base.Add(this.Unknown_12);
                base.Add(this.Unknown_13);
                base.Add(this.Unknown_14);
                base.Add(this.Padding);
                base.Add(this.Unknown_15);
                base.Add(this.Unknown_16);
                base.Add(this.Unknown_17);
                base.Add(this.Unknown_18);
                base.Add(this.Unknown_19);
                base.Add(this.Unknown_20);
                base.Add(this.Unknown_21);
                base.Add(this.Unknown_22);
                base.Add(this.Unknown_23);
                base.Add(this.Unknown_24);
                base.Add(this.Unknown_25);
                base.Add(this.Unknown_26);
                base.Add(this.Unknown_27);
                base.Add(this.Unknown_28);
                base.Add(this.Unknown_29);
                base.Add(this.Padding_0);
                base.Add(this.Unknown_30);
                base.Add(this.Unknown_31);
                base.Add(this.Padding_1);
                base.Add(this.Unknown_32);
                base.Add(this.Unknown_33);
                base.Add(this.Unknown_34);
                base.Add(this.Unknown_35);
                base.Add(this.Unknown_36);
                base.Add(this.Unknown_37);
                base.Add(this.Unknown_38);
                base.Add(this.Unknown_39);
                base.Add(this.Unknown_40);
                base.Add(this.Unknown_41);
                base.Add(this.Unknown_42);
                base.Add(this.Unknown_43);
                base.Add(this.Unknown_44);
                base.Add(this.Unknown_45);
                base.Add(this.Unknown_46);
                base.Add(this.Unknown_47);
                base.Add(this.Unknown_48);
                base.Add(this.Unknown_49);
                base.Add(this.Unknown_50);
                base.Add(this.Unknown_51);
                base.Add(this.Padding_2);
                base.Add(this.Unknown_52);
                base.Add(this.Unknown_53);
                base.Add(this.Unknown_54);
                base.Add(this.Unknown_55);
                base.Add(this.Padding_3);
                base.Add(this.Unknown_56);
                base.Add(this.Unknown_57);
                base.Add(this.Unknown_58);
                base.Add(this.Unknown_59);
                base.Add(this.Unknown_60);
                base.Add(this.Unknown_61);
                base.Add(this.Unknown_62);
                base.Add(this.Unknown_63);
                base.Add(this.Unknown_64);
                base.Add(this.Unknown_65);
                base.Add(this.Unknown_66);
                base.Add(this.Unknown_67);
                base.Add(this.Unknown_68);
                base.Add(this.Unknown_69);
                base.Add(this.Unknown_70);
                base.Add(this.Unknown_71);
                base.Add(this.Unknown_72);
                base.Add(this.Unknown_73);
                base.Add(this.Unknown_74);
                base.Add(this.Padding_4);
                base.Add(this.Unknown_75);
                base.Add(this.Unknown_76);
                base.Add(this.Unknown_77);
                base.Add(this.Unknown_78);
                base.Add(this.Unknown_79);
                base.Add(this.Unknown_80);
                base.Add(this.Unknown_81);
                base.Add(this.Padding_5);
                base.Add(this.Unknown_82);
                base.Add(this.Unknown_83);
                base.Add(this.Unknown_84);
                base.Add(this.Padding_6);
                base.Add(this.Unknown_85);
                base.Add(this.Unknown_86);
                base.Add(this.Padding_7);
                base.Add(this.Unknown_87);
                base.Add(this.Unknown_88);
                base.Add(this.Unknown_89);
                base.Add(this.Padding_8);
                base.Add(this.Unknown_90);
                base.Add(this.Unknown_91);
                base.Add(this.Unknown_92);
                base.Add(this.Padding_9);
            }
        }

        public class Falling_Damage_Layout : TagBlockLayout
        {
            public HaloTagType Distance_Damage = new HaloTagType("Distance Damage");
            public TagIdent Distance_Damage_0 = new TagIdent("Distance Damage");
            public HaloTagType Falling_Damage = new HaloTagType("Falling Damage");
            public TagIdent Falling_Damage_0 = new TagIdent("Falling Damage");
            public HaloTagType Flaming_Death_Damage = new HaloTagType("Flaming Death Damage");
            public TagIdent Flaming_Death_Damage_0 = new TagIdent("Flaming Death Damage");
            public RealFloat Harmful_Falling_Distance_Lower = new RealFloat("Harmful Falling Distance Lower");
            public RealFloat Harmful_Falling_Distance_Upper = new RealFloat("Harmful Falling Distance Upper");
            public static readonly matg.Falling_Damage_Layout Layout = new matg.Falling_Damage_Layout();
            public RealFloat Maximum_Falling_Distance = new RealFloat("Maximum Falling Distance");
            public core.TagInterface.Padding Padding = new core.TagInterface.Padding("Padding", 8);
            public core.TagInterface.Padding Padding_0 = new core.TagInterface.Padding("Padding", 8);
            public core.TagInterface.Padding Padding_1 = new core.TagInterface.Padding("Padding", 0x10);
            public RealFloat Unknown_I = new RealFloat("Unknown I");
            public RealFloat Unknown_J = new RealFloat("Unknown J");
            public RealFloat Unknown_K = new RealFloat("Unknown K");
            public HaloTagType Vehicle_Collision_Damage = new HaloTagType("Vehicle Collision Damage");
            public TagIdent Vehicle_Collision_Damage_0 = new TagIdent("Vehicle Collision Damage");
            public HaloTagType Vehicle_Environment_Collision_Damage = new HaloTagType("Vehicle Environment Collision Damage");
            public TagIdent Vehicle_Environment_Collision_Damage_0 = new TagIdent("Vehicle Environment Collision Damage");
            public HaloTagType Vehicle_Killed_Unit_Damage = new HaloTagType("Vehicle Killed Unit Damage");
            public TagIdent Vehicle_Killed_Unit_Damage_0 = new TagIdent("Vehicle Killed Unit Damage");

            public Falling_Damage_Layout()
            {
                base.Add(this.Padding);
                base.Add(this.Harmful_Falling_Distance_Lower);
                base.Add(this.Harmful_Falling_Distance_Upper);
                base.Add(this.Falling_Damage);
                base.Add(this.Falling_Damage_0);
                base.Add(this.Padding_0);
                base.Add(this.Maximum_Falling_Distance);
                base.Add(this.Distance_Damage);
                base.Add(this.Distance_Damage_0);
                base.Add(this.Vehicle_Environment_Collision_Damage);
                base.Add(this.Vehicle_Environment_Collision_Damage_0);
                base.Add(this.Vehicle_Killed_Unit_Damage);
                base.Add(this.Vehicle_Killed_Unit_Damage_0);
                base.Add(this.Vehicle_Collision_Damage);
                base.Add(this.Vehicle_Collision_Damage_0);
                base.Add(this.Flaming_Death_Damage);
                base.Add(this.Flaming_Death_Damage_0);
                base.Add(this.Padding_1);
                base.Add(this.Unknown_I);
                base.Add(this.Unknown_J);
                base.Add(this.Unknown_K);
            }
        }

        public class Fp_Interface_Layout : TagBlockLayout
        {
            public HaloTagType Body = new HaloTagType("Body");
            public TagIdent Body_0 = new TagIdent("Body");
            public HaloTagType Hands = new HaloTagType("Hands");
            public TagIdent Hands_0 = new TagIdent("Hands");
            public static readonly matg.Fp_Interface_Layout Layout = new matg.Fp_Interface_Layout();
            public core.TagInterface.Padding Padding = new core.TagInterface.Padding("Padding", 160);
            public core.TagInterface.Padding Padding_0 = new core.TagInterface.Padding("Padding", 4);
            public HaloTagType Unit = new HaloTagType("Unit");
            public TagIdent Unit_0 = new TagIdent("Unit");

            public Fp_Interface_Layout()
            {
                base.Add(this.Hands);
                base.Add(this.Hands_0);
                base.Add(this.Body);
                base.Add(this.Body_0);
                base.Add(this.Padding);
                base.Add(this.Unit);
                base.Add(this.Unit_0);
                base.Add(this.Padding_0);
            }
        }

        public class Grenades_Layout : TagBlockLayout
        {
            public HaloTagType Equipment = new HaloTagType("Equipment");
            public TagIdent Equipment_0 = new TagIdent("Equipment");
            public static readonly matg.Grenades_Layout Layout = new matg.Grenades_Layout();
            public ShortInteger Max_Count = new ShortInteger("Max Count");
            public core.TagInterface.Padding Padding = new core.TagInterface.Padding("Padding", 2);
            public core.TagInterface.Padding Padding_0 = new core.TagInterface.Padding("Padding", 0x10);
            public HaloTagType Projectile = new HaloTagType("Projectile");
            public TagIdent Projectile_0 = new TagIdent("Projectile");
            public HaloTagType Throwing_Effect = new HaloTagType("Throwing Effect");
            public TagIdent Throwing_Effect_0 = new TagIdent("Throwing Effect");

            public Grenades_Layout()
            {
                base.Add(this.Max_Count);
                base.Add(this.Padding);
                base.Add(this.Throwing_Effect);
                base.Add(this.Throwing_Effect_0);
                base.Add(this.Padding_0);
                base.Add(this.Equipment);
                base.Add(this.Equipment_0);
                base.Add(this.Projectile);
                base.Add(this.Projectile_0);
            }
        }

        public class Interface_Tag_Refernces_Layout : TagBlockLayout
        {
            public HaloTagType Dialog_Color_Table = new HaloTagType("Dialog Color Table");
            public TagIdent Dialog_Color_Table_0 = new TagIdent("Dialog Color Table");
            public HaloTagType Editor_Color_Table = new HaloTagType("Editor Color Table");
            public TagIdent Editor_Color_Table_0 = new TagIdent("Editor Color Table");
            public HaloTagType Font_System = new HaloTagType("Font System");
            public TagIdent Font_System_0 = new TagIdent("Font System");
            public HaloTagType Font_Terminal = new HaloTagType("Font Terminal");
            public TagIdent Font_Terminal_0 = new TagIdent("Font Terminal");
            public HaloTagType Hud_Color_Table = new HaloTagType("Hud Color Table");
            public TagIdent Hud_Color_Table_0 = new TagIdent("Hud Color Table");
            public HaloTagType Hud_Digits_Definition = new HaloTagType("Hud Digits Definition");
            public TagIdent Hud_Digits_Definition_0 = new TagIdent("Hud Digits Definition");
            public HaloTagType Hud_Globals = new HaloTagType("Hud Globals");
            public TagIdent Hud_Globals_0 = new TagIdent("Hud Globals");
            public static readonly matg.Interface_Tag_Refernces_Layout Layout = new matg.Interface_Tag_Refernces_Layout();
            public HaloTagType Motion_Sensor_Blip = new HaloTagType("Motion Sensor Blip");
            public TagIdent Motion_Sensor_Blip_0 = new TagIdent("Motion Sensor Blip");
            public HaloTagType Motion_Sensor_Blip_Custom = new HaloTagType("Motion Sensor Blip Custom");
            public TagIdent Motion_Sensor_Blip_Custom_0 = new TagIdent("Motion Sensor Blip Custom");
            public HaloTagType Motion_Sensor_Sweep = new HaloTagType("Motion Sensor Sweep");
            public TagIdent Motion_Sensor_Sweep_0 = new TagIdent("Motion Sensor Sweep");
            public HaloTagType Motion_Sensor_Sweep_Mask = new HaloTagType("Motion Sensor Sweep Mask");
            public TagIdent Motion_Sensor_Sweep_Mask_0 = new TagIdent("Motion Sensor Sweep Mask");
            public HaloTagType Multiplayer_Hud_Bitmap = new HaloTagType("Multiplayer Hud Bitmap");
            public TagIdent Multiplayer_Hud_Bitmap_0 = new TagIdent("Multiplayer Hud Bitmap");
            public core.TagInterface.Padding Padding = new core.TagInterface.Padding("Padding", 8);
            public HaloTagType Rasterizer_Invalid = new HaloTagType("Rasterizer Invalid");
            public TagIdent Rasterizer_Invalid_0 = new TagIdent("Rasterizer Invalid");
            public HaloTagType Rasterizer_Plasma_Noise = new HaloTagType("Rasterizer Plasma Noise");
            public TagIdent Rasterizer_Plasma_Noise_0 = new TagIdent("Rasterizer Plasma Noise");
            public HaloTagType Screen_Color_Table = new HaloTagType("Screen Color Table");
            public TagIdent Screen_Color_Table_0 = new TagIdent("Screen Color Table");
            public HaloTagType Widget_Collection___Mainmenu = new HaloTagType("Widget Collection - Mainmenu");
            public TagIdent Widget_Collection___Mainmenu_0 = new TagIdent("Widget Collection - Mainmenu");
            public HaloTagType Widget_Collection___Multiplayer = new HaloTagType("Widget Collection - Multiplayer");
            public TagIdent Widget_Collection___Multiplayer_0 = new TagIdent("Widget Collection - Multiplayer");
            public HaloTagType Widget_Collection___Singleplayer = new HaloTagType("Widget Collection - Singleplayer");
            public TagIdent Widget_Collection___Singleplayer_0 = new TagIdent("Widget Collection - Singleplayer");

            public Interface_Tag_Refernces_Layout()
            {
                base.Add(this.Font_System);
                base.Add(this.Font_System_0);
                base.Add(this.Font_Terminal);
                base.Add(this.Font_Terminal_0);
                base.Add(this.Screen_Color_Table);
                base.Add(this.Screen_Color_Table_0);
                base.Add(this.Hud_Color_Table);
                base.Add(this.Hud_Color_Table_0);
                base.Add(this.Editor_Color_Table);
                base.Add(this.Editor_Color_Table_0);
                base.Add(this.Dialog_Color_Table);
                base.Add(this.Dialog_Color_Table_0);
                base.Add(this.Hud_Globals);
                base.Add(this.Hud_Globals_0);
                base.Add(this.Motion_Sensor_Sweep);
                base.Add(this.Motion_Sensor_Sweep_0);
                base.Add(this.Motion_Sensor_Sweep_Mask);
                base.Add(this.Motion_Sensor_Sweep_Mask_0);
                base.Add(this.Multiplayer_Hud_Bitmap);
                base.Add(this.Multiplayer_Hud_Bitmap_0);
                base.Add(this.Padding);
                base.Add(this.Hud_Digits_Definition);
                base.Add(this.Hud_Digits_Definition_0);
                base.Add(this.Motion_Sensor_Blip);
                base.Add(this.Motion_Sensor_Blip_0);
                base.Add(this.Motion_Sensor_Blip_Custom);
                base.Add(this.Motion_Sensor_Blip_Custom_0);
                base.Add(this.Rasterizer_Invalid);
                base.Add(this.Rasterizer_Invalid_0);
                base.Add(this.Rasterizer_Plasma_Noise);
                base.Add(this.Rasterizer_Plasma_Noise_0);
                base.Add(this.Widget_Collection___Mainmenu);
                base.Add(this.Widget_Collection___Mainmenu_0);
                base.Add(this.Widget_Collection___Singleplayer);
                base.Add(this.Widget_Collection___Singleplayer_0);
                base.Add(this.Widget_Collection___Multiplayer);
                base.Add(this.Widget_Collection___Multiplayer_0);
            }
        }

        public class Materials_Collisions_Layout : TagBlockLayout
        {
            public static readonly matg.Materials_Collisions_Layout Layout = new matg.Materials_Collisions_Layout();
            public TagBlock Materials = new TagBlock("Materials", Materials_Layout.Layout, Map.HaloVersionEnum.Halo2);

            public Materials_Collisions_Layout()
            {
                base.Add(this.Materials);
            }

            public class Materials_Layout : TagBlockLayout
            {
                public static readonly matg.Materials_Collisions_Layout.Materials_Layout Layout = new matg.Materials_Collisions_Layout.Materials_Layout();
                public StringID Name = new StringID("Name");
                public TagBlock Vs_Materials = new TagBlock("Vs Materials", Vs_Materials_Layout.Layout, Map.HaloVersionEnum.Halo2);

                public Materials_Layout()
                {
                    base.Add(this.Name);
                    base.Add(this.Vs_Materials);
                }

                public class Vs_Materials_Layout : TagBlockLayout
                {
                    public static readonly matg.Materials_Collisions_Layout.Materials_Layout.Vs_Materials_Layout Layout = new matg.Materials_Collisions_Layout.Materials_Layout.Vs_Materials_Layout();
                    public StringID Name = new StringID("Name");
                    public RealFloat Value = new RealFloat("Value");

                    public Vs_Materials_Layout()
                    {
                        base.Add(this.Name);
                        base.Add(this.Value);
                    }
                }
            }
        }

        public class Materials_Layout : TagBlockLayout
        {
            public RealFloat Ground_Damp_Fraction_Scale = new RealFloat("Ground Damp Fraction Scale");
            public RealFloat Ground_Depth_Scale = new RealFloat("Ground Depth Scale");
            public RealFloat Ground_Friction_Normal_K0 = new RealFloat("Ground Friction Normal K0");
            public RealFloat Ground_Friction_Normal_K1 = new RealFloat("Ground Friction Normal K1");
            public RealFloat Ground_Friction_Scale = new RealFloat("Ground Friction Scale");
            public static readonly matg.Materials_Layout Layout = new matg.Materials_Layout();
            public StringID Material = new StringID("Material");
            public StringID Material_Type = new StringID("Material Type");
            public HaloTagType Unused = new HaloTagType("Unused");
            public TagIdent Unused_0 = new TagIdent("Unused");

            public Materials_Layout()
            {
                base.Add(this.Material);
                base.Add(this.Material_Type);
                base.Add(this.Ground_Friction_Scale);
                base.Add(this.Ground_Friction_Normal_K0);
                base.Add(this.Ground_Friction_Normal_K1);
                base.Add(this.Ground_Depth_Scale);
                base.Add(this.Ground_Damp_Fraction_Scale);
                base.Add(this.Unused);
                base.Add(this.Unused_0);
            }
        }

        public class Multiplayer_Information__depricated__Layout : TagBlockLayout
        {
            public HaloTagType Ball = new HaloTagType("Ball");
            public TagIdent Ball_0 = new TagIdent("Ball");
            public HaloTagType Flag = new HaloTagType("Flag");
            public TagIdent Flag_0 = new TagIdent("Flag");
            public HaloTagType Flag_Shader = new HaloTagType("Flag Shader");
            public TagIdent Flag_Shader_0 = new TagIdent("Flag Shader");
            public HaloTagType Hill_Shader = new HaloTagType("Hill Shader");
            public TagIdent Hill_Shader_0 = new TagIdent("Hill Shader");
            public static readonly matg.Multiplayer_Information__depricated__Layout Layout = new matg.Multiplayer_Information__depricated__Layout();
            public core.TagInterface.Padding Padding = new core.TagInterface.Padding("Padding", 8);
            public core.TagInterface.Padding Padding_0 = new core.TagInterface.Padding("Padding", 8);
            public core.TagInterface.Padding Padding_1 = new core.TagInterface.Padding("Padding", 8);
            public core.TagInterface.Padding Padding_2 = new core.TagInterface.Padding("Padding", 0x58);
            public HaloTagType Unit = new HaloTagType("Unit");
            public TagIdent Unit_0 = new TagIdent("Unit");

            public Multiplayer_Information__depricated__Layout()
            {
                base.Add(this.Flag);
                base.Add(this.Flag_0);
                base.Add(this.Unit);
                base.Add(this.Unit_0);
                base.Add(this.Padding);
                base.Add(this.Hill_Shader);
                base.Add(this.Hill_Shader_0);
                base.Add(this.Flag_Shader);
                base.Add(this.Flag_Shader_0);
                base.Add(this.Ball);
                base.Add(this.Ball_0);
                base.Add(this.Padding_0);
                base.Add(this.Padding_1);
                base.Add(this.Padding_2);
            }
        }

        public class Player_Control_Layout : TagBlockLayout
        {
            public static readonly matg.Player_Control_Layout Layout = new matg.Player_Control_Layout();
            public RealFloat Look_Auto_leveling_Scale = new RealFloat("Look Auto-leveling Scale");
            public RealFloat Look_Default_Pitch_Rate = new RealFloat("Look Default Pitch Rate");
            public RealFloat Look_Default_Yaw_Rate = new RealFloat("Look Default Yaw Rate");
            public TagBlock Look_Function = new TagBlock("Look Function", Look_Function_Layout.Layout, Map.HaloVersionEnum.Halo2);
            public RealFloat Look_Peg_Threshold = new RealFloat("Look Peg Threshold");
            public RealFloat Look_Unknown_Lower = new RealFloat("Look Unknown Lower");
            public RealFloat Look_Unknown_Lower_0 = new RealFloat("Look Unknown Lower");
            public RealFloat Look_Unknown_Upper = new RealFloat("Look Unknown Upper");
            public RealFloat Look_Unknown_Upper_0 = new RealFloat("Look Unknown Upper");
            public RealFloat Magnetism_Adhesion = new RealFloat("Magnetism Adhesion");
            public RealFloat Magnetism_Friction = new RealFloat("Magnetism Friction");
            public RealFloat Magnetism_Inconsequential_Target_Scale = new RealFloat("Magnetism Inconsequential Target Scale");
            public ShortInteger Min_Autoleveling_Ticks = new ShortInteger("Min Autoleveling Ticks");
            public ShortInteger Min_Weapon_Swap_Ticks = new ShortInteger("Min Weapon Swap Ticks");
            public core.TagInterface.Padding Padding = new core.TagInterface.Padding("Padding", 0x10);
            public core.TagInterface.Padding Padding_0 = new core.TagInterface.Padding("Padding", 8);
            public core.TagInterface.Padding Padding_1 = new core.TagInterface.Padding("Padding", 12);
            public RealFloat Unknown = new RealFloat("Unknown");
            public RealFloat Unknown_0 = new RealFloat("Unknown");
            public RealFloat Unknown_1 = new RealFloat("Unknown");
            public RealFloat Unknown_2 = new RealFloat("Unknown");
            public RealFloat Unknown_3 = new RealFloat("Unknown");
            public RealFloat Unknown_4 = new RealFloat("Unknown");
            public RealFloat Unknown_5 = new RealFloat("Unknown");
            public RealFloat Unknown_6 = new RealFloat("Unknown");
            public RealFloat Unknown_7 = new RealFloat("Unknown");

            public Player_Control_Layout()
            {
                base.Add(this.Magnetism_Friction);
                base.Add(this.Magnetism_Adhesion);
                base.Add(this.Magnetism_Inconsequential_Target_Scale);
                base.Add(this.Padding);
                base.Add(this.Unknown);
                base.Add(this.Unknown_0);
                base.Add(this.Unknown_1);
                base.Add(this.Unknown_2);
                base.Add(this.Unknown_3);
                base.Add(this.Unknown_4);
                base.Add(this.Unknown_5);
                base.Add(this.Padding_0);
                base.Add(this.Look_Default_Pitch_Rate);
                base.Add(this.Look_Default_Yaw_Rate);
                base.Add(this.Look_Peg_Threshold);
                base.Add(this.Look_Unknown_Lower);
                base.Add(this.Look_Unknown_Upper);
                base.Add(this.Look_Unknown_Lower_0);
                base.Add(this.Look_Unknown_Upper_0);
                base.Add(this.Look_Auto_leveling_Scale);
                base.Add(this.Padding_1);
                base.Add(this.Min_Weapon_Swap_Ticks);
                base.Add(this.Min_Autoleveling_Ticks);
                base.Add(this.Unknown_6);
                base.Add(this.Look_Function);
                base.Add(this.Unknown_7);
            }

            public class Look_Function_Layout : TagBlockLayout
            {
                public static readonly matg.Player_Control_Layout.Look_Function_Layout Layout = new matg.Player_Control_Layout.Look_Function_Layout();
                public RealFloat Scale = new RealFloat("Scale");

                public Look_Function_Layout()
                {
                    base.Add(this.Scale);
                }
            }
        }

        public class Player_Information_Layout : TagBlockLayout
        {
            public HaloTagType Active_Camo_Error = new HaloTagType("Active Camo Error");
            public TagIdent Active_Camo_Error_0 = new TagIdent("Active Camo Error");
            public HaloTagType Active_Camo_Off = new HaloTagType("Active Camo Off");
            public TagIdent Active_Camo_Off_0 = new TagIdent("Active Camo Off");
            public HaloTagType Active_Camo_On = new HaloTagType("Active Camo On");
            public TagIdent Active_Camo_On_0 = new TagIdent("Active Camo On");
            public HaloTagType Active_Camo_Ready = new HaloTagType("Active Camo Ready");
            public TagIdent Active_Camo_Ready_0 = new TagIdent("Active Camo Ready");
            public RealFloat Airborne_Acceleration = new RealFloat("Airborne Acceleration");
            public HaloTagType Coop_Respawn_Effect = new HaloTagType("Coop Respawn Effect");
            public TagIdent Coop_Respawn_Effect_0 = new TagIdent("Coop Respawn Effect");
            public RealFloat Double_Speed_Multiplayer = new RealFloat("Double Speed Multiplayer");
            public HaloTagType Flashlight_Error = new HaloTagType("Flashlight Error");
            public TagIdent Flashlight_Error_0 = new TagIdent("Flashlight Error");
            public HaloTagType Flashlight_Off = new HaloTagType("Flashlight Off");
            public TagIdent Flashlight_Off_0 = new TagIdent("Flashlight Off");
            public HaloTagType Flashlight_On = new HaloTagType("Flashlight On");
            public TagIdent Flashlight_On_0 = new TagIdent("Flashlight On");
            public RealFloat Fp_Idle_Time_Lower = new RealFloat("Fp Idle Time Lower");
            public RealFloat Fp_Idle_Time_Upper = new RealFloat("Fp Idle Time Upper");
            public RealFloat Fp_Skip = new RealFloat("Fp Skip");
            public RealFloat Grenade_Origin_X = new RealFloat("Grenade Origin X");
            public RealFloat Grenade_Origin_Y = new RealFloat("Grenade Origin Y");
            public RealFloat Grenade_Origin_Z = new RealFloat("Grenade Origin Z");
            public static readonly matg.Player_Information_Layout Layout = new matg.Player_Information_Layout();
            public core.TagInterface.Padding Padding = new core.TagInterface.Padding("Padding", 0x1c);
            public core.TagInterface.Padding Padding_0 = new core.TagInterface.Padding("Padding", 0x10);
            public core.TagInterface.Padding Padding_1 = new core.TagInterface.Padding("Padding", 12);
            public core.TagInterface.Padding Padding_2 = new core.TagInterface.Padding("Padding", 8);
            public core.TagInterface.Padding Padding_3 = new core.TagInterface.Padding("Padding", 0x10);
            public core.TagInterface.Padding Padding_4 = new core.TagInterface.Padding("Padding", 0x10);
            public RealFloat Run_Acceleration = new RealFloat("Run Acceleration");
            public RealFloat Run_Backward = new RealFloat("Run Backward");
            public RealFloat Run_Forward = new RealFloat("Run Forward");
            public RealFloat Run_Sideways = new RealFloat("Run Sideways");
            public RealFloat Sneak_Acceleration = new RealFloat("Sneak Acceleration");
            public RealFloat Sneak_Backward = new RealFloat("Sneak Backward");
            public RealFloat Sneak_Forward = new RealFloat("Sneak Forward");
            public RealFloat Sneak_Sideways = new RealFloat("Sneak Sideways");
            public RealFloat Stun_Penalty_Jumping = new RealFloat("Stun Penalty Jumping");
            public RealFloat Stun_Penalty_Max_Time = new RealFloat("Stun Penalty Max Time");
            public RealFloat Stun_Penalty_Min_Time = new RealFloat("Stun Penalty Min Time");
            public RealFloat Stun_Penalty_Movement = new RealFloat("Stun Penalty Movement");
            public RealFloat Stun_Penalty_Turning = new RealFloat("Stun Penalty Turning");
            public HaloTagType Unit = new HaloTagType("Unit");
            public TagIdent Unit_0 = new TagIdent("Unit");
            public LongInteger Unknown = new LongInteger("Unknown");
            public RealFloat Unknown_0 = new RealFloat("Unknown");
            public RealFloat Unknown_1 = new RealFloat("Unknown");
            public HaloTagType Unused = new HaloTagType("Unused");
            public TagIdent Unused_0 = new TagIdent("Unused");
            public HaloTagType Unused_1 = new HaloTagType("Unused");
            public TagIdent Unused_2 = new TagIdent("Unused");
            public RealFloat Walking_Speed = new RealFloat("Walking Speed");

            public Player_Information_Layout()
            {
                base.Add(this.Unit);
                base.Add(this.Unit_0);
                base.Add(this.Padding);
                base.Add(this.Walking_Speed);
                base.Add(this.Double_Speed_Multiplayer);
                base.Add(this.Run_Forward);
                base.Add(this.Run_Backward);
                base.Add(this.Run_Sideways);
                base.Add(this.Run_Acceleration);
                base.Add(this.Sneak_Forward);
                base.Add(this.Sneak_Backward);
                base.Add(this.Sneak_Sideways);
                base.Add(this.Sneak_Acceleration);
                base.Add(this.Airborne_Acceleration);
                base.Add(this.Padding_0);
                base.Add(this.Grenade_Origin_X);
                base.Add(this.Grenade_Origin_Y);
                base.Add(this.Grenade_Origin_Z);
                base.Add(this.Padding_1);
                base.Add(this.Stun_Penalty_Movement);
                base.Add(this.Stun_Penalty_Turning);
                base.Add(this.Stun_Penalty_Jumping);
                base.Add(this.Stun_Penalty_Min_Time);
                base.Add(this.Stun_Penalty_Max_Time);
                base.Add(this.Padding_2);
                base.Add(this.Fp_Idle_Time_Lower);
                base.Add(this.Fp_Idle_Time_Upper);
                base.Add(this.Fp_Skip);
                base.Add(this.Padding_3);
                base.Add(this.Coop_Respawn_Effect);
                base.Add(this.Coop_Respawn_Effect_0);
                base.Add(this.Unknown);
                base.Add(this.Unknown_0);
                base.Add(this.Unknown_1);
                base.Add(this.Unused);
                base.Add(this.Unused_0);
                base.Add(this.Unused_1);
                base.Add(this.Unused_2);
                base.Add(this.Padding_4);
                base.Add(this.Active_Camo_On);
                base.Add(this.Active_Camo_On_0);
                base.Add(this.Active_Camo_Off);
                base.Add(this.Active_Camo_Off_0);
                base.Add(this.Active_Camo_Error);
                base.Add(this.Active_Camo_Error_0);
                base.Add(this.Active_Camo_Ready);
                base.Add(this.Active_Camo_Ready_0);
                base.Add(this.Flashlight_On);
                base.Add(this.Flashlight_On_0);
                base.Add(this.Flashlight_Off);
                base.Add(this.Flashlight_Off_0);
                base.Add(this.Flashlight_Error);
                base.Add(this.Flashlight_Error_0);
            }
        }

        public class Rasterizer_Data_Layout : TagBlockLayout
        {
            public RealFloat Active_Camo__Question_Mark__B = new RealFloat("Active Camo ? B");
            public RealFloat Active_Camo__Question_Mark__G = new RealFloat("Active Camo ? G");
            public RealFloat Active_Camo__Question_Mark__R = new RealFloat("Active Camo ? R");
            public RealFloat Active_Camo_Distance_Falloff = new RealFloat("Active Camo Distance Falloff");
            public RealFloat Active_Camo_Hyper_Stealth_Distance_Falloff = new RealFloat("Active Camo Hyper Stealth Distance Falloff");
            public RealFloat Active_Camo_Hyper_Stealth_Refraction = new RealFloat("Active Camo Hyper Stealth Refraction");
            public RealFloat Active_Camo_Refraction_Amount = new RealFloat("Active Camo Refraction Amount");
            public RealFloat Active_Camo_Tint_Color_B = new RealFloat("Active Camo Tint Color B");
            public RealFloat Active_Camo_Tint_Color_G = new RealFloat("Active Camo Tint Color G");
            public RealFloat Active_Camo_Tint_Color_R = new RealFloat("Active Camo Tint Color R");
            public HaloTagType Default_2D = new HaloTagType("Default 2D");
            public TagIdent Default_2D_0 = new TagIdent("Default 2D");
            public HaloTagType Default_3D = new HaloTagType("Default 3D");
            public TagIdent Default_3D_0 = new TagIdent("Default 3D");
            public HaloTagType Default_Cube_Map = new HaloTagType("Default Cube Map");
            public TagIdent Default_Cube_Map_0 = new TagIdent("Default Cube Map");
            public HaloTagType Distance_Attenuation = new HaloTagType("Distance Attenuation");
            public TagIdent Distance_Attenuation_0 = new TagIdent("Distance Attenuation");
            public HaloTagType Distance_Attenuation_2D = new HaloTagType("Distance Attenuation 2D");
            public TagIdent Distance_Attenuation_2D_0 = new TagIdent("Distance Attenuation 2D");
            public LongInteger Flags = new LongInteger("Flags");
            public HaloTagType Glow = new HaloTagType("Glow");
            public TagIdent Glow_0 = new TagIdent("Glow");
            public HaloTagType Gradients = new HaloTagType("Gradients");
            public TagIdent Gradients_0 = new TagIdent("Gradients");
            public static readonly matg.Rasterizer_Data_Layout Layout = new matg.Rasterizer_Data_Layout();
            public HaloTagType Loading_Screen_Background = new HaloTagType("Loading Screen Background");
            public TagIdent Loading_Screen_Background_0 = new TagIdent("Loading Screen Background");
            public HaloTagType Loading_Screen_Logos = new HaloTagType("Loading Screen Logos");
            public TagIdent Loading_Screen_Logos_0 = new TagIdent("Loading Screen Logos");
            public HaloTagType Loading_Screen_Spinner = new HaloTagType("Loading Screen Spinner");
            public TagIdent Loading_Screen_Spinner_0 = new TagIdent("Loading Screen Spinner");
            public HaloTagType Loading_Screen_Sweep = new HaloTagType("Loading Screen Sweep");
            public TagIdent Loading_Screen_Sweep_0 = new TagIdent("Loading Screen Sweep");
            public HaloTagType Loading_Screen_Tickers = new HaloTagType("Loading Screen Tickers");
            public TagIdent Loading_Screen_Tickers_0 = new TagIdent("Loading Screen Tickers");
            public core.TagInterface.Padding Padding = new core.TagInterface.Padding("Padding", 0x10);
            public core.TagInterface.Padding Padding_0 = new core.TagInterface.Padding("Padding", 0x24);
            public HaloTagType Render_Layer = new HaloTagType("Render Layer");
            public TagIdent Render_Layer_0 = new TagIdent("Render Layer");
            public HaloTagType Test_0 = new HaloTagType("Test 0");
            public TagIdent Test_0_0 = new TagIdent("Test 0");
            public HaloTagType Test_1 = new HaloTagType("Test 1");
            public TagIdent Test_1_0 = new TagIdent("Test 1");
            public HaloTagType Test_2 = new HaloTagType("Test 2");
            public TagIdent Test_2_0 = new TagIdent("Test 2");
            public HaloTagType Test_3 = new HaloTagType("Test 3");
            public TagIdent Test_3_0 = new TagIdent("Test 3");
            public HaloTagType Vector_Normalization = new HaloTagType("Vector Normalization");
            public TagIdent Vector_Normalization_0 = new TagIdent("Vector Normalization");
            public TagBlock Vertex_Shaders = new TagBlock("Vertex Shaders", Vertex_Shaders_Layout.Layout, Map.HaloVersionEnum.Halo2);
            public HaloTagType Video_Effect_Noise_Map = new HaloTagType("Video Effect Noise Map");
            public TagIdent Video_Effect_Noise_Map_0 = new TagIdent("Video Effect Noise Map");
            public HaloTagType Video_Effect_Scanline_Map = new HaloTagType("Video Effect Scanline Map");
            public TagIdent Video_Effect_Scanline_Map_0 = new TagIdent("Video Effect Scanline Map");

            public Rasterizer_Data_Layout()
            {
                base.Add(this.Distance_Attenuation);
                base.Add(this.Distance_Attenuation_0);
                base.Add(this.Vector_Normalization);
                base.Add(this.Vector_Normalization_0);
                base.Add(this.Gradients);
                base.Add(this.Gradients_0);
                base.Add(this.Loading_Screen_Background);
                base.Add(this.Loading_Screen_Background_0);
                base.Add(this.Loading_Screen_Sweep);
                base.Add(this.Loading_Screen_Sweep_0);
                base.Add(this.Loading_Screen_Spinner);
                base.Add(this.Loading_Screen_Spinner_0);
                base.Add(this.Glow);
                base.Add(this.Glow_0);
                base.Add(this.Loading_Screen_Logos);
                base.Add(this.Loading_Screen_Logos_0);
                base.Add(this.Loading_Screen_Tickers);
                base.Add(this.Loading_Screen_Tickers_0);
                base.Add(this.Padding);
                base.Add(this.Vertex_Shaders);
                base.Add(this.Default_2D);
                base.Add(this.Default_2D_0);
                base.Add(this.Default_3D);
                base.Add(this.Default_3D_0);
                base.Add(this.Default_Cube_Map);
                base.Add(this.Default_Cube_Map_0);
                base.Add(this.Test_0);
                base.Add(this.Test_0_0);
                base.Add(this.Test_1);
                base.Add(this.Test_1_0);
                base.Add(this.Test_2);
                base.Add(this.Test_2_0);
                base.Add(this.Test_3);
                base.Add(this.Test_3_0);
                base.Add(this.Video_Effect_Scanline_Map);
                base.Add(this.Video_Effect_Scanline_Map_0);
                base.Add(this.Video_Effect_Noise_Map);
                base.Add(this.Video_Effect_Noise_Map_0);
                base.Add(this.Padding_0);
                base.Add(this.Render_Layer);
                base.Add(this.Render_Layer_0);
                base.Add(this.Flags);
                base.Add(this.Active_Camo_Refraction_Amount);
                base.Add(this.Active_Camo_Distance_Falloff);
                base.Add(this.Active_Camo_Tint_Color_R);
                base.Add(this.Active_Camo_Tint_Color_G);
                base.Add(this.Active_Camo_Tint_Color_B);
                base.Add(this.Active_Camo_Hyper_Stealth_Refraction);
                base.Add(this.Active_Camo_Hyper_Stealth_Distance_Falloff);
                base.Add(this.Active_Camo__Question_Mark__R);
                base.Add(this.Active_Camo__Question_Mark__G);
                base.Add(this.Active_Camo__Question_Mark__B);
                base.Add(this.Distance_Attenuation_2D);
                base.Add(this.Distance_Attenuation_2D_0);
            }

            public class Vertex_Shaders_Layout : TagBlockLayout
            {
                public static readonly matg.Rasterizer_Data_Layout.Vertex_Shaders_Layout Layout = new matg.Rasterizer_Data_Layout.Vertex_Shaders_Layout();
                public HaloTagType Vertex_Shader = new HaloTagType("Vertex Shader");
                public TagIdent Vertex_Shader_0 = new TagIdent("Vertex Shader");

                public Vertex_Shaders_Layout()
                {
                    base.Add(this.Vertex_Shader);
                    base.Add(this.Vertex_Shader_0);
                }
            }
        }

        public class Scenario_Descriptions_Layout : TagBlockLayout
        {
            public static readonly matg.Scenario_Descriptions_Layout Layout = new matg.Scenario_Descriptions_Layout();
            public TagBlock Multiplayer = new TagBlock("Multiplayer", Multiplayer_Layout.Layout, Map.HaloVersionEnum.Halo2);
            public TagBlock Single_Player = new TagBlock("Single Player", Single_Player_Layout.Layout, Map.HaloVersionEnum.Halo2);
            public TagBlock Unknown506 = new TagBlock("Unknown506", Unknown506_Layout.Layout, Map.HaloVersionEnum.Halo2);

            public Scenario_Descriptions_Layout()
            {
                base.Add(this.Unknown506);
                base.Add(this.Single_Player);
                base.Add(this.Multiplayer);
            }

            public class Multiplayer_Layout : TagBlockLayout
            {
                public LongInteger Cache_ID = new LongInteger("Cache ID");
                public core.TagInterface.String Chinese_Description = new core.TagInterface.String("Chinese Description", 0x100);
                public core.TagInterface.String Chinese_Name = new core.TagInterface.String("Chinese Name", 0x40);
                public core.TagInterface.String Dutch_Description = new core.TagInterface.String("Dutch Description", 0x100);
                public core.TagInterface.String Dutch_Name = new core.TagInterface.String("Dutch Name", 0x40);
                public core.TagInterface.String English_Description = new core.TagInterface.String("English Description", 0x100);
                public core.TagInterface.String English_Name = new core.TagInterface.String("English Name", 0x40);
                public core.TagInterface.String French_Description = new core.TagInterface.String("French Description", 0x100);
                public core.TagInterface.String French_Name = new core.TagInterface.String("French Name", 0x40);
                public core.TagInterface.String Italian_Description = new core.TagInterface.String("Italian Description", 0x100);
                public core.TagInterface.String Italian_Name = new core.TagInterface.String("Italian Name", 0x40);
                public core.TagInterface.String Japanese_Description = new core.TagInterface.String("Japanese Description", 0x100);
                public core.TagInterface.String Japanese_Name = new core.TagInterface.String("Japanese Name", 0x40);
                public core.TagInterface.String Korean_Description = new core.TagInterface.String("Korean Description", 0x100);
                public core.TagInterface.String Korean_Name = new core.TagInterface.String("Korean Name", 0x40);
                public static readonly matg.Scenario_Descriptions_Layout.Multiplayer_Layout Layout = new matg.Scenario_Descriptions_Layout.Multiplayer_Layout();
                public core.TagInterface.Enumerator Locked = new core.TagInterface.Enumerator("Locked", core.TagInterface.Enumerator.TagEnumeratorIndexType.Long);
                public LongInteger Next_Map_ID = new LongInteger("Next Map ID");
                public core.TagInterface.Padding Padding = new core.TagInterface.Padding("Padding", 4);
                public core.TagInterface.String Portuguese_Description = new core.TagInterface.String("Portuguese Description", 0x100);
                public core.TagInterface.String Portuguese_Name = new core.TagInterface.String("Portuguese Name", 0x40);
                public HaloTagType Preview_Image = new HaloTagType("Preview Image");
                public TagIdent Preview_Image_0 = new TagIdent("Preview Image");
                public core.TagInterface.String Scenario_Path = new core.TagInterface.String("Scenario Path", 0x100);
                public core.TagInterface.String Spanish_Description = new core.TagInterface.String("Spanish Description", 0x100);
                public core.TagInterface.String Spanish_Name = new core.TagInterface.String("Spanish Name", 0x40);
                public LongInteger Team_Options = new LongInteger("Team Options");
                public LongInteger Unknown = new LongInteger("Unknown");
                public LongInteger Unknown_0 = new LongInteger("Unknown");

                public Multiplayer_Layout()
                {
                    base.Add(this.Cache_ID);
                    base.Add(this.Preview_Image);
                    base.Add(this.Preview_Image_0);
                    base.Add(this.English_Name);
                    base.Add(this.Japanese_Name);
                    base.Add(this.Dutch_Name);
                    base.Add(this.French_Name);
                    base.Add(this.Spanish_Name);
                    base.Add(this.Italian_Name);
                    base.Add(this.Korean_Name);
                    base.Add(this.Chinese_Name);
                    base.Add(this.Portuguese_Name);
                    base.Add(this.English_Description);
                    base.Add(this.Japanese_Description);
                    base.Add(this.Dutch_Description);
                    base.Add(this.French_Description);
                    base.Add(this.Spanish_Description);
                    base.Add(this.Italian_Description);
                    base.Add(this.Korean_Description);
                    base.Add(this.Chinese_Description);
                    base.Add(this.Portuguese_Description);
                    base.Add(this.Scenario_Path);
                    base.Add(this.Next_Map_ID);
                    base.Add(this.Locked);
                    base.Add(this.Team_Options);
                    base.Add(this.Unknown);
                    base.Add(this.Unknown_0);
                    base.Add(this.Padding);
                }
            }

            public class Single_Player_Layout : TagBlockLayout
            {
                public LongInteger Cache_ID = new LongInteger("Cache ID");
                public core.TagInterface.String Chinese_Description = new core.TagInterface.String("Chinese Description", 0x100);
                public core.TagInterface.String Chinese_Name = new core.TagInterface.String("Chinese Name", 0x40);
                public core.TagInterface.String Dutch_Description = new core.TagInterface.String("Dutch Description", 0x100);
                public core.TagInterface.String Dutch_Name = new core.TagInterface.String("Dutch Name", 0x40);
                public core.TagInterface.String English_Description = new core.TagInterface.String("English Description", 0x100);
                public core.TagInterface.String English_Name = new core.TagInterface.String("English Name", 0x40);
                public LongInteger Flags = new LongInteger("Flags");
                public core.TagInterface.String French_Description = new core.TagInterface.String("French Description", 0x100);
                public core.TagInterface.String French_Name = new core.TagInterface.String("French Name", 0x40);
                public core.TagInterface.String Italian_Description = new core.TagInterface.String("Italian Description", 0x100);
                public core.TagInterface.String Italian_Name = new core.TagInterface.String("Italian Name", 0x40);
                public core.TagInterface.String Japanese_Description = new core.TagInterface.String("Japanese Description", 0x100);
                public core.TagInterface.String Japanese_Name = new core.TagInterface.String("Japanese Name", 0x40);
                public core.TagInterface.String Korean_Description = new core.TagInterface.String("Korean Description", 0x100);
                public core.TagInterface.String Korean_Name = new core.TagInterface.String("Korean Name", 0x40);
                public static readonly matg.Scenario_Descriptions_Layout.Single_Player_Layout Layout = new matg.Scenario_Descriptions_Layout.Single_Player_Layout();
                public core.TagInterface.String Portuguese_Description = new core.TagInterface.String("Portuguese Description", 0x100);
                public core.TagInterface.String Portuguese_Name = new core.TagInterface.String("Portuguese Name", 0x40);
                public HaloTagType Preview_Image = new HaloTagType("Preview Image");
                public TagIdent Preview_Image_0 = new TagIdent("Preview Image");
                public core.TagInterface.String Spanish_Description = new core.TagInterface.String("Spanish Description", 0x100);
                public core.TagInterface.String Spanish_Name = new core.TagInterface.String("Spanish Name", 0x40);

                public Single_Player_Layout()
                {
                    base.Add(this.Flags);
                    base.Add(this.Cache_ID);
                    base.Add(this.Preview_Image);
                    base.Add(this.Preview_Image_0);
                    base.Add(this.English_Name);
                    base.Add(this.Japanese_Name);
                    base.Add(this.Dutch_Name);
                    base.Add(this.French_Name);
                    base.Add(this.Spanish_Name);
                    base.Add(this.Italian_Name);
                    base.Add(this.Korean_Name);
                    base.Add(this.Chinese_Name);
                    base.Add(this.Portuguese_Name);
                    base.Add(this.English_Description);
                    base.Add(this.Japanese_Description);
                    base.Add(this.Dutch_Description);
                    base.Add(this.French_Description);
                    base.Add(this.Spanish_Description);
                    base.Add(this.Italian_Description);
                    base.Add(this.Korean_Description);
                    base.Add(this.Chinese_Description);
                    base.Add(this.Portuguese_Description);
                }
            }

            public class Unknown506_Layout : TagBlockLayout
            {
                public static readonly matg.Scenario_Descriptions_Layout.Unknown506_Layout Layout = new matg.Scenario_Descriptions_Layout.Unknown506_Layout();
                public core.TagInterface.Padding Padding = new core.TagInterface.Padding("Padding", 0xb40);
                public LongInteger Unknown = new LongInteger("Unknown");

                public Unknown506_Layout()
                {
                    base.Add(this.Unknown);
                    base.Add(this.Padding);
                }
            }
        }

        public class Scenarios_Layout : TagBlockLayout
        {
            public static readonly matg.Scenarios_Layout Layout = new matg.Scenarios_Layout();
            public TagBlock Scenario = new TagBlock("Scenario", Scenario_Layout.Layout, Map.HaloVersionEnum.Halo2);

            public Scenarios_Layout()
            {
                base.Add(this.Scenario);
            }

            public class Scenario_Layout : TagBlockLayout
            {
                public LongInteger block_index = new LongInteger("block index");
                public LongInteger Cache_ID = new LongInteger("Cache ID");
                public static readonly matg.Scenarios_Layout.Scenario_Layout Layout = new matg.Scenarios_Layout.Scenario_Layout();
                public core.TagInterface.String Scenario_Path = new core.TagInterface.String("Scenario Path", 0x100);

                public Scenario_Layout()
                {
                    base.Add(this.block_index);
                    base.Add(this.Cache_ID);
                    base.Add(this.Scenario_Path);
                }
            }
        }

        public class Something_Materials441_Layout : TagBlockLayout
        {
            public static readonly matg.Something_Materials441_Layout Layout = new matg.Something_Materials441_Layout();
            public core.TagInterface.Padding Padding = new core.TagInterface.Padding("Padding", 4);
            public core.TagInterface.Padding Padding_0 = new core.TagInterface.Padding("Padding", 8);
            public core.TagInterface.Padding Padding_1 = new core.TagInterface.Padding("Padding", 8);
            public core.TagInterface.Padding Padding_2 = new core.TagInterface.Padding("Padding", 4);
            public StringID Unknown = new StringID("Unknown");
            public StringID Unknown_0 = new StringID("Unknown");
            public LongInteger Unknown_1 = new LongInteger("Unknown");
            public HaloTagType Unknown_10 = new HaloTagType("Unknown");
            public TagIdent Unknown_11 = new TagIdent("Unknown");
            public HaloTagType Unknown_12 = new HaloTagType("Unknown");
            public TagIdent Unknown_13 = new TagIdent("Unknown");
            public HaloTagType Unknown_14 = new HaloTagType("Unknown");
            public TagIdent Unknown_15 = new TagIdent("Unknown");
            public HaloTagType Unknown_16 = new HaloTagType("Unknown");
            public TagIdent Unknown_17 = new TagIdent("Unknown");
            public HaloTagType Unknown_18 = new HaloTagType("Unknown");
            public TagIdent Unknown_19 = new TagIdent("Unknown");
            public LongInteger Unknown_2 = new LongInteger("Unknown");
            public HaloTagType Unknown_20 = new HaloTagType("Unknown");
            public TagIdent Unknown_21 = new TagIdent("Unknown");
            public StringID Unknown_3 = new StringID("Unknown");
            public StringID Unknown_4 = new StringID("Unknown");
            public RealFloat Unknown_5 = new RealFloat("Unknown");
            public RealFloat Unknown_6 = new RealFloat("Unknown");
            public RealFloat Unknown_7 = new RealFloat("Unknown");
            public HaloTagType Unknown_8 = new HaloTagType("Unknown");
            public TagIdent Unknown_9 = new TagIdent("Unknown");
            public HaloTagType Unused = new HaloTagType("Unused");
            public TagIdent Unused_0 = new TagIdent("Unused");
            public HaloTagType Unused_1 = new HaloTagType("Unused");
            public TagIdent Unused_10 = new TagIdent("Unused");
            public HaloTagType Unused_11 = new HaloTagType("Unused");
            public TagIdent Unused_12 = new TagIdent("Unused");
            public HaloTagType Unused_13 = new HaloTagType("Unused");
            public TagIdent Unused_14 = new TagIdent("Unused");
            public TagIdent Unused_2 = new TagIdent("Unused");
            public HaloTagType Unused_3 = new HaloTagType("Unused");
            public TagIdent Unused_4 = new TagIdent("Unused");
            public HaloTagType Unused_5 = new HaloTagType("Unused");
            public TagIdent Unused_6 = new TagIdent("Unused");
            public HaloTagType Unused_7 = new HaloTagType("Unused");
            public TagIdent Unused_8 = new TagIdent("Unused");
            public HaloTagType Unused_9 = new HaloTagType("Unused");

            public Something_Materials441_Layout()
            {
                base.Add(this.Unknown);
                base.Add(this.Unknown_0);
                base.Add(this.Unknown_1);
                base.Add(this.Unknown_2);
                base.Add(this.Unknown_3);
                base.Add(this.Unknown_4);
                base.Add(this.Padding);
                base.Add(this.Unknown_5);
                base.Add(this.Unknown_6);
                base.Add(this.Unknown_7);
                base.Add(this.Unused);
                base.Add(this.Unused_0);
                base.Add(this.Unknown_8);
                base.Add(this.Unknown_9);
                base.Add(this.Unknown_10);
                base.Add(this.Unknown_11);
                base.Add(this.Unknown_12);
                base.Add(this.Unknown_13);
                base.Add(this.Unknown_14);
                base.Add(this.Unknown_15);
                base.Add(this.Unknown_16);
                base.Add(this.Unknown_17);
                base.Add(this.Unused_1);
                base.Add(this.Unused_2);
                base.Add(this.Unknown_18);
                base.Add(this.Unknown_19);
                base.Add(this.Padding_0);
                base.Add(this.Unused_3);
                base.Add(this.Unused_4);
                base.Add(this.Unused_5);
                base.Add(this.Unused_6);
                base.Add(this.Unused_7);
                base.Add(this.Unused_8);
                base.Add(this.Unused_9);
                base.Add(this.Unused_10);
                base.Add(this.Unused_11);
                base.Add(this.Unused_12);
                base.Add(this.Unused_13);
                base.Add(this.Unused_14);
                base.Add(this.Padding_1);
                base.Add(this.Padding_2);
                base.Add(this.Unknown_20);
                base.Add(this.Unknown_21);
            }
        }

        public class Sound_Layout : TagBlockLayout
        {
            public HaloTagType Classes = new HaloTagType("Classes");
            public TagIdent Classes_0 = new TagIdent("Classes");
            public HaloTagType Dialog_Constants = new HaloTagType("Dialog Constants");
            public TagIdent Dialog_Constants_0 = new TagIdent("Dialog Constants");
            public HaloTagType Effects = new HaloTagType("Effects");
            public TagIdent Effects_0 = new TagIdent("Effects");
            public static readonly matg.Sound_Layout Layout = new matg.Sound_Layout();
            public HaloTagType Mix = new HaloTagType("Mix");
            public TagIdent Mix_0 = new TagIdent("Mix");
            public TagIdent Resource_Hack = new TagIdent("Resource Hack");

            public Sound_Layout()
            {
                base.Add(this.Classes);
                base.Add(this.Classes_0);
                base.Add(this.Effects);
                base.Add(this.Effects_0);
                base.Add(this.Mix);
                base.Add(this.Mix_0);
                base.Add(this.Dialog_Constants);
                base.Add(this.Dialog_Constants_0);
                base.Add(this.Resource_Hack);
            }
        }

        public class Unknown_Effects_Layout : TagBlockLayout
        {
            public HaloTagType Effect = new HaloTagType("Effect");
            public TagIdent Effect_0 = new TagIdent("Effect");
            public static readonly matg.Unknown_Effects_Layout Layout = new matg.Unknown_Effects_Layout();

            public Unknown_Effects_Layout()
            {
                base.Add(this.Effect);
                base.Add(this.Effect_0);
            }
        }

        public class Unknown486_Layout : TagBlockLayout
        {
            public static readonly matg.Unknown486_Layout Layout = new matg.Unknown486_Layout();
            public core.TagInterface.Padding Padding = new core.TagInterface.Padding("Padding", 8);
            public core.TagInterface.Padding Padding_0 = new core.TagInterface.Padding("Padding", 0x10);
            public core.TagInterface.Padding Padding_1 = new core.TagInterface.Padding("Padding", 8);

            public Unknown486_Layout()
            {
                base.Add(this.Padding);
                base.Add(this.Padding_0);
                base.Add(this.Padding_1);
            }
        }

        public class Unknown491_Layout : TagBlockLayout
        {
            public static readonly matg.Unknown491_Layout Layout = new matg.Unknown491_Layout();
            public RealFloat Unknown = new RealFloat("Unknown");
            public RealFloat Unknown_0 = new RealFloat("Unknown");
            public RealFloat Unknown_1 = new RealFloat("Unknown");

            public Unknown491_Layout()
            {
                base.Add(this.Unknown);
                base.Add(this.Unknown_0);
                base.Add(this.Unknown_1);
            }
        }

        public class Unknown95_Layout : TagBlockLayout
        {
            public static readonly matg.Unknown95_Layout Layout = new matg.Unknown95_Layout();
            public HaloTagType Unknown = new HaloTagType("Unknown");
            public TagIdent Unknown_0 = new TagIdent("Unknown");

            public Unknown95_Layout()
            {
                base.Add(this.Unknown);
                base.Add(this.Unknown_0);
            }
        }
    }
}

