﻿namespace core.H2
{
    using core.TagInterface;
    using System;

    public class phmo : TagBlockLayout
    {
        public TagBlock _Materials_ = new TagBlock("_Materials_", _Materials__Layout.Layout, Map.HaloVersionEnum.Halo2);
        public TagBlock _Object_Attributes_ = new TagBlock("_Object_Attributes_", _Object_Attributes__Layout.Layout, Map.HaloVersionEnum.Halo2);
        public TagBlock hkMoppBvTreeShape_codes = new TagBlock("hkMoppBvTreeShape_codes", hkMoppBvTreeShape_codes_Layout.Layout, Map.HaloVersionEnum.Halo2);
        public TagBlock Joints__Hinges_ = new TagBlock("Joints__Hinges_", Joints__Hinges__Layout.Layout, Map.HaloVersionEnum.Halo2);
        public static readonly phmo Layout = new phmo();
        public TagBlock Missed2 = new TagBlock("Missed2", Missed2_Layout.Layout, Map.HaloVersionEnum.Halo2);
        public TagBlock Misssed1 = new TagBlock("Misssed1", Misssed1_Layout.Layout, Map.HaloVersionEnum.Halo2);
        public TagBlock Nodes = new TagBlock("Nodes", Nodes_Layout.Layout, Map.HaloVersionEnum.Halo2);
        public core.TagInterface.Padding Padding = new core.TagInterface.Padding("Padding", 4);
        public core.TagInterface.Padding Padding_0 = new core.TagInterface.Padding("Padding", 0x18);
        public core.TagInterface.Padding Padding_1 = new core.TagInterface.Padding("Padding", 8);
        public core.TagInterface.Padding Padding_2 = new core.TagInterface.Padding("Padding", 8);
        public core.TagInterface.Padding Padding_3 = new core.TagInterface.Padding("Padding", 0x18);
        public core.TagInterface.Padding Padding_4 = new core.TagInterface.Padding("Padding", 0x10);
        public TagBlock Powered_mass_point = new TagBlock("Powered_mass_point", Powered_mass_point_Layout.Layout, Map.HaloVersionEnum.Halo2);
        public RealFloat Unknown = new RealFloat("Unknown");
        public RealFloat unknown_0 = new RealFloat("unknown_0");
        public RealFloat unknown_1 = new RealFloat("unknown_1");
        public TagBlock unknown_2 = new TagBlock("unknown_2", unknown_2_Layout.Layout, Map.HaloVersionEnum.Halo2);
        public TagBlock unknown_3 = new TagBlock("unknown_3", unknown_3_Layout.Layout, Map.HaloVersionEnum.Halo2);
        public TagBlock Unknown223 = new TagBlock("Unknown223", Unknown223_Layout.Layout, Map.HaloVersionEnum.Halo2);
        public TagBlock Unknown239 = new TagBlock("Unknown239", Unknown239_Layout.Layout, Map.HaloVersionEnum.Halo2);
        public TagBlock Unknown243 = new TagBlock("Unknown243", Unknown243_Layout.Layout, Map.HaloVersionEnum.Halo2);
        public TagBlock Unknown25 = new TagBlock("Unknown25", Unknown25_Layout.Layout, Map.HaloVersionEnum.Halo2);
        public TagBlock Unknown264 = new TagBlock("Unknown264", Unknown264_Layout.Layout, Map.HaloVersionEnum.Halo2);
        public TagBlock Unknown268 = new TagBlock("Unknown268", Unknown268_Layout.Layout, Map.HaloVersionEnum.Halo2);
        public TagBlock Unknown48 = new TagBlock("Unknown48", Unknown48_Layout.Layout, Map.HaloVersionEnum.Halo2);
        public TagBlock Unknown9 = new TagBlock("Unknown9", Unknown9_Layout.Layout, Map.HaloVersionEnum.Halo2);
        public TagBlock Unknown9_0 = new TagBlock("Unknown9_0", Unknown9_0_Layout.Layout, Map.HaloVersionEnum.Halo2);
        public TagBlock Vehicle_Attachments = new TagBlock("Vehicle_Attachments", Vehicle_Attachments_Layout.Layout, Map.HaloVersionEnum.Halo2);
        public TagBlock Vehicle_Parts136__Powered_Mass_Point_ = new TagBlock("Vehicle_Parts136__Powered_Mass_Point_", Vehicle_Parts136__Powered_Mass_Point__Layout.Layout, Map.HaloVersionEnum.Halo2);
        public TagBlock Vertices = new TagBlock("Vertices", Vertices_Layout.Layout, Map.HaloVersionEnum.Halo2);

        public phmo()
        {
            base.Add(this.Padding);
            base.Add(this.unknown_0);
            base.Add(this.unknown_1);
            base.Add(this.Unknown);
            base.Add(this.Padding_0);
            base.Add(this.Unknown9);
            base.Add(this.Unknown9_0);
            base.Add(this._Object_Attributes_);
            base.Add(this._Materials_);
            base.Add(this.Unknown48);
            base.Add(this.Misssed1);
            base.Add(this.Powered_mass_point);
            base.Add(this.Vehicle_Attachments);
            base.Add(this.Missed2);
            base.Add(this.Vehicle_Parts136__Powered_Mass_Point_);
            base.Add(this.unknown_2);
            base.Add(this.Vertices);
            base.Add(this.Padding_1);
            base.Add(this.Unknown223);
            base.Add(this.Unknown239);
            base.Add(this.Unknown243);
            base.Add(this.hkMoppBvTreeShape_codes);
            base.Add(this.Padding_2);
            base.Add(this.Unknown25);
            base.Add(this.unknown_3);
            base.Add(this.Nodes);
            base.Add(this.Padding_3);
            base.Add(this.Joints__Hinges_);
            base.Add(this.Unknown268);
            base.Add(this.Padding_4);
            base.Add(this.Unknown264);
        }

        public class _Materials__Layout : TagBlockLayout
        {
            public StringID _Material_ = new StringID("_Material_");
            public StringID _Material_Base_ = new StringID("_Material_Base_");
            public static readonly phmo._Materials__Layout Layout = new phmo._Materials__Layout();
            public LongInteger Unknown = new LongInteger("Unknown");

            public _Materials__Layout()
            {
                base.Add(this._Material_Base_);
                base.Add(this._Material_);
                base.Add(this.Unknown);
            }
        }

        public class _Object_Attributes__Layout : TagBlockLayout
        {
            public RealFloat _Object_Stacking_ = new RealFloat("_Object_Stacking_");
            public static readonly phmo._Object_Attributes__Layout Layout = new phmo._Object_Attributes__Layout();
            public ShortInteger No_Name = new ShortInteger("No_Name");
            public ShortInteger No_Name_0 = new ShortInteger("No_Name_0");
            public RealFloat No_Name_1 = new RealFloat("No_Name_1");
            public RealFloat No_Name_2 = new RealFloat("No_Name_2");
            public RealFloat No_Name_3 = new RealFloat("No_Name_3");
            public RealFloat No_Name_4 = new RealFloat("No_Name_4");
            public LongInteger No_Name_5 = new LongInteger("No_Name_5");
            public core.TagInterface.Padding Padding = new core.TagInterface.Padding("Padding", 4);
            public core.TagInterface.Padding Padding_0 = new core.TagInterface.Padding("Padding", 4);
            public core.TagInterface.Padding Padding_1 = new core.TagInterface.Padding("Padding", 4);
            public core.TagInterface.Padding Padding_2 = new core.TagInterface.Padding("Padding", 4);
            public core.TagInterface.Padding Padding_3 = new core.TagInterface.Padding("Padding", 4);
            public core.TagInterface.Padding Padding_4 = new core.TagInterface.Padding("Padding", 20);
            public LongInteger Unknown = new LongInteger("Unknown");
            public RealFloat unknown_0 = new RealFloat("unknown_0");
            public LongInteger Unknown_0 = new LongInteger("Unknown_0");
            public RealFloat unknown_1 = new RealFloat("unknown_1");
            public RealFloat Unknown_1 = new RealFloat("Unknown_1");
            public LongInteger Unknown_10 = new LongInteger("Unknown_10");
            public LongInteger Unknown_11 = new LongInteger("Unknown_11");
            public LongInteger Unknown_12 = new LongInteger("Unknown_12");
            public ShortInteger unknown_2 = new ShortInteger("unknown_2");
            public RealFloat Unknown_2 = new RealFloat("Unknown_2");
            public ShortInteger unknown_3 = new ShortInteger("unknown_3");
            public ShortInteger Unknown_3 = new ShortInteger("Unknown_3");
            public RealFloat unknown_4 = new RealFloat("unknown_4");
            public ShortInteger Unknown_4 = new ShortInteger("Unknown_4");
            public LongInteger unknown_5 = new LongInteger("unknown_5");
            public RealFloat Unknown_5 = new RealFloat("Unknown_5");
            public LongInteger unknown_6 = new LongInteger("unknown_6");
            public RealFloat Unknown_6 = new RealFloat("Unknown_6");
            public LongInteger Unknown_7 = new LongInteger("Unknown_7");
            public LongInteger Unknown_8 = new LongInteger("Unknown_8");
            public LongInteger Unknown_9 = new LongInteger("Unknown_9");

            public _Object_Attributes__Layout()
            {
                base.Add(this.Unknown);
                base.Add(this.Unknown_0);
                base.Add(this.Unknown_1);
                base.Add(this.Unknown_2);
                base.Add(this.unknown_0);
                base.Add(this.unknown_1);
                base.Add(this.Unknown_3);
                base.Add(this.unknown_2);
                base.Add(this.Unknown_4);
                base.Add(this.unknown_3);
                base.Add(this.unknown_4);
                base.Add(this.Padding);
                base.Add(this._Object_Stacking_);
                base.Add(this.Unknown_5);
                base.Add(this.Padding_0);
                base.Add(this.Unknown_6);
                base.Add(this.No_Name);
                base.Add(this.No_Name_0);
                base.Add(this.No_Name_1);
                base.Add(this.No_Name_2);
                base.Add(this.No_Name_3);
                base.Add(this.No_Name_4);
                base.Add(this.Padding_1);
                base.Add(this.No_Name_5);
                base.Add(this.Unknown_7);
                base.Add(this.Unknown_8);
                base.Add(this.Padding_2);
                base.Add(this.Unknown_9);
                base.Add(this.unknown_5);
                base.Add(this.Unknown_10);
                base.Add(this.Padding_3);
                base.Add(this.Unknown_11);
                base.Add(this.Unknown_12);
                base.Add(this.unknown_6);
                base.Add(this.Padding_4);
            }
        }

        public class hkMoppBvTreeShape_codes_Layout : TagBlockLayout
        {
            public ByteInteger code = new ByteInteger("code");
            public static readonly phmo.hkMoppBvTreeShape_codes_Layout Layout = new phmo.hkMoppBvTreeShape_codes_Layout();

            public hkMoppBvTreeShape_codes_Layout()
            {
                base.Add(this.code);
            }
        }

        public class Joints__Hinges__Layout : TagBlockLayout
        {
            public static readonly phmo.Joints__Hinges__Layout Layout = new phmo.Joints__Hinges__Layout();
            public StringID Name = new StringID("Name");
            public core.TagInterface.Padding Padding = new core.TagInterface.Padding("Padding", 120);
            public LongInteger Unknown = new LongInteger("Unknown");
            public LongInteger Unknown_0 = new LongInteger("Unknown_0");

            public Joints__Hinges__Layout()
            {
                base.Add(this.Name);
                base.Add(this.Unknown);
                base.Add(this.Unknown_0);
                base.Add(this.Padding);
            }
        }

        public class Missed2_Layout : TagBlockLayout
        {
            public core.TagInterface.Flags Flags = new core.TagInterface.Flags("Flags", core.TagInterface.Flags.BitmaskTypeEnum.Long);
            public static readonly phmo.Missed2_Layout Layout = new phmo.Missed2_Layout();
            public StringID Name = new StringID("Name");
            public RealFloat unknown_0 = new RealFloat("unknown_0");
            public RealFloat unknown_1 = new RealFloat("unknown_1");
            public LongInteger unknown_10 = new LongInteger("unknown_10");
            public LongInteger unknown_11 = new LongInteger("unknown_11");
            public LongInteger unknown_12 = new LongInteger("unknown_12");
            public LongInteger unknown_13 = new LongInteger("unknown_13");
            public LongInteger unknown_14 = new LongInteger("unknown_14");
            public LongInteger unknown_15 = new LongInteger("unknown_15");
            public LongInteger unknown_16 = new LongInteger("unknown_16");
            public LongInteger unknown_17 = new LongInteger("unknown_17");
            public LongInteger unknown_18 = new LongInteger("unknown_18");
            public LongInteger unknown_19 = new LongInteger("unknown_19");
            public RealFloat unknown_2 = new RealFloat("unknown_2");
            public LongInteger unknown_20 = new LongInteger("unknown_20");
            public LongInteger unknown_21 = new LongInteger("unknown_21");
            public LongInteger unknown_22 = new LongInteger("unknown_22");
            public RealFloat unknown_3 = new RealFloat("unknown_3");
            public RealFloat unknown_4 = new RealFloat("unknown_4");
            public ShortInteger unknown_5 = new ShortInteger("unknown_5");
            public ShortInteger unknown_6 = new ShortInteger("unknown_6");
            public LongInteger unknown_7 = new LongInteger("unknown_7");
            public LongInteger unknown_8 = new LongInteger("unknown_8");
            public LongInteger unknown_9 = new LongInteger("unknown_9");

            public Missed2_Layout()
            {
                base.Add(this.Name);
                base.Add(this.Flags);
                base.Add(this.unknown_0);
                base.Add(this.unknown_1);
                base.Add(this.unknown_2);
                base.Add(this.unknown_3);
                base.Add(this.unknown_4);
                base.Add(this.unknown_5);
                base.Add(this.unknown_6);
                base.Add(this.unknown_7);
                base.Add(this.unknown_8);
                base.Add(this.unknown_9);
                base.Add(this.unknown_10);
                base.Add(this.unknown_11);
                base.Add(this.unknown_12);
                base.Add(this.unknown_13);
                base.Add(this.unknown_14);
                base.Add(this.unknown_15);
                base.Add(this.unknown_16);
                base.Add(this.unknown_17);
                base.Add(this.unknown_18);
                base.Add(this.unknown_19);
                base.Add(this.unknown_20);
                base.Add(this.unknown_21);
                base.Add(this.unknown_22);
            }
        }

        public class Misssed1_Layout : TagBlockLayout
        {
            public core.TagInterface.Flags Flags = new core.TagInterface.Flags("Flags", core.TagInterface.Flags.BitmaskTypeEnum.Long);
            public static readonly phmo.Misssed1_Layout Layout = new phmo.Misssed1_Layout();
            public StringID Name = new StringID("Name");
            public core.TagInterface.Padding Padding = new core.TagInterface.Padding("Padding", 0x7c);
            public RealFloat unknown_0 = new RealFloat("unknown_0");
            public RealFloat unknown_1 = new RealFloat("unknown_1");
            public LongInteger unknown_10 = new LongInteger("unknown_10");
            public LongInteger unknown_11 = new LongInteger("unknown_11");
            public RealFloat unknown_2 = new RealFloat("unknown_2");
            public RealFloat unknown_3 = new RealFloat("unknown_3");
            public RealFloat unknown_4 = new RealFloat("unknown_4");
            public ShortInteger unknown_5 = new ShortInteger("unknown_5");
            public ShortInteger unknown_6 = new ShortInteger("unknown_6");
            public LongInteger unknown_7 = new LongInteger("unknown_7");
            public LongInteger unknown_8 = new LongInteger("unknown_8");
            public LongInteger unknown_9 = new LongInteger("unknown_9");

            public Misssed1_Layout()
            {
                base.Add(this.Name);
                base.Add(this.Flags);
                base.Add(this.unknown_0);
                base.Add(this.unknown_1);
                base.Add(this.unknown_2);
                base.Add(this.unknown_3);
                base.Add(this.unknown_4);
                base.Add(this.unknown_5);
                base.Add(this.unknown_6);
                base.Add(this.unknown_7);
                base.Add(this.unknown_8);
                base.Add(this.unknown_9);
                base.Add(this.unknown_10);
                base.Add(this.unknown_11);
                base.Add(this.Padding);
            }
        }

        public class Nodes_Layout : TagBlockLayout
        {
            public ShortInteger first_child_node_index = new ShortInteger("first_child_node_index");
            public static readonly phmo.Nodes_Layout Layout = new phmo.Nodes_Layout();
            public StringID name = new StringID("name");
            public ShortInteger next_sibling_node_index = new ShortInteger("next_sibling_node_index");
            public ShortInteger No_Name = new ShortInteger("No_Name");
            public ShortInteger parent_node_index = new ShortInteger("parent_node_index");

            public Nodes_Layout()
            {
                base.Add(this.name);
                base.Add(this.No_Name);
                base.Add(this.parent_node_index);
                base.Add(this.next_sibling_node_index);
                base.Add(this.first_child_node_index);
            }
        }

        public class Powered_mass_point_Layout : TagBlockLayout
        {
            public core.TagInterface.Flags Flags = new core.TagInterface.Flags("Flags", core.TagInterface.Flags.BitmaskTypeEnum.Long);
            public static readonly phmo.Powered_mass_point_Layout Layout = new phmo.Powered_mass_point_Layout();
            public StringID Name = new StringID("Name");
            public RealFloat unknown_0 = new RealFloat("unknown_0");
            public RealFloat unknown_1 = new RealFloat("unknown_1");
            public RealFloat unknown_10 = new RealFloat("unknown_10");
            public RealFloat unknown_11 = new RealFloat("unknown_11");
            public RealFloat unknown_12 = new RealFloat("unknown_12");
            public RealFloat unknown_13 = new RealFloat("unknown_13");
            public RealFloat unknown_14 = new RealFloat("unknown_14");
            public RealFloat unknown_15 = new RealFloat("unknown_15");
            public RealFloat unknown_16 = new RealFloat("unknown_16");
            public RealFloat unknown_17 = new RealFloat("unknown_17");
            public RealFloat unknown_18 = new RealFloat("unknown_18");
            public RealFloat unknown_2 = new RealFloat("unknown_2");
            public RealFloat unknown_3 = new RealFloat("unknown_3");
            public RealFloat unknown_4 = new RealFloat("unknown_4");
            public ShortInteger unknown_5 = new ShortInteger("unknown_5");
            public ShortInteger unknown_6 = new ShortInteger("unknown_6");
            public LongInteger unknown_7 = new LongInteger("unknown_7");
            public LongInteger unknown_8 = new LongInteger("unknown_8");
            public LongInteger unknown_9 = new LongInteger("unknown_9");

            public Powered_mass_point_Layout()
            {
                base.Add(this.Name);
                base.Add(this.Flags);
                base.Add(this.unknown_0);
                base.Add(this.unknown_1);
                base.Add(this.unknown_2);
                base.Add(this.unknown_3);
                base.Add(this.unknown_4);
                base.Add(this.unknown_5);
                base.Add(this.unknown_6);
                base.Add(this.unknown_7);
                base.Add(this.unknown_8);
                base.Add(this.unknown_9);
                base.Add(this.unknown_10);
                base.Add(this.unknown_11);
                base.Add(this.unknown_12);
                base.Add(this.unknown_13);
                base.Add(this.unknown_14);
                base.Add(this.unknown_15);
                base.Add(this.unknown_16);
                base.Add(this.unknown_17);
                base.Add(this.unknown_18);
            }
        }

        public class unknown_2_Layout : TagBlockLayout
        {
            public static readonly phmo.unknown_2_Layout Layout = new phmo.unknown_2_Layout();
            public LongInteger unknown_0 = new LongInteger("unknown_0");
            public LongInteger unknown_1 = new LongInteger("unknown_1");
            public LongInteger unknown_10 = new LongInteger("unknown_10");
            public LongInteger unknown_11 = new LongInteger("unknown_11");
            public LongInteger unknown_2 = new LongInteger("unknown_2");
            public LongInteger unknown_3 = new LongInteger("unknown_3");
            public LongInteger unknown_4 = new LongInteger("unknown_4");
            public LongInteger unknown_5 = new LongInteger("unknown_5");
            public LongInteger unknown_6 = new LongInteger("unknown_6");
            public LongInteger unknown_7 = new LongInteger("unknown_7");
            public LongInteger unknown_8 = new LongInteger("unknown_8");
            public LongInteger unknown_9 = new LongInteger("unknown_9");

            public unknown_2_Layout()
            {
                base.Add(this.unknown_0);
                base.Add(this.unknown_1);
                base.Add(this.unknown_2);
                base.Add(this.unknown_3);
                base.Add(this.unknown_4);
                base.Add(this.unknown_5);
                base.Add(this.unknown_6);
                base.Add(this.unknown_7);
                base.Add(this.unknown_8);
                base.Add(this.unknown_9);
                base.Add(this.unknown_10);
                base.Add(this.unknown_11);
            }
        }

        public class unknown_3_Layout : TagBlockLayout
        {
            public static readonly phmo.unknown_3_Layout Layout = new phmo.unknown_3_Layout();
            public StringID Name = new StringID("Name");
            public TagBlock unknown_0 = new TagBlock("unknown_0", unknown_0_Layout.Layout, Map.HaloVersionEnum.Halo2);

            public unknown_3_Layout()
            {
                base.Add(this.Name);
                base.Add(this.unknown_0);
            }

            public class unknown_0_Layout : TagBlockLayout
            {
                public static readonly phmo.unknown_3_Layout.unknown_0_Layout Layout = new phmo.unknown_3_Layout.unknown_0_Layout();
                public StringID Name = new StringID("Name");
                public TagBlock unknown_0 = new TagBlock("unknown_0", unknown_0x_Layout.Layout, Map.HaloVersionEnum.Halo2);

                public unknown_0_Layout()
                {
                    base.Add(this.Name);
                    base.Add(this.unknown_0);
                }

                public class unknown_0x_Layout : TagBlockLayout
                {
                    public ShortInteger Index = new ShortInteger("Index");
                    public static readonly phmo.unknown_3_Layout.unknown_0_Layout.unknown_0x_Layout Layout = new phmo.unknown_3_Layout.unknown_0_Layout.unknown_0x_Layout();

                    public unknown_0x_Layout()
                    {
                        base.Add(this.Index);
                    }
                }
            }
        }

        public class Unknown223_Layout : TagBlockLayout
        {
            public static readonly phmo.Unknown223_Layout Layout = new phmo.Unknown223_Layout();
            public ShortInteger Unknown = new ShortInteger("Unknown");
            public LongInteger unknown_0 = new LongInteger("unknown_0");
            public ShortInteger Unknown_0 = new ShortInteger("Unknown_0");
            public LongInteger unknown_1 = new LongInteger("unknown_1");
            public ShortInteger Unknown_1 = new ShortInteger("Unknown_1");
            public LongInteger unknown_2 = new LongInteger("unknown_2");
            public ShortInteger Unknown_2 = new ShortInteger("Unknown_2");
            public LongInteger unknown_3 = new LongInteger("unknown_3");
            public LongInteger unknown_4 = new LongInteger("unknown_4");
            public LongInteger unknown_5 = new LongInteger("unknown_5");
            public LongInteger unknown_6 = new LongInteger("unknown_6");
            public LongInteger unknown_7 = new LongInteger("unknown_7");
            public LongInteger unused = new LongInteger("unused");
            public ShortInteger unused_0 = new ShortInteger("unused_0");
            public LongInteger unused_1 = new LongInteger("unused_1");
            public ShortInteger unused_2 = new ShortInteger("unused_2");
            public LongInteger unused_3 = new LongInteger("unused_3");

            public Unknown223_Layout()
            {
                base.Add(this.unknown_0);
                base.Add(this.unknown_1);
                base.Add(this.unknown_2);
                base.Add(this.unknown_3);
                base.Add(this.unknown_4);
                base.Add(this.unknown_5);
                base.Add(this.unknown_6);
                base.Add(this.unknown_7);
                base.Add(this.Unknown);
                base.Add(this.Unknown_0);
                base.Add(this.unused);
                base.Add(this.Unknown_1);
                base.Add(this.unused_0);
                base.Add(this.unused_1);
                base.Add(this.Unknown_2);
                base.Add(this.unused_2);
                base.Add(this.unused_3);
            }
        }

        public class Unknown239_Layout : TagBlockLayout
        {
            public static readonly phmo.Unknown239_Layout Layout = new phmo.Unknown239_Layout();
            public core.TagInterface.Padding Padding = new core.TagInterface.Padding("Padding", 4);
            public LongInteger Unknown = new LongInteger("Unknown");

            public Unknown239_Layout()
            {
                base.Add(this.Unknown);
                base.Add(this.Padding);
            }
        }

        public class Unknown243_Layout : TagBlockLayout
        {
            public LongInteger code = new LongInteger("code");
            public static readonly phmo.Unknown243_Layout Layout = new phmo.Unknown243_Layout();
            public LongInteger shape_collection = new LongInteger("shape_collection");
            public RealFloat Unknown = new RealFloat("Unknown");
            public LongInteger unknown_0 = new LongInteger("unknown_0");
            public LongInteger unknown_1 = new LongInteger("unknown_1");
            public LongInteger unknown_2 = new LongInteger("unknown_2");

            public Unknown243_Layout()
            {
                base.Add(this.unknown_0);
                base.Add(this.unknown_1);
                base.Add(this.unknown_2);
                base.Add(this.shape_collection);
                base.Add(this.code);
                base.Add(this.Unknown);
            }
        }

        public class Unknown25_Layout : TagBlockLayout
        {
            public static readonly phmo.Unknown25_Layout Layout = new phmo.Unknown25_Layout();
            public core.TagInterface.Padding Padding = new core.TagInterface.Padding("Padding", 140);
            public RealFloat Unknown = new RealFloat("Unknown");
            public RealFloat Unknown_0 = new RealFloat("Unknown_0");

            public Unknown25_Layout()
            {
                base.Add(this.Unknown);
                base.Add(this.Unknown_0);
                base.Add(this.Padding);
            }
        }

        public class Unknown264_Layout : TagBlockLayout
        {
            public LongInteger _and_ref_count = new LongInteger("_and_ref_count");
            public LongInteger boundingVolumeShape = new LongInteger("boundingVolumeShape");
            public LongInteger childShape = new LongInteger("childShape");
            public static readonly phmo.Unknown264_Layout Layout = new phmo.Unknown264_Layout();
            public LongInteger No_Name = new LongInteger("No_Name");
            public LongInteger No_Name_0 = new LongInteger("No_Name_0");
            public LongInteger unknown_0 = new LongInteger("unknown_0");
            public LongInteger unknown_1 = new LongInteger("unknown_1");
            public LongInteger unknown_2 = new LongInteger("unknown_2");

            public Unknown264_Layout()
            {
                base.Add(this.No_Name);
                base.Add(this._and_ref_count);
                base.Add(this.No_Name_0);
                base.Add(this.boundingVolumeShape);
                base.Add(this.childShape);
                base.Add(this.unknown_0);
                base.Add(this.unknown_1);
                base.Add(this.unknown_2);
            }
        }

        public class Unknown268_Layout : TagBlockLayout
        {
            public static readonly phmo.Unknown268_Layout Layout = new phmo.Unknown268_Layout();
            public core.TagInterface.Padding Padding = new core.TagInterface.Padding("Padding", 0x74);
            public StringID Unknown = new StringID("Unknown");

            public Unknown268_Layout()
            {
                base.Add(this.Unknown);
                base.Add(this.Padding);
            }
        }

        public class Unknown48_Layout : TagBlockLayout
        {
            public core.TagInterface.Flags Flags = new core.TagInterface.Flags("Flags", core.TagInterface.Flags.BitmaskTypeEnum.Long);
            public static readonly phmo.Unknown48_Layout Layout = new phmo.Unknown48_Layout();
            public StringID Name = new StringID("Name");
            public RealFloat radius = new RealFloat("radius");
            public RealFloat unknown_0 = new RealFloat("unknown_0");
            public RealFloat unknown_1 = new RealFloat("unknown_1");
            public LongInteger unknown_10 = new LongInteger("unknown_10");
            public LongInteger unknown_11 = new LongInteger("unknown_11");
            public LongInteger unknown_12 = new LongInteger("unknown_12");
            public LongInteger unknown_13 = new LongInteger("unknown_13");
            public RealFloat unknown_14 = new RealFloat("unknown_14");
            public RealFloat unknown_15 = new RealFloat("unknown_15");
            public RealFloat unknown_16 = new RealFloat("unknown_16");
            public RealFloat unknown_17 = new RealFloat("unknown_17");
            public RealFloat unknown_18 = new RealFloat("unknown_18");
            public RealFloat unknown_19 = new RealFloat("unknown_19");
            public RealFloat unknown_2 = new RealFloat("unknown_2");
            public RealFloat unknown_20 = new RealFloat("unknown_20");
            public RealFloat unknown_21 = new RealFloat("unknown_21");
            public RealFloat unknown_22 = new RealFloat("unknown_22");
            public RealFloat unknown_23 = new RealFloat("unknown_23");
            public RealFloat unknown_24 = new RealFloat("unknown_24");
            public RealFloat unknown_25 = new RealFloat("unknown_25");
            public RealFloat unknown_26 = new RealFloat("unknown_26");
            public RealFloat unknown_27 = new RealFloat("unknown_27");
            public RealFloat unknown_28 = new RealFloat("unknown_28");
            public RealFloat unknown_29 = new RealFloat("unknown_29");
            public RealFloat unknown_3 = new RealFloat("unknown_3");
            public RealFloat unknown_4 = new RealFloat("unknown_4");
            public ShortInteger unknown_5 = new ShortInteger("unknown_5");
            public ShortInteger unknown_6 = new ShortInteger("unknown_6");
            public LongInteger unknown_7 = new LongInteger("unknown_7");
            public LongInteger unknown_8 = new LongInteger("unknown_8");
            public LongInteger unknown_9 = new LongInteger("unknown_9");

            public Unknown48_Layout()
            {
                base.Add(this.Name);
                base.Add(this.Flags);
                base.Add(this.unknown_0);
                base.Add(this.unknown_1);
                base.Add(this.unknown_2);
                base.Add(this.unknown_3);
                base.Add(this.unknown_4);
                base.Add(this.unknown_5);
                base.Add(this.unknown_6);
                base.Add(this.unknown_7);
                base.Add(this.unknown_8);
                base.Add(this.unknown_9);
                base.Add(this.radius);
                base.Add(this.unknown_10);
                base.Add(this.unknown_11);
                base.Add(this.unknown_12);
                base.Add(this.unknown_13);
                base.Add(this.unknown_14);
                base.Add(this.unknown_15);
                base.Add(this.unknown_16);
                base.Add(this.unknown_17);
                base.Add(this.unknown_18);
                base.Add(this.unknown_19);
                base.Add(this.unknown_20);
                base.Add(this.unknown_21);
                base.Add(this.unknown_22);
                base.Add(this.unknown_23);
                base.Add(this.unknown_24);
                base.Add(this.unknown_25);
                base.Add(this.unknown_26);
                base.Add(this.unknown_27);
                base.Add(this.unknown_28);
                base.Add(this.unknown_29);
            }
        }

        public class Unknown9_0_Layout : TagBlockLayout
        {
            public static readonly phmo.Unknown9_0_Layout Layout = new phmo.Unknown9_0_Layout();
            public ShortInteger No_Name = new ShortInteger("No_Name");
            public ShortInteger No_Name_0 = new ShortInteger("No_Name_0");
            public ShortInteger No_Name_1 = new ShortInteger("No_Name_1");
            public ShortInteger No_Name_2 = new ShortInteger("No_Name_2");
            public StringID No_Name_3 = new StringID("No_Name_3");
            public StringID No_Name_4 = new StringID("No_Name_4");
            public TagBlock Unknown10 = new TagBlock("Unknown10", Unknown10_Layout.Layout, Map.HaloVersionEnum.Halo2);

            public Unknown9_0_Layout()
            {
                base.Add(this.No_Name);
                base.Add(this.No_Name_0);
                base.Add(this.No_Name_1);
                base.Add(this.No_Name_2);
                base.Add(this.Unknown10);
                base.Add(this.No_Name_3);
                base.Add(this.No_Name_4);
            }

            public class Unknown10_Layout : TagBlockLayout
            {
                public static readonly phmo.Unknown9_0_Layout.Unknown10_Layout Layout = new phmo.Unknown9_0_Layout.Unknown10_Layout();
                public RealFloat lower = new RealFloat("lower");
                public ShortInteger No_Name = new ShortInteger("No_Name");
                public ShortInteger No_Name_0 = new ShortInteger("No_Name_0");
                public RealFloat upper = new RealFloat("upper");

                public Unknown10_Layout()
                {
                    base.Add(this.No_Name);
                    base.Add(this.No_Name_0);
                    base.Add(this.lower);
                    base.Add(this.upper);
                }
            }
        }

        public class Unknown9_Layout : TagBlockLayout
        {
            public static readonly phmo.Unknown9_Layout Layout = new phmo.Unknown9_Layout();
            public StringID No_Name = new StringID("No_Name");
            public StringID No_Name_0 = new StringID("No_Name_0");
            public core.TagInterface.Padding Padding = new core.TagInterface.Padding("Padding", 8);
            public core.TagInterface.Padding Padding_0 = new core.TagInterface.Padding("Padding", 0x58);

            public Unknown9_Layout()
            {
                base.Add(this.Padding);
                base.Add(this.No_Name);
                base.Add(this.No_Name_0);
                base.Add(this.Padding_0);
            }
        }

        public class Vehicle_Attachments_Layout : TagBlockLayout
        {
            public LongInteger _user_data__ptr_to_this_hkBoxShape = new LongInteger("_user_data__ptr_to_this_hkBoxShape");
            public LongInteger child_shape = new LongInteger("child_shape");
            public core.TagInterface.Flags Flags = new core.TagInterface.Flags("Flags", core.TagInterface.Flags.BitmaskTypeEnum.Long);
            public LongInteger hkBoxShape_custom_vtable = new LongInteger("hkBoxShape_custom_vtable");
            public LongInteger hkTransformShape_custom_vtable = new LongInteger("hkTransformShape_custom_vtable");
            public static readonly phmo.Vehicle_Attachments_Layout Layout = new phmo.Vehicle_Attachments_Layout();
            public StringID Name = new StringID("Name");
            public RealFloat No_Name = new RealFloat("No_Name");
            public RealFloat No_Name_0 = new RealFloat("No_Name_0");
            public RealFloat No_Name_1 = new RealFloat("No_Name_1");
            public RealFloat No_Name_2 = new RealFloat("No_Name_2");
            public LongInteger pad1 = new LongInteger("pad1");
            public LongInteger radius = new LongInteger("radius");
            public LongInteger size_and_flags = new LongInteger("size_and_flags");
            public ShortInteger Unknown = new ShortInteger("Unknown");
            public RealFloat unknown_0 = new RealFloat("unknown_0");
            public RealFloat unknown_1 = new RealFloat("unknown_1");
            public LongInteger unknown_10 = new LongInteger("unknown_10");
            public LongInteger unknown_11 = new LongInteger("unknown_11");
            public LongInteger unknown_12 = new LongInteger("unknown_12");
            public LongInteger unknown_13 = new LongInteger("unknown_13");
            public LongInteger unknown_14 = new LongInteger("unknown_14");
            public LongInteger unknown_15 = new LongInteger("unknown_15");
            public LongInteger unknown_16 = new LongInteger("unknown_16");
            public LongInteger unknown_17 = new LongInteger("unknown_17");
            public LongInteger unknown_18 = new LongInteger("unknown_18");
            public LongInteger unknown_19 = new LongInteger("unknown_19");
            public RealFloat unknown_2 = new RealFloat("unknown_2");
            public LongInteger unknown_20 = new LongInteger("unknown_20");
            public LongInteger unknown_21 = new LongInteger("unknown_21");
            public RealFloat unknown_3 = new RealFloat("unknown_3");
            public RealFloat unknown_4 = new RealFloat("unknown_4");
            public ShortInteger unknown_5 = new ShortInteger("unknown_5");
            public LongInteger unknown_6 = new LongInteger("unknown_6");
            public LongInteger unknown_7 = new LongInteger("unknown_7");
            public LongInteger unknown_8 = new LongInteger("unknown_8");
            public LongInteger unknown_9 = new LongInteger("unknown_9");
            public LongInteger user_data = new LongInteger("user_data");

            public Vehicle_Attachments_Layout()
            {
                base.Add(this.Name);
                base.Add(this.Flags);
                base.Add(this.unknown_0);
                base.Add(this.unknown_1);
                base.Add(this.unknown_2);
                base.Add(this.unknown_3);
                base.Add(this.unknown_4);
                base.Add(this.unknown_5);
                base.Add(this.Unknown);
                base.Add(this.hkBoxShape_custom_vtable);
                base.Add(this.user_data);
                base.Add(this.radius);
                base.Add(this.pad1);
                base.Add(this.No_Name);
                base.Add(this.No_Name_0);
                base.Add(this.No_Name_1);
                base.Add(this.No_Name_2);
                base.Add(this.hkTransformShape_custom_vtable);
                base.Add(this.size_and_flags);
                base.Add(this._user_data__ptr_to_this_hkBoxShape);
                base.Add(this.child_shape);
                base.Add(this.unknown_6);
                base.Add(this.unknown_7);
                base.Add(this.unknown_8);
                base.Add(this.unknown_9);
                base.Add(this.unknown_10);
                base.Add(this.unknown_11);
                base.Add(this.unknown_12);
                base.Add(this.unknown_13);
                base.Add(this.unknown_14);
                base.Add(this.unknown_15);
                base.Add(this.unknown_16);
                base.Add(this.unknown_17);
                base.Add(this.unknown_18);
                base.Add(this.unknown_19);
                base.Add(this.unknown_20);
                base.Add(this.unknown_21);
            }
        }

        public class Vehicle_Parts136__Powered_Mass_Point__Layout : TagBlockLayout
        {
            public core.TagInterface.Flags Flags = new core.TagInterface.Flags("Flags", core.TagInterface.Flags.BitmaskTypeEnum.Long);
            public static readonly phmo.Vehicle_Parts136__Powered_Mass_Point__Layout Layout = new phmo.Vehicle_Parts136__Powered_Mass_Point__Layout();
            public LongInteger matrix_1_0 = new LongInteger("matrix_1_0");
            public LongInteger matrix_1_1 = new LongInteger("matrix_1_1");
            public LongInteger matrix_1_10 = new LongInteger("matrix_1_10");
            public LongInteger matrix_1_11 = new LongInteger("matrix_1_11");
            public LongInteger matrix_1_2 = new LongInteger("matrix_1_2");
            public LongInteger matrix_1_3 = new LongInteger("matrix_1_3");
            public LongInteger matrix_1_4 = new LongInteger("matrix_1_4");
            public LongInteger matrix_1_5 = new LongInteger("matrix_1_5");
            public LongInteger matrix_1_6 = new LongInteger("matrix_1_6");
            public LongInteger matrix_1_7 = new LongInteger("matrix_1_7");
            public LongInteger matrix_1_8 = new LongInteger("matrix_1_8");
            public LongInteger matrix_1_9 = new LongInteger("matrix_1_9");
            public StringID Name = new StringID("Name");
            public LongInteger Unknown = new LongInteger("Unknown");
            public RealFloat unknown_0 = new RealFloat("unknown_0");
            public LongInteger Unknown_0 = new LongInteger("Unknown_0");
            public RealFloat unknown_1 = new RealFloat("unknown_1");
            public LongInteger Unknown_1 = new LongInteger("Unknown_1");
            public LongInteger unknown_10 = new LongInteger("unknown_10");
            public LongInteger Unknown_10 = new LongInteger("Unknown_10");
            public LongInteger unknown_11 = new LongInteger("unknown_11");
            public LongInteger Unknown_11 = new LongInteger("Unknown_11");
            public LongInteger unknown_12 = new LongInteger("unknown_12");
            public LongInteger Unknown_12 = new LongInteger("Unknown_12");
            public LongInteger unknown_13 = new LongInteger("unknown_13");
            public LongInteger Unknown_13 = new LongInteger("Unknown_13");
            public LongInteger unknown_14 = new LongInteger("unknown_14");
            public LongInteger Unknown_14 = new LongInteger("Unknown_14");
            public LongInteger unknown_15 = new LongInteger("unknown_15");
            public LongInteger Unknown_15 = new LongInteger("Unknown_15");
            public LongInteger unknown_16 = new LongInteger("unknown_16");
            public LongInteger Unknown_16 = new LongInteger("Unknown_16");
            public LongInteger unknown_17 = new LongInteger("unknown_17");
            public LongInteger Unknown_17 = new LongInteger("Unknown_17");
            public LongInteger unknown_18 = new LongInteger("unknown_18");
            public LongInteger Unknown_18 = new LongInteger("Unknown_18");
            public LongInteger unknown_19 = new LongInteger("unknown_19");
            public LongInteger Unknown_19 = new LongInteger("Unknown_19");
            public RealFloat unknown_2 = new RealFloat("unknown_2");
            public LongInteger Unknown_2 = new LongInteger("Unknown_2");
            public LongInteger unknown_20 = new LongInteger("unknown_20");
            public LongInteger Unknown_20 = new LongInteger("Unknown_20");
            public LongInteger unknown_21 = new LongInteger("unknown_21");
            public LongInteger Unknown_21 = new LongInteger("Unknown_21");
            public LongInteger unknown_22 = new LongInteger("unknown_22");
            public LongInteger Unknown_22 = new LongInteger("Unknown_22");
            public LongInteger Unknown_23 = new LongInteger("Unknown_23");
            public LongInteger Unknown_24 = new LongInteger("Unknown_24");
            public LongInteger Unknown_25 = new LongInteger("Unknown_25");
            public LongInteger Unknown_26 = new LongInteger("Unknown_26");
            public RealFloat unknown_3 = new RealFloat("unknown_3");
            public LongInteger Unknown_3 = new LongInteger("Unknown_3");
            public RealFloat unknown_4 = new RealFloat("unknown_4");
            public LongInteger Unknown_4 = new LongInteger("Unknown_4");
            public ShortInteger unknown_5 = new ShortInteger("unknown_5");
            public LongInteger Unknown_5 = new LongInteger("Unknown_5");
            public ShortInteger unknown_6 = new ShortInteger("unknown_6");
            public LongInteger Unknown_6 = new LongInteger("Unknown_6");
            public LongInteger unknown_7 = new LongInteger("unknown_7");
            public LongInteger Unknown_7 = new LongInteger("Unknown_7");
            public LongInteger unknown_8 = new LongInteger("unknown_8");
            public LongInteger Unknown_8 = new LongInteger("Unknown_8");
            public LongInteger unknown_9 = new LongInteger("unknown_9");
            public LongInteger Unknown_9 = new LongInteger("Unknown_9");

            public Vehicle_Parts136__Powered_Mass_Point__Layout()
            {
                base.Add(this.Name);
                base.Add(this.Flags);
                base.Add(this.unknown_0);
                base.Add(this.unknown_1);
                base.Add(this.unknown_2);
                base.Add(this.unknown_3);
                base.Add(this.unknown_4);
                base.Add(this.unknown_5);
                base.Add(this.unknown_6);
                base.Add(this.unknown_7);
                base.Add(this.unknown_8);
                base.Add(this.unknown_9);
                base.Add(this.unknown_10);
                base.Add(this.unknown_11);
                base.Add(this.unknown_12);
                base.Add(this.unknown_13);
                base.Add(this.unknown_14);
                base.Add(this.unknown_15);
                base.Add(this.unknown_16);
                base.Add(this.unknown_17);
                base.Add(this.unknown_18);
                base.Add(this.matrix_1_0);
                base.Add(this.matrix_1_1);
                base.Add(this.matrix_1_2);
                base.Add(this.matrix_1_3);
                base.Add(this.matrix_1_4);
                base.Add(this.matrix_1_5);
                base.Add(this.matrix_1_6);
                base.Add(this.matrix_1_7);
                base.Add(this.matrix_1_8);
                base.Add(this.matrix_1_9);
                base.Add(this.matrix_1_10);
                base.Add(this.matrix_1_11);
                base.Add(this.Unknown);
                base.Add(this.Unknown_0);
                base.Add(this.Unknown_1);
                base.Add(this.Unknown_2);
                base.Add(this.Unknown_3);
                base.Add(this.Unknown_4);
                base.Add(this.Unknown_5);
                base.Add(this.Unknown_6);
                base.Add(this.Unknown_7);
                base.Add(this.Unknown_8);
                base.Add(this.Unknown_9);
                base.Add(this.Unknown_10);
                base.Add(this.Unknown_11);
                base.Add(this.Unknown_12);
                base.Add(this.Unknown_13);
                base.Add(this.Unknown_14);
                base.Add(this.Unknown_15);
                base.Add(this.Unknown_16);
                base.Add(this.Unknown_17);
                base.Add(this.Unknown_18);
                base.Add(this.Unknown_19);
                base.Add(this.Unknown_20);
                base.Add(this.Unknown_21);
                base.Add(this.Unknown_22);
                base.Add(this.Unknown_23);
                base.Add(this.Unknown_24);
                base.Add(this.Unknown_25);
                base.Add(this.Unknown_26);
                base.Add(this.unknown_19);
                base.Add(this.unknown_20);
                base.Add(this.unknown_21);
                base.Add(this.unknown_22);
            }
        }

        public class Vertices_Layout : TagBlockLayout
        {
            public static readonly phmo.Vertices_Layout Layout = new phmo.Vertices_Layout();
            public RealFloat w__radius_ = new RealFloat("w__radius_");
            public RealFloat x = new RealFloat("x");
            public RealFloat y = new RealFloat("y");
            public RealFloat z = new RealFloat("z");

            public Vertices_Layout()
            {
                base.Add(this.x);
                base.Add(this.y);
                base.Add(this.z);
                base.Add(this.w__radius_);
            }
        }
    }
}

