﻿namespace core.H2
{
    using core.TagInterface;
    using System;
    using System.Collections.Generic;

    public class scnr : TagBlockLayout
    {
        public TagBlock AI_Encounters = new TagBlock("AI Encounters", AI_Encounters_Layout.Layout, Map.HaloVersionEnum.Halo2);
        public TagBlock AI_Squad_Types = new TagBlock("AI Squad Types", AI_Squad_Types_Layout.Layout, Map.HaloVersionEnum.Halo2);
        public TagBlock AI_Squads = new TagBlock("AI Squads", AI_Squads_Layout.Layout, Map.HaloVersionEnum.Halo2);
        public TagBlock AI_Zones = new TagBlock("AI Zones", AI_Zones_Layout.Layout, Map.HaloVersionEnum.Halo2);
        public TagBlock Background_Sound_Palette = new TagBlock("Background Sound Palette", Background_Sound_Palette_Layout.Layout, Map.HaloVersionEnum.Halo2);
        public TagBlock Biped_Palette = new TagBlock("Biped Palette", Biped_Palette_Layout.Layout, Map.HaloVersionEnum.Halo2);
        public TagBlock Biped_Placement = new TagBlock("Biped Placement", Biped_Placement_Layout.Layout, Map.HaloVersionEnum.Halo2);
        public TagBlock Characters = new TagBlock("Characters", Characters_Layout.Layout, Map.HaloVersionEnum.Halo2);
        public TagBlock Control_Palette = new TagBlock("Control Palette", Control_Palette_Layout.Layout, Map.HaloVersionEnum.Halo2);
        public TagBlock Control_Placement = new TagBlock("Control Placement", Control_Placement_Layout.Layout, Map.HaloVersionEnum.Halo2);
        public TagBlock Cutscene_Camera = new TagBlock("Cutscene Camera", Cutscene_Camera_Layout.Layout, Map.HaloVersionEnum.Halo2);
        public TagBlock Cutscene_Flags = new TagBlock("Cutscene Flags", Cutscene_Flags_Layout.Layout, Map.HaloVersionEnum.Halo2);
        public TagBlock Cutscene_Titles = new TagBlock("Cutscene Titles", Cutscene_Titles_Layout.Layout, Map.HaloVersionEnum.Halo2);
        public TagBlock Trigger_Volumes = new TagBlock("Trigger Volumes", Trigger_Volumes_Layout.Layout, Map.HaloVersionEnum.Halo2);
        public TagBlock Decal_Palette = new TagBlock("Decal Palette", Decal_Palette_Layout.Layout, Map.HaloVersionEnum.Halo2);
        public TagBlock Decal_Placement = new TagBlock("Decal Placement", Decal_Placement_Layout.Layout, Map.HaloVersionEnum.Halo2);
        public TagBlock Decorator_Palette = new TagBlock("Decorator Palette", Decorator_Palette_Layout.Layout, Map.HaloVersionEnum.Halo2);
        public TagBlock Device_Groups = new TagBlock("Device Groups", Device_Groups_Layout.Layout, Map.HaloVersionEnum.Halo2);
        public TagBlock Equipment_Palette = new TagBlock("Equipment Palette", Equipment_Palette_Layout.Layout, Map.HaloVersionEnum.Halo2);
        public TagBlock Equipment_Placement = new TagBlock("Equipment Placement", Equipment_Placement_Layout.Layout, Map.HaloVersionEnum.Halo2);
        public TagBlock Planar_Fog_Palette = new TagBlock("Planar Fog Palette", Planar_Fog_Palette_Layout.Layout, Map.HaloVersionEnum.Halo2);
        public TagBlock Atmospheric_Fog_Palette = new TagBlock("Atmospheric Fog Palette", Atmospheric_Fog_Palette_Layout.Layout, Map.HaloVersionEnum.Halo2);
        public HaloTagType Global_Lighting = new HaloTagType("Global Lighting");
        public TagIdent Global_Lighting_0 = new TagIdent("Global Lighting");
        public TagBlock Globals = new TagBlock("Globals", Globals_Layout.Layout, Map.HaloVersionEnum.Halo2);
        public TagBlock Scenario_Kill_Triggers = new TagBlock("Scenario Kill Triggers", Scenario_Kill_Triggers_Layout.Layout, Map.HaloVersionEnum.Halo2);
        public static readonly scnr Layout = new scnr();
        public TagBlock Level_Dialog_Palette = new TagBlock("Level Dialogs Palette", Level_Dialogs_Palette_Layout.Layout, Map.HaloVersionEnum.Halo2);
        public TagBlock Light_Volumes_Palette = new TagBlock("Light Volumes Palette", Light_Volumes_Palette_Layout.Layout, Map.HaloVersionEnum.Halo2);
        public TagBlock Light_Volumes_Placement = new TagBlock("Light Volumes Placement", Light_Volumes_Placement_Layout.Layout, Map.HaloVersionEnum.Halo2);
        public HaloTagType Territory_Location_Names = new HaloTagType("Territory Location Names");
        public TagIdent Territory_Location_Names_0 = new TagIdent("Territory Location Names");
        public HaloTagType Location_Names_1 = new HaloTagType("Territory Location Names");
        public TagIdent Location_Names_2 = new TagIdent("Territory Location Names");
        public TagBlock Machine_Palette = new TagBlock("Machine Palette", Machine_Palette_Layout.Layout, Map.HaloVersionEnum.Halo2);
        public TagBlock Machine_Placement = new TagBlock("Machine Placement", Machine_Placement_Layout.Layout, Map.HaloVersionEnum.Halo2);
        public TagBlock Map_Description = new TagBlock("Map Description", Map_Description_Layout.Layout, Map.HaloVersionEnum.Halo2);
        public core.TagInterface.Enumerator Map_Type = new core.TagInterface.Enumerator("Map Type", core.TagInterface.Enumerator.TagEnumeratorIndexType.Word);
        public TagBlock Netgame_Equipment = new TagBlock("Netgame Equipment", Netgame_Equipment_Layout.Layout, Map.HaloVersionEnum.Halo2);
        public TagBlock Netgame_Flags = new TagBlock("Netgame Flags", Netgame_Flags_Layout.Layout, Map.HaloVersionEnum.Halo2);
        public TagBlock Obstacle_Palette = new TagBlock("Obstacle Palette", Obstacle_Palette_Layout.Layout, Map.HaloVersionEnum.Halo2);
        public TagBlock Obstacle_Placement = new TagBlock("Obstacle Placement", Obstacle_Placement_Layout.Layout, Map.HaloVersionEnum.Halo2);
        public core.TagInterface.Padding Padding = new core.TagInterface.Padding("Padding", 12);
        public core.TagInterface.Padding Padding_0 = new core.TagInterface.Padding("Padding", 0x20);
        public core.TagInterface.Padding Padding_1 = new core.TagInterface.Padding("Padding", 0x10);
        public core.TagInterface.Padding Padding_10 = new core.TagInterface.Padding("Padding", 80);
        public core.TagInterface.Padding Padding_11 = new core.TagInterface.Padding("Padding", 8);
        public core.TagInterface.Padding Padding_12 = new core.TagInterface.Padding("Padding", 0x18);
        public core.TagInterface.Padding Padding_13 = new core.TagInterface.Padding("Padding", 8);
        public core.TagInterface.Padding Padding_14 = new core.TagInterface.Padding("Padding", 8);
        public core.TagInterface.Padding Padding_15 = new core.TagInterface.Padding("Padding", 8);
        public core.TagInterface.Padding Padding_16 = new core.TagInterface.Padding("Padding", 8);
        public core.TagInterface.Padding Padding_2 = new core.TagInterface.Padding("Padding", 8);
        public core.TagInterface.Padding Padding_3 = new core.TagInterface.Padding("Padding", 8);
        public core.TagInterface.Padding Padding_4 = new core.TagInterface.Padding("Padding", 0x30);
        public core.TagInterface.Padding Padding_5 = new core.TagInterface.Padding("Padding", 8);
        public core.TagInterface.Padding Padding_6 = new core.TagInterface.Padding("Padding", 8);
        public core.TagInterface.Padding Padding_7 = new core.TagInterface.Padding("Padding", 40);
        public core.TagInterface.Padding Padding_8 = new core.TagInterface.Padding("Padding", 8);
        public core.TagInterface.Padding Padding_9 = new core.TagInterface.Padding("Padding", 4);
        public TagBlock Player_Starting_Locations = new TagBlock("Player Starting Locations", Player_Starting_Locations_Layout.Layout, Map.HaloVersionEnum.Halo2);
        public TagBlock Predicted_Resources = new TagBlock("Predicted Resources", Predicted_Resources_Layout.Layout, Map.HaloVersionEnum.Halo2);
        public TagBlock Predicted_Resources_0 = new TagBlock("Predicted Resources", Predicted_Resources_0_Layout.Layout, Map.HaloVersionEnum.Halo2);
        public TagBlock Player_Starting_Profiles = new TagBlock("Player Starting Profiles", Player_Starting_Profiles_Layout.Layout, Map.HaloVersionEnum.Halo2);
        public TagBlock Scenery_Palette = new TagBlock("Scenery Palette", Scenery_Palette_Layout.Layout, Map.HaloVersionEnum.Halo2);
        public TagBlock Scenery_Placement = new TagBlock("Scenery Placement", Scenery_Placement_Layout.Layout, Map.HaloVersionEnum.Halo2);
        public TagBlock Screen_Effects = new TagBlock("Screen Effects", Screen_Effects_Layout.Layout, Map.HaloVersionEnum.Halo2);
        public TagBlock Script_Data = new TagBlock("Script Data", Script_Data_Layout.Layout, Map.HaloVersionEnum.Halo2);
        public TagBlock Script_Locations = new TagBlock("Script Locations", Script_Locations_Layout.Layout, Map.HaloVersionEnum.Halo2);
        public TagBlock Script_Objects = new TagBlock("Script Objects", Script_Objects_Layout.Layout, Map.HaloVersionEnum.Halo2);
        public TagBlock script_syntax = new TagBlock("Script_Syntax", Script_Syntax.Layout, Map.HaloVersionEnum.Halo2);
        public TagBlock Scripts = new TagBlock("Scripts", Scripts_Layout.Layout, Map.HaloVersionEnum.Halo2);
        public TagBlock Sky_Palette = new TagBlock("Sky Palette", Sky_Palette_Layout.Layout, Map.HaloVersionEnum.Halo2);
        public TagBlock Sound_Environment_Palette = new TagBlock("Sound Environment Palette", Sound_Environment_Palette_Layout.Layout, Map.HaloVersionEnum.Halo2);
        public TagBlock Sound_Scenery_Palette = new TagBlock("Sound Scenery Palette", Sound_Scenery_Palette_Layout.Layout, Map.HaloVersionEnum.Halo2);
        public TagBlock Sound_Scenery_Placement = new TagBlock("Sound Scenery Placement", Sound_Scenery_Placement_Layout.Layout, Map.HaloVersionEnum.Halo2);
        public TagBlock Special_Spawns = new TagBlock("Special Spawns", Special_Spawns_Layout.Layout, Map.HaloVersionEnum.Halo2);
        public TagBlock Starting_Equipment = new TagBlock("Starting Equipment", Starting_Equipment_Layout.Layout, Map.HaloVersionEnum.Halo2);
        public TagBlock Structure_BSPS = new TagBlock("Structure BSPS", Structure_BSPS_Layout.Layout, Map.HaloVersionEnum.Halo2);
        public TagBlock Style_Palette = new TagBlock("Style Palette", Style_Palette_Layout.Layout, Map.HaloVersionEnum.Halo2);
        public HaloTagType Subtitles = new HaloTagType("Subtitles");
        public TagIdent Subtitles_0 = new TagIdent("Subtitles");
        public HaloTagType Title = new HaloTagType("Title");
        public TagIdent Title_0 = new TagIdent("Title");
        public ShortInteger Local_North = new ShortInteger("Local North");
        public TagBlock BSP_Switch_Trigger_Volumes = new TagBlock("BSP Switch Trigger Volumes", BSP_Switch_Trigger_Volumes_Layout.Layout, Map.HaloVersionEnum.Halo2);
        public TagBlock AI_Triggers = new TagBlock("AI Triggers", AI_Triggers_Layout.Layout, Map.HaloVersionEnum.Halo2);
        public TagBlock Unknown_12 = new TagBlock("Unknown12", Unknown_12_Layout.Layout, Map.HaloVersionEnum.Halo2);
        public LongInteger Unknown_13 = new LongInteger("Unknown");
        public LongInteger Unknown_14 = new LongInteger("Unknown");
        public LongInteger Unknown_15 = new LongInteger("Unknown");
        public LongInteger Unknown_16 = new LongInteger("Unknown");
        public LongInteger Unknown_17 = new LongInteger("Unknown");
        public LongInteger Unknown_18 = new LongInteger("Unknown");
        public LongInteger Unknown_19 = new LongInteger("Unknown");
        public LongInteger Unknown_20 = new LongInteger("Unknown");
        public LongInteger Unknown_21 = new LongInteger("Unknown");
        public TagBlock SBSP_Lighting = new TagBlock("SBSP Lighting", SBSP_Lighting_Layout.Layout, Map.HaloVersionEnum.Halo2);
        public TagBlock Interpolators = new TagBlock("Interpolators", Interpolators_Layout.Layout, Map.HaloVersionEnum.Halo2);
        public TagBlock Unknown_3 = new TagBlock("Unknown3", Unknown_3_Layout.Layout, Map.HaloVersionEnum.Halo2);
        public TagBlock References = new TagBlock("References", References_Layout.Layout, Map.HaloVersionEnum.Halo2);
        public TagBlock Unknown_7 = new TagBlock("Unknown7", Unkown_7_Layout.Layout, Map.HaloVersionEnum.Halo2);
        public HaloTagType Unused = new HaloTagType("Unused");
        public TagIdent Unused_0 = new TagIdent("Unused");
        public HaloTagType Unused_1 = new HaloTagType("Unused");
        public TagIdent Unused_2 = new TagIdent("Unused");
        public HaloTagType Unused_3 = new HaloTagType("Unused");
        public TagIdent Unused_4 = new TagIdent("Unused");
        public HaloTagType Unused_5 = new HaloTagType("Unused");
        public TagIdent Unused_6 = new TagIdent("Unused");
        public TagBlock Vehicle_Palette = new TagBlock("Vehicle Palette", Vehicle_Palette_Layout.Layout, Map.HaloVersionEnum.Halo2);
        public TagBlock Vehicle_Placement = new TagBlock("Vehicle Placement", Vehicle_Placement_Layout.Layout, Map.HaloVersionEnum.Halo2);
        public TagBlock Vehicle_Seats = new TagBlock("Vehicle Seats", Vehicle_Seats_Layout.Layout, Map.HaloVersionEnum.Halo2);
        public TagBlock Weapon_Palette = new TagBlock("Weapon Palette", Weapon_Palette_Layout.Layout, Map.HaloVersionEnum.Halo2);
        public TagBlock Weapon_Placement = new TagBlock("Weapon Placement", Weapon_Placement_Layout.Layout, Map.HaloVersionEnum.Halo2);
        public TagBlock Weather_Palette = new TagBlock("Weather", Weather_Layout.Layout, Map.HaloVersionEnum.Halo2);

        public scnr()
        {
            base.Add(this.Unused);
            base.Add(this.Unused_0);
            base.Add(this.Sky_Palette);
            base.Add(this.Map_Type);
            base.Add(this.Local_North);
            base.Add(this.Padding);
            base.Add(this.Predicted_Resources);
            base.Add(this.Padding_0);
            base.Add(this.Script_Objects);
            base.Add(this.Scenery_Placement);
            base.Add(this.Scenery_Palette);
            base.Add(this.Biped_Placement);
            base.Add(this.Biped_Palette);
            base.Add(this.Vehicle_Placement);
            base.Add(this.Vehicle_Palette);
            base.Add(this.Equipment_Placement);
            base.Add(this.Equipment_Palette);
            base.Add(this.Weapon_Placement);
            base.Add(this.Weapon_Palette);
            base.Add(this.Device_Groups);
            base.Add(this.Machine_Placement);
            base.Add(this.Machine_Palette);
            base.Add(this.Control_Placement);
            base.Add(this.Control_Palette);
            base.Add(this.Padding_1);
            base.Add(this.Sound_Scenery_Placement);
            base.Add(this.Sound_Scenery_Palette);
            base.Add(this.Light_Volumes_Placement);
            base.Add(this.Light_Volumes_Palette);
            base.Add(this.Player_Starting_Profiles);
            base.Add(this.Player_Starting_Locations);
            base.Add(this.Trigger_Volumes);
            base.Add(this.Padding_2);
            base.Add(this.Netgame_Flags);
            base.Add(this.Netgame_Equipment);
            base.Add(this.Starting_Equipment);
            base.Add(this.BSP_Switch_Trigger_Volumes);
            base.Add(this.Decal_Placement);
            base.Add(this.Decal_Palette);
            base.Add(this.Padding_3);
            base.Add(this.Style_Palette);
            base.Add(this.AI_Squad_Types);
            base.Add(this.AI_Squads);
            base.Add(this.AI_Encounters);
            base.Add(this.Unknown_3);
            base.Add(this.Characters);
            base.Add(this.Padding_4);
            base.Add(this.Script_Data);
            base.Add(this.Scripts);
            base.Add(this.Globals);
            base.Add(this.References);
            base.Add(this.Padding_5);
            base.Add(this.Script_Locations);
            base.Add(this.Cutscene_Flags);
            base.Add(this.Cutscene_Camera);
            base.Add(this.Cutscene_Titles);
            base.Add(this.Unused_1);
            base.Add(this.Unused_2);
            base.Add(this.Title);
            base.Add(this.Title_0);
            base.Add(this.Unused_3);
            base.Add(this.Unused_4);
            base.Add(this.Structure_BSPS);
            base.Add(this.Unknown_7);
            base.Add(this.Padding_6);
            base.Add(this.Vehicle_Seats);
            base.Add(this.Scenario_Kill_Triggers);
            base.Add(this.script_syntax);
            base.Add(this.AI_Zones);
            base.Add(this.AI_Triggers);
            base.Add(this.Background_Sound_Palette);
            base.Add(this.Sound_Environment_Palette);
            base.Add(this.Weather_Palette);
            base.Add(this.Padding_7);
            base.Add(this.Unknown_12);
            base.Add(this.Unknown_13);
            base.Add(this.Unknown_14);
            base.Add(this.Unknown_15);
            base.Add(this.Unknown_16);
            base.Add(this.Padding_8);
            base.Add(this.Unknown_17);
            base.Add(this.Unknown_18);
            base.Add(this.Unknown_19);
            base.Add(this.Padding_9);
            base.Add(this.Unknown_20);
            base.Add(this.Unknown_21);
            base.Add(this.Padding_10);
            base.Add(this.Special_Spawns);
            base.Add(this.Unused_5);
            base.Add(this.Unused_6);
            base.Add(this.Obstacle_Placement);
            base.Add(this.Obstacle_Palette);
            base.Add(this.Global_Lighting);
            base.Add(this.Global_Lighting_0);
            base.Add(this.Atmospheric_Fog_Palette);
            base.Add(this.Planar_Fog_Palette);
            base.Add(this.Padding_11);
            base.Add(this.Subtitles);
            base.Add(this.Subtitles_0);
            base.Add(this.Padding_12);
            base.Add(this.Decorator_Palette);
            base.Add(this.Padding_13);
            base.Add(this.SBSP_Lighting);
            base.Add(this.Padding_14);
            base.Add(this.Map_Description);
            base.Add(this.Territory_Location_Names);
            base.Add(this.Territory_Location_Names_0);
            base.Add(this.Padding_15);
            base.Add(this.Level_Dialog_Palette);
            base.Add(this.Location_Names_1);
            base.Add(this.Location_Names_2);
            base.Add(this.Interpolators);
            base.Add(this.Padding_16);
            base.Add(this.Screen_Effects);
            base.Add(this.Predicted_Resources_0);
        }

        public Biped_Palette_Layout GetBipedPaletteChunk(int biped_index)
        {
            return (Biped_Palette_Layout) this.Biped_Palette.Chunks[this.GetBipedPlacementChunk(biped_index).Biped_Chunk__Number_.Value];
        }

        public Biped_Placement_Layout GetBipedPlacementChunk(int biped_index)
        {
            return (Biped_Placement_Layout) this.Biped_Placement.Chunks[biped_index];
        }

        public Netgame_Equipment_Layout GetCollection(int collection_index)
        {
            return (Netgame_Equipment_Layout) this.Netgame_Equipment.Chunks[collection_index];
        }

        public Control_Palette_Layout GetControlPaletteChunk(int control_index)
        {
            return (Control_Palette_Layout) this.Control_Palette.Chunks[this.GetControlPlacementChunk(control_index).Palette_Chunk__Number_.Value];
        }

        public Control_Placement_Layout GetControlPlacementChunk(int control_index)
        {
            return (Control_Placement_Layout) this.Control_Placement.Chunks[control_index];
        }

        public Device_Groups_Layout GetDeviceGroup(int device_group_index)
        {
            return (Device_Groups_Layout) this.Device_Groups.Chunks[device_group_index];
        }

        public Equipment_Palette_Layout GetEquipmentPaletteChunk(int equipment_index)
        {
            return (Equipment_Palette_Layout) this.Equipment_Palette.Chunks[this.GetEquipmentPlacementChunk(equipment_index).Equipment_Chunk__Number_.Value];
        }

        public Equipment_Placement_Layout GetEquipmentPlacementChunk(int equipment_index)
        {
            return (Equipment_Placement_Layout) this.Equipment_Placement.Chunks[equipment_index];
        }

        public Light_Volumes_Palette_Layout GetLightPaletteChunk(int light_index)
        {
            return (Light_Volumes_Palette_Layout) this.Light_Volumes_Palette.Chunks[this.GetLightPlacementChunk(light_index).Light_Chunk__Number_.Value];
        }

        public Light_Volumes_Placement_Layout GetLightPlacementChunk(int light_index)
        {
            return (Light_Volumes_Placement_Layout) this.Light_Volumes_Placement.Chunks[light_index];
        }

        public Machine_Palette_Layout GetMachinePaletteChunk(int machine_index)
        {
            return (Machine_Palette_Layout) this.Machine_Palette.Chunks[this.GetMachinePlacementChunk(machine_index).Palette_Chunk__Number_.Value];
        }

        public Machine_Placement_Layout GetMachinePlacementChunk(int machine_index)
        {
            return (Machine_Placement_Layout) this.Machine_Placement.Chunks[machine_index];
        }

        public Obstacle_Palette_Layout GetObstaclePaletteChunk(int obstacle_index)
        {
            return (Obstacle_Palette_Layout) this.Obstacle_Palette.Chunks[this.GetObstaclePlacementChunk(obstacle_index).Palette_Chunk__Number_.Value];
        }

        public Obstacle_Placement_Layout GetObstaclePlacementChunk(int obstacle_index)
        {
            return (Obstacle_Placement_Layout) this.Obstacle_Placement.Chunks[obstacle_index];
        }

        public Scenery_Palette_Layout GetSceneryPaletteChunk(int scenery_index)
        {
            return (Scenery_Palette_Layout) this.Scenery_Palette.Chunks[this.GetSceneryPlacementChunk(scenery_index).Scenery_Chunk__Number_.Value];
        }

        public Scenery_Placement_Layout GetSceneryPlacementChunk(int scenery_index)
        {
            return (Scenery_Placement_Layout) this.Scenery_Placement.Chunks[scenery_index];
        }

        public Sound_Scenery_Palette_Layout GetSoundSceneryPaletteChunk(int sound_scenery_index)
        {
            return (Sound_Scenery_Palette_Layout) this.Sound_Scenery_Palette.Chunks[this.GetSoundSceneryPlacementChunk(sound_scenery_index).palette_index.Value];
        }

        public Sound_Scenery_Placement_Layout GetSoundSceneryPlacementChunk(int sound_scenery_index)
        {
            return (Sound_Scenery_Placement_Layout) this.Sound_Scenery_Placement.Chunks[sound_scenery_index];
        }

        public Vehicle_Palette_Layout GetVehiclePaletteChunk(int vehicle_index)
        {
            return (Vehicle_Palette_Layout) this.Vehicle_Palette.Chunks[this.GetVehiclePlacementChunk(vehicle_index).Vehicle_Chunk__Number_.Value];
        }

        public Vehicle_Placement_Layout GetVehiclePlacementChunk(int vehicle_index)
        {
            return (Vehicle_Placement_Layout) this.Vehicle_Placement.Chunks[vehicle_index];
        }

        public Weapon_Palette_Layout GetWeaponPaletteChunk(int weapon_index)
        {
            return (Weapon_Palette_Layout) this.Weapon_Palette.Chunks[this.GetWeaponPlacementChunk(weapon_index).Palette_Chunk__Number_.Value];
        }

        public Weapon_Placement_Layout GetWeaponPlacementChunk(int weapon_index)
        {
            return (Weapon_Placement_Layout) this.Weapon_Placement.Chunks[weapon_index];
        }

        public class AI_Encounters_Layout : TagBlockLayout
        {
            public static readonly scnr.AI_Encounters_Layout Layout = new scnr.AI_Encounters_Layout();
            public core.TagInterface.String Name = new core.TagInterface.String("Name", 0x20);
            public LongInteger Unknown_0 = new LongInteger("Unknown");
            public LongInteger Unknown_1 = new LongInteger("Unknown");
            public TagBlock Unknown_2 = new TagBlock("Unknown2x", Unknown_2x_Layout.Layout, Map.HaloVersionEnum.Halo2);
            public TagBlock Unknown_3 = new TagBlock("Unknown", Unknown_3_Layout.Layout, Map.HaloVersionEnum.Halo2);

            public AI_Encounters_Layout()
            {
                base.Add(this.Name);
                base.Add(this.Unknown_0);
                base.Add(this.Unknown_1);
                base.Add(this.Unknown_2);
                base.Add(this.Unknown_3);
            }

            public class Unknown_2x_Layout : TagBlockLayout
            {
                public static readonly scnr.AI_Encounters_Layout.Unknown_2x_Layout Layout = new scnr.AI_Encounters_Layout.Unknown_2x_Layout();
                public LongInteger Unknown = new LongInteger("Unknown");
                public LongInteger Unknown_0 = new LongInteger("Unknown");
                public RealFloat Unknown_1 = new RealFloat("Unknown");
                public LongInteger Unknown_2 = new LongInteger("Unknown");
                public LongInteger Unknown_3 = new LongInteger("Unknown");
                public LongInteger Unknown_4 = new LongInteger("Unknown");
                public LongInteger Unknown_5 = new LongInteger("Unknown");
                public LongInteger Unknown_6 = new LongInteger("Unknown");

                public Unknown_2x_Layout()
                {
                    base.Add(this.Unknown);
                    base.Add(this.Unknown_0);
                    base.Add(this.Unknown_1);
                    base.Add(this.Unknown_2);
                    base.Add(this.Unknown_3);
                    base.Add(this.Unknown_4);
                    base.Add(this.Unknown_5);
                    base.Add(this.Unknown_6);
                }
            }

            public class Unknown_3_Layout : TagBlockLayout
            {
                public static readonly scnr.AI_Encounters_Layout.Unknown_3_Layout Layout = new scnr.AI_Encounters_Layout.Unknown_3_Layout();
                public core.TagInterface.Padding Padding = new core.TagInterface.Padding("Padding", 0x30);
                public core.TagInterface.String Unknown = new core.TagInterface.String("Unknown", 0x20);
                public LongInteger Unknown_0 = new LongInteger("Unknown");
                public LongInteger Unknown_1 = new LongInteger("Unknown");
                public LongInteger Unknown_10 = new LongInteger("Unknown");
                public LongInteger Unknown_11 = new LongInteger("Unknown");
                public TagBlock Unknown_12 = new TagBlock("Unknown", Unknown_12_Layout.Layout, Map.HaloVersionEnum.Halo2);
                public LongInteger Unknown_2 = new LongInteger("Unknown");
                public RealFloat Unknown_3 = new RealFloat("Unknown");
                public LongInteger Unknown_4 = new LongInteger("Unknown");
                public RealFloat Unknown_5 = new RealFloat("Unknown");
                public LongInteger Unknown_6 = new LongInteger("Unknown");
                public LongInteger Unknown_7 = new LongInteger("Unknown");
                public LongInteger Unknown_8 = new LongInteger("Unknown");
                public LongInteger Unknown_9 = new LongInteger("Unknown");

                public Unknown_3_Layout()
                {
                    base.Add(this.Unknown);
                    base.Add(this.Unknown_0);
                    base.Add(this.Unknown_1);
                    base.Add(this.Unknown_2);
                    base.Add(this.Unknown_3);
                    base.Add(this.Unknown_4);
                    base.Add(this.Unknown_5);
                    base.Add(this.Unknown_6);
                    base.Add(this.Unknown_7);
                    base.Add(this.Unknown_8);
                    base.Add(this.Unknown_9);
                    base.Add(this.Unknown_10);
                    base.Add(this.Unknown_11);
                    base.Add(this.Padding);
                    base.Add(this.Unknown_12);
                }

                public class Unknown_12_Layout : TagBlockLayout
                {
                    public static readonly scnr.AI_Encounters_Layout.Unknown_3_Layout.Unknown_12_Layout Layout = new scnr.AI_Encounters_Layout.Unknown_3_Layout.Unknown_12_Layout();
                    public LongInteger Unknown = new LongInteger("Unknown");

                    public Unknown_12_Layout()
                    {
                        base.Add(this.Unknown);
                    }
                }
            }
        }

        public class AI_Squad_Types_Layout : TagBlockLayout
        {
            public static readonly scnr.AI_Squad_Types_Layout Layout = new scnr.AI_Squad_Types_Layout();
            public core.TagInterface.String Squad_Type = new core.TagInterface.String("Squad Type", 0x20);
            public LongInteger Unknown = new LongInteger("Unknown");

            public AI_Squad_Types_Layout()
            {
                base.Add(this.Squad_Type);
                base.Add(this.Unknown);
            }
        }

        public class AI_Squads_Layout : TagBlockLayout
        {
            public ShortInteger _Number__of_AI_that_spawn_on_Easy = new ShortInteger("# of AI that spawn on Easy");
            public ShortInteger _Number__of_AI_that_spawn_on_Legendary = new ShortInteger("# of AI that spawn on Legendary");
            public ShortInteger _Primary__Weapon_Pallette_Index = new ShortInteger("(Primary) Weapon Pallette Index");
            public ShortInteger _Secondary__Weapon_Pallette_Index = new ShortInteger("(Secondary) Weapon Pallette Index");
            public TagBlock AI_Actors = new TagBlock("AI Actors", AI_Actors_Layout.Layout, Map.HaloVersionEnum.Halo2);
            public ShortInteger AI_Orders_Index = new ShortInteger("AI Orders Index");
            public ShortInteger AI_Orders_Index_0 = new ShortInteger("AI Orders Index");
            public ShortInteger AI_Orders_Index_1 = new ShortInteger("AI Orders Index");
            public ShortInteger Character_Pallette_Index = new ShortInteger("Character Pallette Index");
            public core.TagInterface.Flags Flags_Question_Mark_ = new core.TagInterface.Flags("Flags?", core.TagInterface.Flags.BitmaskTypeEnum.Long);
            public core.TagInterface.Enumerator Grenade_Type = new core.TagInterface.Enumerator("Grenade Type", core.TagInterface.Enumerator.TagEnumeratorIndexType.Word);
            public static readonly scnr.AI_Squads_Layout Layout = new scnr.AI_Squads_Layout();
            public core.TagInterface.String Name = new core.TagInterface.String("Name", 0x20);
            public ShortInteger Platoons_Index = new ShortInteger("Platoons Index");
            public ShortInteger Unknown_0 = new ShortInteger("Unknown");
            public ShortInteger Unknown_1 = new ShortInteger("Unknown");
            public ShortInteger Unknown_2 = new ShortInteger("Unknown");
            public ShortInteger Unknown_3 = new ShortInteger("Unknown");
            public ShortInteger Unknown_4 = new ShortInteger("Unknown");
            public ShortInteger Unknown_5 = new ShortInteger("Unknown");
            public ShortInteger Unknown_6 = new ShortInteger("Unknown");
            public core.TagInterface.String Unknown_7 = new core.TagInterface.String("Unknown", 0x20);
            public ShortInteger Unknown_8 = new ShortInteger("Unknown");
            public ShortInteger Unknown_9 = new ShortInteger("Unknown");
            public ShortInteger Vehicle_Pallette_Index = new ShortInteger("Vehicle Pallette Index");

            public AI_Squads_Layout()
            {
                base.Add(this.Name);
                base.Add(this.Flags_Question_Mark_);
                base.Add(this.Unknown_0);
                base.Add(this.Platoons_Index);
                base.Add(this.Unknown_1);
                base.Add(this.Unknown_2);
                base.Add(this._Number__of_AI_that_spawn_on_Easy);
                base.Add(this._Number__of_AI_that_spawn_on_Legendary);
                base.Add(this.Unknown_3);
                base.Add(this.Unknown_4);
                base.Add(this.Vehicle_Pallette_Index);
                base.Add(this.Character_Pallette_Index);
                base.Add(this.Unknown_5);
                base.Add(this.Unknown_6);
                base.Add(this._Primary__Weapon_Pallette_Index);
                base.Add(this._Secondary__Weapon_Pallette_Index);
                base.Add(this.Grenade_Type);
                base.Add(this.AI_Orders_Index);
                base.Add(this.AI_Orders_Index_0);
                base.Add(this.AI_Orders_Index_1);
                base.Add(this.AI_Actors);
                base.Add(this.Unknown_7);
                base.Add(this.Unknown_8);
                base.Add(this.Unknown_9);
            }

            public class AI_Actors_Layout : TagBlockLayout
            {
                public ShortInteger _440_index = new ShortInteger("(440)index");
                public static readonly scnr.AI_Squads_Layout.AI_Actors_Layout Layout = new scnr.AI_Squads_Layout.AI_Actors_Layout();
                public StringID Name = new StringID("Name");
                public core.TagInterface.Padding Padding = new core.TagInterface.Padding("Padding", 4);
                public core.TagInterface.Padding Padding_0 = new core.TagInterface.Padding("Padding", 8);
                public ShortInteger unknown = new ShortInteger("unknown");
                public LongInteger Unknown_0 = new LongInteger("Unknown");
                public LongInteger Unknown_1 = new LongInteger("Unknown");
                public LongInteger Unknown_2 = new LongInteger("Unknown");
                public LongInteger Unknown_3 = new LongInteger("Unknown");
                public LongInteger Unknown_4 = new LongInteger("Unknown");
                public LongInteger Unknown_5 = new LongInteger("Unknown");
                public LongInteger Unknown_6 = new LongInteger("Unknown");
                public StringID Unknown_7 = new StringID("Unknown");
                public LongInteger Unknown_8 = new LongInteger("Unknown");
                public core.TagInterface.String Unknown_9 = new core.TagInterface.String("Unknown", 0x20);
                public RealFloat X = new RealFloat("X");
                public RealFloat Y = new RealFloat("Y");
                public RealFloat Z = new RealFloat("Z");

                public AI_Actors_Layout()
                {
                    base.Add(this.Name);
                    base.Add(this.X);
                    base.Add(this.Y);
                    base.Add(this.Z);
                    base.Add(this.Unknown_0);
                    base.Add(this.Unknown_1);
                    base.Add(this.Unknown_2);
                    base.Add(this.Unknown_3);
                    base.Add(this.Unknown_4);
                    base.Add(this.Unknown_5);
                    base.Add(this.Unknown_6);
                    base.Add(this.Padding);
                    base.Add(this.Unknown_7);
                    base.Add(this.Padding_0);
                    base.Add(this.Unknown_8);
                    base.Add(this.Unknown_9);
                    base.Add(this._440_index);
                    base.Add(this.unknown);
                }
            }
        }

        public class AI_Zones_Layout : TagBlockLayout
        {
            public static readonly scnr.AI_Zones_Layout Layout = new scnr.AI_Zones_Layout();
            public core.TagInterface.String Unknown = new core.TagInterface.String("Unknown", 0x20);
            public LongInteger Unknown_0 = new LongInteger("Unknown");
            public LongInteger Unknown_1 = new LongInteger("Unknown");
            public TagBlock Unknown_10 = new TagBlock("Unknown", Unknown_10x_Layout.Layout, Map.HaloVersionEnum.Halo2);
            public LongInteger Unknown_2 = new LongInteger("Unknown");
            public core.TagInterface.String Unknown_3 = new core.TagInterface.String("Unknown", 0x20);
            public RealFloat Unknown_4 = new RealFloat("Unknown");
            public RealFloat Unknown_5 = new RealFloat("Unknown");
            public TagBlock Unknown_6 = new TagBlock("Unknown", Unknown_6_Layout.Layout, Map.HaloVersionEnum.Halo2);
            public TagBlock Unknown_7 = new TagBlock("Unknown", Unknown_7_Layout.Layout, Map.HaloVersionEnum.Halo2);
            public TagBlock Unknown_8 = new TagBlock("Unknown", Unknown_8_Layout.Layout, Map.HaloVersionEnum.Halo2);
            public TagBlock Unknown_9 = new TagBlock("Unknown", Unknown_9_Layout.Layout, Map.HaloVersionEnum.Halo2);

            public AI_Zones_Layout()
            {
                base.Add(this.Unknown);
                base.Add(this.Unknown_0);
                base.Add(this.Unknown_1);
                base.Add(this.Unknown_2);
                base.Add(this.Unknown_3);
                base.Add(this.Unknown_4);
                base.Add(this.Unknown_5);
                base.Add(this.Unknown_6);
                base.Add(this.Unknown_7);
                base.Add(this.Unknown_8);
                base.Add(this.Unknown_9);
                base.Add(this.Unknown_10);
            }

            public class Unknown_10x_Layout : TagBlockLayout
            {
                public static readonly scnr.AI_Zones_Layout.Unknown_10x_Layout Layout = new scnr.AI_Zones_Layout.Unknown_10x_Layout();
                public LongInteger Unknown = new LongInteger("Unknown");
                public RealFloat Unknown_0 = new RealFloat("Unknown");
                public LongInteger Unknown_1 = new LongInteger("Unknown");
                public TagBlock Unknown_2 = new TagBlock("Unknown", Unknown_2_Layout.Layout, Map.HaloVersionEnum.Halo2);

                public Unknown_10x_Layout()
                {
                    base.Add(this.Unknown);
                    base.Add(this.Unknown_0);
                    base.Add(this.Unknown_1);
                    base.Add(this.Unknown_2);
                }

                public class Unknown_2_Layout : TagBlockLayout
                {
                    public static readonly scnr.AI_Zones_Layout.Unknown_10x_Layout.Unknown_2_Layout Layout = new scnr.AI_Zones_Layout.Unknown_10x_Layout.Unknown_2_Layout();
                    public LongInteger Unknown = new LongInteger("Unknown");
                    public LongInteger Unknown_0 = new LongInteger("Unknown");

                    public Unknown_2_Layout()
                    {
                        base.Add(this.Unknown);
                        base.Add(this.Unknown_0);
                    }
                }
            }

            public class Unknown_6_Layout : TagBlockLayout
            {
                public static readonly scnr.AI_Zones_Layout.Unknown_6_Layout Layout = new scnr.AI_Zones_Layout.Unknown_6_Layout();
                public LongInteger Unknown = new LongInteger("Unknown");
                public LongInteger Unknown_0 = new LongInteger("Unknown");

                public Unknown_6_Layout()
                {
                    base.Add(this.Unknown);
                    base.Add(this.Unknown_0);
                }
            }

            public class Unknown_7_Layout : TagBlockLayout
            {
                public static readonly scnr.AI_Zones_Layout.Unknown_7_Layout Layout = new scnr.AI_Zones_Layout.Unknown_7_Layout();
                public LongInteger Unknown = new LongInteger("Unknown");
                public LongInteger Unknown_0 = new LongInteger("Unknown");

                public Unknown_7_Layout()
                {
                    base.Add(this.Unknown);
                    base.Add(this.Unknown_0);
                }
            }

            public class Unknown_8_Layout : TagBlockLayout
            {
                public static readonly scnr.AI_Zones_Layout.Unknown_8_Layout Layout = new scnr.AI_Zones_Layout.Unknown_8_Layout();
                public LongInteger Unknown = new LongInteger("Unknown");
                public TagBlock Unknown_0 = new TagBlock("Unknown", Unknown_0_Layout.Layout, Map.HaloVersionEnum.Halo2);

                public Unknown_8_Layout()
                {
                    base.Add(this.Unknown);
                    base.Add(this.Unknown_0);
                }

                public class Unknown_0_Layout : TagBlockLayout
                {
                    public static readonly scnr.AI_Zones_Layout.Unknown_8_Layout.Unknown_0_Layout Layout = new scnr.AI_Zones_Layout.Unknown_8_Layout.Unknown_0_Layout();
                    public LongInteger Unknown = new LongInteger("Unknown");
                    public LongInteger Unknown_0 = new LongInteger("Unknown");

                    public Unknown_0_Layout()
                    {
                        base.Add(this.Unknown);
                        base.Add(this.Unknown_0);
                    }
                }
            }

            public class Unknown_9_Layout : TagBlockLayout
            {
                public static readonly scnr.AI_Zones_Layout.Unknown_9_Layout Layout = new scnr.AI_Zones_Layout.Unknown_9_Layout();
                public LongInteger Unknown = new LongInteger("Unknown");

                public Unknown_9_Layout()
                {
                    base.Add(this.Unknown);
                }
            }
        }

        public class Background_Sound_Palette_Layout : TagBlockLayout
        {
            public static readonly scnr.Background_Sound_Palette_Layout Layout = new scnr.Background_Sound_Palette_Layout();
            public HaloTagType Looping_Sound = new HaloTagType("Looping Sound");
            public TagIdent Looping_Sound_0 = new TagIdent("Looping Sound");
            public core.TagInterface.String Name = new core.TagInterface.String("Name", 0x20);
            public core.TagInterface.Padding Padding = new core.TagInterface.Padding("Padding", 20);
            public core.TagInterface.Padding Padding_0 = new core.TagInterface.Padding("Padding", 8);
            public core.TagInterface.Padding Padding_1 = new core.TagInterface.Padding("Padding", 8);
            public RealFloat Unknown = new RealFloat("Unknown");
            public LongInteger Unknown_0 = new LongInteger("Unknown");
            public RealFloat Unknown_1 = new RealFloat("Unknown");
            public RealFloat Unknown_2 = new RealFloat("Unknown");
            public HaloTagType Unused = new HaloTagType("Unused");
            public TagIdent Unused_0 = new TagIdent("Unused");

            public Background_Sound_Palette_Layout()
            {
                base.Add(this.Name);
                base.Add(this.Looping_Sound);
                base.Add(this.Looping_Sound_0);
                base.Add(this.Unused);
                base.Add(this.Unused_0);
                base.Add(this.Padding);
                base.Add(this.Unknown);
                base.Add(this.Unknown_0);
                base.Add(this.Unknown_1);
                base.Add(this.Padding_0);
                base.Add(this.Unknown_2);
                base.Add(this.Padding_1);
            }
        }

        public class Biped_Palette_Layout : TagBlockLayout
        {
            public HaloTagType Biped = new HaloTagType("Biped");
            public TagIdent Biped_0 = new TagIdent("Biped");
            public static readonly scnr.Biped_Palette_Layout Layout = new scnr.Biped_Palette_Layout();
            public core.TagInterface.Padding Padding = new core.TagInterface.Padding("Padding", 0x20);

            public Biped_Palette_Layout()
            {
                base.Add(this.Biped);
                base.Add(this.Biped_0);
                base.Add(this.Padding);
            }
        }

        public class Biped_Placement_Layout : TagBlockLayout
        {
            public ShortInteger Biped_Chunk__Number_ = new ShortInteger("Biped Chunk #");
            public ShortInteger bsp_index_1 = new ShortInteger("bsp_index_1");
            public RealFloat Facing_Direction = new RealFloat("Facing Direction");
            public static readonly scnr.Biped_Placement_Layout Layout = new scnr.Biped_Placement_Layout();
            public core.TagInterface.Padding Padding = new core.TagInterface.Padding("Padding", 2);
            public core.TagInterface.Padding Padding_0 = new core.TagInterface.Padding("Padding", 4);
            public core.TagInterface.Padding Padding_1 = new core.TagInterface.Padding("Padding", 4);
            public LongInteger Unknown = new LongInteger("Unknown");
            public LongInteger Unknown_0 = new LongInteger("Unknown");
            public LongInteger Unknown_1 = new LongInteger("Unknown");
            public LongInteger Unknown_10 = new LongInteger("Unknown");
            public LongInteger Unknown_11 = new LongInteger("Unknown");
            public LongInteger Unknown_12 = new LongInteger("Unknown");
            public RealFloat Unknown_2 = new RealFloat("Unknown");
            public LongInteger Unknown_3 = new LongInteger("Unknown");
            public ShortInteger Unknown_4 = new ShortInteger("Unknown");
            public RealFloat Unknown_5 = new RealFloat("Unknown");
            public StringID Unknown_6 = new StringID("Unknown");
            public LongInteger Unknown_7 = new LongInteger("Unknown");
            public LongInteger Unknown_8 = new LongInteger("Unknown");
            public LongInteger Unknown_9 = new LongInteger("Unknown");
            public RealFloat X = new RealFloat("X");
            public RealFloat Y = new RealFloat("Y");
            public RealFloat Z = new RealFloat("Z");

            public Biped_Placement_Layout()
            {
                base.Add(this.Biped_Chunk__Number_);
                base.Add(this.Padding);
                base.Add(this.Unknown);
                base.Add(this.X);
                base.Add(this.Y);
                base.Add(this.Z);
                base.Add(this.Facing_Direction);
                base.Add(this.Unknown_0);
                base.Add(this.Unknown_1);
                base.Add(this.Unknown_2);
                base.Add(this.Padding_0);
                base.Add(this.Unknown_3);
                base.Add(this.bsp_index_1);
                base.Add(this.Unknown_4);
                base.Add(this.Unknown_5);
                base.Add(this.Unknown_6);
                base.Add(this.Unknown_7);
                base.Add(this.Unknown_8);
                base.Add(this.Unknown_9);
                base.Add(this.Unknown_10);
                base.Add(this.Unknown_11);
                base.Add(this.Padding_1);
                base.Add(this.Unknown_12);
            }
        }

        public class Characters_Layout : TagBlockLayout
        {
            public HaloTagType Character = new HaloTagType("Character");
            public TagIdent Character_0 = new TagIdent("Character");
            public static readonly scnr.Characters_Layout Layout = new scnr.Characters_Layout();

            public Characters_Layout()
            {
                base.Add(this.Character);
                base.Add(this.Character_0);
            }
        }

        public class Control_Palette_Layout : TagBlockLayout
        {
            public HaloTagType Control = new HaloTagType("Control");
            public TagIdent Control_0 = new TagIdent("Control");
            public static readonly scnr.Control_Palette_Layout Layout = new scnr.Control_Palette_Layout();
            public core.TagInterface.Padding Padding = new core.TagInterface.Padding("Padding", 0x20);

            public Control_Palette_Layout()
            {
                base.Add(this.Control);
                base.Add(this.Control_0);
                base.Add(this.Padding);
            }
        }

        public class Control_Placement_Layout : TagBlockLayout
        {
            public ShortInteger bsp_index_1 = new ShortInteger("BSP Index");
            public ShortInteger Device_Group_Chunk__Number_ = new ShortInteger("Device Group Chunk #");
            public static readonly scnr.Control_Placement_Layout Layout = new scnr.Control_Placement_Layout();
            public core.TagInterface.Padding Padding = new core.TagInterface.Padding("Padding", 2);
            public core.TagInterface.Padding Padding_0 = new core.TagInterface.Padding("Padding", 4);
            public core.TagInterface.Padding Padding_1 = new core.TagInterface.Padding("Padding", 4);
            public core.TagInterface.Padding Padding_2 = new core.TagInterface.Padding("Padding", 8);
            public core.TagInterface.Padding Padding_3 = new core.TagInterface.Padding("Padding", 8);
            public core.TagInterface.Padding Padding_4 = new core.TagInterface.Padding("Padding", 2);
            public ShortInteger Palette_Chunk__Number_ = new ShortInteger("Palette Chunk #");
            public RealFloat Position_X = new RealFloat("Position X");
            public RealFloat Position_Y = new RealFloat("Position Y");
            public RealFloat Position_Z = new RealFloat("Position Z");
            public RealFloat Unknown = new RealFloat("Unknown");
            public RealFloat Unknown_0 = new RealFloat("Unknown");
            public LongInteger Unknown_1 = new LongInteger("Unknown");
            public RealFloat Unknown_3 = new RealFloat("Unknown");
            public ShortInteger Unknown_4 = new ShortInteger("Unknown");
            public LongInteger Unknown_5 = new LongInteger("Unknown");

            public Control_Placement_Layout()
            {
                base.Add(this.Palette_Chunk__Number_);
                base.Add(this.Padding);
                base.Add(this.Padding_0);
                base.Add(this.Position_X);
                base.Add(this.Position_Y);
                base.Add(this.Position_Z);
                base.Add(this.Unknown);
                base.Add(this.Padding_1);
                base.Add(this.Unknown_0);
                base.Add(this.Padding_2);
                base.Add(this.Unknown_1);
                base.Add(this.bsp_index_1);
                base.Add(this.Padding_4);
                base.Add(this.Unknown_3);
                base.Add(this.Unknown_4);
                base.Add(this.Device_Group_Chunk__Number_);
                base.Add(this.Unknown_5);
                base.Add(this.Padding_3);
            }
        }

        public class Cutscene_Camera_Layout : TagBlockLayout
        {
            public RealFloat Field_of_View = new RealFloat("Field of View");
            public static readonly scnr.Cutscene_Camera_Layout Layout = new scnr.Cutscene_Camera_Layout();
            public core.TagInterface.String Name = new core.TagInterface.String("Name", 0x20);
            public RealFloat Orientation_P = new RealFloat("Orientation P");
            public RealFloat Orientation_R = new RealFloat("Orientation R");
            public RealFloat Orientation_Y = new RealFloat("Orientation Y");
            public core.TagInterface.Padding Padding = new core.TagInterface.Padding("Padding", 4);
            public RealFloat Position_X = new RealFloat("Position X");
            public RealFloat Position_Y = new RealFloat("Position Y");
            public RealFloat Position_Z = new RealFloat("Position Z");

            public Cutscene_Camera_Layout()
            {
                base.Add(this.Padding);
                base.Add(this.Name);
                base.Add(this.Position_X);
                base.Add(this.Position_Y);
                base.Add(this.Position_Z);
                base.Add(this.Orientation_Y);
                base.Add(this.Orientation_P);
                base.Add(this.Orientation_R);
                base.Add(this.Field_of_View);
            }
        }

        public class Cutscene_Flags_Layout : TagBlockLayout
        {
            public RealFloat Facing_P = new RealFloat("Facing P");
            public RealFloat Facing_Y = new RealFloat("Facing Y");
            public static readonly scnr.Cutscene_Flags_Layout Layout = new scnr.Cutscene_Flags_Layout();
            public core.TagInterface.String Name = new core.TagInterface.String("Name", 0x20);
            public core.TagInterface.Padding Padding = new core.TagInterface.Padding("Padding", 4);
            public RealFloat Position_X = new RealFloat("Position X");
            public RealFloat Position_Y = new RealFloat("Position Y");
            public RealFloat Position_Z = new RealFloat("Position Z");

            public Cutscene_Flags_Layout()
            {
                base.Add(this.Padding);
                base.Add(this.Name);
                base.Add(this.Position_X);
                base.Add(this.Position_Y);
                base.Add(this.Position_Z);
                base.Add(this.Facing_Y);
                base.Add(this.Facing_P);
            }
        }

        public class Cutscene_Titles_Layout : TagBlockLayout
        {
            public static readonly scnr.Cutscene_Titles_Layout Layout = new scnr.Cutscene_Titles_Layout();
            public StringID Name = new StringID("Name");
            public core.TagInterface.Padding Padding = new core.TagInterface.Padding("Padding", 4);
            public LongInteger Unknown = new LongInteger("Unknown");
            public LongInteger Unknown_0 = new LongInteger("Unknown");
            public LongInteger Unknown_1 = new LongInteger("Unknown");
            public LongInteger Unknown_2 = new LongInteger("Unknown");
            public RealFloat Unknown_3 = new RealFloat("Unknown");
            public RealFloat Unknown_4 = new RealFloat("Unknown");
            public RealFloat Unknown_5 = new RealFloat("Unknown");

            public Cutscene_Titles_Layout()
            {
                base.Add(this.Name);
                base.Add(this.Unknown);
                base.Add(this.Unknown_0);
                base.Add(this.Unknown_1);
                base.Add(this.Unknown_2);
                base.Add(this.Padding);
                base.Add(this.Unknown_3);
                base.Add(this.Unknown_4);
                base.Add(this.Unknown_5);
            }
        }

        public class Trigger_Volumes_Layout : TagBlockLayout
        {
            public static readonly scnr.Trigger_Volumes_Layout Layout = new scnr.Trigger_Volumes_Layout();
            public RealFloat Length__X_ = new RealFloat("Length (X)");
            public StringID Name = new StringID("Name");
            public core.TagInterface.Padding Padding = new core.TagInterface.Padding("Padding", 4);
            public RealFloat Position_X = new RealFloat("Position X");
            public RealFloat Position_Y = new RealFloat("Position Y");
            public RealFloat Position_Z = new RealFloat("Position Z");
            public RealFloat Thickness = new RealFloat("Thickness");
            public ShortInteger Unknown = new ShortInteger("Unknown");
            public ShortInteger Unknown_0 = new ShortInteger("Unknown");
            public RealFloat Unknown_1 = new RealFloat("Unknown");
            public LongInteger Unknown_2 = new LongInteger("Unknown");
            public LongInteger Unknown_3 = new LongInteger("Unknown");
            public LongInteger Unknown_4 = new LongInteger("Unknown");
            public LongInteger Unknown_5 = new LongInteger("Unknown");
            public RealFloat Unknown_6 = new RealFloat("Unknown");
            public RealFloat Unknown_7 = new RealFloat("Unknown");
            public LongInteger Unknown_8 = new LongInteger("Unknown");
            public RealFloat Width__Y_ = new RealFloat("Width (Y)");

            public Trigger_Volumes_Layout()
            {
                base.Add(this.Name);
                base.Add(this.Unknown);
                base.Add(this.Unknown_0);
                base.Add(this.Padding);
                base.Add(this.Unknown_1);
                base.Add(this.Unknown_2);
                base.Add(this.Unknown_3);
                base.Add(this.Unknown_4);
                base.Add(this.Unknown_5);
                base.Add(this.Unknown_6);
                base.Add(this.Position_X);
                base.Add(this.Position_Y);
                base.Add(this.Position_Z);
                base.Add(this.Length__X_);
                base.Add(this.Width__Y_);
                base.Add(this.Thickness);
                base.Add(this.Unknown_7);
                base.Add(this.Unknown_8);
            }
        }

        public class Decal_Palette_Layout : TagBlockLayout
        {
            public HaloTagType Decal = new HaloTagType("Decal");
            public TagIdent Decal_0 = new TagIdent("Decal");
            public static readonly scnr.Decal_Palette_Layout Layout = new scnr.Decal_Palette_Layout();

            public Decal_Palette_Layout()
            {
                base.Add(this.Decal);
                base.Add(this.Decal_0);
            }
        }

        public class Decal_Placement_Layout : TagBlockLayout
        {
            public static readonly scnr.Decal_Placement_Layout Layout = new scnr.Decal_Placement_Layout();
            public core.TagInterface.Padding Padding = new core.TagInterface.Padding("Padding", 2);
            public ShortInteger Palette_Chunk__Number_ = new ShortInteger("Palette Chunk #");
            public RealFloat Position_X = new RealFloat("Position X");
            public RealFloat Position_Y = new RealFloat("Position Y");
            public RealFloat Position_Z = new RealFloat("Position Z");

            public Decal_Placement_Layout()
            {
                base.Add(this.Palette_Chunk__Number_);
                base.Add(this.Padding);
                base.Add(this.Position_X);
                base.Add(this.Position_Y);
                base.Add(this.Position_Z);
            }
        }

        public class Decorator_Palette_Layout : TagBlockLayout
        {
            public HaloTagType Decorator = new HaloTagType("Decorator");
            public TagIdent Decorator_0 = new TagIdent("Decorator");
            public static readonly scnr.Decorator_Palette_Layout Layout = new scnr.Decorator_Palette_Layout();

            public Decorator_Palette_Layout()
            {
                base.Add(this.Decorator);
                base.Add(this.Decorator_0);
            }
        }

        public class Device_Groups_Layout : TagBlockLayout
        {
            public core.TagInterface.String Device = new core.TagInterface.String("Device", 0x20);
            public ShortInteger Index = new ShortInteger("Index");
            public static readonly scnr.Device_Groups_Layout Layout = new scnr.Device_Groups_Layout();
            public core.TagInterface.Enumerator Only_Use_Once = new core.TagInterface.Enumerator("Only Use Once", core.TagInterface.Enumerator.TagEnumeratorIndexType.Long);
            public ShortInteger Reflexive = new ShortInteger("Reflexive");

            public Device_Groups_Layout()
            {
                base.Add(this.Device);
                base.Add(this.Reflexive);
                base.Add(this.Index);
                base.Add(this.Only_Use_Once);
            }
        }

        public class Equipment_Palette_Layout : TagBlockLayout
        {
            public HaloTagType Equipment = new HaloTagType("Equipment");
            public TagIdent Equipment_0 = new TagIdent("Equipment");
            public static readonly scnr.Equipment_Palette_Layout Layout = new scnr.Equipment_Palette_Layout();
            public core.TagInterface.Padding Padding = new core.TagInterface.Padding("Padding", 0x20);

            public Equipment_Palette_Layout()
            {
                base.Add(this.Equipment);
                base.Add(this.Equipment_0);
                base.Add(this.Padding);
            }
        }

        public class Equipment_Placement_Layout : TagBlockLayout
        {
            public ShortInteger Equipment_Chunk__Number_ = new ShortInteger("Equipment Chunk #");
            public static readonly scnr.Equipment_Placement_Layout Layout = new scnr.Equipment_Placement_Layout();
            public core.TagInterface.Padding Padding = new core.TagInterface.Padding("Padding", 2);
            public core.TagInterface.Padding Padding_0 = new core.TagInterface.Padding("Padding", 8);
            public RealFloat Pitch = new RealFloat("Pitch");
            public RealFloat Roll = new RealFloat("Roll");
            public LongInteger Unknown = new LongInteger("Unknown");
            public LongInteger Unknown_0 = new LongInteger("Unknown");
            public LongInteger Unknown_1 = new LongInteger("Unknown");
            public RealFloat Unknown_2 = new RealFloat("Unknown");
            public LongInteger Unknown_3 = new LongInteger("Unknown");
            public RealFloat X = new RealFloat("X");
            public RealFloat Y = new RealFloat("Y");
            public RealFloat Yaw = new RealFloat("Yaw");
            public RealFloat Z = new RealFloat("Z");

            public Equipment_Placement_Layout()
            {
                base.Add(this.Equipment_Chunk__Number_);
                base.Add(this.Padding);
                base.Add(this.Unknown);
                base.Add(this.X);
                base.Add(this.Y);
                base.Add(this.Z);
                base.Add(this.Yaw);
                base.Add(this.Pitch);
                base.Add(this.Roll);
                base.Add(this.Padding_0);
                base.Add(this.Unknown_0);
                base.Add(this.Unknown_1);
                base.Add(this.Unknown_2);
                base.Add(this.Unknown_3);
            }
        }

        public class Planar_Fog_Palette_Layout : TagBlockLayout
        {
            public HaloTagType Fog = new HaloTagType("Fog");
            public TagIdent Fog_0 = new TagIdent("Fog");
            public StringID Fog_Name = new StringID("Fog Name");
            public LongInteger Fog_Position = new LongInteger("Fog Position");
            public static readonly scnr.Planar_Fog_Palette_Layout Layout = new scnr.Planar_Fog_Palette_Layout();

            public Planar_Fog_Palette_Layout()
            {
                base.Add(this.Fog_Name);
                base.Add(this.Fog);
                base.Add(this.Fog_0);
                base.Add(this.Fog_Position);
            }
        }

        public class Atmospheric_Fog_Palette_Layout : TagBlockLayout
        {
            public StringID Fog_Name = new StringID("Fog Name");
            public static readonly scnr.Atmospheric_Fog_Palette_Layout Layout = new scnr.Atmospheric_Fog_Palette_Layout();
            public core.TagInterface.Padding Padding = new core.TagInterface.Padding("Padding", 8);
            public core.TagInterface.Padding Padding_0 = new core.TagInterface.Padding("Padding", 4);
            public core.TagInterface.Padding Padding_1 = new core.TagInterface.Padding("Padding", 0x48);
            public core.TagInterface.Padding Padding_2 = new core.TagInterface.Padding("Padding", 12);
            public core.TagInterface.Padding Padding_3 = new core.TagInterface.Padding("Padding", 0x20);
            public core.TagInterface.Padding Padding_4 = new core.TagInterface.Padding("Padding", 8);
            public core.TagInterface.Padding Padding_5 = new core.TagInterface.Padding("Padding", 4);
            public RealFloat Unknown = new RealFloat("Unknown");
            public RealFloat Unknown_0 = new RealFloat("Unknown");
            public RealFloat Unknown_1 = new RealFloat("Unknown");
            public RealFloat Unknown_10 = new RealFloat("Unknown");
            public RealFloat Unknown_11 = new RealFloat("Unknown");
            public RealFloat Unknown_12 = new RealFloat("Unknown");
            public RealFloat Unknown_13 = new RealFloat("Unknown");
            public RealFloat Unknown_14 = new RealFloat("Unknown");
            public RealFloat Unknown_15 = new RealFloat("Unknown");
            public RealFloat Unknown_16 = new RealFloat("Unknown");
            public RealFloat Unknown_17 = new RealFloat("Unknown");
            public HaloTagType Unknown_18 = new HaloTagType("Unknown");
            public TagIdent Unknown_19 = new TagIdent("Unknown");
            public RealFloat Unknown_2 = new RealFloat("Unknown");
            public RealFloat Unknown_20 = new RealFloat("Unknown");
            public RealFloat Unknown_21 = new RealFloat("Unknown");
            public RealFloat Unknown_22 = new RealFloat("Unknown");
            public RealFloat Unknown_23 = new RealFloat("Unknown");
            public RealFloat Unknown_3 = new RealFloat("Unknown");
            public RealFloat Unknown_4 = new RealFloat("Unknown");
            public RealFloat Unknown_5 = new RealFloat("Unknown");
            public RealFloat Unknown_6 = new RealFloat("Unknown");
            public RealFloat Unknown_7 = new RealFloat("Unknown");
            public RealFloat Unknown_8 = new RealFloat("Unknown");
            public RealFloat Unknown_9 = new RealFloat("Unknown");

            public Atmospheric_Fog_Palette_Layout()
            {
                base.Add(this.Fog_Name);
                base.Add(this.Unknown);
                base.Add(this.Unknown_0);
                base.Add(this.Unknown_1);
                base.Add(this.Padding);
                base.Add(this.Unknown_2);
                base.Add(this.Unknown_3);
                base.Add(this.Unknown_4);
                base.Add(this.Unknown_5);
                base.Add(this.Unknown_6);
                base.Add(this.Unknown_7);
                base.Add(this.Padding_0);
                base.Add(this.Unknown_8);
                base.Add(this.Unknown_9);
                base.Add(this.Unknown_10);
                base.Add(this.Padding_1);
                base.Add(this.Unknown_11);
                base.Add(this.Unknown_12);
                base.Add(this.Unknown_13);
                base.Add(this.Padding_2);
                base.Add(this.Unknown_14);
                base.Add(this.Unknown_15);
                base.Add(this.Unknown_16);
                base.Add(this.Unknown_17);
                base.Add(this.Padding_3);
                base.Add(this.Unknown_18);
                base.Add(this.Unknown_19);
                base.Add(this.Padding_4);
                base.Add(this.Unknown_20);
                base.Add(this.Unknown_21);
                base.Add(this.Unknown_22);
                base.Add(this.Unknown_23);
                base.Add(this.Padding_5);
            }
        }

        public class Globals_Layout : TagBlockLayout
        {
            public LongInteger Initialization_Expression_Index = new LongInteger("Initialization Expression Index");
            public static readonly scnr.Globals_Layout Layout = new scnr.Globals_Layout();
            public core.TagInterface.String Name = new core.TagInterface.String("Name", 0x20);
            public core.TagInterface.Enumerator Return_Type = new core.TagInterface.Enumerator("Return Type", core.TagInterface.Enumerator.TagEnumeratorIndexType.Word);
            public core.TagInterface.Enumerator Type = new core.TagInterface.Enumerator("Type", core.TagInterface.Enumerator.TagEnumeratorIndexType.Word);

            public Globals_Layout()
            {
                base.Add(this.Name);
                base.Add(this.Type);
                base.Add(this.Return_Type);
                base.Add(this.Initialization_Expression_Index);
            }
        }

        public class Scenario_Kill_Triggers_Layout : TagBlockLayout
        {
            public static readonly scnr.Scenario_Kill_Triggers_Layout Layout = new scnr.Scenario_Kill_Triggers_Layout();
            public ShortInteger trigger_volume = new ShortInteger("Trigger Volume");

            public Scenario_Kill_Triggers_Layout()
            {
                base.Add(this.trigger_volume);
            }
        }

        public class Level_Dialogs_Palette_Layout : TagBlockLayout
        {
            public static readonly scnr.Level_Dialogs_Palette_Layout Layout = new scnr.Level_Dialogs_Palette_Layout();
            public HaloTagType Level_Dialog = new HaloTagType("Level Dialog");
            public TagIdent Level_Dialog_0 = new TagIdent("Level Dialog");

            public Level_Dialogs_Palette_Layout()
            {
                base.Add(this.Level_Dialog);
                base.Add(this.Level_Dialog_0);
            }
        }

        public class Light_Volumes_Palette_Layout : TagBlockLayout
        {
            public static readonly scnr.Light_Volumes_Palette_Layout Layout = new scnr.Light_Volumes_Palette_Layout();
            public HaloTagType Light = new HaloTagType("Light");
            public TagIdent Light_0 = new TagIdent("Light");
            public core.TagInterface.Padding Padding = new core.TagInterface.Padding("Padding", 0x20);

            public Light_Volumes_Palette_Layout()
            {
                base.Add(this.Light);
                base.Add(this.Light_0);
                base.Add(this.Padding);
            }
        }

        public class Light_Volumes_Placement_Layout : TagBlockLayout
        {
            public ShortInteger bsp_index = new ShortInteger("bsp_index");
            public static readonly scnr.Light_Volumes_Placement_Layout Layout = new scnr.Light_Volumes_Placement_Layout();
            public ShortInteger Light_Chunk__Number_ = new ShortInteger("Light Chunk #");
            public core.TagInterface.Padding Padding = new core.TagInterface.Padding("Padding", 6);
            public core.TagInterface.Padding Padding_0 = new core.TagInterface.Padding("Padding", 12);
            public core.TagInterface.Padding Padding_1 = new core.TagInterface.Padding("Padding", 4);
            public core.TagInterface.Padding Padding_2 = new core.TagInterface.Padding("Padding", 4);
            public core.TagInterface.Padding Padding_3 = new core.TagInterface.Padding("Padding", 4);
            public RealFloat Pitch = new RealFloat("Pitch");
            public RealFloat Roll = new RealFloat("Roll");
            public ShortInteger Unknown = new ShortInteger("Unknown");
            public RealFloat Unknown_0 = new RealFloat("Unknown");
            public LongInteger Unknown_1 = new LongInteger("Unknown");
            public RealFloat Unknown_10 = new RealFloat("Unknown");
            public RealFloat Unknown_11 = new RealFloat("Unknown");
            public LongInteger Unknown_2 = new LongInteger("Unknown");
            public RealFloat Unknown_3 = new RealFloat("Unknown");
            public LongInteger Unknown_4 = new LongInteger("Unknown");
            public LongInteger Unknown_5 = new LongInteger("Unknown");
            public LongInteger Unknown_6 = new LongInteger("Unknown");
            public RealFloat Unknown_7 = new RealFloat("Unknown");
            public RealFloat Unknown_8 = new RealFloat("Unknown");
            public LongInteger Unknown_9 = new LongInteger("Unknown");
            public RealFloat X = new RealFloat("X");
            public RealFloat Y = new RealFloat("Y");
            public RealFloat Yaw = new RealFloat("Yaw");
            public RealFloat Z = new RealFloat("Z");

            public Light_Volumes_Placement_Layout()
            {
                base.Add(this.Light_Chunk__Number_);
                base.Add(this.Padding);
                base.Add(this.X);
                base.Add(this.Y);
                base.Add(this.Z);
                base.Add(this.Yaw);
                base.Add(this.Pitch);
                base.Add(this.Roll);
                base.Add(this.Padding_0);
                base.Add(this.bsp_index);
                base.Add(this.Unknown);
                base.Add(this.Unknown_0);
                base.Add(this.Padding_1);
                base.Add(this.Padding_2);
                base.Add(this.Unknown_1);
                base.Add(this.Unknown_2);
                base.Add(this.Padding_3);
                base.Add(this.Unknown_3);
                base.Add(this.Unknown_4);
                base.Add(this.Unknown_5);
                base.Add(this.Unknown_6);
                base.Add(this.Unknown_7);
                base.Add(this.Unknown_8);
                base.Add(this.Unknown_9);
                base.Add(this.Unknown_10);
                base.Add(this.Unknown_11);
            }
        }

        public class Machine_Palette_Layout : TagBlockLayout
        {
            public static readonly scnr.Machine_Palette_Layout Layout = new scnr.Machine_Palette_Layout();
            public HaloTagType Machine = new HaloTagType("Machine");
            public TagIdent Machine_0 = new TagIdent("Machine");
            public core.TagInterface.Padding Padding = new core.TagInterface.Padding("Padding", 0x20);

            public Machine_Palette_Layout()
            {
                base.Add(this.Machine);
                base.Add(this.Machine_0);
                base.Add(this.Padding);
            }
        }

        public class Machine_Placement_Layout : TagBlockLayout
        {
            public ShortInteger bsp_index_1 = new ShortInteger("bspindex1");
            public ShortInteger Device_Group_Chunk__Number_ = new ShortInteger("Device Group Chunk #");
            public static readonly scnr.Machine_Placement_Layout Layout = new scnr.Machine_Placement_Layout();
            public core.TagInterface.Padding Padding = new core.TagInterface.Padding("Padding", 2);
            public core.TagInterface.Padding Padding_0 = new core.TagInterface.Padding("Padding", 4);
            public core.TagInterface.Padding Padding_1 = new core.TagInterface.Padding("Padding", 8);
            public core.TagInterface.Padding Padding_2 = new core.TagInterface.Padding("Padding", 2);
            public ShortInteger Palette_Chunk__Number_ = new ShortInteger("Palette Chunk #");
            public RealFloat Pitch = new RealFloat("Pitch");
            public RealFloat Position_X = new RealFloat("Position X");
            public RealFloat Position_Y = new RealFloat("Position Y");
            public RealFloat Position_Z = new RealFloat("Position Z");
            public RealFloat Roll = new RealFloat("Roll");
            public LongInteger Unknown = new LongInteger("Unknown");
            public LongInteger Unknown_0 = new LongInteger("Unknown");
            public LongInteger Unknown_1 = new LongInteger("Unknown");
            public RealFloat Unknown_3 = new RealFloat("Unknown");
            public ShortInteger Unknown_4 = new ShortInteger("Unknown");
            public LongInteger Unknown_5 = new LongInteger("Unknown");
            public LongInteger Unknown_6 = new LongInteger("Unknown");
            public RealFloat Yaw = new RealFloat("Yaw");

            public Machine_Placement_Layout()
            {
                base.Add(this.Palette_Chunk__Number_);
                base.Add(this.Padding);
                base.Add(this.Unknown);
                base.Add(this.Position_X);
                base.Add(this.Position_Y);
                base.Add(this.Position_Z);
                base.Add(this.Yaw);
                base.Add(this.Pitch);
                base.Add(this.Roll);
                base.Add(this.Padding_0);
                base.Add(this.Unknown_0);
                base.Add(this.Unknown_1);
                base.Add(this.bsp_index_1);
                base.Add(this.Padding_2);
                base.Add(this.Unknown_3);
                base.Add(this.Unknown_4);
                base.Add(this.Device_Group_Chunk__Number_);
                base.Add(this.Unknown_5);
                base.Add(this.Unknown_6);
                base.Add(this.Padding_1);
            }
        }

        public class Map_Description_Layout : TagBlockLayout
        {
            public static readonly scnr.Map_Description_Layout Layout = new scnr.Map_Description_Layout();
            public HaloTagType Map_Description = new HaloTagType("Map Description");
            public TagIdent Map_Description_0 = new TagIdent("Map Description");
            public TagBlock Multiplayer = new TagBlock("Multiplayer", Multiplayer_Layout.Layout, Map.HaloVersionEnum.Halo2);
            public TagBlock Single_Player = new TagBlock("Single Player", Single_Player_Layout.Layout, Map.HaloVersionEnum.Halo2);

            public Map_Description_Layout()
            {
                base.Add(this.Map_Description);
                base.Add(this.Map_Description_0);
                base.Add(this.Single_Player);
                base.Add(this.Multiplayer);
            }

            public class Multiplayer_Layout : TagBlockLayout
            {
                public core.TagInterface.String Chinese_Description = new core.TagInterface.String("Chinese Description", 0x100);
                public core.TagInterface.String Chinese_Name = new core.TagInterface.String("Chinese Name", 0x40);
                public core.TagInterface.String English_Description = new core.TagInterface.String("English Description", 0x100);
                public core.TagInterface.String English_Name = new core.TagInterface.String("English Name", 0x40);
                public core.TagInterface.String French_Description = new core.TagInterface.String("French Description", 0x100);
                public core.TagInterface.String French_Name = new core.TagInterface.String("French Name", 0x40);
                public core.TagInterface.String German_Description = new core.TagInterface.String("German Description", 0x100);
                public core.TagInterface.String German_Name = new core.TagInterface.String("German Name", 0x40);
                public core.TagInterface.String Italian_Description = new core.TagInterface.String("Italian Description", 0x100);
                public core.TagInterface.String Italian_Name = new core.TagInterface.String("Italian Name", 0x40);
                public core.TagInterface.String Japanese_Description = new core.TagInterface.String("Japanese Description", 0x100);
                public core.TagInterface.String Japanese_Name = new core.TagInterface.String("Japanese Name", 0x40);
                public core.TagInterface.String Korean_Description = new core.TagInterface.String("Korean Description", 0x100);
                public core.TagInterface.String Korean_Name = new core.TagInterface.String("Korean Name", 0x40);
                public static readonly scnr.Map_Description_Layout.Multiplayer_Layout Layout = new scnr.Map_Description_Layout.Multiplayer_Layout();
                public core.TagInterface.Enumerator Locked = new core.TagInterface.Enumerator("Locked", core.TagInterface.Enumerator.TagEnumeratorIndexType.Long);
                public LongInteger Map_ID = new LongInteger("Map ID");
                public LongInteger Next_Map_ID = new LongInteger("Next Map ID");
                public core.TagInterface.Padding Padding = new core.TagInterface.Padding("Padding", 4);
                public core.TagInterface.String Portuguese_Description = new core.TagInterface.String("Portuguese Description", 0x100);
                public core.TagInterface.String Portuguese_Name = new core.TagInterface.String("Portuguese Name", 0x40);
                public HaloTagType Preview_Image = new HaloTagType("Preview Image");
                public TagIdent Preview_Image_0 = new TagIdent("Preview Image");
                public core.TagInterface.String Scenario_Path = new core.TagInterface.String("Scenario Path", 0x100);
                public core.TagInterface.String Spanish_Description = new core.TagInterface.String("Spanish Description", 0x100);
                public core.TagInterface.String Spanish_Name = new core.TagInterface.String("Spanish Name", 0x40);
                public LongInteger Team_Options = new LongInteger("Team Options");
                public LongInteger Unknown = new LongInteger("Unknown");
                public LongInteger Unknown_0 = new LongInteger("Unknown");

                public Multiplayer_Layout()
                {
                    base.Add(this.Map_ID);
                    base.Add(this.Preview_Image);
                    base.Add(this.Preview_Image_0);
                    base.Add(this.English_Name);
                    base.Add(this.Japanese_Name);
                    base.Add(this.German_Name);
                    base.Add(this.French_Name);
                    base.Add(this.Spanish_Name);
                    base.Add(this.Italian_Name);
                    base.Add(this.Korean_Name);
                    base.Add(this.Chinese_Name);
                    base.Add(this.Portuguese_Name);
                    base.Add(this.English_Description);
                    base.Add(this.Japanese_Description);
                    base.Add(this.German_Description);
                    base.Add(this.French_Description);
                    base.Add(this.Spanish_Description);
                    base.Add(this.Italian_Description);
                    base.Add(this.Korean_Description);
                    base.Add(this.Chinese_Description);
                    base.Add(this.Portuguese_Description);
                    base.Add(this.Scenario_Path);
                    base.Add(this.Next_Map_ID);
                    base.Add(this.Locked);
                    base.Add(this.Team_Options);
                    base.Add(this.Unknown);
                    base.Add(this.Unknown_0);
                    base.Add(this.Padding);
                }
            }

            public class Single_Player_Layout : TagBlockLayout
            {
                public core.TagInterface.String Chinese_Description = new core.TagInterface.String("Chinese Description", 0x100);
                public core.TagInterface.String Chinese_Name = new core.TagInterface.String("Chinese Name", 0x40);
                public core.TagInterface.String English_Description = new core.TagInterface.String("English Description", 0x100);
                public core.TagInterface.String English_Name = new core.TagInterface.String("English Name", 0x40);
                public core.TagInterface.String French_Description = new core.TagInterface.String("French Description", 0x100);
                public core.TagInterface.String French_Name = new core.TagInterface.String("French Name", 0x40);
                public core.TagInterface.String German_Description = new core.TagInterface.String("German Description", 0x100);
                public core.TagInterface.String German_Name = new core.TagInterface.String("German Name", 0x40);
                public core.TagInterface.String Italian_Description = new core.TagInterface.String("Italian Description", 0x100);
                public core.TagInterface.String Italian_Name = new core.TagInterface.String("Italian Name", 0x40);
                public core.TagInterface.String Japanese_Description = new core.TagInterface.String("Japanese Description", 0x100);
                public core.TagInterface.String Japanese_Name = new core.TagInterface.String("Japanese Name", 0x40);
                public core.TagInterface.String Korean_Description = new core.TagInterface.String("Korean Description", 0x100);
                public core.TagInterface.String Korean_Name = new core.TagInterface.String("Korean Name", 0x40);
                public static readonly scnr.Map_Description_Layout.Single_Player_Layout Layout = new scnr.Map_Description_Layout.Single_Player_Layout();
                public LongInteger Map_ID = new LongInteger("Map ID");
                public core.TagInterface.String Portuguese_Description = new core.TagInterface.String("Portuguese Description", 0x100);
                public core.TagInterface.String Portuguese_Name = new core.TagInterface.String("Portuguese Name", 0x40);
                public HaloTagType Preview_Image = new HaloTagType("Preview Image");
                public TagIdent Preview_Image_0 = new TagIdent("Preview Image");
                public core.TagInterface.String Spanish_Description = new core.TagInterface.String("Spanish Description", 0x100);
                public core.TagInterface.String Spanish_Name = new core.TagInterface.String("Spanish Name", 0x40);
                public LongInteger Unknown = new LongInteger("Unknown");

                public Single_Player_Layout()
                {
                    base.Add(this.Unknown);
                    base.Add(this.Map_ID);
                    base.Add(this.Preview_Image);
                    base.Add(this.Preview_Image_0);
                    base.Add(this.English_Name);
                    base.Add(this.Japanese_Name);
                    base.Add(this.German_Name);
                    base.Add(this.French_Name);
                    base.Add(this.Spanish_Name);
                    base.Add(this.Italian_Name);
                    base.Add(this.Korean_Name);
                    base.Add(this.Chinese_Name);
                    base.Add(this.Portuguese_Name);
                    base.Add(this.English_Description);
                    base.Add(this.Japanese_Description);
                    base.Add(this.German_Description);
                    base.Add(this.French_Description);
                    base.Add(this.Spanish_Description);
                    base.Add(this.Italian_Description);
                    base.Add(this.Korean_Description);
                    base.Add(this.Chinese_Description);
                    base.Add(this.Portuguese_Description);
                }
            }
        }

        public class Netgame_Equipment_Layout : TagBlockLayout
        {
            public core.TagInterface.Enumerator Classifier = new core.TagInterface.Enumerator("Classifier", core.TagInterface.Enumerator.TagEnumeratorIndexType.Long);
            public HaloTagType Collection = new HaloTagType("Collection");
            public TagIdent Collection_0 = new TagIdent("Collection");
            public core.TagInterface.Enumerator Floating = new core.TagInterface.Enumerator("Floating", core.TagInterface.Enumerator.TagEnumeratorIndexType.Long);
            public static readonly scnr.Netgame_Equipment_Layout Layout = new scnr.Netgame_Equipment_Layout();
            public ShortInteger Max_on_Map = new ShortInteger("Max on Map");
            public core.TagInterface.Padding Padding = new core.TagInterface.Padding("Padding", 4);
            public core.TagInterface.Padding Padding_0 = new core.TagInterface.Padding("Padding", 40);
            public core.TagInterface.Padding Padding_1 = new core.TagInterface.Padding("Padding", 0x30);
            public RealFloat Pitch = new RealFloat("Pitch");
            public RealFloat Position_X = new RealFloat("Position X");
            public RealFloat Position_Y = new RealFloat("Position Y");
            public RealFloat Position_Z = new RealFloat("Position Z");
            public ShortInteger Respawn_2 = new ShortInteger("Respawn 2");
            public ShortInteger Respawn_Time = new ShortInteger("Respawn Time");
            public RealFloat Roll = new RealFloat("Roll");
            public core.TagInterface.Enumerator Spawns_in_KOTH__Plus_ = new core.TagInterface.Enumerator("Spawns in KOTH +", core.TagInterface.Enumerator.TagEnumeratorIndexType.Long);
            public ShortInteger Unused = new ShortInteger("Unused");
            public RealFloat Yaw = new RealFloat("Yaw");

            public Netgame_Equipment_Layout()
            {
                base.Add(this.Floating);
                base.Add(this.Spawns_in_KOTH__Plus_);
                base.Add(this.Padding);
                base.Add(this.Unused);
                base.Add(this.Respawn_Time);
                base.Add(this.Respawn_2);
                base.Add(this.Max_on_Map);
                base.Add(this.Classifier);
                base.Add(this.Padding_0);
                base.Add(this.Position_X);
                base.Add(this.Position_Y);
                base.Add(this.Position_Z);
                base.Add(this.Yaw);
                base.Add(this.Pitch);
                base.Add(this.Roll);
                base.Add(this.Collection);
                base.Add(this.Collection_0);
                base.Add(this.Padding_1);
            }
        }

        public class Netgame_Flags_Layout : TagBlockLayout
        {
            public ShortInteger _Number_ = new ShortInteger("#");
            public static readonly scnr.Netgame_Flags_Layout Layout = new scnr.Netgame_Flags_Layout();
            public core.TagInterface.Padding Padding = new core.TagInterface.Padding("Padding", 8);
            public RealFloat Position_X = new RealFloat("Position X");
            public RealFloat Position_Y = new RealFloat("Position Y");
            public RealFloat Position_Z = new RealFloat("Position Z");
            public RealFloat Rotation = new RealFloat("Rotation");
            public core.TagInterface.Enumerator Team = new core.TagInterface.Enumerator("Team", core.TagInterface.Enumerator.TagEnumeratorIndexType.Word);
            public core.TagInterface.Enumerator Type = new core.TagInterface.Enumerator("Type", core.TagInterface.Enumerator.TagEnumeratorIndexType.Word);
            public ShortInteger Unknown = new ShortInteger("Unknown");

            public Netgame_Flags_Layout()
            {
                base.Add(this.Position_X);
                base.Add(this.Position_Y);
                base.Add(this.Position_Z);
                base.Add(this.Rotation);
                base.Add(this.Type);
                base.Add(this.Team);
                base.Add(this._Number_);
                base.Add(this.Unknown);
                base.Add(this.Padding);
            }
        }

        public class Obstacle_Palette_Layout : TagBlockLayout
        {
            public static readonly scnr.Obstacle_Palette_Layout Layout = new scnr.Obstacle_Palette_Layout();
            public HaloTagType Obstacle = new HaloTagType("Obstacle");
            public TagIdent Obstacle_0 = new TagIdent("Obstacle");
            public core.TagInterface.Padding Padding = new core.TagInterface.Padding("Padding", 0x20);

            public Obstacle_Palette_Layout()
            {
                base.Add(this.Obstacle);
                base.Add(this.Obstacle_0);
                base.Add(this.Padding);
            }
        }

        public class Obstacle_Placement_Layout : TagBlockLayout
        {
            public ShortInteger bsp_index_1 = new ShortInteger("bsp_index_1");
            public static readonly scnr.Obstacle_Placement_Layout Layout = new scnr.Obstacle_Placement_Layout();
            public core.TagInterface.Padding Padding = new core.TagInterface.Padding("Padding", 2);
            public core.TagInterface.Padding Padding_0 = new core.TagInterface.Padding("Padding", 6);
            public core.TagInterface.Padding Padding_1 = new core.TagInterface.Padding("Padding", 20);
            public core.TagInterface.Padding Padding_2 = new core.TagInterface.Padding("Padding", 4);
            public ShortInteger Palette_Chunk__Number_ = new ShortInteger("Palette Chunk #");
            public RealFloat Pitch = new RealFloat("Pitch");
            public RealFloat Position_X = new RealFloat("Position X");
            public RealFloat Position_Y = new RealFloat("Position Y");
            public RealFloat Position_Z = new RealFloat("Position Z");
            public RealFloat Roll = new RealFloat("Roll");
            public LongInteger Unknown_0 = new LongInteger("Unknown");
            public ShortInteger Unknown_1 = new ShortInteger("Unknown");
            public RealFloat Unknown_2 = new RealFloat("Unknown");
            public StringID Unknown_3 = new StringID("Unknown");
            public ShortInteger Unknown_4 = new ShortInteger("Unknown_4");
            public RealFloat Yaw = new RealFloat("Yaw");

            public Obstacle_Placement_Layout()
            {
                base.Add(this.Palette_Chunk__Number_);
                base.Add(this.Padding);
                base.Add(this.Padding_2);
                base.Add(this.Position_X);
                base.Add(this.Position_Y);
                base.Add(this.Position_Z);
                base.Add(this.Yaw);
                base.Add(this.Pitch);
                base.Add(this.Roll);
                base.Add(this.Padding_0);
                base.Add(this.Unknown_4);
                base.Add(this.Unknown_0);
                base.Add(this.bsp_index_1);
                base.Add(this.Unknown_1);
                base.Add(this.Unknown_2);
                base.Add(this.Unknown_3);
                base.Add(this.Padding_1);
            }
        }

        public class Player_Starting_Locations_Layout : TagBlockLayout
        {
            public RealFloat Facing_Direction = new RealFloat("Facing Direction");
            public static readonly scnr.Player_Starting_Locations_Layout Layout = new scnr.Player_Starting_Locations_Layout();
            public core.TagInterface.Padding Padding = new core.TagInterface.Padding("Padding", 20);
            public core.TagInterface.Padding Padding_0 = new core.TagInterface.Padding("Padding", 4);
            public RealFloat Position_X = new RealFloat("Position X");
            public RealFloat Position_Y = new RealFloat("Position Y");
            public RealFloat Position_Z = new RealFloat("Position Z");
            public LongInteger Unknown = new LongInteger("Unknown");
            public core.TagInterface.Enumerator Unknown_0 = new core.TagInterface.Enumerator("Unknown", core.TagInterface.Enumerator.TagEnumeratorIndexType.Word);
            public core.TagInterface.Enumerator Unknown_1 = new core.TagInterface.Enumerator("Unknown", core.TagInterface.Enumerator.TagEnumeratorIndexType.Word);
            public LongInteger Unknown_2 = new LongInteger("Unknown");

            public Player_Starting_Locations_Layout()
            {
                base.Add(this.Position_X);
                base.Add(this.Position_Y);
                base.Add(this.Position_Z);
                base.Add(this.Facing_Direction);
                base.Add(this.Unknown);
                base.Add(this.Unknown_0);
                base.Add(this.Unknown_1);
                base.Add(this.Padding);
                base.Add(this.Unknown_2);
                base.Add(this.Padding_0);
            }
        }

        public class Predicted_Resources_0_Layout : TagBlockLayout
        {
            public static readonly scnr.Predicted_Resources_0_Layout Layout = new scnr.Predicted_Resources_0_Layout();
            public TagIdent Resource = new TagIdent("Resource");

            public Predicted_Resources_0_Layout()
            {
                base.Add(this.Resource);
            }
        }

        public class Predicted_Resources_Layout : TagBlockLayout
        {
            public TagIdent Bitmap = new TagIdent("Bitmap");
            public LongInteger Bitmap_Index = new LongInteger("Bitmap Index");
            public static readonly scnr.Predicted_Resources_Layout Layout = new scnr.Predicted_Resources_Layout();

            public Predicted_Resources_Layout()
            {
                base.Add(this.Bitmap_Index);
                base.Add(this.Bitmap);
            }
        }

        public class Player_Starting_Profiles_Layout : TagBlockLayout
        {
            public RealFloat Health_Modifier = new RealFloat("Health Modifier");
            public static readonly scnr.Player_Starting_Profiles_Layout Layout = new scnr.Player_Starting_Profiles_Layout();
            public core.TagInterface.Padding Padding = new core.TagInterface.Padding("Padding", 4);
            public core.TagInterface.Padding Padding_0 = new core.TagInterface.Padding("Padding", 4);
            public HaloTagType Primary_Weapon = new HaloTagType("Primary Weapon");
            public TagIdent Primary_Weapon_0 = new TagIdent("Primary Weapon");
            public core.TagInterface.String Profile_Name = new core.TagInterface.String("Profile Name", 0x20);
            public HaloTagType Secondary_Weapon = new HaloTagType("Secondary Weapon");
            public TagIdent Secondary_Weapon_0 = new TagIdent("Secondary Weapon");
            public RealFloat Shield_Modifier = new RealFloat("Shield Modifier");
            public LongInteger Unknown = new LongInteger("Unknown");

            public Player_Starting_Profiles_Layout()
            {
                base.Add(this.Profile_Name);
                base.Add(this.Health_Modifier);
                base.Add(this.Shield_Modifier);
                base.Add(this.Primary_Weapon);
                base.Add(this.Primary_Weapon_0);
                base.Add(this.Padding);
                base.Add(this.Secondary_Weapon);
                base.Add(this.Secondary_Weapon_0);
                base.Add(this.Padding_0);
                base.Add(this.Unknown);
            }
        }

        public class Scenery_Palette_Layout : TagBlockLayout
        {
            public static readonly scnr.Scenery_Palette_Layout Layout = new scnr.Scenery_Palette_Layout();
            public core.TagInterface.Padding Padding = new core.TagInterface.Padding("Padding", 0x20);
            public HaloTagType Scenery = new HaloTagType("Scenery");
            public TagIdent Scenery_0 = new TagIdent("Scenery");

            public Scenery_Palette_Layout()
            {
                base.Add(this.Scenery);
                base.Add(this.Scenery_0);
                base.Add(this.Padding);
            }
        }

        public class Scenery_Placement_Layout : TagBlockLayout
        {
            public ShortInteger bsp_index_1 = new ShortInteger("bsp_index_1");
            public ShortInteger bsp_index_2 = new ShortInteger("bsp_index_2");
            public static readonly scnr.Scenery_Placement_Layout Layout = new scnr.Scenery_Placement_Layout();
            public core.TagInterface.Padding Padding = new core.TagInterface.Padding("Padding", 2);
            public core.TagInterface.Padding Padding_0 = new core.TagInterface.Padding("Padding", 4);
            public core.TagInterface.Padding Padding_1 = new core.TagInterface.Padding("Padding", 12);
            public RealFloat Pitch = new RealFloat("Pitch");
            public RealFloat Position_X = new RealFloat("Position X");
            public RealFloat Position_Y = new RealFloat("Position Y");
            public RealFloat Position_Z = new RealFloat("Position Z");
            public RealFloat Roll = new RealFloat("Roll");
            public ShortInteger Scenery_Chunk__Number_ = new ShortInteger("Scenery Chunk #");
            public core.TagInterface.Flags Spawns_in__none_means_all_ = new core.TagInterface.Flags("Spawns in (none means all)", core.TagInterface.Flags.BitmaskTypeEnum.Word);
            public LongInteger Unknown = new LongInteger("Unknown");
            public RealFloat Unknown_0 = new RealFloat("Unknown");
            public ShortInteger Unknown_1 = new ShortInteger("Unknown");
            public LongInteger Unknown_10 = new LongInteger("Unknown");
            public LongInteger Unknown_11 = new LongInteger("Unknown");
            public LongInteger Unknown_12 = new LongInteger("Unknown");
            public LongInteger Unknown_13 = new LongInteger("Unknown");
            public ShortInteger Unknown_14 = new ShortInteger("Unknown");
            public ShortInteger Unknown_2 = new ShortInteger("Unknown");
            public LongInteger Unknown_3 = new LongInteger("Unknown");
            public ByteInteger Unknown_5 = new ByteInteger("Unknown");
            public ByteInteger Unknown_6 = new ByteInteger("Unknown");
            public ShortInteger Unknown_8 = new ShortInteger("Unknown");
            public StringID Unknown_9 = new StringID("Unknown");
            public RealFloat Yaw = new RealFloat("Yaw");

            public Scenery_Placement_Layout()
            {
                base.Add(this.Scenery_Chunk__Number_);
                base.Add(this.Padding);
                base.Add(this.Unknown);
                base.Add(this.Position_X);
                base.Add(this.Position_Y);
                base.Add(this.Position_Z);
                base.Add(this.Yaw);
                base.Add(this.Pitch);
                base.Add(this.Roll);
                base.Add(this.Unknown_0);
                base.Add(this.Unknown_1);
                base.Add(this.Unknown_2);
                base.Add(this.Unknown_3);
                base.Add(this.bsp_index_1);
                base.Add(this.Unknown_5);
                base.Add(this.Unknown_6);
                base.Add(this.bsp_index_2);
                base.Add(this.Unknown_8);
                base.Add(this.Unknown_9);
                base.Add(this.Padding_0);
                base.Add(this.Unknown_10);
                base.Add(this.Unknown_11);
                base.Add(this.Unknown_12);
                base.Add(this.Unknown_13);
                base.Add(this.Padding_1);
                base.Add(this.Unknown_14);
                base.Add(this.Spawns_in__none_means_all_);
            }
        }

        public class Screen_Effects_Layout : TagBlockLayout
        {
            public static readonly scnr.Screen_Effects_Layout Layout = new scnr.Screen_Effects_Layout();
            public StringID Name = new StringID("Name");
            public core.TagInterface.Padding Padding = new core.TagInterface.Padding("Padding", 0x10);
            public core.TagInterface.Padding Padding_0 = new core.TagInterface.Padding("Padding", 4);
            public HaloTagType Screen_Effect = new HaloTagType("Screen Effect");
            public TagIdent Screen_Effect_0 = new TagIdent("Screen Effect");
            public RealFloat Unknown = new RealFloat("Unknown");

            public Screen_Effects_Layout()
            {
                base.Add(this.Padding);
                base.Add(this.Screen_Effect);
                base.Add(this.Screen_Effect_0);
                base.Add(this.Name);
                base.Add(this.Padding_0);
                base.Add(this.Unknown);
            }
        }

        public class Script_Data_Layout : TagBlockLayout
        {
            public ByteInteger Character = new ByteInteger("Character");
            public static readonly scnr.Script_Data_Layout Layout = new scnr.Script_Data_Layout();

            public Script_Data_Layout()
            {
                base.Add(this.Character);
            }
        }

        public class Script_Locations_Layout : TagBlockLayout
        {
            public TagBlock Groups = new TagBlock("Groups", Groups_Layout.Layout, Map.HaloVersionEnum.Halo2);
            public static readonly scnr.Script_Locations_Layout Layout = new scnr.Script_Locations_Layout();
            public core.TagInterface.Padding Padding = new core.TagInterface.Padding("Padding", 120);

            public Script_Locations_Layout()
            {
                base.Add(this.Groups);
                base.Add(this.Padding);
            }

            public class Groups_Layout : TagBlockLayout
            {
                public core.TagInterface.String Group_name = new core.TagInterface.String("Group name", 0x20);
                public static readonly scnr.Script_Locations_Layout.Groups_Layout Layout = new scnr.Script_Locations_Layout.Groups_Layout();
                public core.TagInterface.Padding Padding = new core.TagInterface.Padding("Padding", 4);
                public TagBlock Points = new TagBlock("Points", Points_Layout.Layout, Map.HaloVersionEnum.Halo2);
                public LongInteger Unknown = new LongInteger("Unknown");

                public Groups_Layout()
                {
                    base.Add(this.Group_name);
                    base.Add(this.Points);
                    base.Add(this.Unknown);
                    base.Add(this.Padding);
                }

                public class Points_Layout : TagBlockLayout
                {
                    public static readonly scnr.Script_Locations_Layout.Groups_Layout.Points_Layout Layout = new scnr.Script_Locations_Layout.Groups_Layout.Points_Layout();
                    public core.TagInterface.String Point_name = new core.TagInterface.String("Point name", 0x20);
                    public LongInteger Unknown = new LongInteger("Unknown");
                    public LongInteger Unknown_0 = new LongInteger("Unknown");
                    public LongInteger Unknown_1 = new LongInteger("Unknown");
                    public LongInteger Unknown_2 = new LongInteger("Unknown");
                    public RealFloat X = new RealFloat("X");
                    public RealFloat Y = new RealFloat("Y");
                    public RealFloat Z = new RealFloat("Z");

                    public Points_Layout()
                    {
                        base.Add(this.Point_name);
                        base.Add(this.X);
                        base.Add(this.Y);
                        base.Add(this.Z);
                        base.Add(this.Unknown);
                        base.Add(this.Unknown_0);
                        base.Add(this.Unknown_1);
                        base.Add(this.Unknown_2);
                    }
                }
            }
        }

        public class Script_Objects_Layout : TagBlockLayout
        {
            public ShortInteger Index = new ShortInteger("Index");
            public static readonly scnr.Script_Objects_Layout Layout = new scnr.Script_Objects_Layout();
            public core.TagInterface.String Name = new core.TagInterface.String("Name", 0x20);
            public ShortInteger Type = new ShortInteger("Type");

            public Script_Objects_Layout()
            {
                base.Add(this.Name);
                base.Add(this.Type);
                base.Add(this.Index);
            }
        }

        public class Script_Syntax : TagBlockLayout
        {
            public static readonly scnr.Script_Syntax Layout = new scnr.Script_Syntax();
            public Syntax_Block syntax = new Syntax_Block("Unknown");

            public Script_Syntax()
            {
                base.Add(this.syntax);
            }
        }

        public class Scripts_Layout : TagBlockLayout
        {
            public static readonly scnr.Scripts_Layout Layout = new scnr.Scripts_Layout();
            public core.TagInterface.String Name = new core.TagInterface.String("Name", 0x20);
            public core.TagInterface.Enumerator Return_Type = new core.TagInterface.Enumerator("Return Type", core.TagInterface.Enumerator.TagEnumeratorIndexType.Word);
            public LongInteger Root_Expression_Index = new LongInteger("Root Expression Index");
            public core.TagInterface.Enumerator Script_Type = new core.TagInterface.Enumerator("Script Type", core.TagInterface.Enumerator.TagEnumeratorIndexType.Word);

            public Scripts_Layout()
            {
                base.Add(this.Name);
                base.Add(this.Script_Type);
                base.Add(this.Return_Type);
                base.Add(this.Root_Expression_Index);
            }
        }

        public class Sky_Palette_Layout : TagBlockLayout
        {
            public static readonly scnr.Sky_Palette_Layout Layout = new scnr.Sky_Palette_Layout();
            public HaloTagType Sky = new HaloTagType("Sky");
            public TagIdent Sky_0 = new TagIdent("Sky");

            public Sky_Palette_Layout()
            {
                base.Add(this.Sky);
                base.Add(this.Sky_0);
            }
        }

        public class Sound_Environment_Palette_Layout : TagBlockLayout
        {
            public static readonly scnr.Sound_Environment_Palette_Layout Layout = new scnr.Sound_Environment_Palette_Layout();
            public core.TagInterface.String Name = new core.TagInterface.String("Name", 0x20);
            public core.TagInterface.Padding Padding = new core.TagInterface.Padding("Padding", 0x18);
            public HaloTagType Sound_Environment = new HaloTagType("Sound Environment");
            public TagIdent Sound_Environment_0 = new TagIdent("Sound Environment");
            public RealFloat Unknown = new RealFloat("Unknown");
            public RealFloat Unknown_0 = new RealFloat("Unknown");

            public Sound_Environment_Palette_Layout()
            {
                base.Add(this.Name);
                base.Add(this.Sound_Environment);
                base.Add(this.Sound_Environment_0);
                base.Add(this.Unknown);
                base.Add(this.Unknown_0);
                base.Add(this.Padding);
            }
        }

        public class Sound_Scenery_Palette_Layout : TagBlockLayout
        {
            public static readonly scnr.Sound_Scenery_Palette_Layout Layout = new scnr.Sound_Scenery_Palette_Layout();
            public core.TagInterface.Padding Padding = new core.TagInterface.Padding("Padding", 0x20);
            public HaloTagType Sound_Scenery = new HaloTagType("Sound Scenery");
            public TagIdent Sound_Scenery_0 = new TagIdent("Sound Scenery");

            public Sound_Scenery_Palette_Layout()
            {
                base.Add(this.Sound_Scenery);
                base.Add(this.Sound_Scenery_0);
                base.Add(this.Padding);
            }
        }

        public class Sound_Scenery_Placement_Layout : TagBlockLayout
        {
            public ShortInteger bsp_index = new ShortInteger("bsp_index");
            public static readonly scnr.Sound_Scenery_Placement_Layout Layout = new scnr.Sound_Scenery_Placement_Layout();
            public RealPoint3D location = new RealPoint3D("Location");
            public core.TagInterface.Padding Padding = new core.TagInterface.Padding("Padding", 4);
            public ShortInteger palette_index = new ShortInteger("palette_index");
            public ShortInteger unknown = new ShortInteger("unknown");
            public LongInteger Unknown_1 = new LongInteger("Unknown");
            public LongInteger Unknown_10 = new LongInteger("Unknown");
            public RealFloat Unknown_11 = new RealFloat("Unknown");
            public RealFloat Unknown_12 = new RealFloat("Unknown");
            public RealFloat Unknown_13 = new RealFloat("Unknown");
            public RealFloat Unknown_14 = new RealFloat("Unknown");
            public RealFloat Unknown_15 = new RealFloat("Unknown");
            public RealFloat Unknown_16 = new RealFloat("Unknown");
            public LongInteger Unknown_2 = new LongInteger("Unknown");
            public LongInteger Unknown_3 = new LongInteger("Unknown");
            public LongInteger Unknown_4 = new LongInteger("Unknown");
            public LongInteger Unknown_5 = new LongInteger("Unknown");
            public LongInteger Unknown_6 = new LongInteger("Unknown");
            public ShortInteger Unknown_66 = new ShortInteger("Unknown_66");
            public LongInteger Unknown_7 = new LongInteger("Unknown");
            public LongInteger Unknown_8 = new LongInteger("Unknown");
            public RealFloat Unknown_9 = new RealFloat("Unknown");

            public Sound_Scenery_Placement_Layout()
            {
                base.Add(this.palette_index);
                base.Add(this.unknown);
                base.Add(this.Unknown_1);
                base.Add(this.location);
                base.Add(this.Unknown_2);
                base.Add(this.Unknown_3);
                base.Add(this.Unknown_4);
                base.Add(this.Unknown_5);
                base.Add(this.Unknown_6);
                base.Add(this.Padding);
                base.Add(this.bsp_index);
                base.Add(this.Unknown_66);
                base.Add(this.Unknown_7);
                base.Add(this.Unknown_8);
                base.Add(this.Unknown_9);
                base.Add(this.Unknown_10);
                base.Add(this.Unknown_11);
                base.Add(this.Unknown_12);
                base.Add(this.Unknown_13);
                base.Add(this.Unknown_14);
            }
        }

        public class Special_Spawns_Layout : TagBlockLayout
        {
            public TagBlock CTF_Respawns = new TagBlock("CTF Respawns", CTF_Respawns_Layout.Layout, Map.HaloVersionEnum.Halo2);
            public TagBlock Initial_Spawns = new TagBlock("Initial Spawns", Initial_Spawns_Layout.Layout, Map.HaloVersionEnum.Halo2);
            public static readonly scnr.Special_Spawns_Layout Layout = new scnr.Special_Spawns_Layout();
            public RealFloat Objective_Respawn_Z = new RealFloat("Objective Respawn Z");
            public core.TagInterface.Padding Padding = new core.TagInterface.Padding("Padding", 60);
            public RealFloat Unknown = new RealFloat("Unknown");
            public RealFloat Unknown_0 = new RealFloat("Unknown");
            public TagBlock Unknown_1 = new TagBlock("Unknown", Unknown_1_Layout.Layout, Map.HaloVersionEnum.Halo2);

            public Special_Spawns_Layout()
            {
                base.Add(this.Unknown);
                base.Add(this.Unknown_0);
                base.Add(this.Objective_Respawn_Z);
                base.Add(this.Padding);
                base.Add(this.Unknown_1);
                base.Add(this.CTF_Respawns);
                base.Add(this.Initial_Spawns);
            }

            public class CTF_Respawns_Layout : TagBlockLayout
            {
                public StringID Condition = new StringID("Condition");
                public static readonly scnr.Special_Spawns_Layout.CTF_Respawns_Layout Layout = new scnr.Special_Spawns_Layout.CTF_Respawns_Layout();
                public RealFloat Length = new RealFloat("Length");
                public RealFloat Position_X = new RealFloat("Position X");
                public RealFloat Position_Y = new RealFloat("Position Y");
                public RealFloat Position_Z = new RealFloat("Position Z");
                public RealFloat Thickness = new RealFloat("Thickness");
                public LongInteger Unknown = new LongInteger("Unknown");
                public LongInteger Unknown_0 = new LongInteger("Unknown");
                public LongInteger Unknown_1 = new LongInteger("Unknown");
                public RealFloat Unknown_2 = new RealFloat("Unknown");
                public RealFloat Unknown_3 = new RealFloat("Unknown");
                public RealFloat Width = new RealFloat("Width");

                public CTF_Respawns_Layout()
                {
                    base.Add(this.Condition);
                    base.Add(this.Unknown);
                    base.Add(this.Unknown_0);
                    base.Add(this.Unknown_1);
                    base.Add(this.Position_X);
                    base.Add(this.Position_Y);
                    base.Add(this.Position_Z);
                    base.Add(this.Unknown_2);
                    base.Add(this.Unknown_3);
                    base.Add(this.Width);
                    base.Add(this.Length);
                    base.Add(this.Thickness);
                }
            }

            public class Initial_Spawns_Layout : TagBlockLayout
            {
                public StringID Condition = new StringID("Condition");
                public static readonly scnr.Special_Spawns_Layout.Initial_Spawns_Layout Layout = new scnr.Special_Spawns_Layout.Initial_Spawns_Layout();
                public core.TagInterface.Padding Padding = new core.TagInterface.Padding("Padding", 4);
                public RealFloat Position_X = new RealFloat("Position X");
                public RealFloat Position_Y = new RealFloat("Position Y");
                public RealFloat Position_Z = new RealFloat("Position Z");
                public LongInteger Unknown = new LongInteger("Unknown");
                public LongInteger Unknown_0 = new LongInteger("Unknown");
                public RealFloat Unknown_1 = new RealFloat("Unknown");
                public RealFloat Unknown_2 = new RealFloat("Unknown");
                public RealFloat Unknown_3 = new RealFloat("Unknown");
                public RealFloat Unknown_4 = new RealFloat("Unknown");
                public RealFloat Unknown_5 = new RealFloat("Unknown");

                public Initial_Spawns_Layout()
                {
                    base.Add(this.Condition);
                    base.Add(this.Unknown);
                    base.Add(this.Unknown_0);
                    base.Add(this.Padding);
                    base.Add(this.Position_X);
                    base.Add(this.Position_Y);
                    base.Add(this.Position_Z);
                    base.Add(this.Unknown_1);
                    base.Add(this.Unknown_2);
                    base.Add(this.Unknown_3);
                    base.Add(this.Unknown_4);
                    base.Add(this.Unknown_5);
                }
            }

            public class Unknown_1_Layout : TagBlockLayout
            {
                public static readonly scnr.Special_Spawns_Layout.Unknown_1_Layout Layout = new scnr.Special_Spawns_Layout.Unknown_1_Layout();
                public LongInteger Unknown = new LongInteger("Unknown");
                public RealFloat Unknown_0 = new RealFloat("Unknown");
                public RealFloat Unknown_1 = new RealFloat("Unknown");
                public RealFloat Unknown_2 = new RealFloat("Unknown");

                public Unknown_1_Layout()
                {
                    base.Add(this.Unknown);
                    base.Add(this.Unknown_0);
                    base.Add(this.Unknown_1);
                    base.Add(this.Unknown_2);
                }
            }
        }

        public class Starting_Equipment_Layout : TagBlockLayout
        {
            public static readonly scnr.Starting_Equipment_Layout Layout = new scnr.Starting_Equipment_Layout();
            public core.TagInterface.Padding Padding = new core.TagInterface.Padding("Padding", 0x34);
            public core.TagInterface.Padding Padding_0 = new core.TagInterface.Padding("Padding", 0x30);
            public HaloTagType Primary_Weap = new HaloTagType("Primary Weap");
            public TagIdent Primary_Weap_0 = new TagIdent("Primary Weap");
            public HaloTagType Secondary_Weap = new HaloTagType("Secondary Weap");
            public TagIdent Secondary_Weap_0 = new TagIdent("Secondary Weap");
            public core.TagInterface.Enumerator Spawns_in_KOTH__Plus_ = new core.TagInterface.Enumerator("Spawns in KOTH +", core.TagInterface.Enumerator.TagEnumeratorIndexType.Long);
            public core.TagInterface.Enumerator Starting_Grenades = new core.TagInterface.Enumerator("Starting Grenades", core.TagInterface.Enumerator.TagEnumeratorIndexType.Long);
            public HaloTagType Unused = new HaloTagType("Unused");
            public TagIdent Unused_0 = new TagIdent("Unused");
            public HaloTagType Unused_1 = new HaloTagType("Unused");
            public TagIdent Unused_2 = new TagIdent("Unused");
            public HaloTagType Unused_3 = new HaloTagType("Unused");
            public TagIdent Unused_4 = new TagIdent("Unused");
            public HaloTagType Unused_5 = new HaloTagType("Unused");
            public TagIdent Unused_6 = new TagIdent("Unused");

            public Starting_Equipment_Layout()
            {
                base.Add(this.Starting_Grenades);
                base.Add(this.Spawns_in_KOTH__Plus_);
                base.Add(this.Padding);
                base.Add(this.Primary_Weap);
                base.Add(this.Primary_Weap_0);
                base.Add(this.Secondary_Weap);
                base.Add(this.Secondary_Weap_0);
                base.Add(this.Unused);
                base.Add(this.Unused_0);
                base.Add(this.Unused_1);
                base.Add(this.Unused_2);
                base.Add(this.Unused_3);
                base.Add(this.Unused_4);
                base.Add(this.Unused_5);
                base.Add(this.Unused_6);
                base.Add(this.Padding_0);
            }
        }

        public class Structure_BSPS_Layout : TagBlockLayout
        {
            public static readonly scnr.Structure_BSPS_Layout Layout = new scnr.Structure_BSPS_Layout();
            public HaloTagType Light_Map = new HaloTagType("Light Map");
            public TagIdent Light_Map_0 = new TagIdent("Light Map");
            public core.TagInterface.Padding Padding = new core.TagInterface.Padding("Padding", 4);
            public core.TagInterface.Padding Padding_0 = new core.TagInterface.Padding("Padding", 4);
            public core.TagInterface.Padding Padding_1 = new core.TagInterface.Padding("Padding", 4);
            public core.TagInterface.Padding Padding_2 = new core.TagInterface.Padding("Padding", 0x10);
            public LongInteger Primary_Magic_Meta_Offset = new LongInteger("Primary Magic Meta Offset");
            public HaloTagType Structure_BSP = new HaloTagType("Structure BSP");
            public TagIdent Structure_BSP_0 = new TagIdent("Structure BSP");
            public LongInteger Structure_BSP_Offset = new LongInteger("Structure BSP Offset");
            public LongInteger Structure_BSP_Size = new LongInteger("Structure BSP Size");
            public RealFloat Unknown = new RealFloat("Unknown");
            public RealFloat Unknown_0 = new RealFloat("Unknown");
            public RealFloat Unknown_1 = new RealFloat("Unknown");

            public Structure_BSPS_Layout()
            {
                base.Add(this.Structure_BSP_Offset);
                base.Add(this.Structure_BSP_Size);
                base.Add(this.Primary_Magic_Meta_Offset);
                base.Add(this.Padding);
                base.Add(this.Structure_BSP);
                base.Add(this.Structure_BSP_0);
                base.Add(this.Light_Map);
                base.Add(this.Light_Map_0);
                base.Add(this.Padding_0);
                base.Add(this.Unknown);
                base.Add(this.Padding_1);
                base.Add(this.Unknown_0);
                base.Add(this.Unknown_1);
                base.Add(this.Padding_2);
            }
        }

        public class Style_Palette_Layout : TagBlockLayout
        {
            public static readonly scnr.Style_Palette_Layout Layout = new scnr.Style_Palette_Layout();
            public HaloTagType Style = new HaloTagType("Style");
            public TagIdent Style_0 = new TagIdent("Style");

            public Style_Palette_Layout()
            {
                base.Add(this.Style);
                base.Add(this.Style_0);
            }
        }

        public class BSP_Switch_Trigger_Volumes_Layout : TagBlockLayout
        {
            public static readonly scnr.BSP_Switch_Trigger_Volumes_Layout Layout = new scnr.BSP_Switch_Trigger_Volumes_Layout();
            public ByteInteger Unknown = new ByteInteger("Unknown");
            public ByteInteger Unknown_0 = new ByteInteger("Unknown");
            public ByteInteger Unknown_1 = new ByteInteger("Unknown");
            public ByteInteger Unknown_10 = new ByteInteger("Unknown");
            public ByteInteger Unknown_11 = new ByteInteger("Unknown");
            public ByteInteger Unknown_12 = new ByteInteger("Unknown");
            public ByteInteger Unknown_2 = new ByteInteger("Unknown");
            public ByteInteger Unknown_3 = new ByteInteger("Unknown");
            public ByteInteger Unknown_4 = new ByteInteger("Unknown");
            public ByteInteger Unknown_5 = new ByteInteger("Unknown");
            public ByteInteger Unknown_6 = new ByteInteger("Unknown");
            public ByteInteger Unknown_7 = new ByteInteger("Unknown");
            public ByteInteger Unknown_8 = new ByteInteger("Unknown");
            public ByteInteger Unknown_9 = new ByteInteger("Unknown");

            public BSP_Switch_Trigger_Volumes_Layout()
            {
                base.Add(this.Unknown);
                base.Add(this.Unknown_0);
                base.Add(this.Unknown_1);
                base.Add(this.Unknown_2);
                base.Add(this.Unknown_3);
                base.Add(this.Unknown_4);
                base.Add(this.Unknown_5);
                base.Add(this.Unknown_6);
                base.Add(this.Unknown_7);
                base.Add(this.Unknown_8);
                base.Add(this.Unknown_9);
                base.Add(this.Unknown_10);
                base.Add(this.Unknown_11);
                base.Add(this.Unknown_12);
            }
        }

        public class AI_Triggers_Layout : TagBlockLayout
        {
            public static readonly scnr.AI_Triggers_Layout Layout = new scnr.AI_Triggers_Layout();
            public core.TagInterface.String Unknown = new core.TagInterface.String("Unknown", 0x20);
            public LongInteger Unknown_0 = new LongInteger("Unknown");
            public LongInteger Unknown_1 = new LongInteger("Unknown");
            public TagBlock Unknown_2 = new TagBlock("Unknown", Unknown_2_Layout.Layout, Map.HaloVersionEnum.Halo2);

            public AI_Triggers_Layout()
            {
                base.Add(this.Unknown);
                base.Add(this.Unknown_0);
                base.Add(this.Unknown_1);
                base.Add(this.Unknown_2);
            }

            public class Unknown_2_Layout : TagBlockLayout
            {
                public static readonly scnr.AI_Triggers_Layout.Unknown_2_Layout Layout = new scnr.AI_Triggers_Layout.Unknown_2_Layout();
                public core.TagInterface.Padding Padding = new core.TagInterface.Padding("Padding", 4);
                public LongInteger Unknown = new LongInteger("Unknown");
                public LongInteger Unknown_0 = new LongInteger("Unknown");
                public RealFloat Unknown_1 = new RealFloat("Unknown");
                public LongInteger Unknown_2 = new LongInteger("Unknown");
                public core.TagInterface.String Unknown_3 = new core.TagInterface.String("Unknown", 0x20);
                public LongInteger Unknown_4 = new LongInteger("Unknown");

                public Unknown_2_Layout()
                {
                    base.Add(this.Unknown);
                    base.Add(this.Unknown_0);
                    base.Add(this.Unknown_1);
                    base.Add(this.Unknown_2);
                    base.Add(this.Unknown_3);
                    base.Add(this.Unknown_4);
                    base.Add(this.Padding);
                }
            }
        }

        public class Unknown_12_Layout : TagBlockLayout
        {
            public static readonly scnr.Unknown_12_Layout Layout = new scnr.Unknown_12_Layout();
            public TagBlock Unknown = new TagBlock("Unknown", Unknown_Layout.Layout, Map.HaloVersionEnum.Halo2);
            public TagBlock Unknown_0 = new TagBlock("Unknown", Unknown_0_Layout.Layout, Map.HaloVersionEnum.Halo2);
            public LongInteger Unknown_1 = new LongInteger("Unknown");
            public TagBlock Unknown_2 = new TagBlock("Unknown", Unknown_2_Layout.Layout, Map.HaloVersionEnum.Halo2);
            public TagBlock Unknown_3 = new TagBlock("Unknown", Unknown_3_Layout.Layout, Map.HaloVersionEnum.Halo2);
            public TagBlock Unknown_4 = new TagBlock("Unknown", Unknown_4_Layout.Layout, Map.HaloVersionEnum.Halo2);
            public HaloTagType Unused = new HaloTagType("Unused");
            public TagIdent Unused_0 = new TagIdent("Unused");

            public Unknown_12_Layout()
            {
                base.Add(this.Unused);
                base.Add(this.Unused_0);
                base.Add(this.Unknown);
                base.Add(this.Unknown_0);
                base.Add(this.Unknown_1);
                base.Add(this.Unknown_2);
                base.Add(this.Unknown_3);
                base.Add(this.Unknown_4);
            }

            public class Unknown_0_Layout : TagBlockLayout
            {
                public static readonly scnr.Unknown_12_Layout.Unknown_0_Layout Layout = new scnr.Unknown_12_Layout.Unknown_0_Layout();
                public LongInteger Unknown = new LongInteger("Unknown");

                public Unknown_0_Layout()
                {
                    base.Add(this.Unknown);
                }
            }

            public class Unknown_2_Layout : TagBlockLayout
            {
                public static readonly scnr.Unknown_12_Layout.Unknown_2_Layout Layout = new scnr.Unknown_12_Layout.Unknown_2_Layout();
                public LongInteger Unknown = new LongInteger("Unknown");
                public LongInteger Unknown_0 = new LongInteger("Unknown");
                public LongInteger Unknown_1 = new LongInteger("Unknown");

                public Unknown_2_Layout()
                {
                    base.Add(this.Unknown);
                    base.Add(this.Unknown_0);
                    base.Add(this.Unknown_1);
                }
            }

            public class Unknown_3_Layout : TagBlockLayout
            {
                public static readonly scnr.Unknown_12_Layout.Unknown_3_Layout Layout = new scnr.Unknown_12_Layout.Unknown_3_Layout();
                public LongInteger Unknown = new LongInteger("Unknown");

                public Unknown_3_Layout()
                {
                    base.Add(this.Unknown);
                }
            }

            public class Unknown_4_Layout : TagBlockLayout
            {
                public static readonly scnr.Unknown_12_Layout.Unknown_4_Layout Layout = new scnr.Unknown_12_Layout.Unknown_4_Layout();
                public LongInteger Unknown = new LongInteger("Unknown");

                public Unknown_4_Layout()
                {
                    base.Add(this.Unknown);
                }
            }

            public class Unknown_Layout : TagBlockLayout
            {
                public static readonly scnr.Unknown_12_Layout.Unknown_Layout Layout = new scnr.Unknown_12_Layout.Unknown_Layout();
                public LongInteger Unknown = new LongInteger("Unknown");

                public Unknown_Layout()
                {
                    base.Add(this.Unknown);
                }
            }
        }

        public class SBSP_Lighting_Layout : TagBlockLayout
        {
            public static readonly scnr.SBSP_Lighting_Layout Layout = new scnr.SBSP_Lighting_Layout();
            public TagBlock Unknown = new TagBlock("Unknown", Unknown_Layout.Layout, Map.HaloVersionEnum.Halo2);
            public HaloTagType Unused = new HaloTagType("Unused");
            public TagIdent Unused_0 = new TagIdent("Unused");

            public SBSP_Lighting_Layout()
            {
                base.Add(this.Unused);
                base.Add(this.Unused_0);
                base.Add(this.Unknown);
            }

            public class Unknown_Layout : TagBlockLayout
            {
                public static readonly scnr.SBSP_Lighting_Layout.Unknown_Layout Layout = new scnr.SBSP_Lighting_Layout.Unknown_Layout();
                public LongInteger Unknown = new LongInteger("Unknown");
                public RealFloat Unknown_0 = new RealFloat("Unknown");
                public RealFloat Unknown_1 = new RealFloat("Unknown");

                public Unknown_Layout()
                {
                    base.Add(this.Unknown);
                    base.Add(this.Unknown_0);
                    base.Add(this.Unknown_1);
                }
            }
        }

        public class Interpolators_Layout : TagBlockLayout
        {
            public static readonly scnr.Interpolators_Layout Layout = new scnr.Interpolators_Layout();
            public core.TagInterface.Padding Padding = new core.TagInterface.Padding("Padding", 8);
            public core.TagInterface.Padding Padding_0 = new core.TagInterface.Padding("Padding", 4);
            public StringID Unknown = new StringID("Unknown");
            public TagBlock Unknown_0 = new TagBlock("Unknown", Unknown_0_Layout.Layout, Map.HaloVersionEnum.Halo2);

            public Interpolators_Layout()
            {
                base.Add(this.Unknown);
                base.Add(this.Padding);
                base.Add(this.Unknown_0);
                base.Add(this.Padding_0);
            }

            public class Unknown_0_Layout : TagBlockLayout
            {
                public static readonly scnr.Interpolators_Layout.Unknown_0_Layout Layout = new scnr.Interpolators_Layout.Unknown_0_Layout();
                public ByteInteger Unknown = new ByteInteger("Unknown");

                public Unknown_0_Layout()
                {
                    base.Add(this.Unknown);
                }
            }
        }

        public class Unknown_3_Layout : TagBlockLayout
        {
            public static readonly scnr.Unknown_3_Layout Layout = new scnr.Unknown_3_Layout();
            public core.TagInterface.Padding Padding = new core.TagInterface.Padding("Padding", 4);
            public StringID Unknown = new StringID("Unknown");
            public TagBlock Unknown_0 = new TagBlock("Unknown", Unknown_0_Layout.Layout, Map.HaloVersionEnum.Halo2);
            public TagBlock Unknown_1 = new TagBlock("Unknown", Unknown_1_Layout.Layout, Map.HaloVersionEnum.Halo2);

            public Unknown_3_Layout()
            {
                base.Add(this.Unknown);
                base.Add(this.Padding);
                base.Add(this.Unknown_0);
                base.Add(this.Unknown_1);
            }

            public class Unknown_0_Layout : TagBlockLayout
            {
                public static readonly scnr.Unknown_3_Layout.Unknown_0_Layout Layout = new scnr.Unknown_3_Layout.Unknown_0_Layout();
                public LongInteger Unknown = new LongInteger("Unknown");
                public TagBlock Unknown_0 = new TagBlock("Unknown", Unknown_0x_Layout.Layout, Map.HaloVersionEnum.Halo2);

                public Unknown_0_Layout()
                {
                    base.Add(this.Unknown);
                    base.Add(this.Unknown_0);
                }

                public class Unknown_0x_Layout : TagBlockLayout
                {
                    public static readonly scnr.Unknown_3_Layout.Unknown_0_Layout.Unknown_0x_Layout Layout = new scnr.Unknown_3_Layout.Unknown_0_Layout.Unknown_0x_Layout();
                    public LongInteger Unknown = new LongInteger("Unknown");
                    public LongInteger Unknown_0 = new LongInteger("Unknown");

                    public Unknown_0x_Layout()
                    {
                        base.Add(this.Unknown);
                        base.Add(this.Unknown_0);
                    }
                }
            }

            public class Unknown_1_Layout : TagBlockLayout
            {
                public static readonly scnr.Unknown_3_Layout.Unknown_1_Layout Layout = new scnr.Unknown_3_Layout.Unknown_1_Layout();
                public core.TagInterface.Padding Padding = new core.TagInterface.Padding("Padding", 4);
                public StringID Unknown = new StringID("Unknown");
                public TagBlock Unknown_0 = new TagBlock("Unknown", Unknown_0_Layout.Layout, Map.HaloVersionEnum.Halo2);

                public Unknown_1_Layout()
                {
                    base.Add(this.Unknown);
                    base.Add(this.Padding);
                    base.Add(this.Unknown_0);
                }

                public class Unknown_0_Layout : TagBlockLayout
                {
                    public static readonly scnr.Unknown_3_Layout.Unknown_1_Layout.Unknown_0_Layout Layout = new scnr.Unknown_3_Layout.Unknown_1_Layout.Unknown_0_Layout();
                    public StringID Unknown = new StringID("Unknown");

                    public Unknown_0_Layout()
                    {
                        base.Add(this.Unknown);
                    }
                }
            }
        }

        public class References_Layout : TagBlockLayout
        {
            public static readonly scnr.References_Layout Layout = new scnr.References_Layout();
            public HaloTagType Unknown = new HaloTagType("Unknown");
            public TagIdent Unknown_0 = new TagIdent("Unknown");

            public References_Layout()
            {
                base.Add(this.Unknown);
                base.Add(this.Unknown_0);
            }
        }

        public class Unkown_7_Layout : TagBlockLayout
        {
            public static readonly scnr.Unkown_7_Layout Layout = new scnr.Unkown_7_Layout();
            public TagBlock Unknown = new TagBlock("Unknown", Unknown_Layout.Layout, Map.HaloVersionEnum.Halo2);
            public TagBlock Unknown_0 = new TagBlock("Unknown", Unknown_0_Layout.Layout, Map.HaloVersionEnum.Halo2);
            public TagBlock Unused = new TagBlock("Unused", Unused_Layout.Layout, Map.HaloVersionEnum.Halo2);

            public Unkown_7_Layout()
            {
                base.Add(this.Unknown);
                base.Add(this.Unused);
                base.Add(this.Unknown_0);
            }

            public class Unknown_0_Layout : TagBlockLayout
            {
                public static readonly scnr.Unkown_7_Layout.Unknown_0_Layout Layout = new scnr.Unkown_7_Layout.Unknown_0_Layout();
                public LongInteger Unknown = new LongInteger("Unknown");
                public LongInteger Unknown_0 = new LongInteger("Unknown");

                public Unknown_0_Layout()
                {
                    base.Add(this.Unknown);
                    base.Add(this.Unknown_0);
                }
            }

            public class Unknown_Layout : TagBlockLayout
            {
                public static readonly scnr.Unkown_7_Layout.Unknown_Layout Layout = new scnr.Unkown_7_Layout.Unknown_Layout();
                public LongInteger Unknown = new LongInteger("Unknown");
                public LongInteger Unknown_0 = new LongInteger("Unknown");

                public Unknown_Layout()
                {
                    base.Add(this.Unknown);
                    base.Add(this.Unknown_0);
                }
            }

            public class Unused_Layout : TagBlockLayout
            {
                public static readonly scnr.Unkown_7_Layout.Unused_Layout Layout = new scnr.Unkown_7_Layout.Unused_Layout();
                public HaloTagType Unused = new HaloTagType("Unused");
                public TagIdent Unused_0 = new TagIdent("Unused");

                public Unused_Layout()
                {
                    base.Add(this.Unused);
                    base.Add(this.Unused_0);
                }
            }
        }

        public class Vehicle_Palette_Layout : TagBlockLayout
        {
            public static readonly scnr.Vehicle_Palette_Layout Layout = new scnr.Vehicle_Palette_Layout();
            public core.TagInterface.Padding Padding = new core.TagInterface.Padding("Padding", 0x20);
            public HaloTagType Vehicle = new HaloTagType("Vehicle");
            public TagIdent Vehicle_0 = new TagIdent("Vehicle");

            public Vehicle_Palette_Layout()
            {
                base.Add(this.Vehicle);
                base.Add(this.Vehicle_0);
                base.Add(this.Padding);
            }
        }

        public class Vehicle_Placement_Layout : TagBlockLayout
        {
            public ShortInteger bsp_index_1 = new ShortInteger("bsp_index_1");
            public static readonly scnr.Vehicle_Placement_Layout Layout = new scnr.Vehicle_Placement_Layout();
            public core.TagInterface.Padding Padding = new core.TagInterface.Padding("Padding", 2);
            public core.TagInterface.Padding Padding_0 = new core.TagInterface.Padding("Padding", 4);
            public core.TagInterface.Padding Padding_1 = new core.TagInterface.Padding("Padding", 4);
            public LongInteger pitch = new LongInteger("Unknown");
            public LongInteger roll = new LongInteger("Unknown");
            public LongInteger Unknown = new LongInteger("Unknown");
            public LongInteger Unknown_10 = new LongInteger("Unknown");
            public LongInteger Unknown_11 = new LongInteger("Unknown");
            public LongInteger Unknown_12 = new LongInteger("Unknown");
            public RealFloat Unknown_2 = new RealFloat("Unknown");
            public LongInteger Unknown_3 = new LongInteger("Unknown");
            public ShortInteger Unknown_4 = new ShortInteger("Unknown");
            public RealFloat Unknown_5 = new RealFloat("Unknown");
            public StringID Unknown_6 = new StringID("Unknown");
            public LongInteger Unknown_7 = new LongInteger("Unknown");
            public LongInteger Unknown_8 = new LongInteger("Unknown");
            public LongInteger Unknown_9 = new LongInteger("Unknown");
            public ShortInteger Vehicle_Chunk__Number_ = new ShortInteger("Biped Chunk #");
            public RealFloat X = new RealFloat("X");
            public RealFloat Y = new RealFloat("Y");
            public RealFloat yaw = new RealFloat("Facing Direction");
            public RealFloat Z = new RealFloat("Z");

            public Vehicle_Placement_Layout()
            {
                base.Add(this.Vehicle_Chunk__Number_);
                base.Add(this.Padding);
                base.Add(this.Unknown);
                base.Add(this.X);
                base.Add(this.Y);
                base.Add(this.Z);
                base.Add(this.yaw);
                base.Add(this.pitch);
                base.Add(this.roll);
                base.Add(this.Unknown_2);
                base.Add(this.Padding_0);
                base.Add(this.Unknown_3);
                base.Add(this.bsp_index_1);
                base.Add(this.Unknown_4);
                base.Add(this.Unknown_5);
                base.Add(this.Unknown_6);
                base.Add(this.Unknown_7);
                base.Add(this.Unknown_8);
                base.Add(this.Unknown_9);
                base.Add(this.Unknown_10);
                base.Add(this.Unknown_11);
                base.Add(this.Padding_1);
                base.Add(this.Unknown_12);
            }
        }

        public class Vehicle_Seats_Layout : TagBlockLayout
        {
            public static readonly scnr.Vehicle_Seats_Layout Layout = new scnr.Vehicle_Seats_Layout();
            public core.TagInterface.Flags Seats = new core.TagInterface.Flags("Seats", core.TagInterface.Flags.BitmaskTypeEnum.Long);
            public TagIdent Vehicle = new TagIdent("Vehicle");

            public Vehicle_Seats_Layout()
            {
                base.Add(this.Vehicle);
                base.Add(this.Seats);
                List<core.TagInterface.Flags.Bit> list = new List<core.TagInterface.Flags.Bit>();
                for (int i = 0; i < 0x20; i++)
                {
                    core.TagInterface.Flags.Bit item = new core.TagInterface.Flags.Bit();
                    item.BitName = "Seat " + i;
                    item.BitPosition = i;
                    list.Add(item);
                }
                this.Seats.Bits = list;
            }
        }

        public class Weapon_Palette_Layout : TagBlockLayout
        {
            public static readonly scnr.Weapon_Palette_Layout Layout = new scnr.Weapon_Palette_Layout();
            public core.TagInterface.Padding Padding = new core.TagInterface.Padding("Padding", 0x20);
            public HaloTagType Weapon = new HaloTagType("Weapon");
            public TagIdent Weapon_0 = new TagIdent("Weapon");

            public Weapon_Palette_Layout()
            {
                base.Add(this.Weapon);
                base.Add(this.Weapon_0);
                base.Add(this.Padding);
            }
        }

        public class Weapon_Placement_Layout : TagBlockLayout
        {
            public ShortInteger bsp_index_1 = new ShortInteger("bsp_index_1");
            public static readonly scnr.Weapon_Placement_Layout Layout = new scnr.Weapon_Placement_Layout();
            public core.TagInterface.Padding Padding = new core.TagInterface.Padding("Padding", 2);
            public core.TagInterface.Padding Padding_0 = new core.TagInterface.Padding("Padding", 4);
            public core.TagInterface.Padding Padding_1 = new core.TagInterface.Padding("Padding", 0x18);
            public ShortInteger Palette_Chunk__Number_ = new ShortInteger("Palette Chunk #");
            public LongInteger Pitch = new LongInteger("Pitch");
            public LongInteger Roll = new LongInteger("Roll");
            public LongInteger Unknown = new LongInteger("Unknown");
            public RealFloat Unknown_0 = new RealFloat("Unknown");
            public LongInteger Unknown_1 = new LongInteger("Unknown");
            public ShortInteger Unknown_2 = new ShortInteger("Unknown");
            public RealFloat Unknown_3 = new RealFloat("Unknown");
            public LongInteger Unknown_4 = new LongInteger("Unknown");
            public LongInteger Unknown_5 = new LongInteger("Unknown");
            public RealFloat X = new RealFloat("X");
            public LongInteger Y = new LongInteger("Y");
            public LongInteger Yaw = new LongInteger("Yaw");
            public LongInteger Z = new LongInteger("Z");

            public Weapon_Placement_Layout()
            {
                base.Add(this.Palette_Chunk__Number_);
                base.Add(this.Padding);
                base.Add(this.Unknown);
                base.Add(this.X);
                base.Add(this.Y);
                base.Add(this.Z);
                base.Add(this.Yaw);
                base.Add(this.Pitch);
                base.Add(this.Roll);
                base.Add(this.Unknown_0);
                base.Add(this.Padding_0);
                base.Add(this.Unknown_1);
                base.Add(this.bsp_index_1);
                base.Add(this.Unknown_2);
                base.Add(this.Unknown_3);
                base.Add(this.Padding_1);
                base.Add(this.Unknown_4);
                base.Add(this.Unknown_5);
            }
        }

        public class Weather_Layout : TagBlockLayout
        {
            public static readonly scnr.Weather_Layout Layout = new scnr.Weather_Layout();
            public core.TagInterface.Padding Padding = new core.TagInterface.Padding("Padding", 0x24);
            public core.TagInterface.Padding Padding_0 = new core.TagInterface.Padding("Padding", 0x34);
            public HaloTagType Unused = new HaloTagType("Unused");
            public TagIdent Unused_0 = new TagIdent("Unused");
            public core.TagInterface.String Weather = new core.TagInterface.String("Weather", 0x20);
            public HaloTagType Weather_0 = new HaloTagType("Weather");
            public TagIdent Weather_1 = new TagIdent("Weather");

            public Weather_Layout()
            {
                base.Add(this.Weather);
                base.Add(this.Weather_0);
                base.Add(this.Weather_1);
                base.Add(this.Padding);
                base.Add(this.Unused);
                base.Add(this.Unused_0);
                base.Add(this.Padding_0);
            }
        }
    }
}

