﻿namespace core.H2
{
    using core.TagInterface;
    using System;

    public class ugh_ : TagBlockLayout
    {
        public TagBlock Diff_Model_Raw_Data87 = new TagBlock("Diff Model Raw Data87", Diff_Model_Raw_Data87_Layout.Layout, Map.HaloVersionEnum.Halo2);
        public static readonly ugh_ Layout = new ugh_();
        public TagBlock Sound_Choices44 = new TagBlock("Sound Choices44", Sound_Choices44_Layout.Layout, Map.HaloVersionEnum.Halo2);
        public TagBlock Sound_Names25 = new TagBlock("Sound Names25", Sound_Names25_Layout.Layout, Map.HaloVersionEnum.Halo2);
        public TagBlock Sound_Permutations35 = new TagBlock("Sound Permutations35", Sound_Permutations35_Layout.Layout, Map.HaloVersionEnum.Halo2);
        public TagBlock Sound_Raw_Data68 = new TagBlock("Sound Raw Data68", Sound_Raw_Data68_Layout.Layout, Map.HaloVersionEnum.Halo2, 4);
        public TagBlock Unknown17 = new TagBlock("Unknown17", Unknown17_Layout.Layout, Map.HaloVersionEnum.Halo2);
        public TagBlock Unknown28 = new TagBlock("Unknown28", Unknown28_Layout.Layout, Map.HaloVersionEnum.Halo2);
        public TagBlock Unknown4 = new TagBlock("Unknown4", Unknown4_Layout.Layout, Map.HaloVersionEnum.Halo2);
        public TagBlock Unknown51 = new TagBlock("Unknown51", Unknown51_Layout.Layout, Map.HaloVersionEnum.Halo2);
        public TagBlock Unknown73 = new TagBlock("Unknown73", Unknown73_Layout.Layout, Map.HaloVersionEnum.Halo2);
        public TagBlock Zero65 = new TagBlock("Zero65", Zero65_Layout.Layout, Map.HaloVersionEnum.Halo2, 4);

        public ugh_()
        {
            base.Add(this.Unknown4);
            base.Add(this.Unknown17);
            base.Add(this.Sound_Names25);
            base.Add(this.Unknown28);
            base.Add(this.Sound_Permutations35);
            base.Add(this.Sound_Choices44);
            base.Add(this.Unknown51);
            base.Add(this.Zero65);
            base.Add(this.Sound_Raw_Data68);
            base.Add(this.Unknown73);
            base.Add(this.Diff_Model_Raw_Data87);
        }

        public class Diff_Model_Raw_Data87_Layout : TagBlockLayout
        {
            public static readonly ugh_.Diff_Model_Raw_Data87_Layout Layout = new ugh_.Diff_Model_Raw_Data87_Layout();
            public core.TagInterface.Padding Padding = new core.TagInterface.Padding("Padding", 8);
            public Raw_Tag_Block Visual_Raw = new Raw_Tag_Block("Visual Raw", Map.HaloVersionEnum.Halo2, Data.RawDataTypes.H2_ugh_coconuts, new TagBlockLayout());

            public Diff_Model_Raw_Data87_Layout()
            {
                base.Add(this.Padding);
                base.Add(this.Visual_Raw);
            }
        }

        public class Sound_Choices44_Layout : TagBlockLayout
        {
            public ShortInteger chunkCount = new ShortInteger("chunkCount");
            public ShortInteger Index = new ShortInteger("Index");
            public static readonly ugh_.Sound_Choices44_Layout Layout = new ugh_.Sound_Choices44_Layout();
            public ShortInteger Name_Index = new ShortInteger("Name Index");
            public ShortInteger unk1 = new ShortInteger("unknown");
            public LongInteger Unknown = new LongInteger("Unknown");
            public LongInteger Unknown_0 = new LongInteger("Unknown");

            public Sound_Choices44_Layout()
            {
                base.Add(this.Name_Index);
                base.Add(this.unk1);
                base.Add(this.Unknown);
                base.Add(this.Unknown_0);
                base.Add(this.Index);
                base.Add(this.chunkCount);
            }
        }

        public class Sound_Names25_Layout : TagBlockLayout
        {
            public static readonly ugh_.Sound_Names25_Layout Layout = new ugh_.Sound_Names25_Layout();
            public StringID Name = new StringID("Name");

            public Sound_Names25_Layout()
            {
                base.Add(this.Name);
            }
        }

        public class Sound_Permutations35_Layout : TagBlockLayout
        {
            public ShortInteger chunkCount = new ShortInteger("chunkCount");
            public ShortInteger Index = new ShortInteger("Index");
            public ShortInteger indexto4thblock1 = new ShortInteger("indexto4thblock1");
            public ShortInteger indexto4thblock2 = new ShortInteger("indexto4thblock2");
            public ShortInteger indexto4thblock3 = new ShortInteger("indexto4thblock3");
            public static readonly ugh_.Sound_Permutations35_Layout Layout = new ugh_.Sound_Permutations35_Layout();
            public ShortInteger No_Name = new ShortInteger("No_Name");

            public Sound_Permutations35_Layout()
            {
                base.Add(this.No_Name);
                base.Add(this.indexto4thblock1);
                base.Add(this.indexto4thblock2);
                base.Add(this.indexto4thblock3);
                base.Add(this.Index);
                base.Add(this.chunkCount);
            }
        }

        public class Sound_Raw_Data68_Layout : TagBlockLayout
        {
            public static readonly ugh_.Sound_Raw_Data68_Layout Layout = new ugh_.Sound_Raw_Data68_Layout();
            public core.TagInterface.Padding Padding = new core.TagInterface.Padding("Padding", 4);
            public core.TagInterface.Sound_Raw Sound_Raw = new core.TagInterface.Sound_Raw("Sound Raw", Map.HaloVersionEnum.Halo2);

            public Sound_Raw_Data68_Layout()
            {
                base.Add(this.Sound_Raw);
                base.Add(this.Padding);
            }
        }

        public class Unknown17_Layout : TagBlockLayout
        {
            public static readonly ugh_.Unknown17_Layout Layout = new ugh_.Unknown17_Layout();
            public ShortInteger No_Name = new ShortInteger("No_Name");
            public ShortInteger No_Name_0 = new ShortInteger("No_Name");
            public RealFloat One = new RealFloat("One");
            public RealFloat One_0 = new RealFloat("One");
            public RealFloat Unknown = new RealFloat("Unknown");
            public RealFloat Unknown_0 = new RealFloat("Unknown");

            public Unknown17_Layout()
            {
                base.Add(this.Unknown);
                base.Add(this.Unknown_0);
                base.Add(this.No_Name);
                base.Add(this.No_Name_0);
                base.Add(this.One);
                base.Add(this.One_0);
            }
        }

        public class Unknown28_Layout : TagBlockLayout
        {
            public static readonly ugh_.Unknown28_Layout Layout = new ugh_.Unknown28_Layout();
            public ShortInteger No_Name = new ShortInteger("No_Name");
            public ShortInteger No_Name_0 = new ShortInteger("No_Name");
            public ShortInteger No_Name_1 = new ShortInteger("No_Name");
            public ShortInteger No_Name_2 = new ShortInteger("No_Name");
            public ShortInteger No_Name_3 = new ShortInteger("No_Name");

            public Unknown28_Layout()
            {
                base.Add(this.No_Name);
                base.Add(this.No_Name_0);
                base.Add(this.No_Name_1);
                base.Add(this.No_Name_2);
                base.Add(this.No_Name_3);
            }
        }

        public class Unknown4_Layout : TagBlockLayout
        {
            public static readonly ugh_.Unknown4_Layout Layout = new ugh_.Unknown4_Layout();
            public ShortInteger No_Name = new ShortInteger("No_Name");
            public ShortInteger No_Name_0 = new ShortInteger("No_Name");
            public core.TagInterface.Padding Padding = new core.TagInterface.Padding("Padding", 20);
            public RealFloat Pi = new RealFloat("Pi");
            public RealFloat Pi_0 = new RealFloat("Pi");
            public RealFloat Unknown = new RealFloat("Unknown");
            public RealFloat Unknown_0 = new RealFloat("Unknown");
            public RealFloat Unknown_1 = new RealFloat("Unknown");
            public RealFloat Unknown_2 = new RealFloat("Unknown");
            public RealFloat Unknown_3 = new RealFloat("Unknown");
            public RealFloat Unknown_4 = new RealFloat("Unknown");

            public Unknown4_Layout()
            {
                base.Add(this.Unknown);
                base.Add(this.Unknown_0);
                base.Add(this.Unknown_1);
                base.Add(this.Unknown_2);
                base.Add(this.Unknown_3);
                base.Add(this.Unknown_4);
                base.Add(this.No_Name);
                base.Add(this.No_Name_0);
                base.Add(this.Pi);
                base.Add(this.Pi_0);
                base.Add(this.Padding);
            }
        }

        public class Unknown51_Layout : TagBlockLayout
        {
            public static readonly ugh_.Unknown51_Layout Layout = new ugh_.Unknown51_Layout();
            public core.TagInterface.Padding Padding = new core.TagInterface.Padding("Padding", 20);
            public core.TagInterface.Padding Padding_0 = new core.TagInterface.Padding("Padding", 0x18);
            public TagBlock Unknown53 = new TagBlock("Unknown53", Unknown53_Layout.Layout, Map.HaloVersionEnum.Halo2);

            public Unknown51_Layout()
            {
                base.Add(this.Padding);
                base.Add(this.Unknown53);
                base.Add(this.Padding_0);
            }

            public class Unknown53_Layout : TagBlockLayout
            {
                public RealFloat _800 = new RealFloat("800");
                public RealFloat _800_0 = new RealFloat("800");
                public RealFloat _8000 = new RealFloat("8000");
                public RealFloat _8000_0 = new RealFloat("8000");
                public static readonly ugh_.Unknown51_Layout.Unknown53_Layout Layout = new ugh_.Unknown51_Layout.Unknown53_Layout();
                public LongInteger One = new LongInteger("One");
                public core.TagInterface.Padding Padding = new core.TagInterface.Padding("Padding", 4);
                public core.TagInterface.Padding Padding_0 = new core.TagInterface.Padding("Padding", 0x18);
                public core.TagInterface.Padding Padding_1 = new core.TagInterface.Padding("Padding", 0x18);

                public Unknown53_Layout()
                {
                    base.Add(this.One);
                    base.Add(this.Padding);
                    base.Add(this._800);
                    base.Add(this._8000);
                    base.Add(this.Padding_0);
                    base.Add(this._800_0);
                    base.Add(this._8000_0);
                    base.Add(this.Padding_1);
                }
            }
        }

        public class Unknown73_Layout : TagBlockLayout
        {
            public static readonly ugh_.Unknown73_Layout Layout = new ugh_.Unknown73_Layout();
            public core.TagInterface.Padding Padding = new core.TagInterface.Padding("Padding", 4);
            public core.TagInterface.Padding Padding_0 = new core.TagInterface.Padding("Padding", 8);
            public TagBlock Unknown74 = new TagBlock("Unknown74", Unknown74_Layout.Layout, Map.HaloVersionEnum.Halo2);
            public TagBlock Unknown81 = new TagBlock("Unknown81", Unknown81_Layout.Layout, Map.HaloVersionEnum.Halo2);

            public Unknown73_Layout()
            {
                base.Add(this.Unknown74);
                base.Add(this.Unknown81);
                base.Add(this.Padding);
                base.Add(this.Padding_0);
            }

            public class Unknown74_Layout : TagBlockLayout
            {
                public static readonly ugh_.Unknown73_Layout.Unknown74_Layout Layout = new ugh_.Unknown73_Layout.Unknown74_Layout();
                public ShortInteger No_Name = new ShortInteger("No_Name");
                public ShortInteger No_Name_0 = new ShortInteger("No_Name");
                public RealFloat No_Name_1 = new RealFloat("No_Name");
                public LongInteger No_Name_2 = new LongInteger("No_Name");
                public LongInteger No_Name_3 = new LongInteger("No_Name");

                public Unknown74_Layout()
                {
                    base.Add(this.No_Name);
                    base.Add(this.No_Name_0);
                    base.Add(this.No_Name_1);
                    base.Add(this.No_Name_2);
                    base.Add(this.No_Name_3);
                }
            }

            public class Unknown81_Layout : TagBlockLayout
            {
                public static readonly ugh_.Unknown73_Layout.Unknown81_Layout Layout = new ugh_.Unknown73_Layout.Unknown81_Layout();
                public core.TagInterface.Padding Padding = new core.TagInterface.Padding("Padding", 4);

                public Unknown81_Layout()
                {
                    base.Add(this.Padding);
                }
            }
        }

        public class Zero65_Layout : TagBlockLayout
        {
            public static readonly ugh_.Zero65_Layout Layout = new ugh_.Zero65_Layout();
            public core.TagInterface.Padding Padding = new core.TagInterface.Padding("Padding", 1);

            public Zero65_Layout()
            {
                base.Add(this.Padding);
            }
        }
    }
}

