﻿namespace core.H2
{
    using core.TagInterface;
    using System;

    public class weap : TagBlockLayout
    {
        public RealFloat Acceleration_Scale = new RealFloat("Acceleration_Scale");
        public RealFloat Active_Camo_Ding = new RealFloat("Active_Camo_Ding");
        public HaloTagType Aged_Effect = new HaloTagType("Aged_Effect");
        public TagIdent Aged_Effect_0 = new TagIdent("Aged_Effect_0");
        public HaloTagType Aged_Vehicle = new HaloTagType("Aged_Vehicle");
        public TagIdent Aged_Vehicle_0 = new TagIdent("Aged_Vehicle_0");
        public HaloTagType Aged_Weapon = new HaloTagType("Aged_Weapon");
        public TagIdent Aged_Weapon_0 = new TagIdent("Aged_Weapon_0");
        public StringID Ammo_Plural = new StringID("Ammo_Plural");
        public StringID Ammo_Singular = new StringID("Ammo_Singular");
        public TagBlock Attachments = new TagBlock("Attachments", Attachments_Layout.Layout, Map.HaloVersionEnum.Halo2);
        public RealFloat Auto_Aim_Angle__Radians_ = new RealFloat("Auto_Aim_Angle__Radians_");
        public RealFloat Auto_Aim_Range = new RealFloat("Auto_Aim_Range");
        public RealFloat Bounding_Offset_X = new RealFloat("Bounding_Offset_X");
        public RealFloat Bounding_Offset_Y = new RealFloat("Bounding_Offset_Y");
        public RealFloat Bounding_Offset_Z = new RealFloat("Bounding_Offset_Z");
        public RealFloat Bounding_Radius__world_units_ = new RealFloat("Bounding_Radius__world_units_");
        public HaloTagType Crate_Object = new HaloTagType("Crate_Object");
        public TagIdent Crate_Object_0 = new TagIdent("Crate_Object_0");
        public HaloTagType Creation_Effects = new HaloTagType("Creation_Effects");
        public TagIdent Creation_Effects_0 = new TagIdent("Creation_Effects_0");
        public HaloTagType Dash_Melee = new HaloTagType("Dash_Melee");
        public TagIdent Dash_Melee_0 = new TagIdent("Dash_Melee_0");
        public HaloTagType Dash_Melee_Response = new HaloTagType("Dash_Melee_Response");
        public TagIdent Dash_Melee_Response_0 = new TagIdent("Dash_Melee_Response_0");
        public StringID Default_Model = new StringID("Default_Model");
        public RealFloat Deviation_Angle__Radians_ = new RealFloat("Deviation_Angle__Radians_");
        public StringID Dual_Wield = new StringID("Dual_Wield");
        public RealFloat Dynamic_Light_sphere_Offset_X = new RealFloat("Dynamic_Light_sphere_Offset_X");
        public RealFloat Dynamic_Light_sphere_Offset_Y = new RealFloat("Dynamic_Light_sphere_Offset_Y");
        public RealFloat Dynamic_Light_sphere_Offset_Z = new RealFloat("Dynamic_Light_sphere_Offset_Z");
        public RealFloat Dynamic_Light_sphere_radius = new RealFloat("Dynamic_Light_sphere_radius");
        public TagBlock Fire_Effect_Bitmaps = new TagBlock("Fire_Effect_Bitmaps", Fire_Effect_Bitmaps_Layout.Layout, Map.HaloVersionEnum.Halo2);
        public TagBlock Firing_Info = new TagBlock("Firing_Info", Firing_Info_Layout.Layout, Map.HaloVersionEnum.Halo2);
        public core.TagInterface.Flags Flags = new core.TagInterface.Flags("Flags", core.TagInterface.Flags.BitmaskTypeEnum.Long);
        public core.TagInterface.Flags Flags_0 = new core.TagInterface.Flags("Flags_0", core.TagInterface.Flags.BitmaskTypeEnum.Long);
        public TagBlock FP_Models = new TagBlock("FP_Models", FP_Models_Layout.Layout, Map.HaloVersionEnum.Halo2);
        public HaloTagType HUD = new HaloTagType("HUD");
        public TagIdent HUD_0 = new TagIdent("HUD_0");
        public static readonly weap Layout = new weap();
        public LongInteger Lightmap_Shadow_type_enum_ = new LongInteger("Lightmap_Shadow_type_enum_");
        public TagBlock Magazine = new TagBlock("Magazine", Magazine_Layout.Layout, Map.HaloVersionEnum.Halo2);
        public RealFloat Magnetism_Angle__Radians_ = new RealFloat("Magnetism_Angle__Radians_");
        public RealFloat Magnetism_Range = new RealFloat("Magnetism_Range");
        public HaloTagType Material_Effects = new HaloTagType("Material_Effects");
        public TagIdent Material_Effects_0 = new TagIdent("Material_Effects_0");
        public RealFloat Max_Zoom = new RealFloat("Max_Zoom");
        public HaloTagType Melee_Damage = new HaloTagType("Melee_Damage");
        public TagIdent Melee_Damage_0 = new TagIdent("Melee_Damage_0");
        public HaloTagType Melee_Damage_1 = new HaloTagType("Melee_Damage_1");
        public TagIdent Melee_Damage_2 = new TagIdent("Melee_Damage_2");
        public HaloTagType Melee_Response_Damage = new HaloTagType("Melee_Response_Damage");
        public TagIdent Melee_Response_Damage_0 = new TagIdent("Melee_Response_Damage_0");
        public HaloTagType Melee_Response_Damage_1 = new HaloTagType("Melee_Response_Damage_1");
        public TagIdent Melee_Response_Damage_2 = new TagIdent("Melee_Response_Damage_2");
        public RealFloat Min_Zoom = new RealFloat("Min_Zoom");
        public TagBlock Object_Ai_Properties = new TagBlock("Object_Ai_Properties", Object_Ai_Properties_Layout.Layout, Map.HaloVersionEnum.Halo2);
        public HaloTagType Object_Properties = new HaloTagType("Object_Properties");
        public TagIdent Object_Properties_0 = new TagIdent("Object_Properties_0");
        public HaloTagType Overheat_Effect = new HaloTagType("Overheat_Effect");
        public TagIdent Overheat_Effect_0 = new TagIdent("Overheat_Effect_0");
        public core.TagInterface.Padding Padding = new core.TagInterface.Padding("Padding", 8);
        public core.TagInterface.Padding Padding_0 = new core.TagInterface.Padding("Padding", 8);
        public core.TagInterface.Padding Padding_1 = new core.TagInterface.Padding("Padding", 8);
        public core.TagInterface.Padding Padding_2 = new core.TagInterface.Padding("Padding", 8);
        public core.TagInterface.Padding Padding_3 = new core.TagInterface.Padding("Padding", 0x10);
        public core.TagInterface.Padding Padding_4 = new core.TagInterface.Padding("Padding", 8);
        public core.TagInterface.Padding Padding_5 = new core.TagInterface.Padding("Padding", 8);
        public core.TagInterface.Padding Padding_6 = new core.TagInterface.Padding("Padding", 0x10);
        public StringID Picked_Up = new StringID("Picked_Up");
        public StringID Pickup = new StringID("Pickup");
        public StringID Pickup_or_Dual_Wield = new StringID("Pickup_or_Dual_Wield");
        public HaloTagType Pickup_Sound = new HaloTagType("Pickup_Sound");
        public TagIdent Pickup_Sound_0 = new TagIdent("Pickup_Sound_0");
        public TagBlock Predicted_Resource = new TagBlock("Predicted_Resource", Predicted_Resource_Layout.Layout, Map.HaloVersionEnum.Halo2);
        public TagBlock Predicted_Resource_0 = new TagBlock("Predicted_Resource_0", Predicted_Resource_0_Layout.Layout, Map.HaloVersionEnum.Halo2);
        public HaloTagType Ready_Effect = new HaloTagType("Ready_Effect");
        public TagIdent Ready_Effect_0 = new TagIdent("Ready_Effect_0");
        public HaloTagType Shader_Modifier = new HaloTagType("Shader_Modifier");
        public TagIdent Shader_Modifier_0 = new TagIdent("Shader_Modifier_0");
        public HaloTagType Smash_Melee = new HaloTagType("Smash_Melee");
        public TagIdent Smash_Melee_0 = new TagIdent("Smash_Melee_0");
        public HaloTagType Smash_Melee_Response = new HaloTagType("Smash_Melee_Response");
        public TagIdent Smash_Melee_Response_0 = new TagIdent("Smash_Melee_Response_0");
        public StringID Swap = new StringID("Swap");
        public StringID Swap_AI = new StringID("Swap_AI");
        public StringID Swap_or_Dual_Wield = new StringID("Swap_or_Dual_Wield");
        public LongInteger Sweetener_Size_enum_ = new LongInteger("Sweetener_Size_enum_");
        public StringID Switched_To = new StringID("Switched_To");
        public TagBlock Triggers = new TagBlock("Triggers", Triggers_Layout.Layout, Map.HaloVersionEnum.Halo2);
        public TagBlock Unknown = new TagBlock("Unknown", Unknown_Layout.Layout, Map.HaloVersionEnum.Halo2);
        public RealFloat Unknown_0 = new RealFloat("Unknown_0");
        public RealFloat Unknown_1 = new RealFloat("Unknown_1");
        public TagBlock Unknown_10 = new TagBlock("Unknown_10", Unknown_10_Layout.Layout, Map.HaloVersionEnum.Halo2);
        public LongInteger Unknown_11 = new LongInteger("Unknown_11");
        public LongInteger Unknown_12 = new LongInteger("Unknown_12");
        public RealFloat Unknown_13 = new RealFloat("Unknown_13");
        public RealFloat Unknown_14 = new RealFloat("Unknown_14");
        public RealFloat Unknown_15 = new RealFloat("Unknown_15");
        public RealFloat Unknown_16 = new RealFloat("Unknown_16");
        public RealFloat Unknown_17 = new RealFloat("Unknown_17");
        public RealFloat Unknown_18 = new RealFloat("Unknown_18");
        public RealFloat Unknown_19 = new RealFloat("Unknown_19");
        public RealFloat Unknown_2 = new RealFloat("Unknown_2");
        public RealFloat Unknown_20 = new RealFloat("Unknown_20");
        public RealFloat Unknown_21 = new RealFloat("Unknown_21");
        public RealFloat Unknown_22 = new RealFloat("Unknown_22");
        public RealFloat Unknown_23 = new RealFloat("Unknown_23");
        public RealFloat Unknown_24 = new RealFloat("Unknown_24");
        public RealFloat Unknown_25 = new RealFloat("Unknown_25");
        public RealFloat Unknown_26 = new RealFloat("Unknown_26");
        public RealFloat Unknown_27 = new RealFloat("Unknown_27");
        public RealFloat Unknown_28 = new RealFloat("Unknown_28");
        public RealFloat Unknown_29 = new RealFloat("Unknown_29");
        public RealFloat Unknown_3 = new RealFloat("Unknown_3");
        public ShortInteger Unknown_30 = new ShortInteger("Unknown_30");
        public LongInteger Unknown_31 = new LongInteger("Unknown_31");
        public RealFloat Unknown_32 = new RealFloat("Unknown_32");
        public RealFloat Unknown_33 = new RealFloat("Unknown_33");
        public RealFloat Unknown_34 = new RealFloat("Unknown_34");
        public RealFloat Unknown_35 = new RealFloat("Unknown_35");
        public RealFloat Unknown_36 = new RealFloat("Unknown_36");
        public RealFloat Unknown_37 = new RealFloat("Unknown_37");
        public RealFloat Unknown_38 = new RealFloat("Unknown_38");
        public ShortInteger Unknown_39 = new ShortInteger("Unknown_39");
        public RealFloat Unknown_4 = new RealFloat("Unknown_4");
        public core.TagInterface.Enumerator Unknown_40 = new core.TagInterface.Enumerator("Unknown_40", core.TagInterface.Enumerator.TagEnumeratorIndexType.Long);
        public RealFloat Unknown_41 = new RealFloat("Unknown_41");
        public RealFloat Unknown_42 = new RealFloat("Unknown_42");
        public RealFloat Unknown_43 = new RealFloat("Unknown_43");
        public RealFloat Unknown_44 = new RealFloat("Unknown_44");
        public RealFloat Unknown_45 = new RealFloat("Unknown_45");
        public RealFloat Unknown_46 = new RealFloat("Unknown_46");
        public RealFloat Unknown_47 = new RealFloat("Unknown_47");
        public RealFloat Unknown_48 = new RealFloat("Unknown_48");
        public RealFloat Unknown_49 = new RealFloat("Unknown_49");
        public RealFloat Unknown_5 = new RealFloat("Unknown_5");
        public RealFloat Unknown_50 = new RealFloat("Unknown_50");
        public RealFloat Unknown_51 = new RealFloat("Unknown_51");
        public RealFloat Unknown_6 = new RealFloat("Unknown_6");
        public RealFloat Unknown_7 = new RealFloat("Unknown_7");
        public RealFloat Unknown_8 = new RealFloat("Unknown_8");
        public LongInteger Unknown_9 = new LongInteger("Unknown_9");
        public HaloTagType Unused = new HaloTagType("Unused");
        public TagIdent Unused_0 = new TagIdent("Unused_0");
        public HaloTagType Unused_1 = new HaloTagType("Unused_1");
        public TagIdent Unused_10 = new TagIdent("Unused_10");
        public HaloTagType Unused_11 = new HaloTagType("Unused_11");
        public TagIdent Unused_12 = new TagIdent("Unused_12");
        public HaloTagType Unused_13 = new HaloTagType("Unused_13");
        public TagIdent Unused_14 = new TagIdent("Unused_14");
        public HaloTagType Unused_15 = new HaloTagType("Unused_15");
        public TagIdent Unused_16 = new TagIdent("Unused_16");
        public HaloTagType Unused_17 = new HaloTagType("Unused_17");
        public TagIdent Unused_18 = new TagIdent("Unused_18");
        public HaloTagType Unused_19 = new HaloTagType("Unused_19");
        public TagIdent Unused_2 = new TagIdent("Unused_2");
        public TagIdent Unused_20 = new TagIdent("Unused_20");
        public HaloTagType Unused_21 = new HaloTagType("Unused_21");
        public TagIdent Unused_22 = new TagIdent("Unused_22");
        public HaloTagType Unused_23 = new HaloTagType("Unused_23");
        public TagIdent Unused_24 = new TagIdent("Unused_24");
        public HaloTagType Unused_3 = new HaloTagType("Unused_3");
        public TagIdent Unused_4 = new TagIdent("Unused_4");
        public HaloTagType Unused_5 = new HaloTagType("Unused_5");
        public TagIdent Unused_6 = new TagIdent("Unused_6");
        public HaloTagType Unused_7 = new HaloTagType("Unused_7");
        public TagIdent Unused_8 = new TagIdent("Unused_8");
        public HaloTagType Unused_9 = new HaloTagType("Unused_9");
        public StringID Weapon_Short_Form = new StringID("Weapon_Short_Form");
        public StringID Weapon_Type = new StringID("Weapon_Type");
        public core.TagInterface.Enumerator Weapon_Type_0 = new core.TagInterface.Enumerator("Weapon_Type_0", core.TagInterface.Enumerator.TagEnumeratorIndexType.Word);
        public TagBlock Widgets = new TagBlock("Widgets", Widgets_Layout.Layout, Map.HaloVersionEnum.Halo2);
        public HaloTagType Zoom_In_Sound = new HaloTagType("Zoom_In_Sound");
        public TagIdent Zoom_In_Sound_0 = new TagIdent("Zoom_In_Sound_0");
        public ShortInteger Zoom_Levels = new ShortInteger("Zoom_Levels");
        public HaloTagType Zoom_Out_Sound = new HaloTagType("Zoom_Out_Sound");
        public TagIdent Zoom_Out_Sound_0 = new TagIdent("Zoom_Out_Sound_0");

        public weap()
        {
            base.Add(this.Flags);
            base.Add(this.Bounding_Radius__world_units_);
            base.Add(this.Bounding_Offset_X);
            base.Add(this.Bounding_Offset_Y);
            base.Add(this.Bounding_Offset_Z);
            base.Add(this.Acceleration_Scale);
            base.Add(this.Lightmap_Shadow_type_enum_);
            base.Add(this.Sweetener_Size_enum_);
            base.Add(this.Dynamic_Light_sphere_radius);
            base.Add(this.Dynamic_Light_sphere_Offset_X);
            base.Add(this.Dynamic_Light_sphere_Offset_Y);
            base.Add(this.Dynamic_Light_sphere_Offset_Z);
            base.Add(this.Default_Model);
            base.Add(this.Object_Properties);
            base.Add(this.Object_Properties_0);
            base.Add(this.Crate_Object);
            base.Add(this.Crate_Object_0);
            base.Add(this.Shader_Modifier);
            base.Add(this.Shader_Modifier_0);
            base.Add(this.Creation_Effects);
            base.Add(this.Creation_Effects_0);
            base.Add(this.Material_Effects);
            base.Add(this.Material_Effects_0);
            base.Add(this.Object_Ai_Properties);
            base.Add(this.Unknown);
            base.Add(this.Unknown_0);
            base.Add(this.Unknown_1);
            base.Add(this.Unknown_2);
            base.Add(this.Unknown_3);
            base.Add(this.Unknown_4);
            base.Add(this.Unknown_5);
            base.Add(this.Unknown_6);
            base.Add(this.Unknown_7);
            base.Add(this.Unknown_8);
            base.Add(this.Unknown_9);
            base.Add(this.Attachments);
            base.Add(this.Widgets);
            base.Add(this.Padding);
            base.Add(this.Unknown_10);
            base.Add(this.Predicted_Resource);
            base.Add(this.Unknown_11);
            base.Add(this.Unknown_12);
            base.Add(this.Unknown_13);
            base.Add(this.Unknown_14);
            base.Add(this.Pickup);
            base.Add(this.Swap);
            base.Add(this.Pickup_or_Dual_Wield);
            base.Add(this.Swap_or_Dual_Wield);
            base.Add(this.Dual_Wield);
            base.Add(this.Picked_Up);
            base.Add(this.Ammo_Singular);
            base.Add(this.Ammo_Plural);
            base.Add(this.Switched_To);
            base.Add(this.Swap_AI);
            base.Add(this.Unused);
            base.Add(this.Unused_0);
            base.Add(this.Unused_1);
            base.Add(this.Unused_2);
            base.Add(this.Fire_Effect_Bitmaps);
            base.Add(this.Unused_3);
            base.Add(this.Unused_4);
            base.Add(this.Padding_0);
            base.Add(this.Unused_5);
            base.Add(this.Unused_6);
            base.Add(this.Unused_7);
            base.Add(this.Unused_8);
            base.Add(this.Flags_0);
            base.Add(this.Padding_1);
            base.Add(this.Unknown_15);
            base.Add(this.Unknown_16);
            base.Add(this.Ready_Effect);
            base.Add(this.Ready_Effect_0);
            base.Add(this.Unused_9);
            base.Add(this.Unused_10);
            base.Add(this.Unknown_17);
            base.Add(this.Unknown_18);
            base.Add(this.Padding_2);
            base.Add(this.Unknown_19);
            base.Add(this.Unknown_20);
            base.Add(this.Unknown_21);
            base.Add(this.Overheat_Effect);
            base.Add(this.Overheat_Effect_0);
            base.Add(this.Unused_11);
            base.Add(this.Unused_12);
            base.Add(this.Unused_13);
            base.Add(this.Unused_14);
            base.Add(this.Unused_15);
            base.Add(this.Unused_16);
            base.Add(this.Unused_17);
            base.Add(this.Unused_18);
            base.Add(this.Unused_19);
            base.Add(this.Unused_20);
            base.Add(this.Unknown_22);
            base.Add(this.Unknown_23);
            base.Add(this.Unknown_24);
            base.Add(this.Unknown_25);
            base.Add(this.Unknown_26);
            base.Add(this.Unknown_27);
            base.Add(this.Unknown_28);
            base.Add(this.Unknown_29);
            base.Add(this.Melee_Damage);
            base.Add(this.Melee_Damage_0);
            base.Add(this.Melee_Response_Damage);
            base.Add(this.Melee_Response_Damage_0);
            base.Add(this.Melee_Damage_1);
            base.Add(this.Melee_Damage_2);
            base.Add(this.Melee_Response_Damage_1);
            base.Add(this.Melee_Response_Damage_2);
            base.Add(this.Smash_Melee);
            base.Add(this.Smash_Melee_0);
            base.Add(this.Smash_Melee_Response);
            base.Add(this.Smash_Melee_Response_0);
            base.Add(this.Dash_Melee);
            base.Add(this.Dash_Melee_0);
            base.Add(this.Dash_Melee_Response);
            base.Add(this.Dash_Melee_Response_0);
            base.Add(this.Unknown_30);
            base.Add(this.Zoom_Levels);
            base.Add(this.Min_Zoom);
            base.Add(this.Max_Zoom);
            base.Add(this.Auto_Aim_Angle__Radians_);
            base.Add(this.Auto_Aim_Range);
            base.Add(this.Magnetism_Angle__Radians_);
            base.Add(this.Magnetism_Range);
            base.Add(this.Deviation_Angle__Radians_);
            base.Add(this.Padding_3);
            base.Add(this.Unknown_31);
            base.Add(this.Unknown_32);
            base.Add(this.Unknown_33);
            base.Add(this.Unknown_34);
            base.Add(this.Unknown_35);
            base.Add(this.Unknown_36);
            base.Add(this.Unused_21);
            base.Add(this.Unused_22);
            base.Add(this.Unused_23);
            base.Add(this.Unused_24);
            base.Add(this.Padding_4);
            base.Add(this.Unknown_37);
            base.Add(this.Unknown_38);
            base.Add(this.Pickup_Sound);
            base.Add(this.Pickup_Sound_0);
            base.Add(this.Zoom_In_Sound);
            base.Add(this.Zoom_In_Sound_0);
            base.Add(this.Zoom_Out_Sound);
            base.Add(this.Zoom_Out_Sound_0);
            base.Add(this.Active_Camo_Ding);
            base.Add(this.Padding_5);
            base.Add(this.Weapon_Type);
            base.Add(this.Weapon_Short_Form);
            base.Add(this.Unknown_39);
            base.Add(this.Weapon_Type_0);
            base.Add(this.Unknown_40);
            base.Add(this.Padding_6);
            base.Add(this.FP_Models);
            base.Add(this.HUD);
            base.Add(this.HUD_0);
            base.Add(this.Predicted_Resource_0);
            base.Add(this.Magazine);
            base.Add(this.Firing_Info);
            base.Add(this.Triggers);
            base.Add(this.Unknown_41);
            base.Add(this.Unknown_42);
            base.Add(this.Unknown_43);
            base.Add(this.Unknown_44);
            base.Add(this.Unknown_45);
            base.Add(this.Unknown_46);
            base.Add(this.Aged_Vehicle);
            base.Add(this.Aged_Vehicle_0);
            base.Add(this.Aged_Effect);
            base.Add(this.Aged_Effect_0);
            base.Add(this.Aged_Weapon);
            base.Add(this.Aged_Weapon_0);
            base.Add(this.Unknown_47);
            base.Add(this.Unknown_48);
            base.Add(this.Unknown_49);
            base.Add(this.Unknown_50);
            base.Add(this.Unknown_51);
        }

        public class Attachments_Layout : TagBlockLayout
        {
            public static readonly weap.Attachments_Layout Layout = new weap.Attachments_Layout();
            public core.TagInterface.Padding Padding = new core.TagInterface.Padding("Padding", 4);
            public HaloTagType Type = new HaloTagType("Type");
            public TagIdent Type_0 = new TagIdent("Type_0");
            public StringID Unknown = new StringID("Unknown");
            public StringID Unknown_0 = new StringID("Unknown_0");
            public StringID Unknown_1 = new StringID("Unknown_1");

            public Attachments_Layout()
            {
                base.Add(this.Type);
                base.Add(this.Type_0);
                base.Add(this.Unknown);
                base.Add(this.Padding);
                base.Add(this.Unknown_0);
                base.Add(this.Unknown_1);
            }
        }

        public class Fire_Effect_Bitmaps_Layout : TagBlockLayout
        {
            public HaloTagType Bitmap = new HaloTagType("Bitmap");
            public TagIdent Bitmap_0 = new TagIdent("Bitmap_0");
            public static readonly weap.Fire_Effect_Bitmaps_Layout Layout = new weap.Fire_Effect_Bitmaps_Layout();

            public Fire_Effect_Bitmaps_Layout()
            {
                base.Add(this.Bitmap);
                base.Add(this.Bitmap_0);
            }
        }

        public class Firing_Info_Layout : TagBlockLayout
        {
            public core.TagInterface.Enumerator Button_Used = new core.TagInterface.Enumerator("Button_Used", core.TagInterface.Enumerator.TagEnumeratorIndexType.Word);
            public RealFloat Charge_Time_Question_Mark_ = new RealFloat("Charge_Time_Question_Mark_");
            public HaloTagType Charging_Effect = new HaloTagType("Charging_Effect");
            public TagIdent Charging_Effect_0 = new TagIdent("Charging_Effect_0");
            public core.TagInterface.Enumerator First_Projectile_Used_Chunk_ = new core.TagInterface.Enumerator("First_Projectile_Used_Chunk_", core.TagInterface.Enumerator.TagEnumeratorIndexType.Word);
            public ShortInteger ID = new ShortInteger("ID");
            public static readonly weap.Firing_Info_Layout Layout = new weap.Firing_Info_Layout();
            public HaloTagType Overcharge_Damage = new HaloTagType("Overcharge_Damage");
            public TagIdent Overcharge_Damage_0 = new TagIdent("Overcharge_Damage_0");
            public core.TagInterface.Padding Padding = new core.TagInterface.Padding("Padding", 4);
            public core.TagInterface.Padding Padding_0 = new core.TagInterface.Padding("Padding", 4);
            public core.TagInterface.Enumerator Second_Projectile_Used_Chunk_ = new core.TagInterface.Enumerator("Second_Projectile_Used_Chunk_", core.TagInterface.Enumerator.TagEnumeratorIndexType.Word);
            public RealFloat Trigger_Initiation_Time_Question_Mark_ = new RealFloat("Trigger_Initiation_Time_Question_Mark_");
            public core.TagInterface.Enumerator Type = new core.TagInterface.Enumerator("Type", core.TagInterface.Enumerator.TagEnumeratorIndexType.Word);
            public ShortInteger Unknown = new ShortInteger("Unknown");
            public LongInteger Unknown_0 = new LongInteger("Unknown_0");
            public LongInteger Unknown_1 = new LongInteger("Unknown_1");
            public RealFloat Unknown_2 = new RealFloat("Unknown_2");
            public LongInteger Unknown_3 = new LongInteger("Unknown_3");
            public RealFloat Unknown_4 = new RealFloat("Unknown_4");

            public Firing_Info_Layout()
            {
                base.Add(this.ID);
                base.Add(this.Unknown);
                base.Add(this.Button_Used);
                base.Add(this.Type);
                base.Add(this.First_Projectile_Used_Chunk_);
                base.Add(this.Second_Projectile_Used_Chunk_);
                base.Add(this.Unknown_0);
                base.Add(this.Trigger_Initiation_Time_Question_Mark_);
                base.Add(this.Charge_Time_Question_Mark_);
                base.Add(this.Unknown_1);
                base.Add(this.Unknown_2);
                base.Add(this.Padding);
                base.Add(this.Unknown_3);
                base.Add(this.Unknown_4);
                base.Add(this.Padding_0);
                base.Add(this.Charging_Effect);
                base.Add(this.Charging_Effect_0);
                base.Add(this.Overcharge_Damage);
                base.Add(this.Overcharge_Damage_0);
            }
        }

        public class FP_Models_Layout : TagBlockLayout
        {
            public HaloTagType Animation = new HaloTagType("Animation");
            public TagIdent Animation_0 = new TagIdent("Animation_0");
            public static readonly weap.FP_Models_Layout Layout = new weap.FP_Models_Layout();
            public HaloTagType Model = new HaloTagType("Model");
            public TagIdent Model_0 = new TagIdent("Model_0");

            public FP_Models_Layout()
            {
                base.Add(this.Model);
                base.Add(this.Model_0);
                base.Add(this.Animation);
                base.Add(this.Animation_0);
            }
        }

        public class Magazine_Layout : TagBlockLayout
        {
            public RealFloat Chamber_Time = new RealFloat("Chamber_Time");
            public core.TagInterface.Flags Flags = new core.TagInterface.Flags("Flags", core.TagInterface.Flags.BitmaskTypeEnum.Long);
            public ShortInteger Initial_Rounds = new ShortInteger("Initial_Rounds");
            public static readonly weap.Magazine_Layout Layout = new weap.Magazine_Layout();
            public TagBlock Magazines = new TagBlock("Magazines", Magazines_Layout.Layout, Map.HaloVersionEnum.Halo2);
            public ShortInteger Max_Rounds = new ShortInteger("Max_Rounds");
            public LongInteger Max_Rounds_Held = new LongInteger("Max_Rounds_Held");
            public ShortInteger Max_Rounds_Loaded = new ShortInteger("Max_Rounds_Loaded");
            public core.TagInterface.Padding Padding = new core.TagInterface.Padding("Padding", 0x18);
            public HaloTagType Reload_Effect = new HaloTagType("Reload_Effect");
            public TagIdent Reload_Effect_0 = new TagIdent("Reload_Effect_0");
            public ShortInteger Rounds_Recharged__per_second_ = new ShortInteger("Rounds_Recharged__per_second_");
            public LongInteger Rounds_Reloaded = new LongInteger("Rounds_Reloaded");
            public RealFloat Unknown = new RealFloat("Unknown");
            public HaloTagType Unused = new HaloTagType("Unused");
            public TagIdent Unused_0 = new TagIdent("Unused_0");
            public HaloTagType Unused_1 = new HaloTagType("Unused_1");
            public TagIdent Unused_2 = new TagIdent("Unused_2");
            public HaloTagType Unused_3 = new HaloTagType("Unused_3");
            public TagIdent Unused_4 = new TagIdent("Unused_4");

            public Magazine_Layout()
            {
                base.Add(this.Flags);
                base.Add(this.Rounds_Recharged__per_second_);
                base.Add(this.Initial_Rounds);
                base.Add(this.Max_Rounds);
                base.Add(this.Max_Rounds_Loaded);
                base.Add(this.Max_Rounds_Held);
                base.Add(this.Unknown);
                base.Add(this.Rounds_Reloaded);
                base.Add(this.Chamber_Time);
                base.Add(this.Padding);
                base.Add(this.Reload_Effect);
                base.Add(this.Reload_Effect_0);
                base.Add(this.Unused);
                base.Add(this.Unused_0);
                base.Add(this.Unused_1);
                base.Add(this.Unused_2);
                base.Add(this.Unused_3);
                base.Add(this.Unused_4);
                base.Add(this.Magazines);
            }

            public class Magazines_Layout : TagBlockLayout
            {
                public HaloTagType Equipment = new HaloTagType("Equipment");
                public TagIdent Equipment_0 = new TagIdent("Equipment_0");
                public static readonly weap.Magazine_Layout.Magazines_Layout Layout = new weap.Magazine_Layout.Magazines_Layout();
                public LongInteger Rounds = new LongInteger("Rounds");

                public Magazines_Layout()
                {
                    base.Add(this.Rounds);
                    base.Add(this.Equipment);
                    base.Add(this.Equipment_0);
                }
            }
        }

        public class Object_Ai_Properties_Layout : TagBlockLayout
        {
            public LongInteger AI_Flags = new LongInteger("AI_Flags");
            public LongInteger AI_Size__Enum_ = new LongInteger("AI_Size__Enum_");
            public static readonly weap.Object_Ai_Properties_Layout Layout = new weap.Object_Ai_Properties_Layout();
            public LongInteger Leap_jump_speed_enum_ = new LongInteger("Leap_jump_speed_enum_");
            public StringID Weapon_Base = new StringID("Weapon_Base");

            public Object_Ai_Properties_Layout()
            {
                base.Add(this.AI_Flags);
                base.Add(this.Weapon_Base);
                base.Add(this.AI_Size__Enum_);
                base.Add(this.Leap_jump_speed_enum_);
            }
        }

        public class Predicted_Resource_0_Layout : TagBlockLayout
        {
            public static readonly weap.Predicted_Resource_0_Layout Layout = new weap.Predicted_Resource_0_Layout();
            public TagIdent Resource = new TagIdent("Resource");
            public RealFloat Unknown = new RealFloat("Unknown");

            public Predicted_Resource_0_Layout()
            {
                base.Add(this.Unknown);
                base.Add(this.Resource);
            }
        }

        public class Predicted_Resource_Layout : TagBlockLayout
        {
            public static readonly weap.Predicted_Resource_Layout Layout = new weap.Predicted_Resource_Layout();
            public TagIdent Resource = new TagIdent("Resource");
            public RealFloat Unknown = new RealFloat("Unknown");

            public Predicted_Resource_Layout()
            {
                base.Add(this.Unknown);
                base.Add(this.Resource);
            }
        }

        public class Triggers_Layout : TagBlockLayout
        {
            public RealFloat Acceleration_Time__sec_ = new RealFloat("Acceleration_Time__sec_");
            public RealFloat Age_Generated_per_Round = new RealFloat("Age_Generated_per_Round");
            public ShortInteger Ammo_per_Shot = new ShortInteger("Ammo_per_Shot");
            public RealFloat Chamber_Time__sec_ = new RealFloat("Chamber_Time__sec_");
            public RealFloat Deceleration_Time__sec_ = new RealFloat("Deceleration_Time__sec_");
            public RealFloat Distribution_Angle = new RealFloat("Distribution_Angle");
            public core.TagInterface.Enumerator Distribution_Function = new core.TagInterface.Enumerator("Distribution_Function", core.TagInterface.Enumerator.TagEnumeratorIndexType.Word);
            public RealFloat Error_Angle__max_ = new RealFloat("Error_Angle__max_");
            public RealFloat Error_Angle__min_ = new RealFloat("Error_Angle__min_");
            public core.TagInterface.Flags Flags = new core.TagInterface.Flags("Flags", core.TagInterface.Flags.BitmaskTypeEnum.Long);
            public RealFloat Heat_Generated_per_Round = new RealFloat("Heat_Generated_per_Round");
            public static readonly weap.Triggers_Layout Layout = new weap.Triggers_Layout();
            public RealFloat Minimum_Error = new RealFloat("Minimum_Error");
            public core.TagInterface.Padding Padding = new core.TagInterface.Padding("Padding", 4);
            public core.TagInterface.Padding Padding_0 = new core.TagInterface.Padding("Padding", 8);
            public HaloTagType Projectile = new HaloTagType("Projectile");
            public TagIdent Projectile_0 = new TagIdent("Projectile_0");
            public ShortInteger Projectiles_per_Shot = new ShortInteger("Projectiles_per_Shot");
            public RealFloat Rounds_per_Second__max_ = new RealFloat("Rounds_per_Second__max_");
            public RealFloat Rounds_per_Second__min_ = new RealFloat("Rounds_per_Second__min_");
            public ShortInteger Rounds_per_Shot = new ShortInteger("Rounds_per_Shot");
            public RealFloat Spawn_Offset__x_ = new RealFloat("Spawn_Offset__x_");
            public RealFloat Spawn_Offset__y_ = new RealFloat("Spawn_Offset__y_");
            public RealFloat Spawn_Offset__z_ = new RealFloat("Spawn_Offset__z_");
            public RealFloat Unknown = new RealFloat("Unknown");
            public ShortInteger Unknown_0 = new ShortInteger("Unknown_0");
            public RealFloat Unknown_1 = new RealFloat("Unknown_1");
            public RealFloat Unknown_10 = new RealFloat("Unknown_10");
            public RealFloat Unknown_11 = new RealFloat("Unknown_11");
            public RealFloat Unknown_12 = new RealFloat("Unknown_12");
            public RealFloat Unknown_13 = new RealFloat("Unknown_13");
            public RealFloat Unknown_14 = new RealFloat("Unknown_14");
            public LongInteger Unknown_15 = new LongInteger("Unknown_15");
            public LongInteger Unknown_16 = new LongInteger("Unknown_16");
            public LongInteger Unknown_17 = new LongInteger("Unknown_17");
            public RealFloat Unknown_18 = new RealFloat("Unknown_18");
            public LongInteger Unknown_19 = new LongInteger("Unknown_19");
            public ShortInteger Unknown_2 = new ShortInteger("Unknown_2");
            public RealFloat Unknown_20 = new RealFloat("Unknown_20");
            public RealFloat Unknown_21 = new RealFloat("Unknown_21");
            public RealFloat Unknown_22 = new RealFloat("Unknown_22");
            public RealFloat Unknown_23 = new RealFloat("Unknown_23");
            public RealFloat Unknown_24 = new RealFloat("Unknown_24");
            public LongInteger Unknown_25 = new LongInteger("Unknown_25");
            public RealFloat Unknown_26 = new RealFloat("Unknown_26");
            public RealFloat Unknown_27 = new RealFloat("Unknown_27");
            public RealFloat Unknown_28 = new RealFloat("Unknown_28");
            public RealFloat Unknown_29 = new RealFloat("Unknown_29");
            public LongInteger Unknown_3 = new LongInteger("Unknown_3");
            public RealFloat Unknown_30 = new RealFloat("Unknown_30");
            public RealFloat Unknown_31 = new RealFloat("Unknown_31");
            public RealFloat Unknown_32 = new RealFloat("Unknown_32");
            public RealFloat Unknown_33 = new RealFloat("Unknown_33");
            public TagBlock Unknown_34 = new TagBlock("Unknown_34", Unknown_34_Layout.Layout, Map.HaloVersionEnum.Halo2);
            public StringID Unknown_4 = new StringID("Unknown_4");
            public ShortInteger Unknown_5 = new ShortInteger("Unknown_5");
            public ShortInteger Unknown_6 = new ShortInteger("Unknown_6");
            public RealFloat Unknown_7 = new RealFloat("Unknown_7");
            public RealFloat Unknown_8 = new RealFloat("Unknown_8");
            public RealFloat Unknown_9 = new RealFloat("Unknown_9");
            public HaloTagType Unused = new HaloTagType("Unused");
            public TagIdent Unused_0 = new TagIdent("Unused_0");

            public Triggers_Layout()
            {
                base.Add(this.Flags);
                base.Add(this.Rounds_per_Second__min_);
                base.Add(this.Rounds_per_Second__max_);
                base.Add(this.Acceleration_Time__sec_);
                base.Add(this.Deceleration_Time__sec_);
                base.Add(this.Padding);
                base.Add(this.Unknown);
                base.Add(this.Rounds_per_Shot);
                base.Add(this.Unknown_0);
                base.Add(this.Chamber_Time__sec_);
                base.Add(this.Unknown_1);
                base.Add(this.Unknown_2);
                base.Add(this.Ammo_per_Shot);
                base.Add(this.Unknown_3);
                base.Add(this.Unknown_4);
                base.Add(this.Unknown_5);
                base.Add(this.Unknown_6);
                base.Add(this.Unknown_7);
                base.Add(this.Unknown_8);
                base.Add(this.Unknown_9);
                base.Add(this.Unknown_10);
                base.Add(this.Unknown_11);
                base.Add(this.Unknown_12);
                base.Add(this.Unknown_13);
                base.Add(this.Unknown_14);
                base.Add(this.Unknown_15);
                base.Add(this.Unknown_16);
                base.Add(this.Unknown_17);
                base.Add(this.Unknown_18);
                base.Add(this.Distribution_Function);
                base.Add(this.Projectiles_per_Shot);
                base.Add(this.Distribution_Angle);
                base.Add(this.Minimum_Error);
                base.Add(this.Error_Angle__min_);
                base.Add(this.Error_Angle__max_);
                base.Add(this.Spawn_Offset__x_);
                base.Add(this.Spawn_Offset__y_);
                base.Add(this.Spawn_Offset__z_);
                base.Add(this.Unknown_19);
                base.Add(this.Projectile);
                base.Add(this.Projectile_0);
                base.Add(this.Unused);
                base.Add(this.Unused_0);
                base.Add(this.Unknown_20);
                base.Add(this.Unknown_21);
                base.Add(this.Heat_Generated_per_Round);
                base.Add(this.Age_Generated_per_Round);
                base.Add(this.Padding_0);
                base.Add(this.Unknown_22);
                base.Add(this.Unknown_23);
                base.Add(this.Unknown_24);
                base.Add(this.Unknown_25);
                base.Add(this.Unknown_26);
                base.Add(this.Unknown_27);
                base.Add(this.Unknown_28);
                base.Add(this.Unknown_29);
                base.Add(this.Unknown_30);
                base.Add(this.Unknown_31);
                base.Add(this.Unknown_32);
                base.Add(this.Unknown_33);
                base.Add(this.Unknown_34);
            }

            public class Unknown_34_Layout : TagBlockLayout
            {
                public HaloTagType Empty_Damage = new HaloTagType("Empty_Damage");
                public TagIdent Empty_Damage_0 = new TagIdent("Empty_Damage_0");
                public HaloTagType Empty_Effect = new HaloTagType("Empty_Effect");
                public TagIdent Empty_Effect_0 = new TagIdent("Empty_Effect_0");
                public HaloTagType Firing_Damage = new HaloTagType("Firing_Damage");
                public TagIdent Firing_Damage_0 = new TagIdent("Firing_Damage_0");
                public HaloTagType Firing_Effect = new HaloTagType("Firing_Effect");
                public TagIdent Firing_Effect_0 = new TagIdent("Firing_Effect_0");
                public static readonly weap.Triggers_Layout.Unknown_34_Layout Layout = new weap.Triggers_Layout.Unknown_34_Layout();
                public HaloTagType Misfire_Damage = new HaloTagType("Misfire_Damage");
                public TagIdent Misfire_Damage_0 = new TagIdent("Misfire_Damage_0");
                public HaloTagType Misfire_Effect = new HaloTagType("Misfire_Effect");
                public TagIdent Misfire_Effect_0 = new TagIdent("Misfire_Effect_0");
                public ShortInteger Shot_Count_Lower_Bound = new ShortInteger("Shot_Count_Lower_Bound");
                public ShortInteger Shot_Count_Upper_Bound = new ShortInteger("Shot_Count_Upper_Bound");

                public Unknown_34_Layout()
                {
                    base.Add(this.Shot_Count_Lower_Bound);
                    base.Add(this.Shot_Count_Upper_Bound);
                    base.Add(this.Firing_Effect);
                    base.Add(this.Firing_Effect_0);
                    base.Add(this.Misfire_Effect);
                    base.Add(this.Misfire_Effect_0);
                    base.Add(this.Empty_Effect);
                    base.Add(this.Empty_Effect_0);
                    base.Add(this.Firing_Damage);
                    base.Add(this.Firing_Damage_0);
                    base.Add(this.Misfire_Damage);
                    base.Add(this.Misfire_Damage_0);
                    base.Add(this.Empty_Damage);
                    base.Add(this.Empty_Damage_0);
                }
            }
        }

        public class Unknown_10_Layout : TagBlockLayout
        {
            public static readonly weap.Unknown_10_Layout Layout = new weap.Unknown_10_Layout();
            public core.TagInterface.Padding Padding = new core.TagInterface.Padding("Padding", 8);
            public TagBlock Unknown = new TagBlock("Unknown", Unknown_Layout.Layout, Map.HaloVersionEnum.Halo2);

            public Unknown_10_Layout()
            {
                base.Add(this.Unknown);
                base.Add(this.Padding);
            }

            public class Unknown_Layout : TagBlockLayout
            {
                public static readonly weap.Unknown_10_Layout.Unknown_Layout Layout = new weap.Unknown_10_Layout.Unknown_Layout();
                public core.TagInterface.Padding Padding = new core.TagInterface.Padding("Padding", 4);
                public RealFloat Unknown = new RealFloat("Unknown");
                public RealFloat Unknown_0 = new RealFloat("Unknown_0");
                public RealFloat Unknown_1 = new RealFloat("Unknown_1");
                public RealFloat Unknown_2 = new RealFloat("Unknown_2");
                public RealFloat Unknown_3 = new RealFloat("Unknown_3");
                public RealFloat Unknown_4 = new RealFloat("Unknown_4");
                public RealFloat Unknown_5 = new RealFloat("Unknown_5");

                public Unknown_Layout()
                {
                    base.Add(this.Unknown);
                    base.Add(this.Unknown_0);
                    base.Add(this.Unknown_1);
                    base.Add(this.Unknown_2);
                    base.Add(this.Unknown_3);
                    base.Add(this.Unknown_4);
                    base.Add(this.Unknown_5);
                    base.Add(this.Padding);
                }
            }
        }

        public class Unknown_Layout : TagBlockLayout
        {
            public static readonly weap.Unknown_Layout Layout = new weap.Unknown_Layout();
            public core.TagInterface.Padding Padding = new core.TagInterface.Padding("Padding", 4);
            public core.TagInterface.Padding Padding_0 = new core.TagInterface.Padding("Padding", 4);
            public LongInteger Unknown = new LongInteger("Unknown");
            public StringID Unknown_0 = new StringID("Unknown_0");
            public StringID Unknown_1 = new StringID("Unknown_1");
            public StringID Unknown_2 = new StringID("Unknown_2");
            public TagBlock Unknown_3 = new TagBlock("Unknown_3", Unknown_3_Layout.Layout, Map.HaloVersionEnum.Halo2);

            public Unknown_Layout()
            {
                base.Add(this.Unknown);
                base.Add(this.Unknown_0);
                base.Add(this.Unknown_1);
                base.Add(this.Unknown_2);
                base.Add(this.Padding);
                base.Add(this.Unknown_3);
                base.Add(this.Padding_0);
            }

            public class Unknown_3_Layout : TagBlockLayout
            {
                public static readonly weap.Unknown_Layout.Unknown_3_Layout Layout = new weap.Unknown_Layout.Unknown_3_Layout();
                public ByteInteger Unknown = new ByteInteger("Unknown");

                public Unknown_3_Layout()
                {
                    base.Add(this.Unknown);
                }
            }
        }

        public class Widgets_Layout : TagBlockLayout
        {
            public static readonly weap.Widgets_Layout Layout = new weap.Widgets_Layout();
            public HaloTagType Reference = new HaloTagType("Reference");
            public TagIdent Reference_0 = new TagIdent("Reference_0");

            public Widgets_Layout()
            {
                base.Add(this.Reference);
                base.Add(this.Reference_0);
            }
        }
    }
}

