﻿namespace core
{
    using core.TagInterface;
    using System;
    using System.Collections.Generic;

    public class Tag_Category : List<TagDefinition>
    {
        public Map.HaloVersionEnum HaloVersion;

        public Tag_Category(Map.HaloVersionEnum halo_version)
        {
            this.HaloVersion = halo_version;
        }

        public TagDefinition GetTagDefinitionByExtension(string extension)
        {
            foreach (TagDefinition definition in this)
            {
                if (definition.Extension == extension)
                {
                    return definition;
                }
            }
            return null;
        }

        public TagDefinition GetTagDefinitionByTagType(string TagType)
        {
            foreach (TagDefinition definition in this)
            {
                if (definition.TagType == TagType)
                {
                    return definition;
                }
            }
            return null;
        }
    }
}

